DSP.jl
======

[![CI](https://github.com/JuliaDSP/DSP.jl/actions/workflows/CI.yml/badge.svg)](https://github.com/JuliaDSP/DSP.jl/actions?query=workflow%3ACI+branch%3Amaster)
[![codecov](https://codecov.io/gh/JuliaDSP/DSP.jl/graph/badge.svg?token=dpulG6Nqqo)](https://codecov.io/gh/JuliaDSP/DSP.jl)
[![Documentation (stable)](https://img.shields.io/badge/docs-stable-blue.svg)](https://docs.juliadsp.org/stable/)
[![Documentation (latest)](https://img.shields.io/badge/docs-dev-blue.svg)](https://docs.juliadsp.org/latest/)
[![DOI](https://zenodo.org/badge/DOI/10.5281/zenodo.7016211.svg)](https://doi.org/10.5281/zenodo.7016211)

DSP.jl provides a number of common [digital signal processing](https://en.wikipedia.org/wiki/Digital_signal_processing) routines in Julia. These include:

- [Periodogram estimation](https://docs.juliadsp.org/stable/periodograms)
- [Filter design and filtering](https://docs.juliadsp.org/stable/filters)
- [Estimation](https://docs.juliadsp.org/stable/estimation/)
- [Convolution](https://docs.juliadsp.org/stable/convolutions)
- [Linear Predictive Coding](https://docs.juliadsp.org/stable/lpc)
- [Window functions](https://docs.juliadsp.org/stable/windows)
- [Utility functions](https://docs.juliadsp.org/stable/util)

More details can be found in the [Online Documentation](https://docs.juliadsp.org/stable).

The documentation for pre-releases (master) can be found [here](https://docs.juliadsp.org/dev/).

module Filters
using ..Unwrap
using ..Util
using Polynomials: LaurentPolynomial, Polynomial, coeffs, derivative, fromroots, roots, indeterminate

import Base: *
using LinearAlgebra: I, mul!, rmul!
using Statistics: middle
using SpecialFunctions: ellipk
using ..DSP: optimalfftfiltlength, os_fft_complexity, SMALL_FILT_CUTOFF
import ..DSP: filt, filt!
using FFTW

include("coefficients.jl")
export FilterCoefficients,
        ZeroPoleGain,
        PolynomialRatio,
        Biquad,
        SecondOrderSections,
        coefa,
        coefb

include("filt.jl")
export DF2TFilter,
        filtfilt,
        tdfilt,
        tdfilt!,
        fftfilt,
        fftfilt!

include("design.jl")
export FilterType,
        Butterworth,
        Chebyshev1,
        Chebyshev2,
        Elliptic,
        Lowpass,
        Highpass,
        Bandpass,
        ComplexBandpass,
        Bandstop,
        analogfilter,
        digitalfilter,
        bilinear,
        iirnotch,
        kaiserord,
        FIRWindow,
        resample_filter

include("filt_order.jl")
export buttord,
        ellipord,
        cheb1ord,
        cheb2ord,
        remezord


include("response.jl")
export freqresp,
        phaseresp,
        grpdelay,
        impresp,
        stepresp

include("stream_filt.jl")
export FIRFilter,
        outputlength,
        inputlength,
        reset!,
        resample,
        setphase!,
        timedelay

include("remez_fir.jl")
export remez,
        RemezFilterType,
        filter_type_bandpass,
        filter_type_differentiator,
        filter_type_hilbert

end

#====================================================================

Filter order estimation routines.
Jordan R. Smith, 2021.

Filter transformations translated from Scipy to Julia.

SCIPY license:
Copyright (c) 2001, 2002 Enthought, Inc.
All rights reserved.

Copyright (c) 2003-2017 SciPy Developers.
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

  a. Redistributions of source code must retain the above copyright notice,
     this list of conditions and the following disclaimer.
  b. Redistributions in binary form must reproduce the above copyright
     notice, this list of conditions and the following disclaimer in the
     documentation and/or other materials provided with the distribution.
  c. Neither the name of Enthought nor the names of the SciPy Developers
     may be used to endorse or promote products derived from this software
     without specific prior written permission.


THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR CONTRIBUTORS
BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
THE POSSIBILITY OF SUCH DAMAGE.

--- end of scipy license

Design equations based on [1], Chapter 10. Brent's method with Parabolic interpolation
uses code from [3], modifications from Optim.jl's Brent method in [4].

[1] Proakis, J. G., & Manolakis, D. G. (1996). Digital Signal Processing, Fourth Edition.
Prentice Hall, New Jersey.

[2] Virtanen, P., Gommers, R., Oliphant, T. E., Haberland, M., Reddy, T.,
Cournapeau, D., ... & Van Mulbregt, P. (2020). SciPy 1.0: fundamental algorithms for scientific
computing in Python. Nature methods, 17(3), 261-272.

[3] W. H. Press, et al. Numerical recipes. Third Edition. Cambridge university press, 2007. Chapter 10.3

[4] P. K. Mogensen and A. N. Riseth, Optim: A mathematical optimization package for Julia. Journal of Open
Source Software, 2018. https://github.com/JuliaNLSolvers/Optim.jl/blob/master/src/univariate/solvers/brent.jl

====================================================================#

sort_W((a, b)::Tuple{Real,Real}) = (a > b) ? (b, a) : (a, b)

toprototype(Wp::Real, Ws::Real, ::Type{Lowpass}) = Ws / Wp
toprototype(Wp::Real, Ws::Real, ::Type{Highpass}) = Wp / Ws
function toprototype(Wp::Tuple{Real,Real}, Ws::Tuple{Real,Real}, ::Type{Bandpass})
    # bandpass filter must have two corner frequencies we're computing with
    Wa = muladd.(-Wp[1], Wp[2], Ws .^ 2) ./ (Ws .* (Wp[1] - Wp[2]))
    min(abs.(Wa)...)
end
toprototype(Wp::Tuple{Real,Real}, Ws::Tuple{Real,Real}, Rp::Real, Rs::Real, ::Type{Bandstop}) = butterworth_bsfmin(Wp, Ws, Rp, Rs)
fromprototype(Wp::Real, Wscale::Real, ::Type{Lowpass}) = Wp * Wscale
fromprototype(Wp::Real, Wscale::Real, ::Type{Highpass}) = Wp / Wscale

function fromprototype(Wp::Tuple{Real,Real}, Wscale::Real, ::Type{Bandstop})
    diff = Wp[2] - Wp[1]
    prod = Wp[2] * Wp[1]
    k = sqrt(muladd(4 * (Wscale^2), prod, diff^2))
    den = 2 * Wscale
    Wa = (diff + k) / den, (diff - k) / den
    sort_W(abs.(Wa))
end

function fromprototype(Wp::Tuple{Real,Real}, Wscale::Real, ::Type{Bandpass})
    Wsc = (-Wscale, Wscale)
    diff = Wp[2] - Wp[1]
    prod = Wp[2] * Wp[1]
    Wa = muladd.(.-Wsc, diff / 2, sqrt(muladd(Wscale^2 / 4, diff^2, prod)))
    sort_W(abs.(Wa))
end

butterworth_order_estimate(Rp::Real, Rs::Real, warp::Real) = (log(db2pow(Rs) - 1) - log(db2pow(Rp) - 1)) / (2 * log(warp))
butterworth_natfreq_estimate(warp::Real, Rs::Real, order::Integer) = warp / (db2pow(Rs) - 1)^(1 / (2 * order))

function elliptic_order_estimate(Rp::Real, Rs::Real, Wa::Real)
    # Elliptic integer order estmate. Requires Complete Elliptic integral of first kind.
    ϵ = √(db2pow(Rp) - 1) # define selectivity/discrimination parameters.
    k₁ = ϵ / √(db2pow(Rs) - 1)
    k = Wa^-1
    (k^2 < 1) || throw(DomainError(k^2, "Selectivity parameter specifies too narrow of a transition width.")) # check if in-bounds (k₁ << k <~ 1)
    (1 - k₁^2 < 1) || throw(DomainError(1 - k₁^2, "Discrimination parameter specifies too deep of a stopband."))
    K = (ellipk(k^2), ellipk(1 - k^2)) # define the complementary moduli
    K₁ = (ellipk(k₁^2), ellipk(1 - k₁^2))

    # other order approach would be using (k₁'/k₁) / (k′/k).
    (K[1] * K₁[2]) / (K[2] * K₁[1])
end

function chebyshev_order_estimate(Rp::Real, Rs::Real, Wa::Real)
    # Chebyshev1/2 order estimate. Requires inverse hyperbolic cosine.
    ϵs, ϵp = db2pow(Rs) - 1, db2pow(Rp) - 1
    acosh(√(ϵs / ϵp)) / acosh(Wa) # Eq. (10.3.63) in [1]
end

function brent(f, x1::T, x2::T) where {T<:AbstractFloat}
    a, b = x1, x2
    fa, fb = f(a), f(b)
    ϵ, rtol = eps(T), √(eps(T))
    g = 1 / 2 * (3 - √(5)) # golden ratio
    k = zero(T)
    k1 = zero(T)

    # first interval calculation.
    m = muladd(g, (b - a), a)
    m1, m2 = m, m
    fm = f(m)
    fm1, fm2 = fm, fm

    for _ in 1:1000
        p, q = zero(T), zero(T)
        xt = rtol * abs(m) + ϵ
        c = (b + a) / 2
        if (abs(m - c) ≤ 2 * xt - (b - a) / 2)
            break
        end
        if (abs(k1) > xt) # trial parabolic fit
            r = (m - m1) * (fm - fm2)
            q = (m - m2) * (fm - fm1)
            p = muladd((m - m2), q, -(m - m1) * r)
            q = 2 * (q - r)
            if (q > 0)
                p = -p
            else
                q = -q
            end
        end
        if abs(p) < abs(q * k1 / 2) && (p < q * (b - m)) && (p < q * (m - a)) # parabolic step
            k1 = k
            k = p / q
            if ((m + k) < 2 * xt) || ((b - (m + k)) < 2 * xt)
                k = (m < c) ? xt : -xt
            end
        else
            k1 = (m < c) ? b - m : a - m
            k = g * k1
        end

        if (abs(k) > xt)
            xn = m + k
        else
            xn = m + ((k > 0) ? xt : -xt)
        end
        # re-assign variables for next iteration, ("Housekeeping" in [3])
        fn = f(xn)
        if (fn < fm)
            if (xn < m)
                b = m
            else
                a = m
            end
            m2 = m1
            fm2 = fm1
            m1 = m
            fm1 = fm
            m = xn
            fm = fn
        else
            if (xn < m)
                a = xn
            else
                b = xn
            end
            if (fn ≤ fm1) || (m1 == m)
                m2 = m1
                fm2 = fm1
                m1 = xn
                fm1 = fn
            elseif (fn ≤ fm2 || m2 == m || m2 == m1)
                m2 = xn
                fm2 = fn
            end
        end
    end
    m
end

#
# Bandstop cost functions and passband minimization
#
function bsfcost(est_func::F, Wx::Real, uselowband::Bool, Wp::Tuple{Real,Real}, Ws::Tuple{Real,Real}, Rp::Real, Rs::Real) where {F}
    # override one of the passband edges with the test frequency.
    Wpc = uselowband ? (Wx, Wp[2]) : (Wp[1], Wx)

    # get the new warp frequency.
    warp = min(abs.((Ws .* (Wpc[1] - Wpc[2])) ./ muladd.(-Wpc[1], Wpc[2], Ws .^ 2))...)

    # use the new frequency to determine the filter order.
    est_func(Rp, Rs, warp)
end

function bsfmin(est_func::F, Wp::Tuple{Real,Real}, Ws::Tuple{Real,Real}, Rp::Real, Rs::Real) where {F}
    @inline
    # NOTE: the optimization function will adjust the corner frequencies in Wp, returning a new passband tuple.
    Δ = eps(typeof(Wp[1]))^(2 / 3)
    C₁(w) = bsfcost(est_func, w, true, Wp, Ws, Rp, Rs)
    p1 = brent(C₁, Wp[1], Ws[1] - Δ)

    C₂(w) = bsfcost(est_func, w, false, (p1, Wp[2]), Ws, Rp, Rs)
    p2 = brent(C₂, Ws[2] + Δ, Wp[2])
    Wadj = (p1, p2)

    Wa = (Ws .* (p1 - p2)) ./ muladd.(-p1, p2, Ws .^ 2)
    min(abs.(Wa)...), Wadj
end

butterworth_bsfmin(args...) = bsfmin(butterworth_order_estimate, args...)
elliptic_bsfmin(args...) = bsfmin(elliptic_order_estimate, args...)
chebyshev_bsfmin(args...) = bsfmin(chebyshev_order_estimate, args...)

"""
    (N, ωn) = buttord(Wp::Tuple{Real,Real}, Ws::Tuple{Real,Real}, Rp::Real, Rs::Real; domain=:z)

Butterworth order estimate for bandpass and bandstop filter types. `Wp` and `Ws` are 2-element pass
and stopband frequency edges, with no more than `Rp` dB passband ripple and at least `Rs` dB stopband
attenuation. Based on the ordering of passband and bandstop edges, the Bandstop or Bandpass filter
type is inferred. `N` is an integer indicating the lowest estimated filter order, with `ωn` specifying
the cutoff or "-3 dB" frequencies.

If a domain of `:s` is specified, the passband and stopband frequencies are interpreted as radians/second,
giving an order and natural frequencies for an analog filter. The default domain is `:z`, interpreting the
input frequencies as normalized from 0 to 1, where 1 corresponds to π radians/sample.
"""
function buttord(Wp::Tuple{Real,Real}, Ws::Tuple{Real,Real}, Rp::Real, Rs::Real; domain::Symbol=:z)

    # make sure the band edges are in increasing order.
    Wps = sort_W(Wp)
    Wss = sort_W(Ws)

    # infer filter type based on ordering of edges.
    (Wps[1] < Wss[1]) != (Wps[2] > Wss[2]) && throw(ArgumentError("Pass and stopband edges must be ordered for Bandpass/Bandstop filters."))
    ftype = (Wps[1] < Wss[1]) ? Bandstop : Bandpass

    # pre-warp both components, (if Z-domain specified)
    if (domain == :z)
        Ωp = tanpi.(Wps ./ 2)
        Ωs = tanpi.(Wss ./ 2)
    else
        Ωp = Wps
        Ωs = Wss
    end

    if (ftype == Bandstop)
        # optimizer modifies passband frequencies.
        (wa, wpadj) = toprototype(Ωp, Ωs, Rp, Rs, ftype)
    else
        # no optimization in BPF case, use original warped passband edges.
        wa = toprototype(Ωp, Ωs, ftype)
        wpadj = Ωp
    end

    # get the integer order estimate.
    N = ceil(Int, butterworth_order_estimate(Rp, Rs, wa))

    wscale = butterworth_natfreq_estimate(wa, Rs, N)
    if (domain == :z)
        ωn = (2 / π) .* atan.(fromprototype(wpadj, wscale, ftype))
    else
        ωn = fromprototype(wpadj, wscale, ftype)
    end
    N, ωn
end

"""
    (N, ωn) = buttord(Wp::Real, Ws::Real, Rp::Real, Rs::Real; domain=:z)

LPF/HPF Butterworth filter order and -3 dB frequency approximation. `Wp` and `Ws` are
the passband and stopband frequencies, whereas `Rp` and `Rs` are the passband and stopband
ripple attenuations in dB. If the passband is greater than stopband, the filter type
is inferred to be for estimating the order of a highpass filter. `N` specifies the lowest
possible integer filter order, whereas `ωn` is the cutoff or "-3 dB" frequency.

If a domain of `:s` is specified, the passband and stopband edges are interpreted as
radians/second, giving an order and natural frequency result for an analog filter.
The default domain is `:z`, interpreting the input frequencies as normalized from 0 to 1,
where 1 corresponds to π radians/sample.
"""
function buttord(Wp::Real, Ws::Real, Rp::Real, Rs::Real; domain::Symbol=:z)
    # infer which filter type based on the frequency ordering.
    ftype = (Wp < Ws) ? Lowpass : Highpass

    if (domain == :z)
        # need to pre-warp since we want to use formulae for analog case.
        Ωp = tanpi(Wp / 2)
        Ωs = tanpi(Ws / 2)
    else
        # already analog
        Ωp = Wp
        Ωs = Ws
    end
    wa = toprototype(Ωp, Ωs, ftype)

    # rounding up fractional order. Using differences of logs instead of division.
    N = ceil(Int, butterworth_order_estimate(Rp, Rs, wa))

    # specifications for the stopband ripple are met precisely.
    wscale = butterworth_natfreq_estimate(wa, Rs, N)

    # convert back to the original analog filter
    if (domain == :z)
        # bilinear xform
        ωn = (2 / π) * atan(fromprototype(Ωp, wscale, ftype))
    else
        # s-domain, no atan call.
        ωn = fromprototype(Ωp, wscale, ftype)
    end
    N, ωn
end

#
# Elliptic/Chebyshev1 Estimation
#
function ordfreq_est(order_estimate, domain::Symbol, Wp::Real, Ws::Real, Rp::Real, Rs::Real)
    @inline
    ftype = (Wp < Ws) ? Lowpass : Highpass
    if (domain == :z)
        Ωp = tanpi(Wp / 2)
        Ωs = tanpi(Ws / 2)
    else
        Ωp = Wp
        Ωs = Ws
    end
    # Lowpass/Highpass prototype xform is same as Butterworth.
    wa = toprototype(Ωp, Ωs, ftype)
    N = ceil(Int, order_estimate(Rp, Rs, wa))
    if (domain == :z)
        ωn = (2 / π) * atan(Ωp)
    else
        ωn = Ωp
    end
    N, ωn
end

function ordfreq_est(order_estimate::F, domain::Symbol,
        Wp::Tuple{Real,Real}, Ws::Tuple{Real,Real}, Rp::Real, Rs::Real) where {F}
    @inline
    Wps = sort_W(Wp)
    Wss = sort_W(Ws)
    (Wps[1] < Wss[1]) != (Wps[2] > Wss[2]) && throw(ArgumentError("Pass and stopband edges must be ordered for Bandpass/Bandstop filters."))
    ftype = (Wps[1] < Wss[1]) ? Bandstop : Bandpass
    # pre-warp to analog if z-domain.
    (Ωp, Ωs) = (domain == :z) ? (tanpi.(Wps ./ 2), tanpi.(Wss ./ 2)) : (Wps, Wss)
    if (ftype == Bandpass)
        Wa = muladd.(-Ωp[1], Ωp[2], Ωs .^ 2) ./ (Ωs .* (Ωp[1] - Ωp[2]))
        Ωpadj = Ωp
    else
        (Wa, Ωpadj) = bsfmin(order_estimate, Ωp, Ωs, Rp, Rs) # check scipy.
    end
    N = ceil(Int, order_estimate(Rp, Rs, min(abs.(Wa)...)))
    ωn = (domain == :z) ? Wps : Ωpadj
    N, ωn
end

ellipord(args...; domain::Symbol=:z) = ordfreq_est(elliptic_order_estimate, domain, args...)
cheb1ord(args...; domain::Symbol=:z) = ordfreq_est(chebyshev_order_estimate, domain, args...)

for (fcn, filt) in ((:ellipord, "Elliptic (Cauer)"), (:cheb1ord, "Chebyshev Type I"))
    @eval begin
        """
            (N, ωn) = $($fcn)(Wp::Real, Ws::Real, Rp::Real, Rs::Real; domain::Symbol=:z)
            (N, ωn) = $($fcn)(Wp::Tuple{Real, Real}, Ws::Tuple{Real, Real}, Rp::Real, Rs::Real; domain::Symbol=:z)

        Integer and natural frequency order estimation for $($filt) Filters. `Wp` and `Ws`
        indicate the passband and stopband frequency edges, and `Rp` and `Rs` indicate the
        maximum loss in the passband and the minimum attenuation in the stopband, (in dB.)

        Based on the ordering of passband and stopband edges, the Lowpass or Highpass filter type is inferred.
        `N` indicates the smallest integer filter order that achieves the desired specifications,
        and `ωn` contains the natural frequency of the filter, (in this case, simply the passband edge.)\n
        If a domain of `:s` is specified, the passband and stopband edges are interpreted
        as radians/second, giving the order and natural frequencies for an analog filter.
        The default domain is `:z`, interpreting the input frequencies as normalized from 0 to 1,
        where 1 corresponds to π radians/sample.

        `Wp` and `Ws` can also be 2-element frequency edges for Bandpass/Bandstop cases.\n
        `N` is an integer indicating the lowest estimated filter order, with
        `ωn` specifying the cutoff or "-3 dB" frequencies.
        """
        $fcn
    end
end

"""
    (N, ωn) = cheb2ord(Wp::Real, Ws::Real, Rp::Real, Rs::Real; domain::Symbol=:z)

Integer and natural frequency order estimation for Chebyshev Type II (inverse) Filters. `Wp` and `Ws`
are the frequency edges for Bandpass/Bandstop cases, with `Rp` and `Rs` representing the ripple maximum
loss in the passband and minimum ripple attenuation in the stopband in dB.

Based on the ordering of the passband and stopband edges, the Lowpass or Highpass filter type is inferred.
`N` is an integer indicating the lowest estimated filter order, with `ωn` specifying the "-3 dB" cutoff frequency.

If a domain of `:s` is specified, the passband and stopband frequencies are interpreted as radians/second,
giving the order and natural frequencies for an analog filter. The default domain is `:z`, interpreting
the input frequencies as normalized from 0 to 1, where 1 corresponds to π radians/sample.
"""
function cheb2ord(Wp::Real, Ws::Real, Rp::Real, Rs::Real; domain::Symbol=:z)
    ftype = (Wp < Ws) ? Lowpass : Highpass
    (Ωp, Ωs) = (domain == :z) ? (tanpi(Wp / 2), tanpi(Ws / 2)) : (Wp, Ws)
    wa = toprototype(Ωp, Ωs, ftype)
    N = ceil(Int, chebyshev_order_estimate(Rp, Rs, wa))

    # new frequency for stopband spec.
    wnew = 1 / cosh(1 / N * acosh(√(db2pow(Rs) - 1) / √(db2pow(Rp) - 1)))
    wa = (ftype == Lowpass) ? Ωp / wnew : Ωp * wnew
    ωn = (domain == :z) ? (2 / π) * atan(wa) : wa
    N, ωn
end


"""
    (N, ωn) = cheb2ord(Wp::Tuple{Real, Real}, Ws::Tuple{Real, Real}, Rp::Real, Rs::Real; domain::Symbol=:z)

Integer and natural frequency order estimation for Chebyshev Type II (inverse) Filters. `Wp` and `Ws` are
2-element frequency edges for Bandpass/Bandstop cases, with `Rp` and `Rs` representing the ripple maximum
loss in the passband and minimum ripple attenuation in the stopband in dB.

Based on the ordering of the passband and bandstop edges, the Bandstop or Bandpass filter type is inferred.
`N` is an integer indicating the lowest estimated filter order, with `ωn` specifying the "-3 dB" cutoff frequency.

If a domain of `:s` is specified, the passband and stopband frequencies are interpreted as radians/second,
giving the order and natural frequencies for an analog filter. The default domain is `:z`, interpreting
the input frequencies as normalized from 0 to 1, where 1 corresponds to π radians/sample.
"""
function cheb2ord(Wp::Tuple{Real,Real}, Ws::Tuple{Real,Real}, Rp::Real, Rs::Real; domain::Symbol=:z)
    Wps = sort_W(Wp)
    Wss = sort_W(Ws)
    (Wps[1] < Wss[1]) != (Wps[2] > Wss[2]) && throw(ArgumentError("Pass and stopband edges must be ordered for Bandpass/Bandstop filters."))
    ftype = (Wps[1] < Wss[1]) ? Bandstop : Bandpass
    (Ωp, Ωs) = (domain == :z) ? (tanpi.(Wps ./ 2), tanpi.(Wss ./ 2)) : (Wps, Wss)
    if (ftype == Bandpass)
        prod = Ωp[1] * Ωp[2]
        diff = Ωp[1] - Ωp[2]
        Wa = muladd.(Ωs, Ωs, -prod) ./ (Ωs .* diff)
    else
        (Wa, Ωpadj) = chebyshev_bsfmin(Ωp, Ωs, Rp, Rs)
        prod = Ωpadj[1] * Ωpadj[2]
        diff = Ωpadj[1] - Ωpadj[2]
    end
    N = ceil(Int, chebyshev_order_estimate(Rp, Rs, min(abs.(Wa)...)))

    # new frequency for stopband spec.
    wnew = 1 / cosh(1 / N * acosh(√(db2pow(Rs) - 1) / √(db2pow(Rp) - 1)))

    # lowpass prototype to analog filter re-map.
    if (ftype == Bandpass)
        Wna1 = diff / (2 * wnew) + √(diff^2 / (4 * wnew^2) + prod)
    else
        Wna1 = (diff * wnew) / 2 + √(muladd(diff^2, wnew^2 / 4, prod))
    end
    Wna2 = prod / Wna1
    ωn = (domain == :z) ? ((2 / π) * atan(Wna1), (2 / π) * atan(Wna2)) : (Wna1, Wna2)
    N, ωn
end

"""
    N = remezord(Wp::Real, Ws::Real, Rp::Real, Rs::Real)

Order estimation for lowpass digital filter cases based
on the equations and coefficients in [^Rabiner]. The original
equation returned the minimum filter length, whereas this implementation
returns the order (N=L-1). `Wp` and `Ws` are the normalized passband and
stopband frequencies, with `Rp` indicating the passband ripple and `Rs` is the
stopband attenuation (linear.)

NOTE: The value of N is an initial approximation. If under-estimated, the order
should be increased until the design specifications are met.

[^Rabiner]: Herrmann, O., Lawrence R. Rabiner, and D. S. K. Chan.
    "Practical design rules for optimum finite impulse response lowpass digital filters."
    Bell System Technical Journal 52.6 (1973): 769-799.
"""
function remezord(Wp::Real, Ws::Real, Rp::Real, Rs::Real)
    (0 > Wp > 0.5) || (0 > Ws > 0.5) && throw(ArgumentError("Pass and stopband edges must be greater than DC and less than Nyquist."))
    L1, L2 = log10(Rp), log10(Rs)
    df = abs(Ws - Wp) # works in HPF case if passband/stopband edges are flipped
    A = muladd(5.309e-3, L1^2, muladd(7.114e-2, L1, -0.4761))
    B = muladd(2.66e-3, L1^2, muladd(0.5941, L1, 0.4278))
    Kf = muladd(0.51244, (L1 - L2), 11.01217)
    D = muladd(A, L2, -B)
    return ceil(Int, (muladd(-Kf, df^2, D) / df))
end

module Estimation

using LinearAlgebra: eigen, svd
using FFTW
using Statistics: mean

export esprit, jacobsen, quinn

"""
    esprit(x::AbstractArray, M::Integer, p::Integer, Fs::Real=1.0)

ESPRIT [^Roy1986] algorithm for frequency estimation.
Estimation of Signal Parameters via Rotational Invariance Techniques

Given a signal `x` of length N that is the sum of `p` complex exponentials (cisoids) with unknown constant amplitudes and phases,
estimate and return an array of the `p` frequencies.

```math
x(t)=\\sum_{i=1}^p A_ie^{j2\\pi f_i t}
```
where ``A_i`` and ``f_i`` are the amplitude and frequency of the ``i``th cisoid.

# Arguments
- `x::AbstractArray`: complex length N signal array
- `M::Integer`: size of correlation matrix, must be <= N.
      The signal subspace is computed from the SVD of an M x (N-M+1) signal matrix
      formed from N-M+1 length-M shifts of the signal x in its columns.
      For best performance for 1 cisoid, use M = (N+1)/3 (according to van der Veen and Leus).
      For faster execution (due to smaller SVD), use small M or small N-M
- `p::Integer`: number of complex exponentials/frequencies to estimate.
- `Fs::Float64`: sampling frequency, in Hz.

# Returns
length `p` real array of frequencies in units of Hz.

[^Roy1986]: R Roy, A Paulraj and T Kailath, ESPRIT -
    A subspace approach to estimation of parameters of cisoids in noise,
    IEEE Trans. Acoustics, Speech, Signal Process., 34, 1340-1342 (1986).
    <http://ieeexplore.ieee.org/abstract/document/1164935/>.

# Examples
Suppose a signal ``x(t)=2e^{j2\\pi(2500)t} + 5e^{j2\\pi(400)t}`` is corrupted by noise. The goal is
to retrieve the frequencies in the signal. Let the sampling frequency be ``8kHz``.

```@example
julia> Fs = 8000;                 # sampling frequency (Hz)
julia> true_freq = [2500 400];    # true frequencies (Hz)
julia> t = collect(1:Fs)/Fs;      # time vector
julia> x = 2exp.(1im*2π*true_freq[1]*t) + 5exp.(1im*2π*true_freq[2]*t); # original signal x
```
Add gaussian noise in complex form to the signal ``x`` to mimic noise corruption.
```@example
julia> noise = randn(Fs, 2)*[1; 1im];    # complex random noise
julia> x += noise;                       # add noise to signal x
```
Run the ESPRIT algorithm to retrieve approximate frequencies.
```@example
julia> M = 5;    # window length of 5
julia> p = 2;    # 2 frequencies to estimate
julia> esprit(x, M, p, Fs)
2-element Vector{Float64}:
2502.2704154274957
399.8420984461712
```

"""
function esprit(x::AbstractArray, M::Integer, p::Integer, Fs::Real=1.0)
    count(!isone, size(x)) <= 1 || throw(ArgumentError("`x` must be a 1D signal"))
    N = length(x)
    X = getindex.((x,), (1:M) .+ (0:N-M)')
    U, _ = svd(X)
    D, _ = eigen( U[1:end-1, 1:p] \ U[2:end, 1:p] )

    return angle.(D) .* (Fs / 2π)
end

"""
    jacobsen(x::AbstractVector, Fs::Real = 1.0)

Estimate the largest frequency in the complex signal `x` using Jacobsen's
algorithm [^Jacobsen2007]. Argument `Fs` is the sampling frequency.
All frequencies are expressed in Hz.

If the signal `x` is real, the estimated frequency is guaranteed to be
positive, but it may be highly inaccurate (especially for frequencies close to
zero or to `Fs/2`).

If the sampling frequency `Fs` is not provided, then it is assumed that `Fs = 1.0`.

[^Jacobsen2007]: E Jacobsen and P Kootsookos, "Fast, Accurate Frequency Estimators", Chapter
    10 in "Streamlining Digital Signal Processing", edited by R. Lyons, 2007, IEEE Press.
"""
function jacobsen(x::AbstractVector, Fs::Real = 1.0)
    N = length(x)
    X = fft(x)
    k = findmax(abs, X)[2]  # index of DFT peak
    fpeak = fftfreq(N, Fs)[k]  # peak frequency
    if (k == N)     # k+1 is OOB -- X[k+1] = X[1]
        Xkm1 = X[N-1]
        Xkp1 = X[1]
    elseif (k == 1) # k-1 is OOB -- X[k-1] = X[N]
        Xkp1 = X[2]
        Xkm1 = X[N]
    else
        Xkp1 = X[k+1]
        Xkm1 = X[k-1]
    end
    δ = -real( (Xkp1 - Xkm1) / (2X[k] - Xkm1 - Xkp1) )
    estimate = fpeak + δ*Fs/N
    # if signal is real, return positive frequency
    if eltype(x) <: Real
        return abs(estimate)
    end
    return estimate
end

"""
    quinn(x::Vector, f0::Real, Fs::Real = 1.0 ; tol = 1e-6, maxiters = 20)

    quinn(x::Vector, Fs::Real = 1.0 ; kwargs...)

    quinn(x::Vector ; kwargs...)

Algorithms by Quinn and Quinn & Fernandes for frequency estimation. Given a
signal `x` and an initial guess `f0`, estimate and return the frequency of the
largest sinusoid in `x`. `Fs` is the sampling frequency. All frequencies are
expressed in Hz.

If the initial guess `f0` is not provided, then a guess is calculated using
Jacobsen's estimator. If the sampling frequency `Fs` is not provided, then it
is assumed that `Fs = 1.0`.

The following keyword arguments control the algorithm's behavior:

- `tol`: the algorithm stops when the absolute value of the difference between
   two consecutive estimates is less than `tol`. Defaults to `1e-6`.
- `maxiters`: the maximum number of iterations to run. Defaults to `20`.

Returns a tuple `(estimate, reachedmaxiters)`, where `estimate` is the
estimated frequency, and `reachedmaxiters` is `true` if the algorithm finished
after running for `maxiters` iterations (this may indicate that the algorithm
did not converge).

If the signal `x` is real, then the algorithm used is [^Quinn1991]. If the signal is
complex, the algorithm is [^Quinn2009].

[^Quinn1991]: B Quinn and J Fernandes, "A fast efficient technique for the
    estimation of frequency", Biometrika, Vol. 78 (1991).

[^Quinn2009]: B Quinn, "Recent advances in rapid frequency estimation", Digital
    Signal Processing, Vol. 19 (2009), Elsevier.
"""
quinn(x; kwargs...) = quinn(x, jacobsen(x, 1.0), 1.0; kwargs...)

quinn(x, Fs; kwargs...) = quinn(x, jacobsen(x, Fs), Fs; kwargs...)

function quinn(x::Vector{<:Real}, f0::Real, Fs::Real; tol=1e-6, maxiters::Integer=20)
    fₙ = Fs / 2

    # Run a quick estimate of largest sinusoid in x
    ω̂ = π * f0 / fₙ

    # remove DC
    x = x .- mean(x)
    N = length(x)

    # Initialize algorithm
    α = 2cos(ω̂)
    β = zero(eltype(x))
    ξ = zeros(eltype(x), N)
    ξ[1] = x[1]

    # iteration
    iter = 0
    for outer iter = 1:maxiters
        ξ[2] = muladd(α, ξ[1], x[2])
        β = ξ[2] / ξ[1]
        for t in 3:N
            ξ[t] = x[t] + muladd(α, ξ[t-1], -ξ[t-2])
            β = muladd(ξ[t] + ξ[t-2], ξ[t-1], β)
        end
        β /= sum(abs2, @view ξ[1:end-1])
        abs(α - β) < tol && break
        α = 2β - α
    end

    fₙ * acos(0.5 * β) / π, iter == maxiters
end

function quinn(x::Vector{<:Complex}, f0::Real, Fs::Real; tol=1e-6, maxiters::Integer=20)
    fₙ = Fs / 2

    ω̂ = π * f0 / fₙ

    # Remove any DC term in s
    x = x .- mean(x)

    N = length(x)
    ξ = zeros(eltype(x), N)
    ξ[1] = x[1]

    # iteration
    iter = 0
    for outer iter = 1:maxiters
        S = zero(eltype(x))
        cisω̂ = cis(ω̂)
        for t in 2:N
            ξ[t] = x[t] + cisω̂ * ξ[t-1] # step 2
            S += x[t] * conj(ξ[t-1])    # step 3
        end
        num = imag(S * conj(cisω̂))
        den = sum(abs2, @view ξ[1:end-1])
        ω̂ += 2 * num / den

        # stop condition
        (abs(2 * num / den) < tol) && break
    end

    fₙ * ω̂ / π, iter == maxiters
end

end # end module definition

using DSP, Test


Δ = 1e-3
@testset "buttord" begin

    #
    # https://www.mathworks.com/help/signal/ref/buttord.html#d123e9937
    # Example 1: Lowpass Butterworth Example
    #
    # Wp = 40/500;
    # Ws = 150/500;
    # [n, Wn] = buttord(Wp, Ws, 3, 60)
    #

    # z-domain test
    (n, Wn) = buttord(40 / 500, 150 / 500, 3, 60, domain=:z)
    @test n == 5
    @test Wn ≈ 0.081038494957764

    # s-domain test
    (ns, Wns) = buttord(40 / 500, 150 / 500, 3, 60, domain=:s)
    @test ns == 6
    @test Wns ≈ 0.0948683377107

    #
    # Highpass filter example
    # Wp = 1200/2000; Ws=600/2000;
    # Rs = 3; Rp = 60;

    # z-domain (default)
    (nhpf, Wnhpf) = buttord(1200 / 2000, 600 / 2000, 3, 60, domain=:z)
    @test nhpf == 7
    @test Wnhpf ≈ 0.597905417809


    # s-domain test
    (nhpfs, Wnhpfs) = buttord(1200 / 2000, 600 / 2000, 3, 60, domain=:s)
    @test nhpfs == 10
    @test Wnhpfs ≈ 0.598578664562

    #
    # https://www.mathworks.com/help/signal/ref/buttord.html#d123e9937
    # Example 2: Bandpass Butterworth Example
    #
    # Wp = [100 200]/500;
    # Ws = [50 250]/500;
    # Rp = 3;
    # Rs = 40;
    # [n, Wn] = buttord(Wp, Ws, Rp, Rs)
    #

    (nbp, Wnbp) = buttord((100 / 500, 200 / 500), (50 / 500, 250 / 500), 3, 40, domain=:z)
    @test nbp == 8
    @test Wnbp[1] ≈ 0.195101359239
    @test Wnbp[2] ≈ 0.408043633382

    # s-domain
    (nbps, Wnbps) = buttord((100 / 500, 200 / 500), (50 / 500, 250 / 500), 3, 40, domain=:s)
    @test nbps == 9
    @test Wnbps[1] ≈ 0.198730150231
    @test Wnbps[2] ≈ 0.402555927759

    #
    # Bandstop Example, (44.1 kHz Nyquist)
    # Wp = [3200 7800]/22050
    # Ws = [4800 5600]/22050
    # Rp = 2
    # Rs = 60

    # this test may be more sensitive...MATLAB's implementation of bounded minimization
    # will yield different results in comparison to Optim.jl.
    (nbs, Wnbs) = buttord((3200 / 22050, 7800 / 22050), (4800 / 22050, 5600 / 22050), 2, 60, domain=:z)
    @test nbs == 5
    @test ≈(Wnbs[1], 0.172660908966, rtol=Δ)
    @test ≈(Wnbs[2], 0.314956388749, rtol=Δ)

    # s-domain
    (nbss, Wnbss) = buttord((3200 / 22050, 7800 / 22050), (4800 / 22050, 5600 / 22050), 2, 60, domain=:s)
    @test ≈(Wnbss[1], 0.173677826752, rtol=Δ)
    @test ≈(Wnbss[2], 0.318267164272, rtol=Δ)

end

#
# Elliptic/Chebyshev I/II Filter cases tested against SciPy signal results.
#
@testset "ellipord" begin

    Rp, Rs = 3, 40
    Wp = (0.2, 0.7)
    Ws = (0.1, 0.8)

    # Lowpass
    (nl, Wnl) = ellipord(0.1, 0.2, Rp, Rs, domain=:z)
    @test nl == 3
    @test Wnl == 0.1

    # Highpass
    (nh, Wnh) = ellipord(0.3, 0.1, Rp, Rs, domain=:z)
    @test nh == 3
    @test Wnh == 0.3

    # Bandpass (z-domain)
    (nbp, Wnbp) = ellipord(Wp, Ws, Rp, Rs, domain=:z)
    @test nbp == 4
    @test Wnbp == Wp

    # Bandpass (s-domain)
    (nbp, Wnbp) = ellipord(Wp, Ws, Rp, Rs, domain=:s)
    @test nbp == 5
    @test Wnbp == Wp

    # Bandstop (z-domain)
    (nbs, Wnbs) = ellipord(Ws, Wp, Rp, Rs, domain=:z)
    @test nbs == 4
    @test Wnbs == Ws

    # Bandstop (s-domain)
    # n, Wn = scipy.signal.ellipord([0.1, 0.8], [0.2, 0.7], 3, 40, True)
    (nbs, Wnbs) = ellipord(Ws, Wp, Rp, Rs, domain=:s)
    @test nbs == 5
    @test ≈(Wnbs[1], 0.17500000332788998, rtol=Δ)
    @test ≈(Wnbs[2], 0.799993389303865, rtol=Δ)

end

@testset "cheb1ord" begin
    Rp, Rs = 2, 70
    Wp = (0.2, 0.5)
    Ws = (0.1, 0.6)

    # Lowpass
    (nl, Wnl) = cheb1ord(0.1, 0.21, Rp, Rs, domain=:z)
    @test nl == 7
    @test Wnl == 0.1

    # Highpass
    (nh, Wnh) = cheb1ord(0.1, 0.04, Rp, Rs, domain=:z)
    @test nh == 6
    @test Wnh == 0.1

    # Bandpass (z-domain)
    (nbp, Wnbp) = cheb1ord(Wp, Ws, Rp, Rs, domain=:z)
    @test nbp == 9
    @test Wnbp == (0.2, 0.5)


    # Bandpass (s-domain)
    (nbp, Wnbp) = cheb1ord(Wp, Ws, Rp, Rs, domain=:s)
    @test nbp == 10
    @test Wnbp == (0.2, 0.5)

    # Bandstop (z-domain)
    (nbs, Wnbs) = cheb1ord(Ws, Wp, Rp, Rs, domain=:z)
    @test nbs == 9
    @test Wnbs == Ws

    # Bandstop (s-domain)
    (nbs, Wnbs) = cheb1ord(Ws, Wp, Rp, Rs, domain=:s)
    @test nbs == 10
    @test ≈(Wnbs[1], 0.166666612185443, rtol=Δ)
    @test ≈(Wnbs[2], 0.5999933893038649, rtol=Δ)
end

@testset "cheb2ord" begin
    Rp, Rs = 1.2, 80
    Wp = (0.22, 0.51)
    Ws = (0.14, 0.63)

    # Lowpass
    (nl, Wnl) = cheb2ord(0.1, 0.21, Rp, Rs, domain=:z)
    @test nl == 8
    @test Wnl == 0.19411478246577737
    (nl, Wnl) = cheb2ord(0.1, 0.21, Rp, Rs, domain=:s)
    @test nl == 8
    @test Wnl == 0.1987124302811051

    # Highpass
    (nh, Wnh) = cheb2ord(0.21, 0.1, Rp, Rs, domain=:z)
    @test nh == 8
    @test Wnh == 0.10862150541420544
    (nh, Wnh) = cheb2ord(0.21, 0.1, Rp, Rs, domain=:s)
    @test nh == 8
    @test Wnh == 0.10568035411923006

    # Bandpass
    (nbp, Wnbp) = cheb2ord(Wp, Ws, Rp, Rs, domain=:z)
    @test nbp == 9
    @test ≈(Wnbp[1], 0.1608459041132262)
    @test ≈(Wnbp[2], 0.6133747025904719)
    (nbp, Wnbp) = cheb2ord(Wp, Ws, Rp, Rs, domain=:s)
    @test nbp == 11
    @test ≈(Wnbp[1], 0.18262279523940905)
    @test ≈(Wnbp[2], 0.6143811338169016)

    # Bandstop
    (nbs, Wnbs) = cheb2ord(Ws, Wp, Rp, Rs, domain=:z)
    @test nbs == 9
    @test ≈(Wnbs[1], 0.21211425852327126, rtol=Δ)
    @test ≈(Wnbs[2], 0.5225427194473862, rtol=Δ)
    (nbs, Wnbs) = cheb2ord(Ws, Wp, Rp, Rs, domain=:s)
    @test nbs == 11
    @test ≈(Wnbs[1], 0.2159740591083134, rtol=Δ)
    @test ≈(Wnbs[2], 0.5195028184932494, rtol=Δ)

end

# using some simple examples for testing Brent's method.
@testset "brent" begin
    f1(x) = (x + 3) * ((x - 1)^2) # x³ + x² - 5x + 3
    @test ≈(f1(DSP.Filters.brent(f1, -4.0, 4.0)), 0.0, atol=1e-8)
    @test ≈(sin(DSP.Filters.brent(sin, 0.0, 2pi)), -1.0, atol=1e-8)
    @test ≈(cos(DSP.Filters.brent(cos, 0.0, 2pi)), -1.0, atol=1e-8)
end


@testset "remezord" begin
    #
    # Using the test-cases highlighted in [^Parks] Figures 8 and 15.
    #
    # [^Parks]: Rabiner, L. R., McClellan, J. H., & Parks, T. W. (1975).
    #   FIR digital filter design techniques using weighted Chebyshev
    #   approximation. Proceedings of the IEEE, 63(4), 595-610.
    #
    @test remezord(0.41665, 0.49417, 0.0116, 0.0001) == 39
    @test remezord(0.135, 0.203, 0.1, 0.1) == 10
    @test remezord(0.203, 0.135, 0.1, 0.1) == 10 # flipped HPF case.
    @test remezord(0.00963, 0.13271, 0.0116, 0.0001) == 24
end

export diric

"""
    kernel = diric(Ω::Real, n::Integer)

Dirichlet kernel, also known as periodic sinc function,
where `n` should be a positive integer.

Typically returns ``\\frac{\\sin(Ω \\cdot n/2)}{n * \\sin(Ω / 2)}``,
but returns ``±1`` when `Ω` is a multiple of 2π.

In the usual case where `n` is odd, the output is equivalent to
``\\frac{1}{n} \\sum_{k=-(n-1)/2}^{(n-1)/2} e^{i k Ω}``,
which is the discrete-time Fourier transform (DTFT)
of a `n`-point moving average filter.

When `n` is odd or even, the function is 2π or 4π periodic, respectively.
The formula for general `n` is
```math
\\mathrm{diric}(Ω,n) = \\frac{e^{-i (n-1) Ω/2}}{n} \\sum_{k=0}^{n-1} e^{i k Ω}
```
which is a real and symmetric function of `Ω`.

As of 2021-03-19, the Wikipedia definition has different factors.
The definition here is consistent with scipy and other software frameworks.

# Examples

```jldoctest
julia> round.(diric.((-2:0.5:2)*π, 5), digits=9)'
1×9 adjoint(::Vector{Float64}) with eltype Float64:
 1.0  -0.2  0.2  -0.2  1.0  -0.2  0.2  -0.2  1.0

julia> diric(0, 4)
1.0
```
"""
function diric(Ω::T, n::Integer) where T <: AbstractFloat
    n > 0 || throw(DomainError(n, "n not positive"))
    sign = one(T)
    if isodd(n)
        Ω = rem2pi(Ω, RoundNearest) # [-π,π)
    else # wrap to interval [-π,π) to improve precision near ±2π
        Ω = 2 * rem2pi(Ω/2, RoundNearest) # [-2π,2π)
        if Ω > π # [π,2π)
            sign = -one(T)
            Ω -= T(2π) # [-π,0)
        elseif Ω < -π # [-2π,-π)
            sign = -one(T)
            Ω += T(2π) # [0,π)
        end
    end

    denom = sin(Ω / 2)
    atol = eps(T)
    if abs(denom) ≤ atol # denom ≈ 0 ?
        return sign
    end

    return sign * sin(Ω * n/2) / (n * denom) # typical case
end

# handle non AbstractFloat types (e.g., Int, Rational, π)
diric(Ω::Real, n::Integer) = diric(float(Ω), n)

module Util
using ..DSP: xcorr
import Base: *
using LinearAlgebra: mul!, BLAS
using FFTW
using Statistics: mean

export  hilbert,
        fftintype,
        fftouttype,
        fftabs2type,
        nextfastfft,
        dB,
        dBa,
        pow2db,
        amp2db,
        db2pow,
        db2amp,
        rms,
        rmsfft,
        meanfreq,
        unsafe_dot,
        shiftin!,
        finddelay,
        shiftsignal,
        shiftsignal!,
        alignsignals,
        alignsignals!


function hilbert(x::StridedVector{T}) where T<:FFTW.fftwReal
# Return the Hilbert transform of x (a real signal).
# Code inspired by Scipy's implementation, which is under BSD license.
    N = length(x)
    X = zeros(Complex{T}, N)
    p = plan_rfft(x)
    mul!(view(X, 1:(N >> 1)+1), p, x)
    for i = 2:N÷2+isodd(N)
        @inbounds X[i] *= 2.0
    end
    return ifft!(X)
end
hilbert(x::AbstractVector{T}) where {T<:Real} = hilbert(convert(Vector{fftintype(T)}, x))

"""
    hilbert(x)

Computes the analytic representation of x, ``x_a = x + j
\\hat{x}``, where ``\\hat{x}`` is the Hilbert transform of x,
along the first dimension of x.
"""
function hilbert(x::AbstractArray{T}) where T<:Real
    N = size(x, 1)
    xc = Vector{fftintype(T)}(undef, N)
    X = Vector{fftouttype(T)}(undef, N)
    out = similar(x, fftouttype(T))

    p1 = plan_rfft(xc)
    p2 = plan_bfft!(X)
    Xsub = view(X, 1:(N >> 1)+1)
    Xm = view(X, 2:N÷2+isodd(N))
    Xtail = view(X, (N >> 1)+2:N)

    normalization = 1/N
    for off = 0:N:N*(Base.trailingsize(x, 2) - 1)
        copyto!(xc, 1, x, 1 + off, N)

        # fft
        fill!(Xtail, 0)
        mul!(Xsub, p1, xc)

        # scale real part
        for i in eachindex(Xm)
            @inbounds Xm[i] *= 2
        end

        # ifft
        mul!(X, p2, X)

        # scale and copy to output
        @simd for j = 1:N
            @inbounds out[off+j] = X[j] * normalization
        end
    end

    out
end

## FFT TYPES

# Get the input element type of FFT for a given type
fftintype(::Type{T}) where {T<:FFTW.fftwNumber} = T
fftintype(::Type{T}) where {T<:Real} = Float64
fftintype(::Type{T}) where {T<:Complex} = ComplexF64

# Get the return element type of FFT for a given type
fftouttype(::Type{T}) where {T<:FFTW.fftwComplex} = T
fftouttype(::Type{T}) where {T<:FFTW.fftwReal} = Complex{T}
fftouttype(::Type{T}) where {T<:Union{Real,Complex}} = ComplexF64

# Get the real part of the return element type of FFT for a given type
fftabs2type(::Type{Complex{T}}) where {T<:FFTW.fftwReal} = T
fftabs2type(::Type{T}) where {T<:FFTW.fftwReal} = T
fftabs2type(::Type{T}) where {T<:Union{Real,Complex}} = Float64

# Get next fast FFT size for a given signal length
const FAST_FFT_SIZES = (2, 3, 5, 7)

"""
    nextfastfft(n::Integer)
    nextfastfft(ns::Tuple)

Return an estimate for the padded size of an array that
is optimal for the performance of an n-dimensional FFT.

For `Tuple` inputs, this returns a `Tuple` that is the size
of the padded array.

For `Integer` inputs, this returns the closest product of 2, 3, 5, and 7
greater than or equal to `n`.
FFTW contains optimized kernels for these sizes and computes
Fourier transforms of inputs that are a product of these
sizes faster than for inputs of other sizes.

!!! warning

    Currently, `nextfastfft(ns::Tuple)` is implemented as
    `nextfastfft.(ns)`. This may change in future releases if
    a better estimation model is found.

    It is recommended to use `nextfastfft.(ns)` to obtain
    a tuple of padded lengths for 1D FFTs.
"""
nextfastfft(n::Integer) = nextprod(FAST_FFT_SIZES, n)
nextfastfft(ns::Tuple{Vararg{Integer}}) = nextfastfft.(ns)


## COMMON DSP TOOLS

struct dBconvert end
struct dBaconvert end
const dB = dBconvert()
const dBa = dBaconvert()
# for using e.g. 3dB or -3dBa
*(a::Real, ::dBconvert) = db2pow(a)
*(a::Real, ::dBaconvert) = db2amp(a)

"""
    db2pow(a)

Convert dB to a power ratio. This function call also be called
using `a*dB`, i.e. `3dB == db2pow(3)`. The inverse of `pow2db`.
"""
db2pow(a::Real) = exp10(a/10)

"""
    db2amp(a)

Convert dB to an amplitude ratio. This function call also be called
using `a*dBa`, i.e. `3dBa == db2amp(3)`. The inverse of `amp2db`.
"""
db2amp(a::Real) = exp10(a/20)

"""
    pow2db(a)

Convert a power ratio to dB (decibel), or ``10\\log_{10}(a)``.
The inverse of `db2pow`.
"""
pow2db(a::Real) = 10*log10(a)

"""
    amp2db(a)

Convert an amplitude ratio to dB (decibel), or ``20
\\log_{10}(a)=10\\log_{10}(a^2)``. The inverse of `db2amp`.
"""
amp2db(a::Real) = 20*log10(a)

"""
    rms(s; dims)

Return the root mean square (rms) of signal `s`. Optional keyword parameter
`dims` can be used to specify the dimensions along which to compute the rms.
"""
function rms(s::AbstractArray{T}; dims=:) where {T<:Number}
    if dims === (:)
        return sqrt(mean(abs2, s))
    else
        return sqrt.(mean(abs2, s; dims))
    end
end

"""
    rmsfft(f)

Return the root mean square of signal `s` given the FFT transform
`f = fft(s)`. Equivalent to `rms(ifft(f))`.
"""
rmsfft(f::AbstractArray{T}) where {T<:Complex} = sqrt(sum(abs2, f))/length(f)

"""
    meanfreq(x, fs)

Calculate the mean power frequency of `x` with a sampling frequency of `fs`, defined as:
```math
MPF = \\frac{\\sum_{i=1}^{F} f_i X_i^2 }{\\sum_{i=0}^{F} X_i^2 } Hz
```
where ``F`` is the Nyquist frequency, and ``X`` is the power spectral density.
"""
function meanfreq(x::AbstractVector{<:Real}, fs=2*π)
    pxx = abs2.(rfft(x))

    len = length(x)
    npoints = fld(len,2)
    freqrg = fs/len.*(0:(npoints))

    mf = sum(pxx.*freqrg)./sum(pxx)
    return mf
end

# Computes the dot product of a single column of a, specified by aColumnIdx, with the vector b.
# The number of elements used in the dot product determined by the size(A)[1].
# Note: bIdx is the last element of b used in the dot product.
function unsafe_dot(a::AbstractMatrix{T}, aColIdx::Integer, b::AbstractVector{V}, bLastIdx::Integer) where {T,V}
    @inline     # generally good for performance
    aLen     = size(a, 1)
    bBaseIdx = bLastIdx - aLen
    dotprod  = zero(promote_type(T, V))
    @simd for i in 1:aLen
        @inbounds dotprod += a[i, aColIdx] * b[bBaseIdx + i]
    end

    return dotprod
end

@inline function unsafe_dot(a::Matrix{T}, aColIdx::Integer, b::Vector{T}, bLastIdx::Integer) where T<:BLAS.BlasReal
    GC.@preserve a b begin
        pa = pointer(a, size(a, 1)*(aColIdx-1) + 1)
        pb = pointer(b, bLastIdx - size(a, 1)  + 1)
        BLAS.dot(size(a, 1), pa, 1, pb, 1)
    end
end

# cold path for FIR(Standard/Decimator) - b is usually history
function unsafe_dot(
    a::AbstractMatrix{T}, aColIdx::Integer,
    b::AbstractVector{V},
    c::AbstractVector{V}, cLastIdx::Integer
) where {T,V}
    aLen = size(a, 1)
    bLen = length(b)
    bLen == aLen-1  || throw(ArgumentError("length(b) must equal size(a, 1) - 1"))
    cLastIdx < aLen || throw(DomainError(cLastIdx, "cLastIdx must be < length(a)"))

    dotprod = zero(promote_type(T, V))
    @simd for i in 1:aLen-cLastIdx
        @inbounds dotprod += a[i, aColIdx] * b[i+cLastIdx-1]
    end
    @simd for i in 1:cLastIdx
        @inbounds dotprod += a[aLen-cLastIdx+i, aColIdx] * c[i]
    end

    return dotprod
end

function unsafe_dot(a::AbstractVector{T}, b::AbstractArray{V}, bLastIdx::Integer) where {T,V}
    @inline     # normally inlines anyway, but just in case
    aLen     = length(a)
    bBaseIdx = bLastIdx - aLen
    dotprod  = zero(promote_type(T, V))
    @simd for i in 1:aLen
        @inbounds dotprod += a[i] * b[bBaseIdx + i]
    end

    return dotprod
end

@inline function unsafe_dot(a::Vector{T}, b::Array{T}, bLastIdx::Integer) where T<:BLAS.BlasReal
    GC.@preserve a b BLAS.dot(length(a), pointer(a), 1, pointer(b, bLastIdx - length(a) + 1), 1)
end

# cold path for FIR(Interpolator/Rational/Arbitrary) - b is usually history
function unsafe_dot(a::AbstractVector{T}, b::AbstractVector{V}, c::AbstractVector{V}, cLastIdx::Integer) where {T,V}
    aLen    = length(a)
    dotprod = zero(promote_type(T, V))
    @simd for i in 1:aLen-cLastIdx
        @inbounds dotprod += a[i] * b[i+cLastIdx-1]
    end
    @simd for i in 1:cLastIdx
        @inbounds dotprod += a[aLen-cLastIdx+i] * c[i]
    end

    return dotprod
end

"""
    shiftin!(a::AbstractVector{T}, b::AbstractVector{T}) where T

Shifts `b` into the end of `a`.

```jldoctest
julia> shiftin!([1,2,3,4], [5, 6])
4-element Vector{Int64}:
 3
 4
 5
 6
```
"""
function shiftin!(a::AbstractVector{T}, b::AbstractVector{T}) where T
    @noinline
    aLen = length(a)
    bLen = length(b)
    fi_a = firstindex(a)
    fi_b = firstindex(b)
    copy_fn! = (a isa Vector && b isa Vector) ? unsafe_copyto! : copyto!

    if bLen >= aLen
        copy_fn!(a, fi_a, b, fi_b + bLen - aLen, aLen)
    else
        copy_fn!(a, fi_a, a, fi_a + bLen, aLen - bLen)
        copy_fn!(a, fi_a + aLen - bLen, b, fi_b, bLen)
    end

    return a
end

# DELAY FINDING UTILITIES

"""
    finddelay(x, y)

Estimate the delay of x with respect to y by locating the peak of their
cross-correlation.

The output delay will be positive when x is delayed with respect y, negative if
advanced, 0 otherwise.

# Example
```jldoctest
julia> finddelay([0, 0, 1, 2, 3], [1, 2, 3])
2

julia> finddelay([1, 2, 3], [0, 0, 1, 2, 3])
-2
```
"""
function finddelay(x::AbstractVector{<: Real}, y::AbstractVector{<: Real})
    s = xcorr(y, x, padmode=:none)
    max_corr = maximum(abs, s)
    max_idxs = findall(x -> abs(x) == max_corr, s)

    center_idx = length(x)
    # Delay is position of peak cross-correlation relative to center.
    # If the maximum cross-correlation is not unique, use the position
    # closest to the center.
    d_ind = argmin(abs.(center_idx .- max_idxs))
    d = center_idx - max_idxs[d_ind]
end

"""
    shiftsignal!(x, s)

Mutating version of shiftsignals(): shift x of s samples and fill the spaces
with zeros in-place.

See also [`shiftsignal`](@ref).
"""
function shiftsignal!(x::AbstractVector, s::Integer)
    l = length(x)
    if abs(s) > l
        throw(DomainError(s, "The absolute value of s must not be greater than the length of x"))
    end
    if s > 0
        x[s + 1:l] = x[1:l - s]
        x[1:s] .= 0
    elseif s < 0
        x[1:l + s] = x[1 - s:l]
        x[l + s + 1:l] .= 0
    end
    x
end

"""
    shiftsignal(x, s)

Shift elements of signal x in time by a given amount s of samples and fill
the spaces with zeros. For circular shifting, use circshift.

# Example
```jldoctest
julia> shiftsignal([1, 2, 3], 2)
3-element Vector{Int64}:
 0
 0
 1

julia> shiftsignal([1, 2, 3], -2)
3-element Vector{Int64}:
 3
 0
 0
```

See also [`shiftsignal!`](@ref).
"""
shiftsignal(x::AbstractVector, s::Integer) = shiftsignal!(copy(x), s)

"""
    alignsignals!(x, y)

Mutating version of alignsignals(): time align x to y in-place.

See also [`alignsignals`](@ref).
"""
function alignsignals!(x, y)
    d = finddelay(x, y)
    x = shiftsignal!(x, -d)
    x, d
end

"""
    alignsignals(x, y)

Use finddelay() and shiftsignal() to time align x to y. Also return the delay
of x with respect to y.

# Example
```jldoctest
julia> alignsignals([0, 0, 1, 2, 3], [1, 2, 3])
([1, 2, 3, 0, 0], 2)

julia> alignsignals([1, 2, 3], [0, 0, 1, 2, 3])
([0, 0, 1], -2)
```

See also [`alignsignals!`](@ref).
"""
alignsignals(x, y) = alignsignals!(copy(x), y)

end # end module definition

using DSP, Test
using Polynomials: Polynomial

!(@__DIR__() in LOAD_PATH) && push!(LOAD_PATH, @__DIR__)
using FilterTestHelpers: read_reference_data

#######################################
#
#  http://www.mathworks.com.au/help/signal/ref/freqz.html
#  Example 1: Frequency response from transfer function
#
#  dlmwrite('freqz-eg1.txt',[w, abs(h)], 'delimiter', '\t', 'precision', '%.12f')
#
#######################################
@testset "freqresp from TF" begin
    # Matlab
    freqz_eg1_w_abs = read_reference_data("freqz-eg1.txt")
    matlab_abs = freqz_eg1_w_abs[:, 2]

    # Julia
    b0 = 0.05634
    b1 = [1,  1]
    b2 = [1, -1.0166, 1]
    a1 = [1, -0.683]
    a2 = [1, -1.4461, 0.7957]
    b = b0*conv(b1, b2)
    a = conv(a1, a2)

    w     = range(0, stop=6.280045284537, length=2001)
    h     = freqresp(PolynomialRatio(b, a), w)
    h_abs = convert(Array{Float64}, abs.(h))
    h_ref = [b0 * Polynomial(b1)(z) * Polynomial(b2)(z) / (Polynomial(a1)(z) * Polynomial(a2)(z)) for z ∈ exp.(-im*w)]

    # Test
    @test h_abs ≈ matlab_abs
    @test h ≈ h_ref
end

#######################################
#
# freqresp with conversion to PolynomialRatio may lead to undesirable roundoff errors
# check by using the same poles and zeros such that they should cancel
#
#######################################
@testset "freqresp pole/zero cancellation" begin
    rs = [1-10.0^-n for n in 1:15]
    @test freqresp(ZeroPoleGain(rs, reverse(rs), 42.0), range(0, stop=2π, length=50)) ≈ fill(42., 50)

    biq = Biquad(42.0, 84.0*real(.999999*exp(im)), 42.0*.999999^2, 2.0*real(.999999*exp(im)), .999999^2)
    @test freqresp(biq, range(0, stop=2π, length=50)) ≈ fill(42.0, 50)

    pr = [1-10.0^-n for n in 1:10]
    zr = reverse(pr)
    bs = [Biquad(42.0, 84.0*real(r[1]*exp(im)), 42.0*r[1]^2, 2.0*real(r[2]*exp(im)), r[2]^2) for r in zip(zr, pr)]
    sos = SecondOrderSections(bs, 42.0^-9)
    @test freqresp(sos, range(0, stop=2π, length=50)) ≈ fill(42.0, 50)

    @test freqresp(ZeroPoleGain(ComplexF64[], ComplexF64[], 42.0), range(0, stop=2π, length=50)) == fill(42.0, 50)
    @test freqresp(SecondOrderSections(Biquad{:z,Float64}[], 42.0), range(0, stop=2π, length=50)) == fill(42.0, 50)
end

#######################################
#
#  Test frequency, phase, impulse and step response
#
#  Data from Matlab using b,a and a from above:
#  ir = impz(b,a, 512);
#  stepr = stepz(b,a, 512);
#  h = abs(freqz(b,a));
#  [phi,f] =  phasez(b, a);
#  all = [f, ir, stepr, h, phi];
#  dlmwrite('responses-eg1.txt',all, 'delimiter', '\t', 'precision', '%.12f')
#
#######################################
@testset "impresp, stepresp, freqresp, phaseresp" begin
    Hdelay = PolynomialRatio{:z}([0, 1], [1])
    W = range(0, stop=2π, length=100)
    for Tf in (PolynomialRatio, ZeroPoleGain, Biquad, SecondOrderSections)
        H = convert(Tf, Hdelay)
        @test freqresp(H, W) ≈ exp.(-W*im)
        @test phaseresp(H, W) ≈ -W
        @test grpdelay(H, W) ≈ fill(1.0, length(W))
        @test impresp(H, 10) == [0, 1, 0, 0, 0, 0, 0, 0, 0, 0]
        @test stepresp(H, 10) == [0, 1, 1, 1, 1, 1, 1, 1, 1, 1]
    end

    matlab_resp = read_reference_data("responses-eg1.txt")
    b0 = 0.05634
    b1 = [1,  1]
    b2 = [1, -1.0166, 1]
    a1 = [1, -0.683]
    a2 = [1, -1.4461, 0.7957]
    b = b0*conv(b1, b2)
    a = conv(a1, a2)
    df = PolynomialRatio(b, a)
    w = matlab_resp[:,1]

    #Impulse response
    impz_matlab = matlab_resp[:,2]
    @test impresp(df, 512) ≈ impz_matlab

    #Step response
    stepz_matlab = matlab_resp[:,3]
    @test stepresp(df, 512) ≈ stepz_matlab

    h_matlab = matlab_resp[:,4]
    @test abs.(freqresp(df, w)) ≈ h_matlab
    @test abs.(freqresp(SecondOrderSections(df), w)) ≈ h_matlab
    @test abs.(freqresp(ZeroPoleGain(df), w)) ≈ h_matlab

    phi_matlab = matlab_resp[:,5]
    @test phaseresp(df, w) ≈ phi_matlab


    # Test diffent versions of the functions
    H, w = freqresp(df)
    @test H == freqresp(df, w)
    @test minimum(w) ≤ 0                 # w should cover frequencies from 0 ...
    @test maximum(w) ≥ float(π)          # ... to π ...
    @test maximum(abs.(diff(w))) < 0.03  # and be sufficiently dense

    phi, w = phaseresp(df)
    @test phi == phaseresp(df, w)
    @test minimum(w) ≤ 0                 # w should cover frequencies from 0 ...
    @test maximum(w) ≥ float(π)          # ... to π ...
    @test maximum(abs.(diff(w))) < 0.03  # and be sufficiently dense

    @test cumsum(impresp(df)) ≈ stepresp(df)
end

#######################################
#
#  http://www.mathworks.com.au/help/signal/ref/freqs.html
#  Example 1: Frequency response from the transfer function
#
#  dlmwrite('freqs-eg1.txt',[w; mag; phasedeg]', 'delimiter', '\t', 'precision', '%.10f')
#
#######################################
@testset "freqresp(::FilterCoefficients{:s})" begin
    w = 10 .^ range(-1, stop=1, length=50)
    for (b, a, H) in (
            ([1, 0], [1], w*im), # s
            ([1], [1, 0], 1 ./ (w*im)), # 1/s
            ([0, 0, 1], [2, 10], 1 ./ (2*w*im .+ 10)), # 1/(2s + 10)
            ([1, 0, 1], [2, 10], (1 .- w.^2) ./ (2*w*im .+ 10)), # (s^2 + 1)/(2s + 10)
        )
        @test freqresp(PolynomialRatio{:s}(b, a), w) ≈ H
        @test freqresp(ZeroPoleGain(PolynomialRatio{:s}(b, a)), w) ≈ H
        if isone(a[1]) && lastindex(Polynomial(reverse(b))) <= lastindex(Polynomial(reverse(a)))
            @test freqresp(Biquad(PolynomialRatio{:s}(b, a)), w) ≈ H
        else
            # cannot represent this PolynomialRatio as a Biquad due to implied a0=1
            @test_broken freqresp(Biquad(PolynomialRatio{:s}(b, a)), w) ≈ H
        end
        if lastindex(Polynomial(reverse(b))) <= lastindex(Polynomial(reverse(a)))
            @test freqresp(SecondOrderSections(PolynomialRatio{:s}(b, a)), w) ≈ H
        else
            # cannot represent this PolynomialRatio as a Biquad due to implied a0=1
            @test_broken freqresp(SecondOrderSections(PolynomialRatio{:s}(b, a)), w) ≈ H
        end
    end

    # Julia
    a = [1.0, 0.4, 1.0]
    b = [0.2, 0.3, 1.0]
    w = 10 .^ range(-1, stop=1, length=50)

    h        = freqresp(PolynomialRatio{:s}(b, a), w)
    mag      = convert(Array{Float64}, abs.(h))
    phasedeg = (180/pi)*phaseresp(PolynomialRatio{:s}(b, a), w)

    # Matlab
    freqs_eg1_w_mag_phasedeg = read_reference_data("freqs-eg1.txt")
    matlab_w        = freqs_eg1_w_mag_phasedeg[:,1]
    matlab_mag      = freqs_eg1_w_mag_phasedeg[:,2]
    matlab_phasedeg = freqs_eg1_w_mag_phasedeg[:,3]
    h_ref = [Polynomial(reverse(b))(s) / Polynomial(reverse(a))(s) for s ∈ im*w]

    # Test
    @test w ≈ matlab_w
    @test h ≈ h_ref
    @test mag ≈ matlab_mag
    @test phasedeg ≈ matlab_phasedeg

    @test h ≈ freqresp(ZeroPoleGain(PolynomialRatio{:s}(b, a)), w)
    @test h ≈ freqresp(SecondOrderSections(PolynomialRatio{:s}(b, a)), w)
end

# ######################################
#
#  Test grpdelay
#
#  Data from Matlab using b,a and a from above:
#  [gd, w] = grpdelay(b, a, 512)
#  all = [w gd]
#  dlmwrite('grpdelay_eg1.txt', all, 'delimiter', '\t', 'precision', '%.12f')
#
# ######################################
@testset "grpdelay" begin
    matlab_delay = read_reference_data("grpdelay_eg1.txt")
    b0 = 0.05634
    b1 = [1,  1]
    b2 = [1, -1.0166, 1]
    a1 = [1, -0.683]
    a2 = [1, -1.4461, 0.7957]
    b = b0*conv(b1, b2)
    a = conv(a1, a2)
    df = PolynomialRatio(b, a)
    w = matlab_delay[:, 1]

    grpdelay_matlab = matlab_delay[:, 2]
    @test grpdelay(df, w) ≈ grpdelay_matlab

    # Test with IIR filters types I-IV
    tau, w = grpdelay(PolynomialRatio([1, 1, 1, 1, 1], [1]))
    @test tau ≈ fill(2.0, length(w))
    tau, w = grpdelay(PolynomialRatio([1, 1, 1, 1, 1, 1], [1]))
    @test tau ≈ fill(2.5, length(w))
    tau, w = grpdelay(PolynomialRatio([1, 0, -1], [1]))
    @test tau ≈ fill(1.0, length(w))
    tau, w = grpdelay(PolynomialRatio([1, -1], [1]))
    @test tau ≈ fill(0.5, length(w))
    @test minimum(w) ≤ 0                 # w should cover frequencies from 0 ...
    @test maximum(w) ≥ float(π)          # ... to π ...
    @test maximum(abs.(diff(w))) < 0.03  # and be sufficiently dense

    # group delay of analog filters
    w = matlab_delay[:, 1]
    @test grpdelay(PolynomialRatio{:s}([1, 2], [123]), w) ≈ 0.5 ./ (1 .+ w.^2/4)
    @test grpdelay(PolynomialRatio{:s}([123], [1, 2]), w) ≈ -0.5 ./ (1 .+ w.^2/4)
    @test grpdelay(PolynomialRatio{:s}([1, 2], [3, 9]), w) ≈ 0.5 ./ (1 .+ w.^2/4) - 1/3 ./ (1 .+ w.^2/9)
    tau, w = grpdelay(PolynomialRatio{:s}([1, 2], [123]))
    @test tau ≈ 0.5 ./ (1 .+ w.^2/4)
    @test minimum(w) < 2 < maximum(w) # position of zero covered
    tau, w = grpdelay(PolynomialRatio{:s}([123], [1, 2]))
    @test tau ≈ -0.5 ./ (1 .+ w.^2/4)
    @test minimum(w) < 2 < maximum(w) # position of pole covered
    tau, w = grpdelay(PolynomialRatio{:s}([1, 2], [3, 9]))
    @test tau ≈ 0.5 ./ (1 .+ w.^2/4) - 1/3 ./ (1 .+ w.^2/9)
    @test minimum(w) < 2 && 3 < maximum(w) # position of pole and zero covered
end

# Implementations of filt, filtfilt, and fftfilt

#
# filt and filt!
#
using ..DSP: _filt_fir!, _filt_iir!

## PolynomialRatio

"""
    filt!(out, f, x)

Same as [`filt()`](@ref) but writes the result into the `out`
argument. Output array `out` may not be an alias of `x`, i.e. filtering may
not be done in place.
"""
filt!(out, f::PolynomialRatio{:z}, x::AbstractArray) = filt!(out, coefb(f), coefa(f), x)

"""
    filt(f::FilterCoefficients{:z}, x::AbstractArray)

Apply filter or filter coefficients `f` along the first dimension
of array `x`. If `f` is a `PolynomialRatio`, `Biquad`, or
`SecondOrderSections`, filtering is implemented directly. If
`f` is a `ZeroPoleGain` object, it is first converted to a
`SecondOrderSections` object.  If `f` is a Vector, it is
interpreted as an FIR filter, and a naïve or FFT-based algorithm is
selected based on the data and filter length.
"""
filt(f::PolynomialRatio{:z}, x) = filt(coefb(f), coefa(f), x)

## SecondOrderSections

# filt! algorithm (no checking, returns si)
function _filt!(out::AbstractArray, si::AbstractMatrix{S}, f::SecondOrderSections{:z},
                x::AbstractArray, col::CartesianIndex) where {S}
    g = f.g
    biquads = f.biquads
    @inbounds for i in axes(x, 1)
        yi = x[i, col]
        for fi in eachindex(biquads)
            biquad = biquads[fi]
            xi = yi
            yi = muladd(biquad.b0, xi, si[1, fi])
            si[1, fi] = muladd(biquad.a1, -yi, muladd(biquad.b1, xi, si[2, fi]))
            si[2, fi] = muladd(biquad.b2, xi, -biquad.a2 * yi)
        end
        out[i, col] = g * yi
    end
    si
end

function filt!(out::AbstractArray, f::SecondOrderSections{:z,T,G}, x::AbstractArray{S}) where {T,G,S}
    size(x) != size(out) && throw(DimensionMismatch("out size must match x"))

    si = Matrix{promote_type(T, G, S)}(undef, 2, length(f.biquads))
    for col in CartesianIndices(axes(x)[2:end])
        fill!(si, zero(eltype(si)))
        _filt!(out, si, f, x, col)
    end
    out
end

filt(f::SecondOrderSections{:z,T,G}, x::AbstractArray{S}) where {T,G,S<:Number} =
    filt!(similar(x, promote_type(T, G, S)), f, x)

## Biquad

# filt! algorithm (no checking, returns si)
function _filt!(out::AbstractArray, si1::Number, si2::Number, f::Biquad{:z},
                x::AbstractArray, col::CartesianIndex)
    @inbounds for i in axes(x, 1)
        xi = x[i, col]
        yi = muladd(f.b0, xi, si1)
        si1 = muladd(f.a1, -yi, muladd(f.b1, xi, si2))
        si2 = muladd(f.b2, xi, -f.a2 * yi)
        out[i, col] = yi
    end
    (si1, si2)
end

function filt!(out::AbstractArray, f::Biquad{:z,T}, x::AbstractArray{S}) where {T,S}
    size(x) != size(out) && throw(DimensionMismatch("out size must match x"))

    for col in CartesianIndices(axes(x)[2:end])
        _filt!(out, zero(promote_type(T, S)), zero(promote_type(T, S)), f, x, col)
    end
    out
end

filt(f::Biquad{:z,T}, x::AbstractArray{S}) where {T,S<:Number} =
    filt!(similar(x, promote_type(T, S)), f, x)

## For arbitrary filters, convert to SecondOrderSections
filt(f::FilterCoefficients{:z}, x) = filt(convert(SecondOrderSections, f), x)
filt!(out, f::FilterCoefficients{:z}, x) = filt!(out, convert(SecondOrderSections, f), x)

"""
    DF2TFilter(coef::FilterCoefficients{:z})
    DF2TFilter(coef::FilterCoefficients{:z}, coldims::Tuple)
    DF2TFilter(coef::FilterCoefficients{:z}, sitype::Type, coldims::Tuple = ())
    DF2TFilter(coef::FilterCoefficients{:z}, si)

Construct a stateful direct form II transposed filter with
coefficients `coef`.

The initial filter state defaults to zeros (of a type derived from `coef`)
suitable for vector input. Another element type of the state can be specified
with `sitype`.

To allow column-wise filtering of higher-dimensional input, the size of the
extra dimensions have to be given in `coldims`. To e.g. column-wise filter an
input with size `(L, N1, N2)`, set `coldims` to `(N1, N2)`.

Alternatively, an array representing the initial filter state can be passed
as `si`.

If `coef` is a `PolynomialRatio`, `Biquad`, or `SecondOrderSections`,
filtering is implemented directly. If `coef` is a `ZeroPoleGain`
object, it is first converted to a `SecondOrderSections` object.
"""
struct DF2TFilter{T<:FilterCoefficients{:z},S<:Array}
    coef::T
    state::S

    function DF2TFilter{Ti,Si}(coef::PolynomialRatio{:z}, state::Array) where {Ti,Si}
        size(state, 1) == max(length(coefa(coef)), length(coefb(coef)))-1 ||
            throw(ArgumentError("length of state vector must match filter order"))
        new{Ti,Si}(coef, state)
    end
    function DF2TFilter{Ti,Si}(coef::SecondOrderSections{:z}, state::Array) where {Ti,Si}
        size(state, 1) == 2 && size(state, 2) == length(coef.biquads) ||
            throw(ArgumentError("state must be 2 x nbiquads"))
        new{Ti,Si}(coef, state)
    end
    function DF2TFilter{Ti,Si}(coef::Biquad{:z}, state::Array) where {Ti,Si}
        size(state, 1) == 2 || throw(ArgumentError("length of state must be 2"))
        new{Ti,Si}(coef, state)
    end
end

DF2TFilter(coef::Union{PolynomialRatio{:z,T},Biquad{:z,T}}, state::S) where {T,S<:Array} =
    DF2TFilter{typeof(coef),S}(coef, state)

DF2TFilter(coef::SecondOrderSections{:z,T,G}, state::S) where {T,G,S<:Array} =
    DF2TFilter{SecondOrderSections{:z,T,G},S}(coef, state)

## PolynomialRatio
DF2TFilter(coef::PolynomialRatio{:z,T}, coldims::Tuple{Vararg{Integer}}) where {T} = DF2TFilter(coef, T, coldims)
DF2TFilter(coef::PolynomialRatio{:z,T}, ::Type{V}=T, coldims::Tuple{Vararg{Integer}}=()) where {T,V} =
    DF2TFilter(coef, zeros(promote_type(T, V), max(length(coefa(coef)), length(coefb(coef))) - 1, coldims...))

function filt!(out::AbstractArray{<:Any,N}, f::DF2TFilter{<:PolynomialRatio,Array{T,N}} where T, x::AbstractArray{<:Any,N}) where N
    size(x) != size(out) && throw(ArgumentError("out size must match x"))

    si = f.state
    size(x)[2:end] != size(si)[2:end] && throw(ArgumentError("state size must match x"))

    n = size(si, 1) + 1
    b = coefb(f.coef)
    if n == 1
        mul!(out, x, b[1])
    else
        a = coefa(f.coef)
        outer_dims = CartesianIndices(axes(x)[2:end])

        if length(a) != 1
            for col in outer_dims
                _filt_iir!(out, b, a, x, view(si, :, col), col)
            end
        elseif n <= SMALL_FILT_CUTOFF
            _small_filt_fir_storesi!(out, b, x, si, Val(length(b)))
        else
            for col in outer_dims
                _filt_fir!(out, b, x, view(si, :, col), col)
            end
        end
    end
    return out
end
function _small_filt_fir_storesi!(
    out::AbstractArray, h::AbstractVector, x::AbstractArray,
    si::Array, ::Val{bs}
) where {bs}

    bs < 2 && throw(ArgumentError("invalid tuple size"))
    length(h) != bs && throw(ArgumentError("length(h) does not match bs"))
    b = ntuple(j -> h[j], Val(bs))
    col_len = size(si, 1)
    LI = LinearIndices(si)
    for col in CartesianIndices(axes(x)[2:end])
        @static if VERSION >= v"1.12"
            si_vec = Base.wrap(Array, memoryref(si.ref, LI[1, col]), col_len)
        else
            si_vec = view(si, :, col)
        end
        _filt_fir!(out, b, x, si_vec, col, Val(true))
    end
end

## SecondOrderSections
DF2TFilter(coef::SecondOrderSections{:z,T}, coldims::Tuple{Vararg{Integer}}) where {T} = DF2TFilter(coef, T, coldims)
DF2TFilter(coef::SecondOrderSections{:z,T,G}, ::Type{V}=T, coldims::Tuple{Vararg{Integer}}=()) where {T,G,V} =
    DF2TFilter(coef, zeros(promote_type(T, G, V), 2, length(coef.biquads), coldims...))

function filt!(out::AbstractArray{<:Any,N}, f::DF2TFilter{<:SecondOrderSections,<:Array}, x::AbstractArray{<:Any,N}) where N
    size(x) != size(out) && throw(ArgumentError("out size must match x"))
    size(x)[2:end] != size(f.state)[3:end] && throw(ArgumentError("state size must match x"))
    for col in CartesianIndices(axes(x)[2:end])
        _filt!(out, view(f.state, :, :, col), f.coef, x, col)
    end
    return out
end

## Biquad
DF2TFilter(coef::Biquad{:z,T}, coldims::Tuple{Vararg{Integer}}) where {T} = DF2TFilter(coef, T, coldims)
DF2TFilter(coef::Biquad{:z,T}, ::Type{V}=T, coldims::Tuple{Vararg{Integer}}=()) where {T,V} =
    DF2TFilter(coef, zeros(promote_type(T, V), 2, coldims...))

function filt!(out::AbstractArray{<:Any,N}, f::DF2TFilter{<:Biquad,Array{T,N}} where T, x::AbstractArray{<:Any,N}) where N
    size(x) != size(out) && throw(ArgumentError("out size must match x"))
    si = f.state
    size(x)[2:end] != size(si)[2:end] && throw(ArgumentError("state size must match x"))
    for col in CartesianIndices(axes(x)[2:end])
        (si[1, col], si[2, col]) = _filt!(out, si[1, col], si[2, col], f.coef, x, col)
    end
    return out
end

"""
    filt(f::DF2TFilter{<:FilterCoefficients{:z},<:Array{T}}, x::AbstractArray{V}) where {T,V}

Apply the [stateful filter](@ref stateful-filter-objects) `f` on `x`.

!!! warning
    The output array has eltype `promote_type(T, V)`, where
    `T` is the eltype of the filter state.\n
    For more control over the output type, provide a preallocated
    output array `out` to `filt!(out, f, x)`.
"""
filt(f::DF2TFilter{<:FilterCoefficients{:z},<:Array{T}}, x::AbstractArray{V}) where {T,V} =
    filt!(similar(x, promote_type(T, V)), f, x)

# Fall back to SecondOrderSections
DF2TFilter(coef::FilterCoefficients{:z}, coldims::Tuple{Vararg{Integer}}=()) =
    DF2TFilter(convert(SecondOrderSections, coef), coldims)
DF2TFilter(coef::FilterCoefficients{:z}, ::Type{V}, coldims::Tuple{Vararg{Integer}}=()) where {V} =
    DF2TFilter(convert(SecondOrderSections, coef), V, coldims)

#
# filtfilt
#

# Extrapolate the beginning of a signal for use by filtfilt. This
# computes:
#
# [(2 * x[1]) .- x[pad_length+1:-1:2],
#  x,
#  (2 * x[end]) .- x[end-1:-1:end-pad_length]]
#
# in place in output. The istart and n parameters determine the portion
# of the input signal x to extrapolate.
function extrapolate_signal!(out, sig, pad_length)
    n = length(sig)
    length(out) >= n + 2 * pad_length || throw(ArgumentError("output is incorrectly sized"))
    x = 2 * sig[1]
    for i = 1:pad_length
        out[i] = x - sig[2+pad_length-i]
    end
    copyto!(out, 1+pad_length, sig, 1, n)
    x = 2 * sig[n]
    for i = 1:pad_length
        out[n+pad_length+i] = x - sig[n-i]
    end
    out
end

# Zero phase digital filtering by processing data in forward and reverse direction
function iir_filtfilt(b::AbstractVector, a::AbstractVector, x::AbstractArray)
    pad_length = min(3 * (max(length(a), length(b)) - 1), size(x, 1) - 1)
    zi, bn, an = filt_stepstate(b, a)
    t = Base.promote_eltype(bn, an, x)
    zitmp = similar(zi, t)
    extrapolated = Vector{t}(undef, size(x, 1) + 2 * pad_length)
    out = similar(x, t)

    for col in CartesianIndices(axes(x)[2:end])
        extrapolate_signal!(extrapolated, view(x, :, col), pad_length)
        _filt_iir!(extrapolated, bn, an, extrapolated, mul!(zitmp, zi, extrapolated[1]), CartesianIndex())
        reverse!(extrapolated)
        _filt_iir!(extrapolated, bn, an, extrapolated, mul!(zitmp, zi, extrapolated[1]), CartesianIndex())
        for j in axes(x, 1)
            out[j, col] = extrapolated[end-pad_length+1-j]
        end
    end

    out
end

"""
    filtfilt(coef::FilterCoefficients, x::AbstractArray)
    filtfilt(b::AbstractVector, x::AbstractArray)
    filtfilt(b::AbstractVector, a::AbstractVector, x::AbstractArray)

Filter `x` in the forward and reverse directions using either a
`FilterCoefficients` object `coef`, or the coefficients `b` and optionally `a`
as in [`filt`](@ref). The initial state of the filter is computed so
that its response to a step function is steady state. Before
filtering, the data is extrapolated at both ends with an
odd-symmetric extension of length
`min(3*(max(length(b), length(a))-1), size(x, 1) - 1)`.

Because `filtfilt` applies the given filter twice, the effective
filter order is twice the order of `coef`. The resulting signal has
zero phase distortion.
"""
function filtfilt end

function filtfilt(b::AbstractVector, x::AbstractArray)
    nb = length(b)
    # Only need as much padding as the order of the filter
    T = Base.promote_eltype(b, x)
    extrapolated = similar(x, T, (size(x, 1)+2*(nb-1), size(x)[2:end]...))

    # Convolve b with its reverse
    newb = reverse(b, 1)
    filt!(newb, b, newb)
    resize!(newb, 2nb-1)
    for i = 1:nb-1
        newb[nb+i] = newb[nb-i]
    end

    # Extrapolate each column
    for col in CartesianIndices(axes(x)[2:end])
        @views extrapolate_signal!(extrapolated[:, col], x[:, col], nb-1)
    end

    # Filter
    filt!(extrapolated, newb, extrapolated)

    # Drop garbage at start
    return extrapolated[2nb-1:end, axes(extrapolated)[2:end]...]
end

# Choose whether to use FIR or iir_filtfilt depending on
# length of a
function filtfilt(b::AbstractVector, a::AbstractVector, x::AbstractArray)
    if length(a) == 1
        if a[1] != 1
            b /= a[1]
        end
        filtfilt(b, x)
    else
        iir_filtfilt(b, a, x)
    end
end

# Zero phase digital filtering for second order sections
function filtfilt(f::SecondOrderSections{:z,T,G}, x::AbstractArray{S}) where {T,G,S}
    zi = filt_stepstate(f)
    pad_length = min(6 * length(f.biquads), size(x, 1) - 1)
    t = promote_type(T, G, S)
    zitmp = similar(zi, t)
    extrapolated = Vector{t}(undef, size(x, 1) + pad_length * 2)
    out = similar(x, t)

    for col in CartesianIndices(axes(x)[2:end])
        extrapolate_signal!(extrapolated, view(x, :, col), pad_length)
        _filt!(extrapolated, mul!(zitmp, zi, extrapolated[1]), f, extrapolated, CartesianIndex())
        reverse!(extrapolated)
        _filt!(extrapolated, mul!(zitmp, zi, extrapolated[1]), f, extrapolated, CartesianIndex())
        for j in axes(x, 1)
            out[j, col] = extrapolated[end-pad_length+1-j]
        end
    end

    out
end

# Support for other filter types
filtfilt(f::FilterCoefficients{:z}, x) = filtfilt(convert(SecondOrderSections, f), x)
filtfilt(f::PolynomialRatio{:z}, x) = filtfilt(coefb(f), coefa(f), x)

## Initial filter state

# Compute an initial state for filt with coefficients (b,a) such that its
# response to a step function is steady state. Also returns padded (b, a).
function filt_stepstate(b::AbstractVector{V}, a::AbstractVector{V}) where V<:Number
    T = typeof(one(V) / one(V))
    scale_factor = a[1]
    if !isone(scale_factor)
        a = a ./ scale_factor
        b = b ./ scale_factor
    elseif T !== V
        a = convert.(T, a)
        b = convert.(T, b)
    end

    bs = length(b)
    as = length(a)
    sz = max(bs, as)
    sz > 0 || throw(ArgumentError("a and b must have at least one element each"))

    # Pad the coefficients with zeros if needed
    bs < sz && (b = copyto!(zeros(T, sz), b))
    as < sz && (a = copyto!(zeros(T, sz), a))
    sz == 1 && return (T[], b, a)

    # construct the companion matrix A and vector B:
    A = [-a[2:end] Matrix{T}(I, sz-1, sz-2)]
    B = @views @. muladd(a[2:end], -b[1], b[2:end])
    # Solve si = A*si + B
    # (I - A)*si = B
    si = (((I - A) \ B) .*= scale_factor)
    return (si, b, a)
end

filt_stepstate(b::AbstractVector{<:Number}, a::AbstractVector{<:Number}) =
    filt_stepstate(promote(b, a)...)

function filt_stepstate(f::SecondOrderSections{:z,T}) where T
    biquads = f.biquads
    si = Matrix{T}(undef, 2, length(biquads))
    y = one(T)
    for i in eachindex(biquads)
        biquad = biquads[i]
        a1, a2, b0, b1, b2 = biquad.a1, biquad.a2, biquad.b0, biquad.b1, biquad.b2

        # At steady state, we have:
        #  y = s1 + b0*x
        # s1 = s2 + b1*x - a1*y
        # s2 = b2*x - a2*y
        # where x is the input and y is the output. Solving these
        # equations yields the following.
        den = (1 + a1 + a2)
        si[1, i] = muladd((a1 + a2), -b0, b1 + b2) / den * y
        si[2, i] = muladd(a1, b2, muladd(-a2, (b0 + b1), b2)) / den * y
        y *= (b0 + b1 + b2) / den
    end
    si
end

"""
    tdfilt(h::AbstractVector, x::AbstractArray)

Apply filter or filter coefficients `h` along the first dimension
of array `x` using a naïve time-domain algorithm
"""
function tdfilt(h::AbstractVector{H}, x::AbstractArray{T}) where {H,T<:Real}
    filt(h, one(H), x)
end

"""
    tdfilt!(out::AbstractArray, h::AbstractVector, x::AbstractArray)

Like `tdfilt`, but writes the result into array `out`. Output array `out` may
not be an alias of `x`, i.e. filtering may not be done in place.
"""
function tdfilt!(out::AbstractArray, h::AbstractVector{H}, x::AbstractArray) where H
    filt!(out, h, one(H), x)
end

filt(h::AbstractVector{H}, x::AbstractArray{T}) where {H,T} =
    filt!(similar(x, promote_type(H, T)), h, x)

#
# fftfilt and filt
#

"""
    fftfilt(h::AbstractVector{<:Real}, x::AbstractArray{<:Real})

Apply FIR filter taps `h` along the first dimension of array `x`
using an FFT-based overlap-save algorithm.
"""
function fftfilt(b::AbstractVector{H}, x::AbstractArray{T},
                 nfft::Integer=optimalfftfiltlength(length(b), length(x))) where {H<:Real,T<:Real}
    _fftfilt!(similar(x, promote_type(H, T)), b, x, nfft)
end

"""
    fftfilt!(out::AbstractArray, h::AbstractVector, x::AbstractArray)

Like `fftfilt` but writes result into out array.
"""
function fftfilt!(
    out::AbstractArray{<:Real},
    b::AbstractVector{<:Real},
    x::AbstractArray{<:Real},
    nfft::Integer=optimalfftfiltlength(length(b), length(x))
)
    size(out) == size(x) || throw(ArgumentError("out and x must be the same size"))
    _fftfilt!(out, b, x, nfft)
end

# Like fftfilt! but does not check if out and x are the same size
function _fftfilt!(
    out::AbstractArray{<:Real},
    b::AbstractVector{H},
    x::AbstractArray{T},
    nfft::Integer
) where {T<:Real,H<:Real}
    nb = length(b)
    nx = size(x, 1)
    normfactor = nfft
    W = promote_type(H, T)

    L = min(nx, nfft - (nb - 1))
    tmp1 = Vector{W}(undef, nfft)
    tmp2 = Vector{Complex{W}}(undef, nfft >> 1 + 1)

    p1 = plan_rfft(tmp1)
    p2 = plan_brfft(tmp2, nfft)

    # FFT of filter
    filterft = similar(tmp2)
    tmp1[1:nb] .= b ./ normfactor
    tmp1[nb+1:end] .= zero(W)
    mul!(filterft, p1, tmp1)

    # FFT of chunks
    for colstart = 0:nx:length(x)-1, off = 1:L:nx
        npadbefore = max(0, nb - off)
        xstart = off - nb + npadbefore + 1
        n = min(nfft - npadbefore, nx - xstart + 1)

        fill!(tmp1, zero(W))
        copyto!(tmp1, npadbefore+1, x, colstart+xstart, n)

        mul!(tmp2, p1, tmp1)
        broadcast!(*, tmp2, tmp2, filterft)
        mul!(tmp1, p2, tmp2)

        # Copy to output
        copyto!(out, colstart+off, tmp1, nb, min(L, nx - off + 1))
    end

    out
end

# Filter x using FIR filter b, heuristically choosing to perform convolution in
# the time domain using tdfilt or in the frequency domain using fftfilt
function filt(b::AbstractVector{T}, x::AbstractArray{T}) where T<:Number
    filt_choose_alg!(similar(x, T), b, x)
end

# Like filt but mutates output array
function filt!(out::AbstractArray, b::AbstractVector, x::AbstractArray)
    size(out) == size(x) || throw(ArgumentError("out must be the same size as x"))
    filt_choose_alg!(out, b, x)
end

# Perform FIR filtering with either time domain or fft based algorithms, writing
# output to `out` argument. Does not check that x and out are the same size.
function filt_choose_alg!(
    out::AbstractArray{<:Real},
    b::AbstractVector{<:Real},
    x::AbstractArray{<:Real}
)
    nb = length(b)

    if nb > SMALL_FILT_CUTOFF
        nx = size(x, 1)
        nfft = optimalfftfiltlength(nb, nx)
        _fftfilt!(out, b, x, nfft)
    else
        tdfilt!(out, b, x)
    end
end

function filt_choose_alg!(out::AbstractArray, b::AbstractVector, x::AbstractArray)
    tdfilt!(out, b, x)
end

#####
##### Multitapered periodogram
#####

struct MTConfig{T,R1,F,P,T1,T2,W,R2}
    n_samples::Int
    fs::R1
    nfft::Int
    ntapers::Int
    freq::F
    plan::P
    fft_input_tmp::T1
    fft_output_tmp::T2
    window::W
    onesided::Bool
    r::R2 # inverse normalization; e.g. equal to `fs*N` for an unwindowed/untapered periodogram of a signal of length `N`
          # e.g. equal to `fs*ntapers*ones(ntapers)` when tapered by properly normalized window functions (i.e. norm-2 equal to 1 for each taper)
          # can be adjusted to weight the tapers, e.g. by the eigenvalues of the DPSS windows
    function MTConfig{T}(n_samples, nfft, ntapers, freq::F, fs::R1, plan::P, fft_input_tmp::T1,
                         fft_output_tmp::T2, window::W, onesided, r::R2) where {T,R1,F,P,T1,T2,W,R2}
        n_samples > 0 || throw(ArgumentError("`n_samples` must be positive"))
        nfft >= n_samples || throw(ArgumentError("Must have `nfft >= n_samples`"))
        ntapers > 0 || throw(ArgumentError("`ntapers` must be positive"))
        fs > 0 || throw(ArgumentError("`fs` must be positive"))
        if size(plan) != size(fft_input_tmp)
            throw(DimensionMismatch(lazy"""Must have `size(plan) == size(fft_input_tmp)`;
                got `size(plan)` = $(size(plan)) and `size(fft_input_tmp)` = $(size(fft_input_tmp))"""))
        elseif size(fft_input_tmp) != (nfft,)
            throw(DimensionMismatch(lazy"""Must have `size(fft_input_tmp) == (nfft,)`;
                got `size(fft_input_tmp)` = $(size(fft_input_tmp)) and `nfft` = $(nfft)"""))
        elseif size(fft_output_tmp) != (length(freq),)
            throw(DimensionMismatch(lazy"""Must have `size(fft_output_tmp) == (length(freq),)`;
                got `size(fft_output_tmp)` = $(size(fft_output_tmp)) and `length(freq)` = $(length(freq))"""))
        elseif size(window) != (n_samples, ntapers)
            throw(DimensionMismatch(lazy"""Must have `size(window) == (n_samples, ntapers)`;
                got `size(window)` = $(size(window)) and `(ntapers, n_samples)` = $((n_samples, ntapers))"""))
        elseif size(r) != (ntapers,)
            throw(DimensionMismatch(lazy"""Must have `size(r) == (ntapers,)`;
            got `size(r)` = $(size(r)) and `(ntapers,)` = $((ntapers,))"""))
        elseif onesided && T <: Complex
            throw(ArgumentError("cannot compute one-sided FFT of a complex signal"))
        end
        return new{T,R1,F,P,T1,T2,W,R2}(n_samples, fs, nfft,
                                        ntapers, freq, plan,
                                        fft_input_tmp,
                                        fft_output_tmp, window,
                                        onesided, r)
    end
end

# provides an `MTConfig` with `keep_only_large_evals` and `weight_by_evals` options used in some of the reference tests.
function dpss_config(::Type{T}, n_samples; nw=4, ntapers = 2nw-1, fs=1, keep_only_large_evals=false,
                     weight_by_evals=false, kwargs...) where {T}

    window = dpss(n_samples, nw, ntapers)

    if keep_only_large_evals
        evals = dpsseig(window, nw)
        keep_evals_mask = evals .> 0.9
        window = window[:, keep_evals_mask]
        evals = evals[keep_evals_mask]
        ntapers = size(window, 2)
    else
        evals = nothing
    end

    if weight_by_evals
        if evals === nothing
            evals = dpsseig(window, nw)
        end
        taper_weights = evals ./ sum(evals)
    else
        taper_weights = fill(1/ntapers, ntapers)
    end

    return MTConfig{T}(n_samples; window, nw, ntapers, taper_weights, fs, kwargs...)
end


"""
    MTConfig{T}(n_samples; fs=1,
            nfft = nextpow(2, n_samples),
            window = nothing,
            nw = 4,
            ntapers = 2 * nw - 1,
            taper_weights = fill(1/ntapers, ntapers),
            onesided::Bool=T<:Real,
            fft_flags = FFTW.MEASURE)

Creates a config object which holds the configuration state
and temporary variables used in multitaper computations,
e.g. [`mt_pgram!`](@ref), [`mt_spectrogram`](@ref), [`MTSpectrogramConfig`](@ref),
[`MTCrossSpectraConfig`](@ref), and [`MTCoherenceConfig`](@ref).

An `MTConfig` can be re-used between computations as long
as none of the input arguments change.

* `n_samples`: the number of samples to be used as input when computing multitaper periodograms
  with this configuration. Used for pre-allocating temporary buffers.
* `fs`: the number of samples per second of the input signal
* `nfft`: length of input vector to the FFT; if `nfft > n_samples`, then the
  input signal will be zero-padded until it is of length `nfft`.
* `window`: window function to use for tapering. If left at the default of `nothing`,
  `window` will be set to `dpss(n_samples, nw, ntapers)`.
* `ntapers`: the number of tapers to use.
* `taper_weights = fill(1/ntapers, ntapers)`: how to weight the contribution of each taper.
  The default setting is to simply average them.
* `onesided`: whether or not to compute a "one-sided" FFT by using that real signal data
  yields conjugate-symmetry in Fourier space.
* `fft_flags`: flags to control how the FFT plan is generated.
"""
function MTConfig{T}(n_samples; fs=1, nfft=nextpow(2, n_samples), window=nothing, nw=4,
                     ntapers=2 * nw - 1, taper_weights = fill(1/ntapers, ntapers),
                    onesided::Bool=T <: Real,
                     fft_flags=FFTW.MEASURE) where {T}
    if onesided && T <: Complex
        throw(ArgumentError("cannot compute one-sided FFT of a complex signal"))
    end
    n_samples > 0 || throw(ArgumentError("`n_samples` must be positive"))
    nfft >= n_samples || throw(ArgumentError("Must have `nfft >= n_samples`"))
    freq = onesided ? rfftfreq(nfft, fs) : fftfreq(nfft, fs)
    fft_input_tmp = zeros(T, nfft)
    fft_output_tmp = Vector{fftouttype(T)}(undef, length(freq))
    plan = onesided ? plan_rfft(fft_input_tmp; flags=fft_flags) :
           plan_fft(fft_input_tmp; flags=fft_flags)
    if window === nothing
        r = fs ./ taper_weights
        window = dpss(n_samples, nw, ntapers)
    else
        r = fs .* vec(sum(abs2, window; dims=1)) ./ taper_weights
    end

    return MTConfig{T}(n_samples, nfft, ntapers, freq, fs, plan, fft_input_tmp,
                       fft_output_tmp, window, onesided, r)
end

function allocate_output(config::MTConfig{T}) where {T}
    return Vector{fftabs2type(T)}(undef, length(config.freq))
end


# Internal function used in [`mt_pgram!`](@ref) and [`mt_cross_power_spectra!`](@ref).
function mt_fft_tapered!(fft_output, signal, taper_index, config)
    # Create the input: tapered + zero-padded version of the signal
    fft_input = config.fft_input_tmp
    @inbounds for i in eachindex(signal)
        fft_input[i] = config.window[i, taper_index] * signal[i]
    end

    # do the FFT
    mul!(fft_output, config.plan, fft_input)
    return nothing
end


"""
    mt_pgram(s; onesided=eltype(s)<:Real, nfft=nextfastfft(n), fs=1, nw=4, ntapers=iceil(2nw)-1, window=dpss(length(s), nw, ntapers))
    mt_pgram(signal::AbstractVector, config::MTConfig)

Computes the multitaper periodogram of a signal `s`.

If `window` is not specified, the signal is tapered with
`ntapers` discrete prolate spheroidal sequences with
time-bandwidth product `nw`. Each sequence is equally weighted;
adaptive multitaper is not (yet) supported.

If `window` is specified, each column is applied as a taper. The
sum of periodograms is normalized by the total sum of squares of
`window`.

Returns a `Periodogram`.

See also [`mt_pgram!`](@ref) and [`MTConfig`](@ref).
"""
mt_pgram

function mt_pgram(s::AbstractVector{T}; onesided::Bool=eltype(s)<:Real,
                  nfft::Int=nextfastfft(length(s)), fs::Real=1,
                  nw::Real=4, ntapers::Int=ceil(Int, 2nw)-1,
                  window::Union{AbstractMatrix,Nothing}=nothing) where T<:Number
    config = MTConfig{T}(length(s); fs,
        nfft, window, nw, ntapers, onesided,
        fft_flags=FFTW.ESTIMATE)
    out = allocate_output(config)
    return mt_pgram!(out, s, config)
end

function mt_pgram!(output, s::AbstractVector{T}; onesided::Bool=eltype(s)<:Real,
    nfft::Int=nextfastfft(length(s)), fs::Real=1,
    nw::Real=4, ntapers::Int=ceil(Int, 2nw)-1,
    window::Union{AbstractMatrix,Nothing}=nothing) where T<:Number
    config = MTConfig{T}(length(s); fs,
        nfft, window, nw, ntapers, onesided,
        fft_flags=FFTW.ESTIMATE)
    return mt_pgram!(output, s, config)
end

function mt_pgram(signal::AbstractVector, config::MTConfig)
    out = allocate_output(config)
    return mt_pgram!(out, signal, config)
end

"""
    mt_pgram!(output, s::AbstractVector{T}; onesided::Bool=eltype(s)<:Real,
        nfft::Int=nextfastfft(length(s)), fs::Real=1,
        nw::Real=4, ntapers::Int=ceil(Int, 2nw)-1,
        window::Union{AbstractMatrix,Nothing}=nothing) where T<:Number
    mt_pgram!(output::AbstractVector, signal::AbstractVector, config::MTConfig) -> Periodogram

Computes a multitapered periodogram, storing the output in `output`. Arguments:

* `signal::AbstractVector`: should be of length `config.n_samples`
* `output::AbstractVector`: should be of length `length(config.freq)`

Optionally pass an [`MTConfig`](@ref) object to preallocate temporary variables
and choose configuration settings; otherwise, keyword arguments may be passed
to choose those settings.

Returns a `Periodogram`.

See also [`mt_pgram`](@ref) and [`MTConfig`](@ref).
"""
mt_pgram!

function mt_pgram!(output::AbstractVector, signal::AbstractVector, config::MTConfig)
    if length(output) != length(config.freq)
        throw(DimensionMismatch(lazy"""Expected `output` to be of length `length(config.freq)`;
                got `length(output) = $(length(output)) and `length(config.freq)` = $(length(config.freq))"""))
    end
    if length(signal) != config.n_samples
        throw(DimensionMismatch(lazy"""Expected `signal` to be of length `config.n_samples`;
                got `length(signal) == $(length(signal)) and `config.n_samples` = $(config.n_samples)"""))
    end
    fft_output = config.fft_output_tmp

    output .= 0
    for taper_index in 1:(config.ntapers)
        mt_fft_tapered!(fft_output, signal, taper_index, config)
        fft2pow!(output, fft_output, config.nfft, config.r[taper_index], config.onesided)
    end
    return Periodogram(output, config.freq)
end

#####
##### Multitapered spectrogram
#####

struct MTSpectrogramConfig{T,C<:MTConfig{T}}
    n_samples::Int
    n_overlap_samples::Int
    time::Float64Range
    mt_config::C
end

"""
    MTSpectrogramConfig(n_samples, mt_config::MTConfig{T}, n_overlap_samples) where {T}
    MTSpectrogramConfig{T}(n_samples, samples_per_window, n_overlap_samples; fs=1, kwargs...) where {T}

Creates a `MTSpectrogramConfig` which holds configuration and temporary variables for [`mt_spectrogram`](@ref) and [`mt_spectrogram!`](@ref).
Any keyword arguments accepted by [`MTConfig`](@ref) may be passed here, or an `MTConfig` object itself.
"""
function MTSpectrogramConfig(n_samples::Int, mt_config::MTConfig{T}, n_overlap_samples::Int) where {T}
    samples_per_window = mt_config.n_samples
    if samples_per_window <= n_overlap_samples
        throw(ArgumentError(lazy"Need `samples_per_window > n_overlap_samples`; got `samples_per_window` = $(samples_per_window) and `n_overlap_samples` = $(n_overlap_samples)."))
    end

    f = samples_per_window / 2
    hop = samples_per_window - n_overlap_samples

    len = n_samples < samples_per_window ? 0 : div(n_samples - samples_per_window, hop) + 1
    time = range(f, step = hop, length = len) / mt_config.fs
    return MTSpectrogramConfig{T,typeof(mt_config)}(n_samples, n_overlap_samples, time,
                                                    mt_config)
end

# add a method for if the user specifies the type, i.e. `MTSpectrogramConfig{T}`
function MTSpectrogramConfig{T}(n_samples::Int, mt_config::MTConfig{T}, n_overlap_samples::Int) where {T}
    return MTSpectrogramConfig(n_samples, mt_config, n_overlap_samples)
end

# Create the `MTConfig` if it's not passed
function MTSpectrogramConfig{T}(n_samples::Int, samples_per_window::Int,
                                n_overlap_samples::Int; fs=1, kwargs...) where {T}
    return MTSpectrogramConfig(n_samples, MTConfig{T}(samples_per_window; fs, kwargs...), n_overlap_samples)
end

"""
    mt_spectrogram!(output, signal::AbstractVector{T}, n::Int=length(signal) >> 3,
        n_overlap::Int=n >> 1; fs=1, onesided::Bool=T <: Real, kwargs...) where {T}
    mt_spectrogram!(destination::AbstractMatrix, signal::AbstractVector, config::MTSpectrogramConfig)

Computes a multitaper spectrogram using the parameters specified in `config`. Arguments:

* `destination`: `length(config.mt_config.freq)` x `length(config.time)` matrix. This can be created by `DSP.allocate_output(config)`.
* `signal`: vector of length `config.n_samples`
* `config`: optionally, pass an [`MTSpectrogramConfig`](@ref) object to hold temporary variables and configuration settings. Otherwise, settings arguments may be passed directly.

Returns a `Spectrogram`.

See also [`mt_spectrogram`](@ref).
"""
mt_spectrogram!

function mt_spectrogram!(output, signal::AbstractVector{T}, n::Int=length(signal) >> 3,
        n_overlap::Int=n >> 1; kwargs...) where {T}
    config = MTSpectrogramConfig{T}(length(signal), n, n_overlap;
        fft_flags=FFTW.ESTIMATE, kwargs...)
    return mt_spectrogram!(output, signal, config)
end

@views function mt_spectrogram!(destination::AbstractMatrix, signal::AbstractVector,
                                config::MTSpectrogramConfig)
    if size(destination) != (length(config.mt_config.freq), length(config.time))
        throw(DimensionMismatch(lazy"""Expected `destination` to be of size `(length(config.mt_config.freq), length(config.time))`;
                got `size(destination) == $(size(destination)) and
                `(length(config.mt_config.freq), length(config.time))` = $((length(config.mt_config.freq), length(config.time)))"""))
    end
    if length(signal) != config.n_samples
        throw(DimensionMismatch(lazy"""Expected `signal` to be of length `config.n_samples`;
                got `length(signal) = $(length(signal)) and `config.n_samples` = $(config.n_samples)"""))
    end
    samples_per_window = config.mt_config.n_samples
    subepochs = arraysplit(signal, samples_per_window, config.n_overlap_samples)
    @assert length(subepochs) == length(config.time)
    for (time_index, subepoch) in enumerate(subepochs)
        mt_pgram!(destination[:, time_index], subepoch, config.mt_config)
    end
    return Spectrogram(destination, config.mt_config.freq, config.time)
end

function allocate_output(config::MTSpectrogramConfig{T}) where {T}
    return Matrix{fftabs2type(T)}(undef, length(config.mt_config.freq), length(config.time))
end

function mt_spectrogram(signal::AbstractVector, config::MTSpectrogramConfig)
    output = allocate_output(config)
    return mt_spectrogram!(output, signal, config)
end

"""
    mt_spectrogram(signal::AbstractVector{T}, n::Int=length(s) >> 3,
                                  n_overlap::Int=n >> 1; fs=1,
                                  onesided::Bool=T <: Real, kwargs...) where {T}
    mt_spectrogram(signal::AbstractVector, config::MTSpectrogramConfig)

Compute a multitaper spectrogram, returning a `Spectrogram` object.
Optionally pass a [`MTSpectrogramConfig`](@ref) object; otherwise, any additional keyword
arguments accepted by [`MTConfig`](@ref) may be passed to configure the tapering.

Returns a `Spectrogram`.

See also [`mt_spectrogram!`](@ref).
"""
mt_spectrogram

function mt_spectrogram(signal::AbstractVector{T}, n::Int=length(signal) >> 3,
                        n_overlap::Int=n >> 1; kwargs...) where {T}
    config = MTSpectrogramConfig{T}(length(signal), n, n_overlap; fft_flags=FFTW.ESTIMATE, kwargs...)
    return mt_spectrogram(signal, config)
end




"""
    mt_spectrogram(signal::AbstractVector, mt_config::MTConfig,
                   n_overlap::Int=mt_config.n_samples >> 1) -> Spectrogram

Compute a multitaper spectrogram using an an [`MTConfig`](@ref) object to choose
the window size. Note that all the workspace variables are contained in the [`MTConfig`](@ref) object, and this object can be re-used between spectrogram computations, so that only the output needs to be allocated.

Returns a `Spectrogram`.

See also [`mt_spectrogram!`](@ref).

## Example

```julia
signal1 = sin.(10_000) .+ randn(10_000)
mt_config = MTConfig{Float64}(1000) # 1000 samples per window
spec1 = mt_spectrogram(signal1, mt_config, 500)
signal2 = cos.(2_000) .+ randn(2_000)
spec2 = mt_spectrogram(signal2, mt_config, 250) # same `mt_config`, different signal, different overlap
```
"""
function mt_spectrogram(signal::AbstractVector, mt_config::MTConfig{T},
                        n_overlap::Int=mt_config.n_samples >> 1) where {T}
    config = MTSpectrogramConfig{T}(length(signal), mt_config, n_overlap)
    return mt_spectrogram(signal, config)
end

#####
##### Multitapered cross spectral matrix
#####

# the following code was initially ported from MNE-python before being partially rewritten.
# MNE-python's 3-clause BSD license can be found here: <https://github.com/mne-tools/mne-python/blob/c6b22e82b64da0ed0f52a5f28bd4711e47090f9e/LICENSE.txt>.


"""
    CrossPowerSpectra{T,F,A<:AbstractArray{T, 3}}

Access the cross power spectral density (an `n_channels` x `n_channels` x `length(freq)` array) via the function [`power`](@ref),
and the frequencies by the function [`freq`](@ref).

See also [`mt_cross_power_spectra`](@ref) and [`mt_cross_power_spectra!`](@ref).
"""
struct CrossPowerSpectra{T,F,A<:AbstractArray{T, 3}}
    power::A
    freq::F
end

freq(c::CrossPowerSpectra) = c.freq
power(c::CrossPowerSpectra) = c.power

function check_onesided_real(mt_config::MTConfig{T}) where T
    if !((T <: Real) && mt_config.onesided)
        throw(ArgumentError("Only real data is supported (with the default choice of `onesided=true`) for this operation."))
    end
    return nothing
end

struct MTCrossSpectraConfig{T,T1,T2,T3,T4,F,T5,T6,C<:MTConfig{T}}
    n_channels::Int
    normalization_weights::T1
    x_mt::T2
    demean::Bool
    mean_per_channel::T3
    demeaned_signal::T4
    freq::F
    freq_range::T5
    freq_inds::T6
    ensure_aligned::Bool
    mt_config::C
    function MTCrossSpectraConfig{T,T1,T2,T3,T4,F,T5,T6,C}(
        n_channels::Int, normalization_weights::T1, x_mt::T2,
        demean::Bool, mean_per_channel::T3, demeaned_signal::T4, freq::F, freq_range::T5,
        freq_inds::T6, ensure_aligned::Bool, mt_config::C
    ) where {T,T1,T2,T3,T4,F,T5,T6,C<:MTConfig{T}}
        check_onesided_real(mt_config)  # this restriction is artificial; the code needs to be generalized
        return new{T,T1,T2,T3,T4,F,T5,T6,C}(
            n_channels, normalization_weights, x_mt,
            demean, mean_per_channel, demeaned_signal, freq, freq_range,
            freq_inds, ensure_aligned, mt_config
        )
    end
    function MTCrossSpectraConfig(n_channels::Int, normalization_weights::T1, x_mt::T2,
        demean::Bool, mean_per_channel::T3, demeaned_signal::T4, freq::F, freq_range::T5,
        freq_inds::T6, ensure_aligned::Bool, mt_config::C
    ) where {T,T1,T2,T3,T4,F,T5,T6,C<:MTConfig{T}}
        MTCrossSpectraConfig{T,T1,T2,T3,T4,F,T5,T6,C}(
            n_channels, normalization_weights, x_mt,
            demean, mean_per_channel, demeaned_signal, freq, freq_range,
            freq_inds, ensure_aligned, mt_config
        )
    end
end

"""
    MTCrossSpectraConfig{T}(n_channels, n_samples; fs=1, demean=false, freq_range=nothing,
                            ensure_aligned = T == Float32 || T == Complex{Float32}, kwargs...) where {T}
    MTCrossSpectraConfig(n_channels, mt_config::MTConfig{T}; demean=false, freq_range=nothing,
                         ensure_aligned = T == Float32 || T == Complex{Float32})

Creates a configuration object used for [`mt_cross_power_spectra`](@ref) and [`mt_cross_power_spectra!`](@ref).

* `n_channels`: the number of channels of the input.
* `n_samples`: the number of samples for each channel of the input.
* `demean`: if `true`, the channelwise mean will be subtracted from the input signals before the cross spectral powers are computed.
* `freq_range`: if `nothing`, all frequencies are retained. Otherwise, only frequencies between `first(freq_range)` and `last(freq_range)` are retained.
* `ensure_aligned = T == Float32 || T == Complex{Float32}`: perform an extra copy to ensure that the FFT output is memory-aligned
* Additionally, either pass an [`MTConfig`](@ref) object, or keyword arguments such as `fs` accepted by [`MTConfig`](@ref).

Returns a `CrossPowerSpectra` object.
"""
function MTCrossSpectraConfig{T}(n_channels, n_samples; fs=1, demean=false,
                                 freq_range=nothing,
                                 ensure_aligned = T == Float32 || T == Complex{Float32},
                                 kwargs...) where {T}
    mt_config = MTConfig{T}(n_samples; fs, kwargs...)
    return MTCrossSpectraConfig{T}(n_channels, mt_config; demean, freq_range, ensure_aligned)
end

# extra method to ensure it's ok to pass the redundant type parameter {T}
MTCrossSpectraConfig{T}(n_channels, mt_config::MTConfig{T}; kwargs...) where {T} =
    MTCrossSpectraConfig(n_channels, mt_config; kwargs...)

function MTCrossSpectraConfig(n_channels, mt_config::MTConfig{T}; demean=false,
        freq_range=nothing, ensure_aligned = T == Float32 || T == Complex{Float32}) where {T}

    n_samples = mt_config.n_samples
    if demean
        mean_per_channel = Vector{T}(undef, n_channels)
        demeaned_signal = Matrix{T}(undef, n_channels, n_samples)
    else
        mean_per_channel = nothing
        demeaned_signal = nothing
    end

    normalization_weights = 2 ./ mt_config.r

    x_mt = Array{fftouttype(T),3}(undef, length(mt_config.freq), mt_config.ntapers,
                                  n_channels)
    if freq_range !== nothing
        freq_mask = first(freq_range) .< mt_config.freq .< last(freq_range)
        freq_inds = findall(freq_mask)
        freq = mt_config.freq[freq_mask]
    else
        freq_inds = eachindex(mt_config.freq)
        freq = mt_config.freq
    end
    return MTCrossSpectraConfig(n_channels, normalization_weights, x_mt, demean,
                                mean_per_channel, demeaned_signal, freq,
                                freq_range, freq_inds, ensure_aligned, mt_config)
end

function allocate_output(config::MTCrossSpectraConfig{T}) where {T}
    n_chan = config.n_channels
    n_freqs = length(config.freq)
    return Array{fftouttype(T),3}(undef, n_chan, n_chan,
                                  n_freqs)
end

"""
    mt_cross_power_spectra!(output, signal::AbstractMatrix; fs=1, kwargs...)
    mt_cross_power_spectra!(output, signal::AbstractMatrix, config::MTCrossSpectraConfig)

Computes multitapered cross power spectra between channels of a signal. Arguments:

* `output`: `n_channels` x `n_channels` x `length(config.freq)`. Can be created by `DSP.allocate_output(config)`.
* `signal`: `n_channels` x `n_samples`
* `config`: `MTCrossSpectraConfig{T}`: optionally pass a [`MTCrossSpectraConfig`](@ref) to
  preallocate temporary and choose configuration settings.
  Otherwise, one may pass any keyword arguments accepted by this object.

Produces a `CrossPowerSpectra` object holding the `n_channels` x `n_channels` x `n_frequencies`
output array and the corresponding frequencies (accessed by [`freq`](@ref)).

See also [`mt_cross_power_spectra`](@ref) and [`MTCrossSpectraConfig`](@ref).
"""
mt_cross_power_spectra!

function mt_cross_power_spectra!(output, signal::AbstractMatrix{T}; fs=1, kwargs...) where {T}
    n_channels, n_samples = size(signal)
    config = MTCrossSpectraConfig{T}(n_channels, n_samples; fs, fft_flags=FFTW.ESTIMATE,
                                     kwargs...)
    return mt_cross_power_spectra!(output, signal, config)
end

@views function mt_cross_power_spectra!(output, signal::AbstractMatrix,
                                   config::MTCrossSpectraConfig)
    n_chan = config.n_channels
    n_samples = config.mt_config.n_samples
    n_freqi = length(config.freq_inds)

    if size(signal) != (n_chan, n_samples)
        throw(DimensionMismatch(lazy"Size of `signal` does not match `(config.n_channels, config.mt_config.n_samples)`;
        got `size(signal)`=$(size(signal)) but `(config.n_channels, config.mt_config.n_samples)`=$((n_chan, n_samples))"))
    end
    if size(output) != (n_chan, n_chan, n_freqi)
        throw(DimensionMismatch(lazy"Size of `output` does not match `(config.n_channels, config.n_channels, length(config.freq_inds))`;
        got `size(output)`=$(size(output)) but `(config.n_channels, config.n_channels, length(config.freq_inds))`=$((n_chan, n_chan, n_freqi))"))
    end

    if config.demean
        mean!(config.mean_per_channel, signal)
        config.demeaned_signal .= signal .- config.mean_per_channel
        signal = config.demeaned_signal
    end

    x_mt = config.x_mt

    if config.ensure_aligned
        mt_fft_tapered_multichannel_ensure_aligned!(x_mt, signal, config)
    else
        mt_fft_tapered_multichannel!(x_mt, signal, config)
    end
    x_mt[1, :, :] ./= sqrt(2)
    if iseven(config.mt_config.nfft)
        x_mt[end, :, :] ./= sqrt(2)
    end
    cs_inner!(output, config.normalization_weights, x_mt, config)
    return CrossPowerSpectra(output, config.freq)
end

function mt_fft_tapered_multichannel_ensure_aligned!(x_mt, signal, config)
    fft_output = config.mt_config.fft_output_tmp
    for k in 1:(config.n_channels), taper in 1:config.mt_config.ntapers
        # we do this in two steps so that we are sure `fft_output` has the memory alignment FFTW expects (without needing the `FFTW.UNALIGNED` flag)
        mt_fft_tapered!(fft_output, signal[k, :], taper, config.mt_config)
        x_mt[:, taper, k] .= fft_output
    end
end

@views function mt_fft_tapered_multichannel!(x_mt, signal, config)
    for k in 1:(config.n_channels), taper in 1:config.mt_config.ntapers
        mt_fft_tapered!(x_mt[:, taper, k], signal[k, :], taper, config.mt_config)
    end
end

function cs_inner!(output, normalization_weights, x_mt, config)
    freq_inds = config.freq_inds
    n_channels = config.n_channels
    @boundscheck checkbounds(output, 1:n_channels, 1:n_channels, eachindex(freq_inds))
    @boundscheck checkbounds(x_mt, freq_inds, eachindex(normalization_weights), 1:n_channels)
    output .= zero(eltype(output))
    # Up to the `normalization_weights` scaling, we have
    # J_k^l(f) = x_mt[k, f, l]
    # Ŝ^lm(f) = output[l, m, f]
    # using the notation from https://en.wikipedia.org/wiki/Multitaper#The_method
    # so the formula `Ŝ^lm(f) = \sum_k conj(J_k^l(f)) * (J_k^m(f))`` becomes the following loop:
    @inbounds for (fi, f) in enumerate(freq_inds),
                  m in 1:n_channels,
                  l in 1:n_channels,
                  k in eachindex(normalization_weights)

        output[l, m, fi] += normalization_weights[k] * x_mt[f, k, l] * conj(x_mt[f, k, m])
    end
    return nothing
end

"""
    mt_cross_power_spectra(signal::AbstractMatrix{T}; fs=1, kwargs...) where {T}
    mt_cross_power_spectra(signal::AbstractMatrix, config::MTCrossSpectraConfig)

Computes multitapered cross power spectra between channels of a signal. Arguments:

* `signal`: `n_channels` x `n_samples`
* Optionally pass an [`MTCrossSpectraConfig`](@ref) object to preallocate temporary variables
and choose configuration settings. Otherwise, any keyword arguments accepted by [`MTCrossSpectraConfig`](@ref) may be passed here.

Produces a `CrossPowerSpectra` object holding the `n_channels` x `n_channels` x `n_frequencies`
output array (accessed by [`power`](@ref)) and the corresponding frequencies (accessed by [`freq`](@ref)).

See also [`mt_cross_power_spectra!`](@ref) and [`MTCrossSpectraConfig`](@ref).
"""
mt_cross_power_spectra

function mt_cross_power_spectra(signal::AbstractMatrix{T}; fs=1, kwargs...) where {T}
    n_channels, n_samples = size(signal)
    config = MTCrossSpectraConfig{T}(n_channels, n_samples; fs, fft_flags=FFTW.ESTIMATE,
                                     kwargs...)
    return mt_cross_power_spectra(signal, config)
end

function mt_cross_power_spectra(signal::AbstractMatrix, config::MTCrossSpectraConfig)
    output = allocate_output(config)
    return mt_cross_power_spectra!(output, signal, config)
end

#####
##### Multitapered coherences
#####

struct MTCoherenceConfig{T,T1,C<:MTCrossSpectraConfig{T}}
    cs_matrix::T1
    cs_config::C
end

"""
    MTCoherenceConfig{T}(n_channels, n_samples; fs=1, demean=false, freq_range=nothing, kwargs...) where T
    MTCoherenceConfig(cs_config::MTCrossSpectraConfig{T}) where {T}
    MTCoherenceConfig(n_channels, mt_config::MTConfig{T}; demean=false, freq_range=nothing,
        ensure_aligned = T == Float32 || T == Complex{Float32}) where {T}

Creates a configuration object for coherences from a [`MTCrossSpectraConfig`](@ref). Provides a helper method
with the same arugments as `MTCrossSpectraConfig` to construct the `MTCrossSpectraConfig` object.

See also [`mt_coherence`](@ref) and [`mt_coherence!`](@ref).
"""
MTCoherenceConfig(cs_config::MTCrossSpectraConfig) =
    MTCoherenceConfig(allocate_output(cs_config), cs_config)

# add a method to cover the case in which the user specifies the `{T}` here
MTCoherenceConfig{T}(cs_config::MTCrossSpectraConfig{T}) where {T} = MTCoherenceConfig(cs_config)

function MTCoherenceConfig{T}(n_channels, n_samples; kwargs...) where {T}
    cs_config = MTCrossSpectraConfig{T}(n_channels, n_samples; kwargs...)
    return MTCoherenceConfig(cs_config)
end

# ensure it's OK to pass the extra {T} type parameter
MTCoherenceConfig{T}(n_channels, mt_config::MTConfig{T}; kwargs...) where T =
    MTCoherenceConfig(n_channels, mt_config; kwargs...)

function MTCoherenceConfig(n_channels, mt_config::MTConfig{T}; kwargs...) where {T}
    cs_config = MTCrossSpectraConfig(n_channels, mt_config; kwargs...)
    return MTCoherenceConfig(cs_config)
end


function allocate_output(config::MTCoherenceConfig{T}) where {T}
    n_chan = config.cs_config.n_channels
    n_freqs = length(config.cs_config.freq)
    return Array{real(T),3}(undef, n_chan, n_chan, n_freqs)
end

"""
    coherence_from_cs!(output::AbstractArray, cs_matrix)

Compute the pairwise channel coherences from a cross spectral matrix, storing the result in `output`.
"""
function coherence_from_cs!(output::AbstractArray{T}, cs_matrix) where T
    n_channels = size(cs_matrix, 2)
    n_freqs = size(cs_matrix, 3)
    @boundscheck checkbounds(output, 1:n_channels, 1:n_channels, 1:n_freqs)
    @boundscheck checkbounds(cs_matrix, 1:n_channels, 1:n_channels, 1:n_freqs)
    output .= zero(T)
    @inbounds for f in 1:n_freqs,
                ch2 in 1:n_channels,
                ch1 in (ch2 + 1):n_channels # lower triangular matrix

        output[ch1, ch2, f] = abs(cs_matrix[ch1, ch2, f]) /
                                sqrt(real(cs_matrix[ch1, ch1, f] *
                                    cs_matrix[ch2, ch2, f]))
    end
    output .+= PermutedDimsArray(output, (2, 1, 3)) # symmetrize
    # diagonal elements should be `1` for any frequency
    @inbounds for k in axes(output, 3), i in 1:n_channels
        output[i, i, k] = one(T)
    end
    return nothing
end

"""
    Coherence{T, F, A<:AbstractArray{T, 3}}

Holds an `n_channels` x `n_channels` x `length(freq)` array consisting of the pairwise coherences between each channel for each frequency which is accessed by [`coherence`](@ref), as well
as the frequencies accessed by [`freq`](@ref).

See also [`mt_coherence`](@ref) and [`mt_coherence!`](@ref).
"""
struct Coherence{T,F,A<:AbstractArray{T, 3}}
    coherence::A
    freq::F
end

freq(c::Coherence) = c.freq

"""
    coherence(c::Coherence)

Given an `Coherence` object, returns an `n_channels` x `n_channels` x `length(freq(c))`
array consisting of the pairwise coherences between each channel for each frequency.
"""
coherence(c::Coherence) = c.coherence

"""
    mt_coherence!(output, signal::AbstractMatrix; fs=1, freq_range=nothing, demean=false, kwargs...)
    mt_coherence!(output, signal::AbstractMatrix, config::MTCoherenceConfig)

Computes the pairwise coherences between channels.

* `output`: `n_channels` x `n_channels` matrix
* `signal`: `n_samples` x `n_channels` matrix
* `config`: optional configuration object that pre-allocates temporary variables and choose settings.

Returns a `Coherence` object.

See also [`mt_coherence`](@ref) and [`MTCoherenceConfig`](@ref).
"""
mt_coherence!

function mt_coherence!(output, signal::AbstractMatrix,
                       config::MTCoherenceConfig)
    n_chan = config.cs_config.n_channels
    n_samples = config.cs_config.mt_config.n_samples
    n_freqs = length(config.cs_config.freq)

    if size(signal) != (n_chan, n_samples)
        throw(DimensionMismatch(lazy"Size of `signal` does not match `(config.cs_config.n_channels, config.cs_config.mt_config.n_samples)`;
            got `size(signal)`=$(size(signal)) but `(config.cs_config.n_channels, config.cs_config.mt_config.n_samples)`=$((n_chan, n_samples))"))
    end
    if size(output) != (n_chan, n_chan, n_freqs)
        throw(DimensionMismatch(lazy"Size of `output` does not match `(config.cs_config.n_channels, config.cs_config.n_channels, length(config.cs_config.freq))`;
        got `size(output)`=$(size(output)) but `(config.cs_config.n_channels, config.cs_config.n_channels, length(config.cs_config.freq))`=$((n_chan, n_chan, n_freqs))"))
    end
    cs = mt_cross_power_spectra!(config.cs_matrix, signal, config.cs_config)
    coherence_from_cs!(output, power(cs))

    return Coherence(output, config.cs_config.freq)
end

function mt_coherence!(output, signal::AbstractMatrix{T}; kwargs...) where {T}
    n_channels, n_samples = size(signal)
    config = MTCoherenceConfig{T}(n_channels, n_samples; fft_flags=FFTW.ESTIMATE, kwargs...)
    return mt_coherence!(output, signal, config)
end


"""
    mt_coherence(signal::AbstractMatrix{T}; fs=1, freq_range = nothing, demean=false, kwargs...) where T
    mt_coherence(signal::AbstractMatrix, config::MTCoherenceConfig)

Arguments:

* `signal`: `n_channels` x `n_samples` matrix
* Optionally pass an `MTCoherenceConfig` to pre-allocate temporary variables and choose configuration settings, otherwise, see [`MTCrossSpectraConfig`](@ref) for the meaning of the keyword arguments.

Returns a `Coherence` object.

See also [`mt_coherence`](@ref) and [`MTCoherenceConfig`](@ref).
"""
mt_coherence

function mt_coherence(signal::AbstractMatrix{T}; kwargs...) where {T}
    n_channels, n_samples = size(signal)
    config = MTCoherenceConfig{T}(n_channels, n_samples; fft_flags=FFTW.ESTIMATE, kwargs...)
    return mt_coherence(signal, config)
end


function mt_coherence(signal::AbstractMatrix, config::MTCoherenceConfig)
    cohs = allocate_output(config)
    return mt_coherence!(cohs, signal, config)
end

using Documenter, DSP

DocMeta.setdocmeta!(DSP, :DocTestSetup, :(using DSP); recursive=true)

makedocs(
    modules = [DSP],
    format = Documenter.HTML(),
    sitename = "DSP.jl",
    pages = [
        "Home" => "index.md",
        "Submodules" => [
            "periodograms.md",
            "estimation.md",
            "windows.md",
            "filters.md",
            "util.md",
            "convolutions.md",
            "lpc.md"
        ],
        "Internals" => "internals.md",
        "Index" => "appendix.md"
    ],
)

deploydocs(
    repo = "github.com/JuliaDSP/DSP.jl.git",
    target = "build",
    deps   = nothing,
    make   = nothing,
    push_preview = true,
)

using DSP, Test

!(@__DIR__() in LOAD_PATH) && push!(LOAD_PATH, @__DIR__)
using FilterTestHelpers: read_reference_data

reference_vec(s) = vec(read_reference_data(s))

@testset "rational ratio" begin
    # AM Modulator
    # sig(t) = [(1 + sin(2π*0.005*t)) * sin(2π*.05*t) for t in t]
    x_ml = reference_vec("resample_x.txt")

    #
    # [y,b] = resample(x, $num, $den)
    #
    for rate in (1//2, 2//1, 3//2, 2//3)
        num, den = numerator(rate), denominator(rate)
        h_ml = reference_vec("resample_taps_$(num)_$(den).txt")
        y_ml = reference_vec("resample_y_$(num)_$(den).txt")
        y_jl = resample(x_ml, rate, h_ml)
        @test y_ml ≈ y_jl
        @test y_ml ≈ resample(x_ml, rate) rtol = 0.001     # check default taps are ok
    end
end

@testset "array signal" begin
    x, mat, rate = rand(10_000), rand(121, 212), 1.23456789
    h = resample_filter(rate)
    # check that filtering with taps from `resample_filter` give equal results
    @test resample(x, rate) == resample(x, rate, h)
    @test resample(x, rate, 64, 0.8) == resample(x, rate, resample_filter(rate, 64, 0.8), 64)
    @test resample(mat, rate; dims=1) == resample(mat, rate, h; dims=1)
    @test resample(mat, rate; dims=2) == resample(mat, rate, h; dims=2)

    rate = 1//2
    x_ml = reference_vec("resample_x.txt")
    h_ml = reference_vec("resample_taps_1_2.txt")
    y_ml = reference_vec("resample_y_1_2.txt")
    expected_result = [y_ml ℯ * y_ml]
    X = [x_ml ℯ * x_ml]

    y_jl  = resample(X, rate, h_ml; dims=1)
    arb_y = resample(X, float(rate); dims=1)
    rat_y = resample(X, rate; dims=1)
    @test y_jl ≈ expected_result
    @test arb_y ≈ expected_result  rtol = 0.002     # test that default taps are good enough
    @test rat_y ≈ expected_result  rtol = 0.0005

    y_jl  = resample(X', rate, h_ml; dims=2)
    arb_y = resample(X', float(rate); dims=2)
    rat_y = resample(X', rate; dims=2)
    @test y_jl ≈ expected_result'
    @test arb_y ≈ expected_result' rtol = 0.002
    @test rat_y ≈ expected_result' rtol = 0.0005

    expected_result_3d = permutedims(reshape(expected_result, (size(expected_result, 1), size(expected_result, 2), 1)), (3, 1, 2))
    X_3d = permutedims(reshape(X, (size(X, 1), size(X, 2), 1)), (3, 1, 2))
    y_jl = resample(X_3d, rate, h_ml; dims=2)
    @test y_jl ≈ expected_result_3d

    expected_result_3d = permutedims(expected_result_3d, (1, 3, 2))
    X_3d = permutedims(X_3d, (1, 3, 2))
    y_jl = resample(X_3d, rate, h_ml; dims=3)
    @test y_jl ≈ expected_result_3d

    # check buffer is resized properly (vs old implementation)
    # also test that FIRInterpolator/Decimator is reset!ed properly (issue #625)
    for dims in 1:3, rate in (1.2, 0.8, 4, 2//1, 1//2)
        A = rand(3, 3, 3)
        @test resample(A, rate; dims) == mapslices(v -> resample(v, rate), A; dims)
    end
end

@testset "irrational ratio" begin
    ratio    = 3.141592653589793
    cycles   = 2
    tx       = range(0, stop=cycles, length=1000)
    x        = sinpi.(2*tx)
    y        = resample(x, ratio)
    yLen     = length(y)
    ty       = range(0, length=yLen, step=step(tx)/ratio)
    yy       = sinpi.(2*ty)
    idxLower = round(Int, yLen/3)
    idxUpper = idxLower*2
    yDelta   = abs.(y[idxLower:idxUpper].-yy[idxLower:idxUpper])
    @test maximum(yDelta) < 0.00025

    # Test Float32 ratio (#302)
    f32_ratio = convert(Float32, ratio)
    f32_y     = resample(x, f32_ratio)
    ty        = range(0, length=yLen, step=step(tx)/f32_ratio)
    yy        = sinpi.(2*ty)
    idxLower  = round(Int, yLen/3)
    idxUpper  = idxLower*2
    yDelta    = abs.(f32_y[idxLower:idxUpper].-yy[idxLower:idxUpper])
    @test maximum(yDelta) < 0.00025
end

@testset "arbitrary ratio" begin
    # https://github.com/JuliaDSP/DSP.jl/issues/317
    @testset "Buffer length calculation" begin
        @test length(resample(sin.(1:1:35546),  1/55.55)) == 640
        @test length(resample(randn(1822), 0.9802414928649835)) == 1786
        @test length(resample(1:16_367_000*2, 10_000_000/16_367_000)) == 20_000_000
        @test resample(zeros(1000), 0.012) == zeros(12)
    end
end

@testset "resample_filter" begin
    @testset "decimation" begin
        ratio = 1//2
        h     = resample_filter(ratio)
        r0    = abs.(freqresp(PolynomialRatio(h, [1]), 0))
        rc    = abs.(freqresp(PolynomialRatio(h, [1]), ratio*π))
        @test isapprox(r0, 1.0)
        @test isapprox(rc, numerator(ratio)/2, rtol=0.001)

        ratio = 1//32
        h     = resample_filter(ratio)
        r0    = abs.(freqresp(PolynomialRatio(h, [1]), 0))
        rc    = abs.(freqresp(PolynomialRatio(h, [1]), ratio*π))
        @test isapprox(r0, numerator(ratio))
        @test isapprox(rc, numerator(ratio)/2, rtol=0.001)
    end

    @testset "interpolation" begin
        ratio = 2//1
        h     = resample_filter(ratio)
        r0    = abs.(freqresp(PolynomialRatio(h, [1]), 0))
        rc    = abs.(freqresp(PolynomialRatio(h, [1]), 1/ratio*π))
        @test isapprox(r0, numerator(ratio))
        @test isapprox(rc, numerator(ratio)/2, rtol=0.001)

        ratio = 32//1
        h     = resample_filter(ratio)
        r0    = abs.(freqresp(PolynomialRatio(h, [1]), 0))
        rc    = abs.(freqresp(PolynomialRatio(h, [1]), 1/ratio*π))
        @test isapprox(r0, numerator(ratio))
        @test isapprox(rc, numerator(ratio)/2, rtol=0.001)
    end

    @testset "arbitrary rate" begin
        ratio = 3.141592653589793
        Nϕ    = 32
        fc    = 1/Nϕ
        h     = resample_filter(ratio, Nϕ)
        r0    = abs.(freqresp(PolynomialRatio(h, [1]), 0))
        rc    = abs.(freqresp(PolynomialRatio(h, [1]), fc*π))
        @test isapprox(r0, Nϕ)
        @test isapprox(rc, Nϕ/2, rtol=0.001)
    end
end

@testset "inputlength" begin
    # FIRDecimator, FIRInterpolator, FIRRational
    for _ in 1:1000
        M=rand(1:10)//rand(1:10)
        H=FIRFilter(zeros(rand(1:100)), M)
        if M != 1
            setphase!(H, 10*rand())
        end
        yL = rand(1:100)
        @test outputlength(H, inputlength(H, yL)) <= yL < outputlength(H, inputlength(H, yL)+1)
        @test outputlength(H, inputlength(H, yL, RoundUp)-1) < yL <= outputlength(H, inputlength(H, yL, RoundUp))
    end

    # FIRArbitrary
    for _ in 1:1000
        M = 10*rand()
        H = FIRFilter(zeros(rand(1:100)), M)
        setphase!(H, 10*rand())
        yL = rand(1:100)
        @test outputlength(H, inputlength(H, yL)) <= yL < outputlength(H, inputlength(H, yL)+1)
        @test outputlength(H, inputlength(H, yL, RoundUp)-1) < yL <= outputlength(H, inputlength(H, yL, RoundUp))
    end
    let M = 2.0, H = FIRFilter(resample_filter(M), M)
        setphase!(H, timedelay(H))
        yL = 200
        @test outputlength(H, inputlength(H, yL)) <= yL < outputlength(H, inputlength(H, yL)+1)
        @test outputlength(H, inputlength(H, yL, RoundUp)-1) < yL <= outputlength(H, inputlength(H, yL, RoundUp))
    end
end

@testset "FIRFilter types" begin
    using DSP.Filters: FIRStandard, FIRInterpolator
    # test FIRRational(::Vector, ::Int(/Int32)) inferred result type
    FIRFutyp = Union{FIRFilter{<:FIRInterpolator},FIRFilter{<:FIRStandard}}
    @test only(Base.return_types(FIRFilter, (Vector, Int64))) <: FIRFutyp broken=VERSION<v"1.11"
    @test only(Base.return_types(FIRFilter, (Vector, Int32))) <: FIRFutyp broken=VERSION<v"1.11"
    FIRFutype{T} = Union{FIRFilter{FIRInterpolator{T},T},FIRFilter{FIRStandard{T},T}} where T
    @test only(Base.return_types(FIRFilter, (Vector{Float64}, Int64))) == FIRFutype{Float64}
    @test only(Base.return_types(FIRFilter, (Vector{Float64}, Int32))) == FIRFutype{Float64}

    # check that non-Int / Rational{Int} ratios get converted properly
    x = rand(200)
    @test resample(x, Int32(3)) == resample(x, Int64(3))
    @test resample(x, Rational{Int32}(1, 3)) == resample(x, Rational{Int64}(1, 3))
    @test resample(x, Rational{Int32}(2, 3)) == resample(x, Rational{Int64}(2, 3))
end

#in matlab:
#x=rand(512,1);
#[s,f,t,p]=spectrogram(x,ones(1,256),128,256,10);
#save
#
#in julia:
#using MAT
#
#matdata=matread("matlab.mat")
#
#for i in ("x", "f", "t", "p")
#  fid=open("spectrogram_$i.txt","w")
#  print(fid,matdata["$i"])
#  close(fid)
#end

using DSP, Test
using Statistics: mean
using FFTW: fft, fftfreq, fftshift, rfft, ifft
using DSP: allocate_output

!(@__DIR__() in LOAD_PATH) && push!(LOAD_PATH, @__DIR__)
using FilterTestHelpers

@testset "matlab ref" begin
    x0 = read_reference_data("spectrogram_x.txt") |> vec
    f0 = read_reference_data("spectrogram_f.txt") |> vec
    t0 = read_reference_data("spectrogram_t.txt") |> vec
    p0 = read_reference_data("spectrogram_p.txt")
    spec = spectrogram(x0, 256, 128; fs=10)
    p, f, t = power(spec), freq(spec), time(spec)

    # with real input matlab outputs a 1-sided PSD
    @test p0 ≈ p
    @test f0 ≈ f
    @test t0 ≈ t


    mt_spec = mt_spectrogram(x0, 256, 128; fs=10)
    @test freq(mt_spec) == f
    @test time(mt_spec) == t
    @test power(mt_spec)[:,1] ≈ power(mt_pgram(x0[1:256]; fs=10))

    function test_mtspec(m, mt_spec)
        @test power(m) ≈ power(mt_spec)
        @test freq(m) == freq(mt_spec)
        @test time(m) == time(mt_spec)
        nothing
    end

    # in-place full precision version:
    spec_config = MTSpectrogramConfig{Float64}(length(x0), 256, 128; fs=10)
    out = allocate_output(spec_config)
    mt_spec2 = mt_spectrogram!(out, x0, spec_config)
    test_mtspec(mt_spec2, mt_spec)

    # out-of-place with config:
    r = mt_spectrogram(x0, spec_config)
    test_mtspec(r, mt_spec)

    # in-place without config:
    r = mt_spectrogram!(out, x0, 256, 128; fs=10)
    test_mtspec(r, mt_spec)

    # in-place half precision version:
    spec_config = MTSpectrogramConfig{Float32}(length(x0), 256, 128; fs=10)
    out = allocate_output(spec_config)
    mt_spec3 = mt_spectrogram!(out, x0, spec_config)
    test_mtspec(mt_spec3, mt_spec)

    mt_spec4 = mt_spectrogram!(out, Float32.(x0), spec_config)
    test_mtspec(mt_spec4, mt_spec)

    # We can also only pass the window config. Full precision:
    config = MTConfig{Float64}(256; fs=10)
    mt_spec5 = mt_spectrogram(x0, config, 128)
    test_mtspec(mt_spec5, mt_spec)

    # We can also only pass the window config. Half precision:
    config = MTConfig{Float32}(256; fs=10)
    mt_spec6 = mt_spectrogram(x0, config, 128)
    test_mtspec(mt_spec6, mt_spec)

    # with Float32 input:
    mt_spec7 = mt_spectrogram(Float32.(x0), config, 128)
    test_mtspec(mt_spec7, mt_spec)

    @test_throws DimensionMismatch mt_spectrogram!(similar(out, size(out, 1), size(out, 2)+1), x0, spec_config)
    @test_throws DimensionMismatch mt_spectrogram!(out, vcat(x0, x0), spec_config)
end

@testset "0:7" begin
    #Matlab: p = pwelch(0:7, [1, 1, 1, 1, 1, 1, 1, 1], 0, 8, 1, 'twosided')
    data = 0:7
    data0 = Float64[98.0,
                    13.656854249492380,
                    4.0,
                    2.343145750507620,
                    2.0,
                    2.343145750507620,
                    4.0,
                    13.656854249492380]
    @test power(periodogram(data, onesided=false)) ≈ data0
    @test power(@test_deprecated welch_pgram(data, length(data), 0, onesided=false)) ≈ data0
    @test power(welch_pgram(data, length(data), 0, onesided=false, window=nothing)) ≈ data0
    @test power(spectrogram(data, length(data), 0, onesided=false)) ≈ data0
    @test power(periodogram(complex.([data;], [data;]), onesided=false)) ≈ data0*2
    @test power(@test_deprecated welch_pgram(complex.([data;], [data;]), length(data), 0, onesided=false)) ≈ data0*2
    @test power(welch_pgram(complex.([data;], [data;]), length(data), 0, onesided=false, window=nothing)) ≈ data0*2
    @test power(spectrogram(complex.([data;], [data;]), length(data), 0, onesided=false)) ≈ data0*2

    # # ~~~~~~~~ Tests with no window ~~~~~~~~~~~~~~~~~~~
    # Matlab: p = pwelch(0:7, [1, 1], 0, 2, 1, 'twosided')
    expected = Float64[34.5, 0.5]
    @test power(@test_deprecated welch_pgram(data, 2, 0; onesided=false)) ≈ expected
    @test power(welch_pgram(data, 2, 0; onesided=false, window=nothing)) ≈ expected
    @test mean(power(spectrogram(data, 2, 0; onesided=false)), dims=2) ≈ expected

    # Matlab: p = pwelch(0:7, [1, 1, 1], 0, 3, 1, 'twosided')
    expected = Float64[25.5, 1.0, 1.0]
    @test power(@test_deprecated welch_pgram(data, 3, 0; onesided=false)) ≈ expected
    @test power(welch_pgram(data, 3, 0; onesided=false, window=nothing)) ≈ expected
    @test mean(power(spectrogram(data, 3, 0; onesided=false)), dims=2) ≈ expected

    # Matlab: p = pwelch(0:7, [1, 1, 1], 1, 3, 1, 'twosided')
    expected = Float64[35.0, 1.0, 1.0]
    @test power(@test_deprecated welch_pgram(data, 3, 1; onesided=false)) ≈ expected
    @test power(welch_pgram(data, 3, 1; onesided=false, window=nothing)) ≈ expected
    @test mean(power(spectrogram(data, 3, 1; onesided=false)), dims=2) ≈ expected

    # Matlab: p = pwelch(0:7, [1, 1, 1, 1], 1, 4, 1, 'twosided')
    expected = Float64[45, 2, 1, 2]
    @test power(@test_deprecated welch_pgram(data, 4, 1; onesided=false)) ≈ expected
    @test power(welch_pgram(data, 4, 1; onesided=false, window=nothing)) ≈ expected
    @test mean(power(spectrogram(data, 4, 1; onesided=false)), dims=2) ≈ expected

    # ~~~~~~~~~~~ This one tests periodogram ~~~~~~~~~~~~
    # ~ If functionality of the other arguments has been
    # ~ tested above, we only test here that the correct
    # ~ value of the spectral density is obtained when
    # ~ using a window. More tests to be added if needed
    #Matlab: p = pwelch(0:7, window_func(8), 0, 8, 1, 'twosided')
    cases = (
        (hamming,  Float64[65.461623986801527,
                           20.556791795515764,
                            0.369313143650544,
                            0.022167446610882,
                            0.025502985564107,
                            0.022167446610882,
                            0.369313143650544,
                           20.556791795515764]),
        (bartlett, Float64[62.999999999999993,
                           21.981076052592442,
                            0.285714285714286,
                            0.161781090264695,
                            0.142857142857143,
                            0.161781090264695,
                            0.285714285714286,
                           21.981076052592442])
    )

    @testset for (window1, expected) in cases
        @test power(periodogram(data; window=window1, onesided=false)) ≈ expected
        @test power(welch_pgram(data, length(data), 0; window=window1, onesided=false)) ≈ expected
        @test power(spectrogram(data, length(data), 0; window=window1, onesided=false)) ≈ expected
        @test power(periodogram(data; window=window1(length(data)), onesided=false)) ≈ expected
        @test power(welch_pgram(data, length(data), 0; window=window1(length(data)), onesided=false)) ≈ expected
        @test power(spectrogram(data, length(data), 0; window=window1(length(data)), onesided=false)) ≈ expected
    end

    # Padded periodogram
    # MATLAB: a = periodogram(0:7, [], 32);
    expected = [
                      98
        174.463067389405
        121.968086934209
        65.4971744936088
        27.3137084989848
        12.1737815028909
        10.3755170959439
        10.4034038628775
                       8
        5.25810953219633
        4.47015397150535
        4.89522578856669
        4.68629150101524
        3.69370284475603
         3.1862419983415
        3.61553458569862
                       2
    ]
    @test power(periodogram(data; nfft=32)) ≈ expected
    @test power(@test_deprecated welch_pgram(data, length(data), 0; nfft=32)) ≈ expected
    @test power(welch_pgram(data, length(data), 0; nfft=32, window=nothing)) ≈ expected
    @test power(spectrogram(data, length(data), 0; nfft=32)) ≈ expected

    # Padded periodogram with window
    # MATLAB: a = periodogram(0:7, hamming(8), 32, 1)
    expected = [
          65.4616239868015
          122.101693164395
          98.8444689598445
           69.020252632913
          41.1135835910315
          20.5496474310966
          8.43291449161938
          2.78001620362588
         0.738626287301088
         0.174995741770789
        0.0501563022944516
        0.0327357460012861
        0.0443348932217643
        0.0553999745503552
        0.0561319901616643
        0.0526025934871384
        0.0255029855641069
    ]
    @test power(periodogram(data; window=hamming, nfft=32)) ≈ expected
    @test power(welch_pgram(data, length(data), 0; window=hamming, nfft=32)) ≈ expected
    @test power(spectrogram(data, length(data), 0; window=hamming, nfft=32)) ≈ expected

    # test welch_pgram configuration object
    expected = power(welch_pgram(data, length(data), 0; window=hamming, nfft=32))
    config = WelchConfig(data; n=length(data), noverlap=0, window=hamming, nfft=32)
    @test power(welch_pgram(data, config)) == expected

    # test welch_pgram!
    out = similar(expected)
    @test power(welch_pgram!(out, data, config)) == expected
    @test power(welch_pgram!(out, data, length(data), 0; window=hamming, nfft=32)) == expected
    @test_throws ArgumentError welch_pgram!(convert(Vector{Float32}, out), data, config)
    @test_throws ArgumentError welch_pgram!(convert(Vector{Float32}, out), Float32.(data), config)
    @test_throws DimensionMismatch welch_pgram!(empty!(out), data, config)

    # test welch_pgram! with float64 data
    out = similar(expected)
    @test power(welch_pgram!(out, convert(UnitRange{Float64}, data), config)) == expected

    # Test fftshift
    p = periodogram(data); p_shifted = fftshift(p)
    @test power(p) == power(p_shifted)
    @test freq(p) ≈ freq(p_shifted)
    @test p_shifted == fftshift(p_shifted)

    p = periodogram(data; onesided=false)
    @test fftshift(power(p)) == power(fftshift(p))
    @test fftshift(freq(p)) == freq(fftshift(p))
end

@testset "fftshift" begin
    data = 1:100

    p = spectrogram(data); p_shifted = fftshift(p)
    @test power(p) == power(p_shifted)
    @test freq(p) ≈ freq(p_shifted)
    @test p_shifted == fftshift(p_shifted)

    p = spectrogram(data; onesided=false)
    @test fftshift(power(p), 1) == power(fftshift(p))
    @test fftshift(freq(p)) == freq(fftshift(p))

    using DSP.Periodograms: Periodogram2

    # for coverage, not very useful...
    p = Periodogram2([1 2; 3 4], 1:2, fftfreq(2)); ps = fftshift(p)
    @test ps.power == fftshift(p.power, 2)
    @test (ps.freq1, ps.freq2) == (p.freq1, fftshift(p.freq2))
end

@testset "2D" begin
    data2d = read_reference_data("per2dx.txt")
    expectedsum = vec(read_reference_data("per2dsum.txt"))
    expectedmean = vec(read_reference_data("per2dmean.txt"))
    # 2-d periodgram (radialsum)
    # computed in octave with raPsd2d ((C) E. Ruzanski) replacing nanmean with nansum
    # P = raPsd2d(x,1)'*n^2
    @test power(periodogram(data2d,fs=1, radialsum=true)) ≈ expectedsum

    # 2-d periodgram (radialavg)
    # computed in octave with raPsd2d ((C) E. Ruzanski)
    # P = raPsd2d(x,1)'*n^2
    @test power(periodogram(data2d, fs=1, radialavg=true)) ≈ expectedmean

    # 2-d periodgram 2-d PSD
    @test power(periodogram(data2d, fs=1)) ≈ abs2.(fft(data2d))*1/prod(size(data2d))
    # 2-d periodgram 2-d PSD with padding
    pads = (size(data2d,1)+4,size(data2d,1)+7)
    data2dpad = zeros(Float64,pads...)
    data2dpad[1:size(data2d,1),1:size(data2d,2)] = data2d
    @test power(periodogram(data2d, fs=1, nfft=pads)) ≈ abs2.(fft(data2dpad))*1/prod(size(data2d))
    # 2-d periodgram radial freq
    @test freq(periodogram(data2d, fs=3.3, radialsum=true)) ≈ freq(periodogram(vec(data2d[1,:]), fs=3.3))
    # 2-d periodgram 2-d freq
    f1,f2 = freq(periodogram(data2d, fs=3.3))
    f1d = freq(periodogram(vec(data2d[1,:]), fs=3.3, onesided=false))
    @assert size(data2d,1)==size(data2d,2)
    for j=1:size(data2d,2)
        for i=1:size(data2d,1)
            @test  [f1[i],f2[j]] ≈ [f1d[i],f1d[j]]
        end
    end
    # Test fftshift
    p = periodogram(data2d); p_shifted = fftshift(p)
    @test fftshift(power(p)) == power(fftshift(p))
    @test p_shifted == fftshift(p_shifted)
    f = freq(p)
    @test (fftshift(f[1]),fftshift(f[2])) == freq(p_shifted)
end

@testset "radial" begin
    # 2-d periodgram radial test for a non-square signal sparse in fft space
    n1 = 52
    n2 = 46  # assuming n1>n2
    nf = (22,7) # the non-zero location
    F = (fftfreq(n1,1),fftfreq(n2,1))
    a = [F[1][nf[1]],F[2][nf[2]]]
    FB = Bool[[F[1][i], F[2][j]]==a || [F[1][i], F[2][j]]==-a for i = 1:n1, j = 1:n2]
    ind = findall(FB)
    x = zeros(n1,n2)*0im;
    x[ind] = [1+2im,1-2im]
    y = real(ifft(x))

    fwn = round(Int, sqrt((a[1])^2+(a[2])^2)*n2)
    pe = zeros(n2>>1 + 1)
    pe[fwn+1] = 2*abs2(x[nf...])/n1/n2
    P = periodogram(y,nfft=(n1,n2),radialsum=true)
    @test power(P) ≈ pe
    @test freq(P)[fwn+1] ≈ fwn/n2
end

# Testing STFT function and comparing results with MATLAB
@testset "stft" begin
    fs = 16000
    nfft = 512
    nwin = 400
    nhop = 160
    s = vec(read_reference_data("stft_x.txt"))

    Sjl = stft(s, nwin, nwin-nhop; nfft=nfft, fs=fs, window=hanning)
    Sml_re = read_reference_data("stft_S_real.txt")
    Sml_im = read_reference_data("stft_S_imag.txt")
    Sml = complex.(Sml_re, Sml_im)
    @test Sjl ≈ Sml
end

@testset "fft2oneortwosided!" begin
    n = 10
    floatt = Float64
    for onesided in (true, false),
            nfft in (n, n+2, n+3),
           atype in (floatt, Complex{floatt})
        nout = nout = onesided ? (nfft >> 1)+1 : nfft
        x = zeros(atype, nfft)
        if atype <: Real
            x[1:n] = rand(atype, n)
            xrcfft = rfft(x)
        else
            x[1:n] = rand(floatt, n)+im*rand(floatt, n)
            xrcfft = fft(x)
        end
        xfft = fft(x)
        out = zeros(fftouttype(atype), (nout, 3))
        if !(onesided == true && atype <: Complex)
            outft = DSP.Periodograms.fft2oneortwosided!(out, xrcfft, nfft, onesided, nout)
        end
        if onesided == true && atype <: Real
            @test out[:,2] ≈ xrcfft
            @test out[:,[1,3]] ≈ xrcfft.*[0 0]
        elseif onesided == false && atype <: Real
            @test out[:,2] ≈ xfft
            @test out[:,[1,3]] ≈ xfft.*[0 0]
        elseif onesided == false && atype <: Complex
            @test out[:,2] ≈ xfft
            @test out[:,[1,3]] ≈ xfft.*[0 0]
        else
            #onesided complex
        end
    end
end

@testset "mt_pgram" begin
    # MATLAB: x = pmtm(stft_x, 4, 5000, 16000, 'unity')
    s = vec(read_reference_data("stft_x.txt"))
    mtdata = vec(read_reference_data("mt_pgram.txt"))
    @test power(mt_pgram(s; fs=16000)) ≈ mtdata
    @test power(mt_pgram(s; fs=16000, window=dpss(length(s), 4))) ≈ mtdata

    # error tests
    @test_throws ArgumentError periodogram([1 2 3])
    @test_throws ArgumentError periodogram(rand(2,3), nfft=(3,2))
    @test_throws ArgumentError periodogram([1 2;3 4],radialsum=true, radialavg=true)

    # #124
    q = arraysplit(ones(Float64, 1000),100,10);
    @test map(mean, q) == ones(Float64, 11)

    # test that iterating ArraySplit always yields the same Vector
    q = arraysplit(-10:10,4,2)
    for x in q
        @assert isa(x, Vector)
        @test pointer(x) == pointer(q.buf)
    end

    x = vec(read_reference_data("pmtm_x.txt"))
    @test eltype(x) <: Float64

    # MATLAB code:
    # fft = 2^nextpow2(length(x));
    # [pxx,fx] = pmtm(x,4,nfft,1000,'unity');
    fx = vec(read_reference_data("pmtm_fx.txt"))
    pxx = vec(read_reference_data("pmtm_pxx.txt"))

    fs = 1000
    nw=4
    nfft = nextpow(2, length(x))
    result = mt_pgram(x; fs=fs, nw=nw, nfft=nfft)
    @test freq(result) ≈ fx
    @test power(result) ≈ pxx

    # Test against in-place. Full precision:
    config = MTConfig{Float64}(length(x); fs=fs, nw=nw, nfft=nfft)
    out = allocate_output(config)
    @test eltype(out) == Float64
    result2 = mt_pgram!(out, x, config)
    @test freq(result2) ≈ fx
    @test power(result2) ≈ pxx

    # in-place without config
    r = mt_pgram!(out, x; fs=fs, nw=nw, nfft=nfft)
    @test freq(r) ≈ fx
    @test power(r) ≈ pxx

    # out-of-place with config
    r = mt_pgram(x, config)
    @test freq(r) ≈ fx
    @test power(r) ≈ pxx

    # Lower precision output:
    config = MTConfig{Float32}(length(x); fs=fs, nw=nw, nfft=nfft)
    out = allocate_output(config)
    @test eltype(out) == Float32
    result3 = mt_pgram!(out, x, config)
    @test freq(result3) ≈ fx
    @test power(result3) ≈ pxx

    # with Float32 input:
    result4 = mt_pgram!(out, Float32.(x), config)
    @test freq(result4) ≈ fx
    @test power(result4) ≈ pxx

    @test_throws DimensionMismatch mt_pgram!(similar(out, length(out)+1), x, config)
    @test_throws DimensionMismatch mt_pgram!(out, vcat(x, one(eltype(x))), config)

    y = vec(read_reference_data("pmtm_y.txt"))
    z = x + im*y
    @test eltype(z) <: Complex{Float64}

    # MATLAB code: `[pzz,fz] = pmtm(z,4,nfft,1000, 'unity')`
    fz = vec(read_reference_data("pmtm_fz.txt"))
    pzz = vec(read_reference_data("pmtm_pzz.txt"))
    result = mt_pgram(z; fs=fs, nw=nw, nfft=nfft)
    result_mask = 0 .< freq(result) .< 500
    freqs = freq(result)[result_mask]
    @test freqs ≈ fz[2:length(freqs)+1]
    @test power(result)[result_mask] ≈ pzz[2:length(freqs)+1]

    # Test against in-place. Full precision:
    config = MTConfig{Complex{Float64}}(length(z); fs=fs, nw=nw, nfft=nfft)
    out = allocate_output(config)
    @test eltype(out) == Float64

    result2 = mt_pgram!(out, z, config)
    @test freq(result2) == freq(result)
    @test power(result2) ≈ power(result)

    # Lower precision output:
    config = MTConfig{Complex{Float32}}(length(z); fs=fs, nw=nw, nfft=nfft)
    out = allocate_output(config)
    @test eltype(out) == Float32

    result2 = mt_pgram!(out, z, config)
    @test freq(result2) == freq(result)
    @test power(result2) ≈ power(result)

    # Lower precision computation:
    result3 = mt_pgram!(out, Complex{Float32}.(z), config)
    @test freq(result3) == freq(result)
    @test power(result3) ≈ power(result)

end

# this script is used to generate the ascii plots used in the window docstrings

using UnicodePlots
using DSP

open(joinpath(@__DIR__, "..", "src", "winplots.jl"), "w") do io

    println(io, """
    #####################################################
    # THIS FILE IS AUTO-GENERATED
    # to re-generate use the `gen_winplots.jl` script
    #####################################################
    """)

    for (winfunc, args) in [
        (rect, ()),
        (hanning, ()),
        (hamming, ()),
        (tukey, (0.4)),
        (cosine, ()),
        (lanczos, ()),
        (triang, ()),
        (bartlett, ()),
        (gaussian, (0.2)),
        (bartlett_hann, ()),
        (blackman, ()),
        (blackmanharris, ()),
        (nuttall, ()),
        (kaiser, (3)),
        (flattop, ()),
        (dpss, (2, 1)),
        ]

        ymax = winfunc == dpss ? 0.2 : 1.0
        n = winfunc == triang ? 7 : 69

        fname = split(string(winfunc), ".")[end]
        println(io, "const $(fname)_winplot = padplot(\"\"\"")
        # convert Nx1 matrices to vectors with [:] - necessary for dpss
        if (winfunc == flattop)
            print(io, lineplot(winfunc(n, args...)[:], ylim=[-0.1,ymax], xlim=[1,n], width=70, canvas=BlockCanvas))
        else
            print(io, lineplot(winfunc(n, args...)[:], ylim=[0,ymax], xlim=[1,n], width=70, canvas=BlockCanvas))
        end
        println(io, "\"\"\")\n")
    end
end

# deprecations in 0.8
import .Util.nextfastfft
@deprecate nextfastfft(ns...) nextfastfft.(ns) false

@deprecate (conv(u::AbstractVector{T}, v::AbstractVector{T}, A::AbstractMatrix{T}) where T) conv(u, transpose(v), A)

@deprecate(
    filt!(out, f::PolynomialRatio{:z}, x::AbstractVector, si::AbstractVector),
    filt!(out, DF2TFilter(f, copy(si)), x)
)
@deprecate(
    filt!(out, f::PolynomialRatio{:z}, x::AbstractArray{<:Any, N}, si::AbstractArray{<:Any, N}) where {N},
    filt!(out, DF2TFilter(f, copy(si)), x)
)
@deprecate(
    filt!(out, f::PolynomialRatio{:z}, x::AbstractArray, si::AbstractVector),
    filt!(out, DF2TFilter(f, repeat(si; outer=(1, size(x)[2:end]...))), x)
)
@deprecate(
    filt(f::PolynomialRatio{:z}, x::AbstractVector, si::AbstractVector),
    filt(DF2TFilter(f, copy(si)), x)
)
@deprecate(
    filt(f::PolynomialRatio{:z}, x::AbstractArray{<:Any, N}, si::AbstractArray{<:Any, N}) where {N},
    filt(DF2TFilter(f, copy(si)), x)
)
@deprecate(
    filt(f::PolynomialRatio{:z}, x::AbstractArray, si::AbstractVector),
    filt(DF2TFilter(f, repeat(si; outer=(1, size(x)[2:end]...))), x)
)
@deprecate(
    filt!(out, f::SecondOrderSections{:z}, x::AbstractVector, si::AbstractVecOrMat),
    filt!(out, DF2TFilter(f, copy(si)), x)
)
@deprecate(
    filt!(out, f::SecondOrderSections{:z}, x::AbstractArray, si::AbstractArray),
    filt!(out, DF2TFilter(f, copy(si)), x)
)
@deprecate(
    filt!(out, f::SecondOrderSections{:z}, x::AbstractArray, si::AbstractVecOrMat),
    filt!(out, DF2TFilter(f, repeat(si; outer=(1, 1, size(x)[2:end]...))), x)
)
@deprecate(
    filt(f::SecondOrderSections{:z}, x::AbstractVector, si::AbstractVecOrMat),
    filt(DF2TFilter(f, copy(si)), x)
)
@deprecate(
    filt(f::SecondOrderSections{:z}, x::AbstractArray, si::AbstractArray),
    filt(DF2TFilter(f, copy(si)), x)
)
@deprecate(
    filt(f::SecondOrderSections{:z}, x::AbstractArray, si::AbstractVecOrMat),
    filt(DF2TFilter(f, repeat(si; outer=(1, 1, size(x)[2:end]...))), x)
)
@deprecate(
    filt!(out, f::Biquad{:z}, x::AbstractVector, si::AbstractVector),
    filt!(out, DF2TFilter(f, copy(si)), x)
)
@deprecate(
    filt!(out, f::Biquad{:z}, x::AbstractArray{<:Any, N}, si::AbstractArray{<:Any, N}) where {N},
    filt!(out, DF2TFilter(f, copy(si)), x)
)
@deprecate(
    filt!(out, f::Biquad{:z}, x::AbstractArray, si::AbstractVector),
    filt!(out, DF2TFilter(f, repeat(si; outer=(1, size(x)[2:end]...))), x)
)
@deprecate(
    filt(f::Biquad{:z}, x::AbstractVector, si::AbstractVector),
    filt(DF2TFilter(f, copy(si)), x)
)
@deprecate(
    filt(f::Biquad{:z}, x::AbstractArray{<:Any, N}, si::AbstractArray{<:Any, N}) where {N},
    filt(DF2TFilter(f, copy(si)), x)
)
@deprecate(
    filt(f::Biquad{:z}, x::AbstractArray, si::AbstractVector),
    filt(DF2TFilter(f, repeat(si; outer=(1, size(x)[2:end]...))), x)
)
@deprecate(
    filt!(out, b::Union{AbstractVector, Number}, a::Union{AbstractVector, Number}, x::AbstractVector, si::AbstractVector),
    filt!(out, DF2TFilter(PolynomialRatio(b, a), copy(si)), x)
)
@deprecate(
    filt!(out, b::Union{AbstractVector, Number}, a::Union{AbstractVector, Number}, x::AbstractArray{<:Any, N}, si::AbstractArray{<:Any, N}) where {N},
    filt!(out, DF2TFilter(PolynomialRatio(b, a), copy(si)), x)
)
@deprecate(
    filt!(out, b::Union{AbstractVector, Number}, a::Union{AbstractVector, Number}, x::AbstractArray, si::AbstractVector),
    filt!(out, DF2TFilter(PolynomialRatio(b, a), repeat(si; outer=(1, size(x)[2:end]...))), x)
)
@deprecate(
    filt(b::Union{AbstractVector, Number}, a::Union{AbstractVector, Number}, x::AbstractVector, si::AbstractVector),
    filt(DF2TFilter(PolynomialRatio(b, a), copy(si)), x)
)
@deprecate(
    filt(b::Union{AbstractVector, Number}, a::Union{AbstractVector, Number}, x::AbstractArray{<:Any, N}, si::AbstractArray{<:Any, N}) where {N},
    filt(DF2TFilter(PolynomialRatio(b, a), copy(si)), x)
)
@deprecate(
    filt(b::Union{AbstractVector, Number}, a::Union{AbstractVector, Number}, x::AbstractArray, si::AbstractVector),
    filt(DF2TFilter(PolynomialRatio(b, a), repeat(si; outer=(1, size(x)[2:end]...))), x)
)

# linear phase FIR filter design that optimizes maximum error
# in the frequency domain

#=============================================

Translated from C code in scipy into Julia.
Tom Krauss, 2018.

SCIPY license:
Copyright (c) 2001, 2002 Enthought, Inc.
All rights reserved.

Copyright (c) 2003-2017 SciPy Developers.
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

  a. Redistributions of source code must retain the above copyright notice,
     this list of conditions and the following disclaimer.
  b. Redistributions in binary form must reproduce the above copyright
     notice, this list of conditions and the following disclaimer in the
     documentation and/or other materials provided with the distribution.
  c. Neither the name of Enthought nor the names of the SciPy Developers
     may be used to endorse or promote products derived from this software
     without specific prior written permission.


THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR CONTRIBUTORS
BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
THE POSSIBILITY OF SUCH DAMAGE.

--- end of scipy license

The remez and associated functions were extracted from sigtoolsmodule.c,
with the following header comment:

SIGTOOLS module by Travis Oliphant

Copyright 2005 Travis Oliphant
Permission to use, copy, modify, and distribute this software without fee
is granted under the SciPy License.

C CODE BANNER

/********************************************************
 *
 *  Code taken from remez.c by Erik Kvaleberg which was
 *    converted from an original FORTRAN by:
 *
 * AUTHORS: JAMES H. MCCLELLAN
 *
 *         DEPARTMENT OF ELECTRICAL ENGINEERING AND COMPUTER SCIENCE
 *         MASSACHUSETTS INSTITUTE OF TECHNOLOGY
 *         CAMBRIDGE, MASS. 02139
 *
 *         THOMAS W. PARKS
 *         DEPARTMENT OF ELECTRICAL ENGINEERING
 *         RICE UNIVERSITY
 *         HOUSTON, TEXAS 77001
 *
 *         LAWRENCE R. RABINER
 *         BELL LABORATORIES
 *         MURRAY HILL, NEW JERSEY 07974
 *
 *
 *  Adaptation to C by
 *      egil kvaleberg
 *      husebybakken 14a
 *      0379 oslo, norway
 *  Email:
 *      egil@kvaleberg.no
 *  Web:
 *      http://www.kvaleberg.com/
 *
 *********************************************************/

=============================================#

# RemezFilterType:
#    Type I and II symmetric linear phase: neg==0   (filter_type==bandpass)
#    Type III and IV negative symmetric linear phase: neg==1   (filter_type==hilbert or differentiator)
@enum RemezFilterType filter_type_bandpass filter_type_differentiator filter_type_hilbert



"""
    lagrange_interp(k::Integer, n::Integer, m::Integer, x::AbstractVector)

CALCULATE THE LAGRANGE INTERPOLATION COEFFICIENTS
"""
function lagrange_interp(k::Integer, n::Integer, m::Integer, x::AbstractVector)
    retval = 1.0
    q = x[k]
    for l = 1:m, j = l:m:n
        if j != k
            retval *= 2.0 * (q - x[j])
        end
    end
    1.0 / retval
end


"""
    build_grid(numtaps, band_defs, Hz, grid_density, neg)

Returns `grid`, `des`, and `wt` arrays
"""
function build_grid(nfilt, band_defs, Hz, grid_density, neg::Bool)
    nodd = isodd(nfilt)
    nfcns = nfilt ÷ 2
    nfcns += nodd & !neg

    #
    # SET UP THE DENSE GRID. THE NUMBER OF POINTS IN THE GRID
    # IS (FILTER LENGTH + 1)*GRID DENSITY/2
    #
    delf = 0.5 / (grid_density * nfcns)

    flimlow = neg ? delf : 0.0
    flimhigh = (neg == nodd) ? 0.5 - delf : 0.5
    function normalize_banddef_entry(b)
        # normalize and clamp band-edges
        fl = convert(Float64, clamp(b.first[1] / Hz, flimlow, flimhigh))
        fu = convert(Float64, clamp(b.first[2] / Hz, flimlow, flimhigh))
        # make sure desired and weight are functions
        if isa(b.second, Tuple{Any, Any})
            desired = b.second[1]
            weight = b.second[2]
        else
            desired = b.second
            weight = 1.0
        end
        if isa(desired, Real)
            desired = Returns(desired)
        end
        if isa(weight, Real)
            weight = Returns(weight)
        end
        return Pair{Tuple{Float64,Float64},Tuple{Any,Any}}((fl, fu), (desired, weight))
    end
    normalized_band_defs = normalize_banddef_entry.(band_defs)

    # work around JuliaLang/julia#15276
    ngrid = let delf=delf
        sum(max(length(band_def.first[1]:delf:band_def.first[2]), 1) for band_def in normalized_band_defs)#::Int
    end

    grid = zeros(Float64, ngrid)  # the array of frequencies, between 0 and 0.5
    des = zeros(Float64, ngrid)   # the desired function on the grid
    wt = zeros(Float64, ngrid)    # array of weights

    j = 1

    #
    # CALCULATE THE DESIRED MAGNITUDE RESPONSE AND THE WEIGHT
    # FUNCTION ON THE GRID
    #
    # and
    #
    # SET UP A NEW APPROXIMATION PROBLEM WHICH IS EQUIVALENT
    # TO THE ORIGINAL PROBLEM
    #
    for band_def in normalized_band_defs
        flow, fup = band_def.first
        # outline inner loop to have it type-stable (band_def.second is Tuple{Any,Any})
        j = _buildgrid!(grid, des, wt, j, [(flow:delf:fup)[1:end-1]; fup], neg, nodd, Hz,
                        band_def.second)
    end
    @assert ngrid == j - 1

    return grid, des, wt
end

function _buildgrid!(grid, des, wt, j, fs, neg, nodd, Hz, des_wt)
    desired, weight = des_wt
    for f in fs
        change = neg ? sinpi(nodd ? 2f : f) : (nodd ? 1.0 : cospi(f))
        grid[j] = cospi(2f)
        des[j] = desired(f * Hz) / change
        wt[j] = weight(f * Hz) * change
        j += 1
    end
    return j
end

"""
    function freq_eval(xf, x::AbstractVector, y::AbstractVector, ad::AbstractVector)
-----------------------------------------------------------------------
 FUNCTION: freq_eval (gee)
  FUNCTION TO EVALUATE THE FREQUENCY RESPONSE USING THE
  LAGRANGE INTERPOLATION FORMULA IN THE BARYCENTRIC FORM

-----------------------------------------------------------------------
"""
function freq_eval(xf, x::AbstractVector, y::AbstractVector, ad::AbstractVector)
    d = 0.0
    p = 0.0

    for j in eachindex(ad)
        c = ad[j] / (xf - x[j])
        d += c
        p = muladd(c, y[j], p)
    end

    p/d
end

function initialize_y(dev::Float64, nz::Integer, iext::AbstractArray, des::AbstractArray, wt::AbstractArray, y::AbstractArray)
    nu = 1
    if dev > 0.0
        nu = -1
    end
    dev = -nu * dev
    k = nu
    for j = 1 : nz
        l = iext[j]
        y[j] = des[l] + k * dev / wt[l]
        k = -k
    end
    nu, dev
end

#=========
Banner from C code

-----------------------------------------------------------------------
 SUBROUTINE: remez
  THIS SUBROUTINE IMPLEMENTS THE REMEZ EXCHANGE ALGORITHM
  FOR THE WEIGHTED CHEBYSHEV APPROXIMATION OF A CONTINUOUS
  FUNCTION WITH A SUM OF COSINES.  INPUTS TO THE SUBROUTINE
  ARE A DENSE GRID WHICH REPLACES THE FREQUENCY AXIS, THE
  DESIRED FUNCTION ON THIS GRID, THE WEIGHT FUNCTION ON THE
  GRID, THE NUMBER OF COSINES, AND AN INITIAL GUESS OF THE
  EXTREMAL FREQUENCIES.  THE PROGRAM MINIMIZES THE CHEBYSHEV
  ERROR BY DETERMINING THE BSMINEST LOCATION OF THE EXTREMAL
  FREQUENCIES (POINTS OF MAXIMUM ERROR) AND THEN CALCULATES
  THE COEFFICIENTS OF THE BEST APPROXIMATION.
-----------------------------------------------------------------------
=========#
"""
    remez(numtaps::Integer, band_defs;
          Hz::Real=1.0,
          neg::Bool=false,
          maxiter::Integer=25,
          grid_density::Integer=16)

Calculate the minimax optimal filter using the Remez exchange algorithm [^McClellan1973a] [^McClellan1973b].

This is the simplified API that accepts just 2 required arguments (numtaps, band_defs).
For a scipy compatible version see the 3 arguments version (numtaps, bands, desired).

Calculate the filter-coefficients for the finite impulse response
(FIR) filter whose transfer function minimizes the maximum error
between the desired gain and the realized gain in the specified
frequency bands using the Remez exchange algorithm.

# Arguments
- `numtaps::Integer`: The desired number of taps in the filter.
    The number of taps is the number of terms in the filter, or the filter
    order plus one.
- `band_defs`: A sequence of band definitions.
    This sequence defines the bands. Each entry is a pair. The pair's
    first item is a tuple of band edges (low, high). The pair's second item
    defines the desired response and weight in that band. The weight is optional
    and defaults to 1.0. Both the desired response and weight may be either scalars
    or functions. If a function, the function should accept a real frequency and
    return the real desired response or real weight. Examples:
    + LPF with unity weights. `[(0, 0.475) => 1, (0.5, 1.0) => 0]`
    + LPF with weight of 2 in the stop band. `[(0, 0.475) => (1, 1), (0.5, 1.0) => (0, 2)]`
    + BPF with unity weights. `[(0, 0.375) => 0, (0.4, 0.5) => 1, (0.525, 1.0) => 0]`
    + Hilbert transformer. `[(0.1, 0.95) => 1]; neg=true`
    + Differentiator. `[(0.01, 0.99) => (f -> f/2, f -> 1/f)]; neg=true`
- `Hz::Real`: The sampling frequency in Hz. Default is 1.
- `neg::Bool`: Whether the filter has negative symmetry or not. Default is false.
    If false, the filter is even-symmetric. If true, the filter is odd-symmetric.
    neg=true means that h[n]=-h[end+1-n]; neg=false means that h[n]=h[end+1-n].
- `maxiter::Integer`: (optional)
    Maximum number of iterations of the algorithm. Default is 25.
- `grid_density:Integer`: (optional)
    Grid density. The dense grid used in `remez` is of size
    `(numtaps + 1) * grid_density`. Default is 16.

# Returns
- `h::Array{Float64,1}`: A rank-1 array containing the coefficients of the optimal
    (in a minimax sense) filter.

[^McClellan1973a]: J. H. McClellan and T. W. Parks,
    A unified approach to the design of optimum FIR linear phase digital filters,
    IEEE Trans. Circuit Theory, vol. CT-20, pp. 697-701, 1973.

[^McClellan1973b]: J. H. McClellan, T. W. Parks and L. R. Rabiner,
    A Computer Program for Designing Optimum FIR Linear Phase Digital Filters,
    IEEE Trans. Audio Electroacoust., vol. AU-21, pp. 506-525, 1973.

# Examples
Construct a length 35 filter with a passband at 0.15-0.4 Hz
(desired response of 1), and stop bands at 0-0.1 Hz and 0.45-0.5 Hz
(desired response of 0). Note: the behavior in the frequency ranges between
those bands - the transition bands - is unspecified.

```jldoctest
julia> bpass = remez(35, [(0, 0.1)=>0, (0.15, 0.4)=>1, (0.45, 0.5)=>0]);
```

You can trade-off maximum error achieved for transition bandwidth.
The wider the transition bands, the lower the maximum error in the
bands specified. Here is a bandpass filter with the same passband, but
wider transition bands.

```jldoctest
julia> bpass2 = remez(35, [(0, 0.08)=>0, (0.15, 0.4)=>1, (0.47, 0.5)=>0]);
```

Here we compute the frequency responses and plot them in dB.

```julia-repl
julia> using PyPlot
julia> b = PolynomialRatio(bpass, [1.0])
julia> b2 = PolynomialRatio(bpass2, [1.0])
julia> f = range(0, stop=0.5, length=1000)
julia> plot(f, 20*log10.(abs.(freqresp(b,f,1.0))))
julia> plot(f, 20*log10.(abs.(freqresp(b2,f,1.0))))
julia> grid()
```

# Examples from the unittests - standard (even) symmetry.

Length 151 LPF (Low Pass Filter).
```jldoctest
julia> h = remez(151, [(0, 0.475) => 1, (0.5, 1.0) => 0]; Hz=2.0);
```

Length 152 LPF. Non-default "weight" input.
```jldoctest
julia> h = remez(152, [(0, 0.475) => (1, 1), (0.5, 1.0) => (0, 2)]; Hz=2.0);
```

Length 51 HPF (High Pass Filter).
```jldoctest
julia> h = remez(51, [(0, 0.75) => 0, (0.8, 1.0) => 1]; Hz=2.0);
```

Length 180 BPF (Band Pass Filter).
```jldoctest
julia> h = remez(180, [(0, 0.375) => 0, (0.4, 0.5) => 1, (0.525, 1.0) => 0]; Hz=2.0, maxiter=30);
```

# Examples from the unittests - Odd-symmetric filters - hilbert and differentiators type.
Even length - has a much better approximation since the response is not constrained to 0 at
the nyquist frequency.  Length 20 Hilbert transformer.
```jldoctest
julia> h = remez(20, [(0.1, 0.95) => 1]; neg=true, Hz=2.0);
```

Length 21 Hilbert transformer.
```jldoctest
julia> h = remez(21, [(0.1, 0.95) => 1]; neg=true, Hz=2.0);
```

Length 200 differentiator.
```jldoctest
julia> h = remez(200, [(0.01, 0.99) => (f -> f/2, f -> 1/f)]; neg=true, Hz=2.0);
```

Length 201 differentiator.
```jldoctest
julia> h = remez(201, [(0.05, 0.95) => (f -> f/2, f -> 1/f)]; neg=true, Hz=2.0);
```

Inverse sinc filter - custom response function
```julia-repl
julia> L = 64; Fs = 4800*L;
julia> passband_response_function = f -> (f==0) ? 1.0 : abs.((π*f/4800) ./ sin.(π*f/4800));
julia> h = remez(201, [(    0.0, 2880.0) => (passband_response_function, 1.0),
                (10000.0,   Fs/2) => (0.0, 100.0)]; Hz=Fs);
```
"""
function remez(numtaps::Integer, band_defs;
                Hz::Real=1.0,
                neg::Bool=false,
                maxiter::Integer=25,
                grid_density::Integer=16)
    all(b.first[1] <= b.first[2] for b in band_defs) ||
        throw(ArgumentError("lower band edge higher then upper band edge"))
    all(band_defs[i].first[2] < band_defs[i+1].first[1] for i in 1:length(band_defs)-1) ||
        throw(ArgumentError("band edges is not monotonically increasing"))
    (0 <= band_defs[1].first[1]) && (band_defs[end].first[2] <= 0.5*Hz) ||
        throw(ArgumentError("band edges must be between 0 and `Hz`/2"))

    grid, des, wt = build_grid(numtaps, band_defs, Hz, grid_density, neg)

    nfilt = numtaps
    ngrid = length(grid)

    nodd = isodd(nfilt)   # boolean: "nodd" means filter length is odd
    nfcns = numtaps ÷ 2   # integer divide
    if nodd && !neg
        nfcns = nfcns + 1
    end

    nz  = nfcns+1
    nzz = nfcns+2
    iext = zeros(Int64, nzz)   # indices of extremals
    x = zeros(Float64, nzz)
    y = zeros(Float64, nz)

    for j = 1:nz
        iext[j] = (j-1)*(ngrid-1) ÷ nfcns + 1
    end

    dev = 0.0     # deviation from the desired function,
                  # that is, the amount of "ripple" on the extremal set
    devl = -1.0   # deviation on last iteration
    niter = 0
    ad = zeros(Float64, nz)

    jet = ((nfcns-1) ÷ 15) + 1

    while true

        #
        # Start next iteration
        #
    #   @label L100
        iext[nzz] = ngrid + 1
        niter += 1
        if niter > maxiter
            @warn("remez() iteration count exceeds maxiter = $maxiter, filter is not converged; try increasing maxiter")
            # the filter is returned in its current, unconverged state.
            break
        end

        for j = 1:nz
            x[j] = grid[iext[j]]
        end

        for j = 1 : nz
            ad[j] = lagrange_interp(j, nz, jet, x)
        end

        dnum = 0.0
        dden = 0.0
        k = 1
        for j = 1 : nz
            l = iext[j]
            dnum = muladd(ad[j], des[l], dnum)
            dden = muladd(k, ad[j] / wt[l], dden)
            k = -k
        end
        dev = dnum / dden

        fill!(y, 0.0)
        nu, dev = initialize_y(dev, nz, iext, des, wt, y)

        if dev <= devl
            # finished
            throw(ErrorException("remez() - failure to converge at iteration $niter, try reducing transition band width"))
        end
        devl = dev

        #
        # SEARCH FOR THE EXTREMAL FREQUENCIES OF THE BEST APPROXIMATION
        #

        # Between here and L370, the extremal index set is updated in a loop
        # roughly over the index "j" - although the logic is complicated as
        # the extremal set may grow or shrink in an iteration.
        # j - the index of the current extremal being updated
        # nz - the number of cosines in the approximation (including the constant term).
        #      nz = nfcns + 1 where nfcns = nfilt / 2, and
        #      nfilt is the filter length or number of taps.
        #      For example, for a length 15 filter, nfcns = 7 and nz = 8.
        # jchgne - the number of extremal indices that changed this iteration
        jchnge = 0
        k1 = iext[1]
        knz = iext[nz]
        klow = 0
        nut = -nu
        j = 1

        local comp

      @label L200
        j == nzz && (ynz = comp)   # equivalent to "if (j == nzz) ynz = comp; end"
        j >= nzz && @goto L300
        kup = iext[j+1]
        l = iext[j]+1
        nut = -nut
        j == 2 && (y1 = comp)
        comp = dev
        l >= kup && @goto L220
        err = (freq_eval(grid[l], x, y, ad) - des[l]) * wt[l]
        nut*err <= comp && @goto L220
        comp = nut * err
      @label L210
        l += 1; l >= kup && @goto L215
        err = (freq_eval(grid[l], x, y, ad) - des[l]) * wt[l]
        nut*err <= comp && @goto L215
        comp = nut * err
        @goto L210

      @label L215
        iext[j] = l - 1; j += 1
        klow = l - 1
        jchnge += 1
        @goto L200

      @label L220
        l -= 1
      @label L225
        l -= 1; l <= klow && @goto L250
        err = (freq_eval(grid[l], x, y, ad) - des[l]) * wt[l]
        nut*err > comp && @goto L230
        jchnge <= 0 && @goto L225
        @goto L260

      @label L230
        comp = nut * err
      @label L235
        l -= 1; l <= klow && @goto L240
        err = (freq_eval(grid[l], x, y, ad) - des[l]) * wt[l]
        nut*err <= comp && @goto L240
        comp = nut * err
        @goto L235
      @label L240
        klow = iext[j]
        iext[j] = l+1
        j += 1
        jchnge += 1
        @goto L200

      @label L250
        l = iext[j]+1
        jchnge > 0 && @goto L215

      @label L255
        l += 1; l >= kup && @goto L260
        err = (freq_eval(grid[l], x, y, ad) - des[l]) * wt[l]
        nut*err <= comp && @goto L255
        comp = nut * err

        @goto L210
      @label L260
        klow = iext[j]; j += 1
        @goto L200

      @label L300
        j > nzz && @goto L320
        k1 > iext[1] && (k1 = iext[1])
        knz < iext[nz] && (knz = iext[nz])
        nut1 = nut
        nut = -nu
        l = 0
        kup = k1
        comp = ynz*(1.00001)
        luck = 1
      @label L310
        l += 1; l >= kup && @goto L315
        err = (freq_eval(grid[l], x, y, ad) - des[l]) * wt[l]
        nut*err <= comp && @goto L310
        comp =  nut * err
        j = nzz
        @goto L210

      @label L315
        luck = 6
        @goto L325

      @label L320
        luck > 9 && @goto L350
        comp > y1 && (y1 = comp)
        k1 = iext[nzz]
      @label L325
        l = ngrid+1
        klow = knz
        nut = -nut1
        comp = y1*(1.00001)
      @label L330
        l -= 1; l <= klow && @goto L340
        err = (freq_eval(grid[l], x, y, ad) - des[l]) * wt[l]
        nut*err <= comp && @goto L330
        j = nzz
        comp =  nut * err
        luck = luck + 10
        @goto L235
      @label L340
        luck == 6 && @goto L370
        for j = 1 : nfcns
            iext[nzz-j] = iext[nz-j]
        end
        iext[1] = k1
        continue    # @goto L100
      @label L350
        for j = 1:nz
            iext[j] = iext[j+1]
        end

        continue    # @goto L100
      @label L370


        if jchnge <= 0  # we are done if none of the extremal indices changed
            break
        end
    end  # while

    #
    #    CALCULATION OF THE COEFFICIENTS OF THE BEST APPROXIMATION
    #    USING THE INVERSE DISCRETE FOURIER TRANSFORM
    #

    a = zeros(Float64, nfcns)   # frequency response on evenly spaced grid
    p = zeros(Float64, nfcns)
    q = zeros(Float64, nfcns-2)
    alpha = zeros(Float64, nzz)   # return vector

    fsh = 1.0e-06
    x[nzz] = -2.0
    delf = 1 / (2*nfcns - 1)
    l = 1

    # Boolean for "kkk" in C code.
    full_grid = (band_defs[1].first[1] == 0.0 && band_defs[end].first[2] == 0.5*Hz) || (nfcns <= 3)
    if !full_grid
        aa    = 2.0/(grid[1]-grid[ngrid])
        bb    = -(grid[1]+grid[ngrid])/(grid[1]-grid[ngrid])
    end

    # Fill in "a" array with the frequency response on an evenly
    # spaced set of frequencies. Care is taken to use "y[l]" -
    # an already computed response on one of the extremals "l" -
    # if the extremal is equal to the frequency ft. If no y[l]
    # matches, a[j] is computed using freq_eval.
    for j = 1 : nfcns
        xt = cospi(2 * (j - 1) * delf)
        if !full_grid
            xt = (xt-bb)/aa
        end
        if (l > 1)
            l = l-1
        end
        while x[l]-xt >= fsh
            l += 1
        end
        if xt-x[l] < fsh
            a[j] = y[l]
        else
            a[j] = freq_eval(xt, x, y, ad)
        end
    end

    nm1 = nfcns - 1   # nm1 => "nfcns minus 1"

    for j = 1 : nfcns
        dtemp = 0.0
        for k = 1 : nm1
            dtemp = muladd(a[k+1], cospi(2 * (j-1) * delf * k), dtemp)
        end
        alpha[j] = 2dtemp + a[1]
    end

    for j = 2 : nfcns
        alpha[j] *= 2.0 * delf
    end
    alpha[1] *= delf

    if !full_grid
        p[1] = muladd(2alpha[nfcns], bb, alpha[nm1])
        p[2] = 2.0*aa*alpha[nfcns]
        q[1] = alpha[nfcns-2]-alpha[nfcns]
        for j = 2 : nm1
            if j >= nm1
                aa *= 0.5
                bb *= 0.5
            end
            p[j+1] = 0.0
            for k = 1 : j
                a[k] = p[k]
                p[k] = 2.0 * bb * a[k]
            end
            p[2] = muladd(a[1], 2aa, p[2])
            for k = 1 : j-1
                p[k] += muladd(aa, a[k+1], q[k])
            end
            for k = 3 : j+1
                p[k] = muladd(aa, a[k-1], p[k])
            end

            if j != nm1
                for k = 1 : j
                    q[k] = -a[k]
                end
                q[1] += alpha[nfcns - 1 - j]
            end
        end
        for j = 1 : nfcns
            alpha[j] = p[j]
        end
    end

    if nfcns <= 3
        alpha[nfcns+1] = alpha[nfcns+2] = 0.0
    end

    #
    # CALCULATE THE IMPULSE RESPONSE.
    #
    h = zeros(Float64, nfilt)
    if !neg
        if nodd
            for j = 1 : nm1
                h[j] = 0.5 * alpha[nz-j]
            end
            h[nfcns] = alpha[1]
        else
            h[1] = 0.25 * alpha[nfcns]
            for j = 2 : nm1
                h[j] = 0.25 * (alpha[nz-j] + alpha[nfcns+2-j])
            end
            h[nfcns] = muladd(0.5, alpha[1], 0.25 * alpha[2])
        end
    else
        if nodd
            h[1] = 0.25 * alpha[nfcns]
            h[2] = 0.25 * alpha[nm1]
            for j = 1 : nm1
                h[j] = 0.25 * (alpha[nz-j] - alpha[nfcns+3-j])
            end
            h[nfcns] = muladd(0.5, alpha[1], -0.25 * alpha[3])
            h[nz] = 0.0
        else
            h[1] = 0.25 * alpha[nfcns]
            for j = 2 : nm1
                h[j] = 0.25 * (alpha[nz-j] - alpha[nfcns+2-j])
            end
            h[nfcns] = muladd(0.5, alpha[1], -0.25 * alpha[2])
        end
    end

    for j = 1 : nfcns
        k = nfilt + 1 - j
        if !neg
           h[k] = h[j]
        else
           h[k] = -h[j]
        end
    end
    if neg && nodd
        h[nz] = 0.0
    end

    return h
end


"""
    remez(numtaps::Integer,
          bands::Vector,
          desired::Vector;
          weight::Vector=[],
          Hz::Real=1.0,
          filter_type::RemezFilterType=filter_type_bandpass,
          maxiter::Integer=25,
          grid_density::Integer=16)

This is the scipy compatible version that requires 3 arguments (numtaps, bands, desired).
For a simplified API, see the 2 argument version (numtaps, band_defs). The filters
designed are equivalent, the inputs are just specified in a different way.
Below the arguments and examples are described that differ from the simplified
API version.

# Arguments
- `bands::Vector`: A monotonic sequence containing the band edges in Hz.
    All elements must be non-negative and less than half the sampling
    frequency as given by `Hz`.
- `desired::Vector`:A sequence half the size of bands containing the desired
    gain in each of the specified bands.
- `weight::Vector`: (optional)
    A relative weighting to give to each band region. The length of
    `weight` has to be half the length of `bands`.
- `filter_type::RemezFilterType`: Default is `filter_type_bandpass`.
    The type of filter:
    +  `filter_type_bandpass` : flat response in bands. This is the default.
    +  `filter_type_differentiator` : frequency proportional response in bands.
        Odd symetric as in `filter_type_hilbert` case, but with a linear sloping
        desired response.
    +  `filter_type_hilbert` : filter with odd symmetry, that is, type III
                  (for even order) or type IV (for odd order)
                  linear phase filters.

# Examples
Compare the examples with the simplified API and the Scipy API.
Each of the following blocks first designs a filter using the
simplified (recommended) API, and then designs the same filter
using the Scipy-compatible API.

```jldoctest
julia> bpass = remez(35, [(0, 0.1)=>0, (0.15, 0.4)=>1, (0.45, 0.5)=>0]);

julia> bpass = remez(35, [0, 0.1, 0.15, 0.4, 0.45, 0.5], [0, 1, 0]);

```

```jldoctest
julia> bpass2 = remez(35, [(0, 0.08)=>0, (0.15, 0.4)=>1, (0.47, 0.5)=>0]);

julia> bpass2 = remez(35, [0, 0.08, 0.15, 0.4, 0.47, 0.5], [0, 1, 0]);

```

```jldoctest
julia> h = remez(20, [(0.1, 0.95) => 1]; neg=true, Hz=2.0);

julia> h = remez(20, [0.1, 0.95], [1]; filter_type=filter_type_hilbert, Hz=2.0);

```

```jldoctest
julia> h = remez(200, [(0.01, 0.99) => (f -> f/2, f -> 1/f)]; neg=true, Hz=2.0);

julia> h = remez(200, [0.01, 0.99], [1]; filter_type=filter_type_differentiator, Hz=2.0);

```
"""
function remez(numtaps::Integer, bands::Vector, desired::Vector;
               weight::Vector=fill(1.0, length(desired)),
               Hz::Real=1.0,
               filter_type::RemezFilterType=filter_type_bandpass,
               kwargs...)
    issorted(bands) || throw(ArgumentError("`bands` is not monotonically increasing"))
    length(bands) == 2length(desired) ||
        throw(ArgumentError("`desired` must be half the length of `bands`."))
    length(bands) == 2length(weight) ||
        throw(ArgumentError("`weight` must be half the length of `bands`."))
    band_ranges = [(bands[i], bands[i+1]) for i in 1:2:length(bands)]
    if filter_type == filter_type_differentiator
        eff = [f -> d*f/Hz for d in desired]
        wate = [d > 0.0001 ? f -> w/(f/Hz) : f -> w for (w, d) in zip(weight, desired)]
    else
        eff = desired
        wate = weight
    end
    band_defs = [r => (d, w) for (r, d, w) in zip(band_ranges, eff, wate)]
    neg = filter_type in (filter_type_hilbert, filter_type_differentiator)
    return remez(numtaps, band_defs; Hz, neg, kwargs...)
end

module DSP

using FFTW
using LinearAlgebra: Transpose, mul!, rmul!
using IterTools: subsets

export conv, conv!, deconv, filt, filt!, xcorr

# This function has methods added in `periodograms` but is not exported,
# so we define it here so one can do `DSP.allocate_output` instead of
# `DSP.Periodograms.allocate_output`.
function allocate_output end

include("dspbase.jl")

include("util.jl")
include("unwrap.jl")
include("windows.jl")
include("periodograms.jl")
include("Filters/Filters.jl")
include("lpc.jl")
include("estimation.jl")
include("diric.jl")

using Reexport
@reexport using .Util, .Windows, .Periodograms, .Filters, .LPC, .Unwrap, .Estimation

include("deprecated.jl")
end

# Filter some noise, try to learn the coefficients
using DSP, Test
using Statistics: std
@testset "$method" for method in (LPCBurg(), LPCLevinson())
    @testset "$T" for T in (Float64, ComplexF64)
        coeffs = T <: Complex ? [1, 0.5 + 0.2im, 0.3 - 0.5im, 0.2] : [1, 0.5, 0.3, 0.2]
        s = randn(T, 50000)
        x = filt(1, coeffs, s)

        # Analyze the filtered noise, attempt to reconstruct the coefficients above
        ar, e = lpc(x[1000:end], length(coeffs) - 1, method)

        @test all(<(0.01), abs.(ar .- coeffs[2:end]))
        @test isapprox(e, std(s); rtol=0.01)
    end
end

# test dotu, levinson with complex Int coefficients
@test isapprox(levinson(complex(1:10), 3)[1] |> real, -[1.25, 0, 0.25])

# test that lpc defaults to Burg
@test let v = rand(1000)
    lpc(v, 20) == lpc(v, 20, LPCBurg())
end

# diric.jl Dirichlet kernel tests

@testset "diric" begin
    @test_throws DomainError diric(0, -2)
    @test @inferred(diric(0, 4)) ≈ 1
    @test @inferred(diric(0 // 1, 5)) == 1
    @test @inferred(diric(4π, 4)) ≈ 1
    @test @inferred(diric(2π, 4)) ≈ -1
    @test @inferred(diric(0, 5)) ≈ 1
    @test @inferred(diric(2π, 5)) ≈ 1
    @test @inferred(diric(π, 5)) ≈ 1 // 5
    @test @inferred(diric(π/2, 5)) ≈ diric(-π/2, 5) ≈ -0.2
    @test abs(@inferred(diric(π/2, 4))) < eps()
    @test abs(@inferred(diric(3π/2, 4))) < eps()

    # check type inference
    @inferred diric(2, 4)
    @inferred diric(Float16(1), 4)
    @inferred diric(0.1f0, 4)
    @inferred diric(0., 4)
    @inferred diric(BigFloat(1), 4)

    # accuracy test near 2π for even n
    dirics(Ω,n) = real(exp(-1im * (n-1) * Ω/2)/n * sum(exp.(1im*(0:(n-1))*Ω)))
    Ω = 2π .+ 4π * (-101:2:101)/100 * 1e-9
    n = 400
    @test dirics.(Ω,n) ≈ diric.(Ω,n)
end

using DSP, Test

@testset "esprit" begin
    # create a sum of sinusoids in noise, and estimate their frequencies
    Fs = 10000.0           # sampling frequency in Hz
    duration = 1           # length of signal, in seconds
    n = Int(Fs * duration) # number of samples
    t = collect((1:n)/Fs)  # time vector
    frequencies = [1000.0 1250.0]
    amplitudes = [2.0 1.5]
    phases = [0.7 -1.0]
    x = exp.( 1im*2*π*t*frequencies .+ phases) * amplitudes'
    noise = randn(n, 2)*[1;1im]
    sigma = 0.1
    noise *= sigma
    x += noise
    M = 300
    p = 2                  # number of sinusoids to estimate
    frequencies_estimated = sort(esprit(x, M, p, Fs))
    @test isapprox(frequencies', frequencies_estimated; atol = 1e-2)
end

@testset "jacobsen" begin
    fs = 100
    t = range(0, 5; step=1/fs)
    function test_complex_jacobsen(fs, fc, f=0, t=t)
        sc = cispi.(2 * fc * t .+ f)
        f_est_complex = jacobsen(sc, fs)
        isapprox(f_est_complex, fc; atol=1e-5)
    end
    # test at two arbitrary frequencies
    @test test_complex_jacobsen(fs, -40.3, 1 / 1.4)
    @test test_complex_jacobsen(fs, 14.3, 1 / 3)
    # test near fs/2
    @test test_complex_jacobsen(fs, 49.90019)
    # test near -fs/2
    @test test_complex_jacobsen(fs, -49.90019)
    # test near +zero
    @test test_complex_jacobsen(fs, 0.04)
    # test near -zero
    @test test_complex_jacobsen(fs, -0.1)
    # tests for real signals: test only around fs/4, where the
    # expected error is small.
    fr = 28.3
    sr = cospi.(2 * fr * t .+ 1 / 4.2)
    f_est_real = jacobsen(sr, fs)
    @test isapprox(f_est_real, fr; atol=1e-5)
    fr = 23.45
    sr = sinpi.(2 * fr * t .+ 3 / 2.2)
    f_est_real = jacobsen(sr, fs)
    @test isapprox(f_est_real, fr; atol=1e-5)
end

@testset "quinn" begin
    function test_quinn(f, s, args...)
        (f_est_real, maxiter) = quinn(s, args...)
        @test maxiter == false
        @test isapprox(f_est_real, f; atol=1e-3)
        return nothing
    end
    ### real input
    fs = 100
    t = range(0, 5; step=1/fs)
    fr = 28.3
    sr = cospi.(2 * fr * t .+ 1 / 4.2)
    test_quinn(fr, sr, 50, fs)
    # use default initial guess
    test_quinn(fr, sr, fs) # initial guess given by Jacobsen
    # use default fs
    test_quinn(fr / fs, sr) # fs = 1.0, initial guess given by Jacobsen

    ### complex input
    fc = -40.3
    sc = cispi.(2 * fc * t .+ 1 / 1.4)
    test_quinn(fc, sc, -20, fs)
    # use default initial guess
    test_quinn(fc, sc, fs) # initial guess given by Jacobsen
    # use default fs
    test_quinn(fc / fs, sc) # fs = 1.0, initial guess by Jacobsen
end

using DSP, Test
using Random: MersenneTwister, default_rng, seed!
using StableRNGs
using Statistics: mean

@testset "Unwrap 1D" begin
    unwrapped = [0.1, 0.2, 0.3, 0.4]
    @test unwrap([0.1, 0.2, 0.3, 0.4]) ≈ unwrapped
    @test unwrap([0.1, 0.2 + 2pi, 0.3, 0.4]) ≈ unwrapped
    @test unwrap([0.1, 0.2 - 2pi, 0.3, 0.4]) ≈ unwrapped
    @test unwrap([0.1, 0.2 - 2pi, 0.3 - 2pi, 0.4]) ≈ unwrapped
    @test unwrap([0.1 + 2pi, 0.2, 0.3, 0.4]) ≈ unwrapped .+ 2pi
    @test unwrap([0.1, 0.2 + 6pi, 0.3, 0.4]) ≈ unwrapped

    test_v = [0.1, 0.2, 0.3 + 2pi, 0.4]
    res_v = unwrap(test_v)
    @test res_v ≈ unwrapped
    @test test_v == [0.1, 0.2, 0.3 + 2pi, 0.4]

    res_v .= 0
    unwrap!(res_v, test_v)
    @test res_v ≈ unwrapped
    @test test_v == [0.1, 0.2, 0.3 + 2pi, 0.4]

    @test unwrap!(test_v) === test_v
    @test test_v ≈ unwrapped

    # test unwrapping within multi-dimensional array
    wrapped = repeat([0.1, 0.2 + 2pi, 0.3, 0.4], 1, 2)
    unwrapped = hcat(unwrapped, unwrapped)
    @test unwrap(wrapped, dims=2) ≈ wrapped
    @test unwrap(wrapped, dims=1) ≈ unwrapped
    @test unwrap!(copy(wrapped), dims=2) ≈ wrapped
    @test unwrap!(copy(wrapped), dims=1) ≈ unwrapped

    # this should eventually default to the multi-dimensional case
    @test_throws ArgumentError unwrap!(similar(wrapped), wrapped)

    # test unwrapping with other ranges
    unwrapped = [1.0:100;]
    wrapped = Float64[i % 10 for i in unwrapped]
    @test unwrap(wrapped, range=10) ≈ unwrapped

    # test generically typed unwrapping
    types = (Float32, Float64, BigFloat)
    for T in types
        A_unwrapped = collect(range(0, stop=4convert(T, π), length=10))
        A_wrapped = A_unwrapped .% (2convert(T, π))

        @test unwrap(A_wrapped) ≈ A_unwrapped
        unwrap!(A_wrapped)
        @test A_wrapped ≈ A_unwrapped

        A_unwrapped_range = collect(range(0, stop=4, length=10))
        test_range = convert(T, 2)
        A_wrapped_range = A_unwrapped_range .% test_range
        @test unwrap(A_wrapped_range; range=test_range) ≈ A_unwrapped_range
    end
end

# tests for multi-dimensional unwrapping
@testset "Unwrap 2D" begin
    types = (Float32, Float64, BigFloat)
    for T in types
        v_unwrapped = collect(range(0, stop=4convert(T, π), length=7))
        A_unwrapped = v_unwrapped .+ v_unwrapped'
        A_wrapped = A_unwrapped .% (2convert(T, π))

        test_unwrapped = unwrap(A_wrapped, dims=1:2)
        d = first(A_unwrapped) - first(test_unwrapped)
        @test (test_unwrapped .+ d) ≈ A_unwrapped
        unwrap!(A_wrapped, dims=1:2)
        d = first(A_unwrapped) - first(A_wrapped)
        @test (A_wrapped .+ d) ≈ A_unwrapped

        v_unwrapped_range = collect(range(0, stop=4, length=7))
        A_unwrapped_range = v_unwrapped_range .+ v_unwrapped_range'
        test_range = convert(T, 2)
        A_wrapped_range = A_unwrapped_range .% test_range

        test_unwrapped_range = unwrap(A_wrapped_range, dims=1:2; range=test_range)
        d = first(A_unwrapped_range) - first(test_unwrapped_range)
        @test (test_unwrapped_range .+ d) ≈ A_unwrapped_range

        # Test circular_dims
        # after unwrapping, pixels at borders should be equal to corresponding pixels
        # on other side
        circular_dims = (true, true)
        wa_vec = range(0, stop=4convert(T, π), length=10)
        wa_uw = wa_vec .+ zeros(10)'
        # make periodic
        wa_uw[end, :] = wa_uw[1, :]
        wa_w = wa_uw .% (2π)
        wa_test = unwrap(wa_w, dims=1:2, circular_dims=circular_dims, rng=MersenneTwister(0))
        # with wrap-around, the borders should be equal, but for this problem the
        # image may not be recovered exactly
        @test wa_test[:, 1] ≈ wa_test[:, end]
        @test wa_test[end, :] ≈ wa_test[1, :]
        # In this case, calling unwrap w/o circular_dims does not recover the borders
        wa_test_nowa = unwrap(wa_w, dims=1:2)
        @test !(wa_test_nowa[end, :] ≈ wa_test_nowa[1, :])

    end
end

@testset "Unwrap 3D" begin
    types = (Float32, Float64, BigFloat)

    f_nowrap(x, y, z) = 0.1x^2 - 2y + 2z
    f_wraparound2(x, y, z) = 5*sin(x) + 2*cos(y) + z
    f_wraparound3(x, y, z) = 5*sin(x) + 2*cos(y) - 4*cos(z)

    for T in types
        grid = range(zero(T), stop=2convert(T, π), length=11)

        for (func, circular_dims) in (
            (f_nowrap,      (false, false, false)),
            (f_wraparound2, (true, true, false)),
            (f_wraparound3, (true, true, true))
        )
            f_uw = func.(grid, grid', reshape(grid, 1, 1, :))
            f_wr = f_uw .% (2convert(T, π))
            uw_test = unwrap(f_wr; dims=1:3, circular_dims)
            offset = first(f_uw) - first(uw_test)
            @test (uw_test .+ offset) ≈ f_uw rtol = eps(T)  # oop

            # test in-place version
            unwrap!(f_wr; dims=1:3, circular_dims)
            offset = first(f_uw) - first(f_wr)
            @test (f_wr .+ offset) ≈ f_uw rtol = eps(T)     # ip
        end
    end
end

@testset "reproducible unwrap" begin
    function measure(s, rng, seed=rand(UInt))
        u1 = unwrap(s; dims=1:ndims(s), rng=seed!(rng, seed))
        u2 = unwrap(s; dims=1:ndims(s), rng=seed!(rng, seed))
        return sqrt(mean(abs2, u1 - u2))
    end

    x1 = 1234 * rand(10_000)
    x2 = 1357 * rand(200, 200)
    x3 = 1248 * rand(30, 30, 30)

    for x in (x1, x2, x3)
        @test measure(x, default_rng()) == measure(x, MersenneTwister()) ==
              measure(x, StableRNG(10)) == 0.0
    end
end

using FFTW, DSP, Test

!(@__DIR__() in LOAD_PATH) && push!(LOAD_PATH, @__DIR__)
using FilterTestHelpers

# not exported, but used for some internal testing
using DSP.Windows: makewindow
@testset "makewindow" begin
    # make sure we're evaluating the given function at the correct points for
    # all combinations of arguments
    @test makewindow(identity, 6, 0, false) ≈ [-0.5, -0.3, -0.1, 0.1, 0.3, 0.5]
    win = makewindow(identity, 6, 0, true)
    # doesn't matter whether the middle value is evaluated at +/- 0.5
    @test win ≈ [0.0, 1/6, 1/3, 1/2, -1/3, -1/6] || win ≈ [0.0, 1/6, 1/3, -1/2, -1/3, -1/6]
    # we actually only end up with one real zero here, because one of the
    # "padding" values is used to split the -1/2 from +1/2. For windows that go
    # to zero padding will actually add `padding` zeros, because evaluating at
    # +/- 0.5 will be zero.
    @test makewindow(identity, 6, 2, false) ≈ [-0.5, -0.3, -0.1, 0.1, 0.3, 0.5, 0.0, 0.0]
    @test makewindow(identity, 6, 2, true) ≈ [0.0, 1/6, 1/3, 1/2, 0.0, -1/2, -1/3, -1/6]
    @test makewindow(identity, 5, 0, false) ≈ [-0.5, -0.25, 0.0, 0.25, 0.5]
    @test makewindow(identity, 5, 0, true) ≈ [0.0, 0.2, 0.4, -0.4, -0.2]
    @test makewindow(identity, 5, 2, false) ≈ [-0.5, -0.25, 0.0, 0.25, 0.5, 0.0, 0.0]
    @test makewindow(identity, 5, 2, true) ≈ [0.0, 0.2, 0.4, 0.0, 0.0, -0.4, -0.2]

    @test makewindow(x->42.0, 1, 0, false) ≈ [42.0]
    @test makewindow(x->42.0, 1, 0, true) ≈ [42.0]
    @test makewindow(x->42.0, 1, 2, false) ≈ [42.0, 0.0, 0.0]
    @test makewindow(x->42.0, 1, 2, true) ≈ [42.0, 0.0, 0.0]
end

@testset "dspss" begin
    # Test dpss against dpss computed with MATLAB
    d1 = dpss(128, 4)
    d2 = read_reference_data("dpss128,4.txt")
    @test d1 ≈ d2

    # Test dpsseig against dpss from MATLAB
    lambda = [0.9999999997159923,0.9999999731146645,0.9999988168667646,
              0.9999680890685374,0.9994167543397652,0.9925560207018469,
              0.9368556668429153]
    @test dpsseig(d1, 4) ≈ lambda
end

@testset "common windows" begin
    # Checking Hanning, Hamming, Triangular, Bartlett, Bartlett-Hann, Tukey,
    # Blackman, Blackman-Harris-4term and Nuttall-4term windows against values
    # computed with MATLAB. Lanczos and cosine are checked against values
    # generated with DSP.jl v0.4.0 and Blackman-Harris-3term as well as
    # Nuttall-3term with DSP.jl v0.8.5 to test for regressions, as there's no
    # reference MATLAB implementation. Gaussian is compared against DSP.jl from
    # commit da1b195, when the implementation was corrected (see GH issue #204)
    @test rect(128) == ones(128)

    hanning_jl = hanning(128)
    hann_jl = hann(128)
    hanning_ml = read_reference_data("hanning128.txt")
    @test hanning_jl ≈ hanning_ml
    @test hann_jl ≈ hanning_ml

    hamming_jl = hamming(128)
    hamming_ml = read_reference_data("hamming128.txt")
    @test hamming_jl ≈ hamming_ml

    triang_jl = triang(128)
    triang_ml = read_reference_data("triang128.txt")
    @test triang_jl ≈ triang_ml

    # for odd `n` the `triang` window should be the middle n-2 samples of the
    # bartlett
    @test triang(5) ≈ bartlett(7)[2:6]

    bartlett_jl = bartlett(128)
    bartlett_ml = read_reference_data("bartlett128.txt")
    @test bartlett_jl ≈ bartlett_ml

    barthann_jl = bartlett_hann(128)
    barthann_ml = read_reference_data("bartlett_hann128.txt")
    @test bartlett_jl ≈ bartlett_ml

    blackman_jl = blackman(128)
    blackman_ml = read_reference_data("blackman128.txt")
    @test blackman_jl ≈ blackman_ml
    @test minimum(blackman_jl) == 0.0

    blackmanharris_3term_jl = blackmanharris(128, 3)
    blackmanharris_3term_ref = read_reference_data("blackmanharris_3term_128.txt")
    @test blackmanharris_3term_jl ≈ blackmanharris_3term_ref

    blackmanharris_4term_jl = blackmanharris(128)
    blackmanharris_4term_ml = read_reference_data("blackmanharris_4term_128.txt")
    @test blackmanharris_4term_jl ≈ blackmanharris_4term_ml

    nuttall_3term_jl = nuttall(128, 3)
    nuttall_3term_ref = read_reference_data("nuttall_3term_128.txt")
    @test nuttall_3term_jl ≈ nuttall_3term_ref

    nuttall_4term_jl = nuttall(128)
    nuttall_4term_ml = read_reference_data("nuttall_4term_128.txt")
    @test nuttall_4term_jl ≈ nuttall_4term_ml

    kaiser_jl = kaiser(128, 0.4/π)
    kaiser_ml = read_reference_data("kaiser128,0.4.txt")
    @test kaiser_jl ≈ kaiser_ml

    flattop_jl = flattop(128)
    flattop_ml = read_reference_data("flattop.txt")
    @test flattop_jl ≈ flattop_ml

    gaussian_jl = gaussian(128, 0.2)
    gaussian_ref = read_reference_data("gaussian128,0.2.txt")
    @test gaussian_jl ≈ gaussian_ref

    tukey_jl = tukey(128, 0.4)
    tukey_ml = read_reference_data("tukey128,0.4.txt")
    @test tukey_jl ≈ tukey_ml

    @test tukey(128, 0) == rect(128)

    lanczos_jl = lanczos(128)
    lanczos_ref = read_reference_data("lanczos128.txt")
    @test lanczos_jl ≈ lanczos_ref

    cosine_jl = cosine(128)
    cosine_ref = read_reference_data("cosine128.txt")
    @test cosine_jl ≈ cosine_ref

    @test_throws ArgumentError blackmanharris(128, 2)
    @test_throws ArgumentError nuttall(128, 2)
end

zeroarg_wins = [rect, hanning, hamming, cosine, lanczos,
    bartlett, bartlett_hann, blackman, triang, flattop]
onearg_wins = [gaussian, kaiser, tukey]
termarg_wins = [blackmanharris, nuttall]
@testset "zero-phase windows" begin
    for winf in zeroarg_wins
        if winf == triang
            # triang needs to be special-cased here because it has different
            # definitions for odd and even `n` (and also the underlying
            # continuous function changes with `n`), so it doesn't match the
            # zerophase assumption below
            @test triang(6, zerophase=true) ≈ [1.0, 0.75, 0.5, 0.25, 0.5, 0.75]
            @test triang(7, zerophase=true) ≈ [1.0, 0.75, 0.5, 0.25, 0.25, 0.5, 0.75]
        else
            @test winf(8, zerophase=true) ≈ ifftshift(winf(9)[1:8])
            # the `zerophase=false` version doesn't hit the center point, but the
            # zerophase one does, so this ends up introducing a 1/2-sample shift.
            @test winf(9, zerophase=true) ≈ ifftshift(winf(19)[2:2:end])
        end
    end

    # test the window functions that need extra args
    for winf in onearg_wins
        @test winf(8, 0.5, zerophase=true) == ifftshift(winf(9, 0.5)[1:8])
        @test winf(9, 0.5, zerophase=true) == ifftshift(winf(19, 0.5)[2:2:end])
    end

    # Test the window functions that accept the `term` arg (number of coefficients)
    for winf in termarg_wins
        @test winf(8, 4, zerophase=true) == ifftshift(winf(9, 4)[1:8])
        @test winf(9, 4, zerophase=true) == ifftshift(winf(19, 4)[2:2:end])
    end
    # 3-term blackmanharris and nuttall are special cases because of their odd
    # number of coefficients. These coefficients are generated with DSP.jl
    # v0.8.5 to test for regressions, as there's no reference MATLAB
    # implementation.
    @test blackmanharris(6, 3, zerophase=true) ≈ [1.0, 0.632395, 0.134845, 0.0049, 0.134845, 0.632395]
    @test nuttall(6, 3, zerophase=true) ≈ [1.0, 0.63391075, 0.13657015, 0.0053188, 0.13657015, 0.63391075]

    @test dpss(8, 2, 1, zerophase=true)[:] == ifftshift(dpss(9, 2, 1)[1:8])
    # odd-length zerophase dpss windows not currently supported
    @test_throws ArgumentError dpss(9, 2, 1, zerophase=true)
end

@testset "window return types" begin
    # make sure return types are correct
    n = 12
    ft = typeof(1.0)
    for W in(:rect, :hanning, :hamming, :cosine, :lanczos, :triang, :bartlett, :bartlett_hann, :blackman)
        @eval @test Vector{$ft} == typeof($W($n)) && length($W($n)) == $n
    end

    @test Vector{ft} == typeof(tukey(n, 0.4)) && length(tukey(n, 0.4)) == n
    @test Vector{ft} == typeof(gaussian(n, 0.4)) && length(gaussian(n, 0.4)) == n
    @test Vector{ft} == typeof(kaiser(n, 0.4)) && length(kaiser(n, 0.4)) == n
    @test Vector{ft} == typeof(blackmanharris(n, 4)) && length(blackmanharris(n, 4)) == n
    @test Vector{ft} == typeof(blackmanharris(n, 3)) && length(blackmanharris(n, 3)) == n
    @test Vector{ft} == typeof(nuttall(n, 4)) && length(nuttall(n, 4)) == n
    @test Vector{ft} == typeof(nuttall(n, 3)) && length(nuttall(n, 3)) == n

    @test Matrix{ft} == typeof(dpss(n, 1.5)) && size(dpss(n, 1.5),1) == n   # size(,2) depends on the parameters
end

@testset "tensor product windows" begin
    # test all combinations of arguments. Each arg and kwarg can be not present,
    # a single value, or a 2-tuple
    function push_args!((w1e, w2e, w3e), arg, ::Type{T}, f) where {T}
        if arg isa T
            push!(w1e.args, f(arg))
            push!(w2e.args, f(arg))
            push!(w3e.args, f(arg))
        elseif arg isa Tuple
            push!(w1e.args, f(arg[1]))
            push!(w2e.args, f(arg[2]))
            push!(w3e.args, f(arg))
        end
    end

    function test_matrix_window(winfs, args)
        for winf in winfs,
             arg in args
            for padding in (nothing, 4, (4,5)),
              zerophase in (nothing, true, (true,false))
                w1_expr = :($winf(15))
                w2_expr = :($winf(20))
                w3_expr = :($winf((15,20)))
                w_all = (w1_expr, w2_expr, w3_expr)

                push_args!(w_all, arg, Real, identity)
                push_args!(w_all, padding, Integer, s -> Expr(:kw, :padding, s))
                push_args!(w_all, zerophase, Bool, s -> Expr(:kw, :zerophase, s))

                w1 = eval(w1_expr)
                w2 = eval(w2_expr)
                w3 = eval(w3_expr)
                @test w3 ≈ w1 * w2'
            end
        end
    end

    test_matrix_window(zeroarg_wins, (nothing,))
    test_matrix_window(onearg_wins, (0.4, (0.4, 0.5)))
    test_matrix_window(termarg_wins, (3, 4))
end

module LPC


using ..DSP: xcorr

using LinearAlgebra: dot, BlasComplex, BLAS

export lpc, arburg, levinson, LPCBurg, LPCLevinson

# Dispatch types for lpc()
struct LPCBurg end
struct LPCLevinson end

"""
    lpc(x::AbstractVector, p::Integer, [LPCBurg()])

Given input signal `x` and prediction order `p`, returns IIR coefficients `a`
and average reconstruction error `prediction_err`. Note that this method does
NOT return the leading ``1`` present in the true autocorrelative estimate; it
omits it as it is implicit in every LPC estimate, and must be manually
reintroduced if the returned vector should be treated as a polynomial.

The algorithm used is determined by the last optional parameter, and can be
either `LPCBurg` ([`arburg`](@ref)) or `LPCLevinson` ([`levinson`](@ref)).
"""
function lpc end

function lpc(x::AbstractVector{<:Number}, p::Integer, ::LPCBurg)
    a, prediction_err = arburg(x, p)
    popfirst!(a)
    return a, prediction_err
end

"""
    arburg(x::AbstractVector, p::Integer)

LPC (Linear Predictive Coding) estimation, using the Burg method.
This function implements the mathematics published in [^Lagrange], and
the recursion relation as noted in [^Vos], in turn referenced from [^Andersen].

[^Lagrange]: Enhanced Partial Tracking Using Linear Prediction.
    [DAFX 2003 article, Lagrange et al]
    (http://www.sylvain-marchand.info/Publications/dafx03.pdf)

[^Vos]: [A Fast Implementation of Burg’s Method]
    (https://www.opus-codec.org/docs/vos_fastburg.pdf).
    © 2013 Koen Vos, licensed under [CC BY 3.0]
    (https://creativecommons.org/licenses/by/3.0/)

[^Andersen]: N. Andersen. Comments on the performance of maximum entropy algorithms.
    Proceedings of the IEEE 66.11: 1581-1582, 1978.
"""
function arburg(x::AbstractVector{T}, p::Integer) where T<:Number
    # Initialize prediction error with the variance of the signal
    unnormed_err = abs(dot(x, x))
    prediction_err = unnormed_err / length(x)
    R = typeof(prediction_err)
    F = promote_type(R, Base.promote_union(T))

    ef = collect(F, x)                  # forward error
    eb = copy(ef)                       # backwards error
    a = zeros(F, p + 1); a[1] = 1       # prediction coefficients
    rev_buf = similar(a, p)             # buffer to store a in reverse
    reflection_coeffs = similar(a, p)   # reflection coefficients

    den = convert(R, 2unnormed_err)
    ratio = one(R)

    @views for m in 1:p
        cf = pop!(ef)
        cb = popfirst!(eb)
        den = muladd(ratio, den, -(abs2(cf) + abs2(cb)))

        k = -2 * dot(eb, ef) / den
        reflection_coeffs[m] = k

        rev_buf[1:m] .= a[m:-1:1]
        kc = conj(k)
        @. a[2:m+1] = muladd(kc, conj(rev_buf[1:m]), a[2:m+1])

        # update prediction errors
        for i in eachindex(ef, eb)
            ef_i, eb_i = ef[i], eb[i]
            ef[i] = muladd(k, eb_i, ef[i])
            eb[i] = muladd(kc, ef_i, eb[i])
        end

        ratio = one(R) - abs2(k)
        prediction_err *= ratio
    end

    return a, prediction_err, reflection_coeffs
end

function lpc(x::AbstractVector{<:Number}, p::Integer, ::LPCLevinson)
    R_xx = xcorr(x; scaling=:biased)[length(x):end]
    a, prediction_err = levinson(R_xx, p)
    return a, prediction_err
end

"""
    levinson(x::AbstractVector, p::Integer)

Implements Levinson recursion, as described in [^Levinson], to find
the solution `a` of the linear equation
```math
\\mathbf{T} (-\\vec{a})
=
\\begin{bmatrix}
    x_2 \\\\
    \\vdots \\\\
    x_{p+1}
\\end{bmatrix}
```
in the case where ``\\mathbf{T}`` is Hermitian and Toeplitz, with first column `x[1:p]`.
This function can be used for LPC (Linear Predictive Coding) estimation,
by providing `LPCLevinson()` as an argument to `lpc`.

[^Levinson]: The Wiener (RMS) Error Criterion in Filter Design and Prediction.
    N. Levinson, Studies in Applied Mathematics 25(1946), 261-278.\\
    <https://doi.org/10.1002/sapm1946251261>
"""
function levinson(R_xx::AbstractVector{U}, p::Integer) where U<:Number
    # for m = 1
    k = -R_xx[2] / R_xx[1]
    F = promote_type(Base.promote_union(U), typeof(k))
    prediction_err = real(R_xx[1] * (one(F) - abs2(k)))
    R = typeof(prediction_err)
    T = promote_type(F, R)

    a = zeros(T, p)
    reflection_coeffs = zeros(T, p)
    a[1] = reflection_coeffs[1] = k
    rev_a = similar(a, p - 1)     # buffer to store a in reverse

    @views for m = 2:p
        rev_a[1:m-1] .= a[m-1:-1:1]
        k = -(R_xx[m+1] + dotu(R_xx[2:m], rev_a[1:m-1])) / prediction_err
        @. a[1:m-1] = muladd(k, conj(rev_a[1:m-1]), a[1:m-1])
        a[m] = reflection_coeffs[m] = k
        prediction_err *= (one(R) - abs2(k))
    end

    # Return autocorrelation coefficients, error estimate, and reflection coefficients
    return a, prediction_err, reflection_coeffs
end

# for convenience, define dotu as dot for real vectors
dotu(x::AbstractVector{<:Real}, y::AbstractVector{<:Real}) = dot(x, y)
dotu(x::AbstractVector{T}, y::AbstractVector{T}) where T<:BlasComplex = BLAS.dotu(x, y)
function dotu(x::AbstractVector{T}, y::AbstractVector{V}) where {T,V}
    dotprod = zero(promote_type(T, V))
    for i in eachindex(x, y)
        dotprod = muladd(x[i], y[i], dotprod)
    end
    dotprod
end

# Default users to using Burg estimation as it is in general more stable
lpc(x, p) = lpc(x, p, LPCBurg())

end # module LPC

module Windows
using ..Util
using Bessels: besseli0
using LinearAlgebra: Diagonal, SymTridiagonal, eigen!, mul!, rmul!
using FFTW

export  rect,
        hann,
        hanning,
        hamming,
        tukey,
        cosine,
        lanczos,
        triang,
        bartlett,
        gaussian,
        bartlett_hann,
        blackman,
        blackmanharris,
        nuttall,
        kaiser,
        flattop,
        dpss,
        dpsseig

# this gets shared between the docstrings of all the window functions because
# they share these args.
const zerophase_docs = """
If `zerophase` is `false` (the default) the window is centered around index
`(n+1)/2`, which is commonly used for FIR filter design. These are often used
for FIR filter design, and usually odd-length. Note that for even-length windows
this will cause the window center to be located between samples.

If `zerophase` is `true` the window is centered around index 1 (with the
negative half wrapped to the end of the vector). Additionally this creates a
"periodic" window, which means that if there is no padding then the left and
right endpoints of the window wrap around to the same sample, so the window
length is the same as an `n+1`-length non-`zerophase` window. Alternatively you
can think of the continuous `zerophase` window being of width `n` and the
non-`zerophase` window being of length `n-1`. `zerophase` windows are often used
in FFT processing, and are usually even-length.
"""

function twoD_docs(arg=nothing)
    argstr = if arg !== nothing
        "`$arg`, "
    else
        ""
    end
    """
    Providing a `dims` `Tuple` rather than a single `n` constructs a 2D window.
    $argstr`padding` and `zerophase` can then be given either as a single value
    for both horizontal and vertical or a 2-tuple to specify them separately.
    """
end

"""
    padplot(plotstr)

Takes a multiline string and pre-pads it so that it shows up as
preformatted code when included in a docstring.
"""
function padplot(plotstr)
    minpad = typemax(Int)
    lines = split(plotstr, "\n")
    # count the minimum number of spaces preceeding any line
    for line in lines
        line == "" && continue
        minpad = min(minpad, length(match(r"^ *", line).match))
    end

    pad = " " ^ (4-minpad)
    join((string(pad, line) for line in lines), "\n")
end

include("winplots.jl")

"""
    makewindow(winfunc::Function, n::Integer, padding::Integer, zerophase::Bool)

Generate a discrete window vector of the given length with `padding` zeros.
`winfunc` should be a function giving the window value in the domain of
[-0.5, 0.5]. The function is assumed to be 0 outside of this domain.

$zerophase_docs

Example:

```julia
function hanning(n::Integer; padding::Integer=0, zerophase::Bool=false)
    makewindow(n, padding, zerophase) do x
        0.5*(1+cos(2pi*x))
    end
end
```
"""
function makewindow(winfunc::Function, n::Integer, padding::Integer, zerophase::Bool)
    if n < 0
        throw(ArgumentError("`n` must be nonnegative"))
    end
    if padding < 0
        throw(ArgumentError("`padding` must be nonnegative"))
    end
    win = zeros(n+padding)
    if n == 1
        win[1] = winfunc(0.0)
    elseif zerophase
        # note that the endpoint of the window gets set in both lines. In the
        # unpadded case this will set the same index (which shouldn't make a
        # difference if the window is symmetric), but it's necessary for when
        # there's padding, which ends up in the center of the vector length
        # n÷2+1
        win[1:n÷2+1] .= winfunc.(range(0.0, (n÷2)/n; length=n÷2+1))
        # length n÷2
        win[end-n÷2+1:end] .= winfunc.(range(-(n÷2)/n, -1/n; length=n÷2))
    else
        win[1:n] .= winfunc.(range(-0.5, 0.5; length=n))
    end

    win
end

#
# Window functions
#

# equations rendered into Unicode with https://arthursonzogni.com/Diagon/

"""
$rect_winplot

    rect(n::Integer; padding::Integer=0, zerophase::Bool=false)
    rect(dims; padding=0, zerophase=false)

Rectangular window of length `n`, padded with `padding` zeros. This window is 1
within the window, and 0 outside of it.

$(twoD_docs())

$zerophase_docs
"""
function rect(n::Integer; padding::Integer=0, zerophase::Bool=false)
    makewindow(_ -> 1.0, n, padding, zerophase)
end


"""
$hanning_winplot

    hanning(n::Integer; padding::Integer=0, zerophase::Bool=false)
    hanning(dims; padding=0, zerophase=false)

Hanning window of length `n` with `padding` zeros. The Hanning (or Hann) window
is a raised-cosine window that reaches zero at the endpoints.

The window is defined by sampling the continuous function:

           1 + cos(2πx)
    w(x) = ──────────── = cos²(πx)
                2

in the domain `[-0.5, 0.5]`

The `hanning` window satisfies the Constant Overlap-Add (COLA) property with a
hop of 0.5, which means that adding together a sequence of delayed windows with
50% overlap will result in a constant signal. This is useful when synthesizing
a signal from a number of overlapping frames (each with a roughly rectangular
window), to eliminate windowing amplitude modulation.

While this windowing function was originally named after its inventor Julius
Von Hann, colloquial usage has adjusted to refer to it as the "Hanning" window,
to better match the similarly-named "Hamming" window.  Because of this, both
`hann()` and `hanning()` are exported from this module.

Note that the `hanning` window is the `cosine` window squared.

$(twoD_docs())

$zerophase_docs
"""
function hanning(n::Integer; padding::Integer=0, zerophase::Bool=false)
    makewindow(x -> 0.5 * (1 + cospi(2x)), n, padding, zerophase)
end
const hann = hanning

"""
$hamming_winplot

    hamming(n::Integer; padding::Integer=0, zerophase::Bool=false)
    hamming(dims; padding=0, zerophase=false)

Hamming window of length `n` with `padding` zeros. The Hamming window does not
reach zero at the endpoints and so has a shallower frequency roll-off when
compared to the Hanning window, but is designed to cancel the first side-lobe.

The window is defined by sampling the continuous function:

    w(x) = 0.54 + 0.46*cos(2pi*x)

in the domain `[-0.5, 0.5]`

$(twoD_docs())

$zerophase_docs
"""
function hamming(n::Integer; padding::Integer=0, zerophase::Bool=false)
    makewindow(x -> muladd(0.46, cospi(2x), 0.54), n, padding, zerophase)
end

"""
$tukey_winplot

    tukey(n::Integer, α::Real; padding::Integer=0, zerophase::Bool=false)
    tukey(dims, α; padding=0, zerophase=false)

Tukey window of length `n` with `padding` zeros. The Tukey window has a flat top
and reaches zero at the endpoints, with a sinusoidal transition area
parameterized by `α`. For `α == 0`, the window is equivalent to a rectangular
window. For `α == 1`, the window is a Hann window.

The window is defined by sampling the continuous function:

           ⎛              ⎛2π ⎛    1 - α⎞⎞
           ⎜      1 + cos ⎜── ⎜x + ─────⎟⎟             1 - α
           ⎜              ⎝ α ⎝      2  ⎠⎠       x ≤ - ─────
           ⎜      ─────────────────────────              2
           ⎜                  2
           ⎜
           ⎜                                       1 - α       1 - α
    w(x) = ⎜      1                              - ───── < x ≤ ─────
           ⎜                                         2           2
           ⎜
           ⎜              ⎛2π ⎛    1 - α⎞⎞
           ⎜      1 + cos ⎜── ⎜x - ─────⎟⎟           1 - α
           ⎜              ⎝ α ⎝      2  ⎠⎠       x > ─────
           ⎜      ─────────────────────────            2
           ⎝                  2

in the domain `[-0.5, 0.5]`

$(twoD_docs("α"))

$zerophase_docs
"""
function tukey(n::Integer, α::Real; padding::Integer=0, zerophase::Bool=false)
    # check that α is reasonable
    !(0 <= α <= 1) && throw(DomainError(α, "α must be in the range [0, 1]."))

    # if α is less than machine precision, call it zero and return the
    # rectangular window for this length.  if we don't short circuit this
    # here, it will blow up below.
    abs(α) <= eps() && return rect(n; padding, zerophase)

    makewindow(n, padding, zerophase) do x
        if x <= -(1-α)/2
            0.5*(1 + cospi(2/α*(x+(1-α)/2)))
        elseif x <= (1-α)/2
            1.0
        else
            0.5*(1 + cospi(2/α*(x-(1-α)/2)))
        end
    end
end

"""
$cosine_winplot

    cosine(n::Integer; padding::Integer=0, zerophase::Bool=false)
    cosine(dims; padding=0, zerophase=false)

Cosine window of length `n` with `padding` zeros. The cosine window is the first
lobe of a cosine function (with the zero crossings at +/- π as endpoints). Also
called the sine window.

The window is defined by sampling the continuous function:

    w(x) = cos(πx)

in the domain `[-0.5, 0.5]`

Note that the cosine window is the square root of the `hanning` window, so it is
sometimes used when you are applying the window twice, such as the analysis and
synthesis steps of an STFT.

$(twoD_docs())

$zerophase_docs
"""
function cosine(n::Integer; padding::Integer=0, zerophase::Bool=false)
    makewindow(cospi, n, padding, zerophase)
end

"""
$lanczos_winplot

    lanczos(n::Integer; padding::Integer=0, zerophase::Bool=false)
    lanczos(dims; padding=0, zerophase=false)

Lanczos window of length `n` with `padding` zeros. The Lanczos window is the
main lobe of a `sinc` function.

The window is defined by sampling the continuous function:

                      sin(2πx)
    w(x) = sinc(2x) = ────────
                         2πx

in the domain `[-0.5, 0.5]`

$(twoD_docs())

$zerophase_docs
"""
function lanczos(n::Integer; padding::Integer=0, zerophase::Bool=false)
    makewindow(x -> sinc(2x), n, padding, zerophase)
end

"""
$triang_winplot

    triang(n::Integer; padding::Integer=0, zerophase::Bool=false)
    triang(dims; padding=0, zerophase=false)

Triangular window of length `n` with `padding` zeros. The Triangular window does
not reach zero at the endpoints. For odd `n` the `triang` window is the center
`n` points of an `n+2`-point [`bartlett`](@ref) window (i.e. the samples just
outside the window would be zero). For even `n` the window slope is the same as
the `n-1` window but delayed by a half sample so the zero points would be 1/2
sample past the ends of the window.

The window is defined by sampling the continuous function:

            ⎛    2(n-1)
            ⎜1 - ────── abs(x)     n is even
            ⎜       n
    w(x) =  ⎜
            ⎜    2(n-1)
            ⎜1 - ────── abs(x)     n is odd
            ⎝     n+1

in the domain `[-0.5, 0.5]`.

$(twoD_docs())

$zerophase_docs

When `zerophase` is `true` substitute `n+1` for `n` in the above window
expressions.
"""
function triang(n::Integer; padding::Integer=0, zerophase::Bool=false)
    # for the purpose of calculating the slope of the window, consider `n` to be
    # 1 larger to compensate for the fact that `zerophase` gives a periodic
    # window
    m = zerophase ? n+1 : n
    scale = iseven(m) ? 2(m-1)/m : 2(m-1)/(m+1)
    makewindow(x -> muladd(-scale, abs(x), 1), n, padding, zerophase)
end

"""
$bartlett_winplot

    bartlett(n::Integer; padding::Integer=0, zerophase::Bool=false)
    bartlett(dims; padding=0, zerophase=false)

Bartlett window of length `n`. The Bartlett window is a triangular window that
reaches 0 at the endpoints. This is equivalent to convolving two rectangular
windows of length `(n-1)/2` and adding the zero endpoints. See `triang` for a
window that does not reach zero at the endpoints.

The window is defined by sampling the continuous function:

    1 - abs(2x)

in the domain `[-0.5, 0.5]`

$(twoD_docs())

$zerophase_docs
"""
function bartlett(n::Integer; padding::Integer=0, zerophase::Bool=false)
    makewindow(x -> 1 - abs(2x), n, padding, zerophase)
end

"""
$gaussian_winplot

    gaussian(n::Integer, σ::Real; padding::Integer=0, zerophase::Bool=false)
    gaussian(dims, σ; padding=0, zerophase=false)

Gives an n-sample gaussian window defined by sampling the function:

            ⎛        2⎞
            ⎜-1   ⎛x⎞ ⎟
            ⎜── ⋅ ⎜─⎟ ⎟
            ⎝ 2   ⎝σ⎠ ⎠
    w(x) = e

in the domain `[-0.5,0.5]`. This means that for `σ=0.5` the endpoints of the
window will correspond to 1 standard deviation away from the center.

$(twoD_docs("σ"))

$zerophase_docs
"""
function gaussian(n::Integer, σ::Real; padding::Integer=0, zerophase::Bool=false)
    σ > 0.0 || throw(DomainError(σ, "σ must be positive"))
    makewindow(x -> exp(-0.5*(x/σ)^2), n, padding, zerophase)
end

"""
$bartlett_hann_winplot

    bartlett_hann(n::Integer; padding::Integer=0, zerophase::Bool=false)
    bartlett_hann(dims; padding=0, zerophase=false)

Bartlett-Hann window of length `n` with `padding` zeros. The Bartlett-Hann
window is a weighted sum of the Bartlett and Hann windows.

The window is defined by sampling the continuous function:

    w(x) = 0.62 - 0.48*abs(x) + 0.38*cos(2π*x)

in the domain `[-0.5, 0.5]`

$(twoD_docs())

$zerophase_docs
"""
function bartlett_hann(n::Integer; padding::Integer=0, zerophase::Bool=false)
    a0, a1, a2 = 0.62, 0.48, 0.38
    makewindow(n, padding, zerophase) do x
        muladd(a2, cospi(2x), muladd(-a1, abs(x), a0))
    end
end

"""
$blackman_winplot

    blackman(n::Integer; padding::Integer=0, zerophase::Bool=false)
    blackman(dims; padding=0, zerophase=false)

Approximates the "Exact" Blackman window. This is the generalized Blackman
window with α = 0.16.

The window is defined by sampling the continuous function:

    w(x) = 0.42 + 0.5*cos(2π*x) + 0.08*cos(4π*x)

in the domain `[-0.5, 0.5]`

$(twoD_docs())

$zerophase_docs
"""
function blackman(n::Integer; padding::Integer=0, zerophase::Bool=false)
    a0, a1, a2 = 0.42, 0.5, 0.08
    makewindow(n, padding, zerophase) do x
        muladd(a1, cospi(2x), muladd(a2, cospi(4x), a0))
    end
end

"""
$blackmanharris_winplot

    blackmanharris(n::Integer, term::Integer=4; padding::Integer=0, zerophase::Bool=false)
    blackmanharris(dims, term::Integer; padding=0, zerophase=false)
    blackmanharris(dims, Tuple{term::Integer, term::Integer}; padding=0, zerophase=false)

Blackman-Harris window of length `n` with `padding` zeros. The Blackman-Harris
window is a linear combination of three or four trigonometric terms, optimized
for minimum sidelobe level (at the expense of a wider main lobe). The number of
terms can be selected with `term` ∈ [3,4]. For `term = 3`, the maximum sidelobe
level is about -70.83 dB, while for `term = 4` (the default), it improves to
-92.01 dB. Note, that Nuttall proved those coefficients to not be the most
optimized ones in [Nuttall, A. H. (1981). Some windows with very good sidelobe
behavior. IEEE Transactions on Acoustics, Speech, Signal Processing, 29,
84-91](https://ieeexplore.ieee.org/document/1163506).

The 3-term window `w3(x)` and the 4-term window `w4(x)` are defined by sampling
the following continuous functions in the domain `[-0.5, 0.5]`:

    w3(x) = 0.42323 + 0.49755*cos(2π*x) + 0.07922*cos(4π*x)

    w4(x) = 0.35875 + 0.48829*cos(2π*x) + 0.14128*cos(4π*x) + 0.01168*cos(6π*x)

Due to the symmetric definition of the domain around zero, all coefficients are positive.
For more details see [Harris, F. J. (1978). On the Use of Windows for Harmonic
Analysis with the Discrete Fourier Transform. Proceedings of the IEEE, 66(1),
51-83](https://ieeexplore.ieee.org/document/1455106).

The `blackmanharris` windows do not generally satisfy the Constant Overlap-Add
(COLA) property. Nevertheless, when using `zerophase = true` and implementing the
following boundary conditions they approximately do:
- For the 3-term window the overlap should be 66% and the window length should
  be a multiple of 3.
- For the 4-term window the overlap should be 75% and the window length should
  be a multiple of 2.

$(twoD_docs())

$zerophase_docs
"""
function blackmanharris(n::Integer, term::Integer=4; padding::Integer=0, zerophase::Bool=false)
    if term == 4
        a0, a1, a2, a3 = 0.35875, 0.48829, 0.14128, 0.01168
        makewindow(n, padding, zerophase) do x
            muladd(a1, cospi(2x), muladd(a2, cospi(4x), muladd(a3, cospi(6x), a0)))
        end
    elseif term == 3
        a0, a1, a2 = 0.42323, 0.49755, 0.07922
        makewindow(n, padding, zerophase) do x
            muladd(a1, cospi(2x), muladd(a2, cospi(4x), a0))
        end
    else
        throw(ArgumentError("`term` must be either 3 or 4"))
    end
end

"""
$nuttall_winplot

    nuttall(n::Integer, term::Integer=4; padding::Integer=0, zerophase::Bool=false)
    nuttall(dims, term::Integer; padding=0, zerophase=false)
    nuttall(dims, Tuple{term_x::Integer, term_y::Integer}; padding=0, zerophase=false)

Nuttall window of length `n` with `padding` zeros. These windows can be seen as
the improved version of the Blackman-Harris windows with regard to maximum
sidelobe level. The number of terms can be selected with `term` ∈ [3,4]. For
`term = 3`, the maximum sidelobe level is about -71.48 dB, while for `term = 4`
(the default), it improves to -98.17 dB.

The 3-term window `w3(x)` and the 4-term window `w4(x)` are defined by sampling
the following continuous functions in the domain `[-0.5, 0.5]`:

    w3(x) = 0.4243801 + 0.4973406*cos(2π*x) + 0.0782793*cos(4π*x)

    w4(x) = 0.3635819 + 0.4891775*cos(2π*x) + 0.1365995*cos(4π*x) + 0.0106411*cos(6π*x)

Due to the symmetric definition of the domain around zero, all coefficients are positive.
For more details see [Nuttall, A. H. (1981). Some windows with very good
sidelobe behavior. IEEE Transactions on Acoustics, Speech, Signal Processing,
29, 84-91](https://ieeexplore.ieee.org/document/1163506)

The `nuttall` windows do not generally satisfy the Constant Overlap-Add
(COLA) property. Nevertheless, when using `zerophase = true` and implementing the
following boundary conditions they approximately do:
- For the 3-term window the overlap should be 66% and the window length should
  be a multiple of 3.
- For the 4-term window the overlap should be 75% and the window length should
  be a multiple of 4.

$(twoD_docs())

$zerophase_docs
"""
function nuttall(n::Integer, term::Integer=4; padding::Integer=0, zerophase::Bool=false)
    if term == 4
        a0, a1, a2, a3 = 0.3635819, 0.4891775, 0.1365995, 0.0106411
        makewindow(n, padding, zerophase) do x
            muladd(a1, cospi(2x), muladd(a2, cospi(4x), muladd(a3, cospi(6x), a0)))
        end
    elseif term == 3
        a0, a1, a2 = 0.4243801, 0.4973406, 0.0782793
        makewindow(n, padding, zerophase) do x
            muladd(a1, cospi(2x), muladd(a2, cospi(4x), a0))
        end
    else
        throw(ArgumentError("`term` must be either 3 or 4"))
    end
end

"""
$kaiser_winplot

    kaiser(n::Integer, α::Real; padding::Integer=0, zerophase::Bool=false)
    kaiser(dims, α; padding=0, zerophase=false)

Kaiser window of length `n` parameterized by `α`. The Kaiser window approximates
the DPSS window (given by `dpss`), using a simplified definition relying on a
Bessel function. Larger values for `α` give a wider main lobe but have lower
sidelobes. Typically `α` is set around 3.

The window is defined by sampling the continuous function:


             ⎛  ⎛   _________⎞⎞
             ⎜  ⎜  ╱        2⎟⎟
    w(x) = I₀⎝πα⎝╲╱ 1 - (2x) ⎠⎠
           ────────────────────
                   I₀(πα)

in the domain `[-0.5, 0.5]`

Where I₀(⋅) is the zeroth-order modified Bessel function of the first kind.

$(twoD_docs("α"))

$zerophase_docs
"""
function kaiser(n::Integer, α::Real; padding::Integer=0, zerophase::Bool=false)
    pf = 1.0/besseli0(pi*α)
    makewindow(n, padding, zerophase) do x
        pf*besseli0(pi*α*(sqrt(1 - (2x)^2)))
    end
end

"""
$flattop_winplot

    flattop(n::Integer; padding::Integer=0, zerophase::Bool=false)
    flattop(dims; padding=0, zerophase=false)

Flattop window of length `n` with `padding` zeros and coefficients selected as
in MATLAB. As the name suggests, this window results in a flat (and wide) main
lobe with sidelobe suppression of about 91 dB.

The window is defined by sampling the continuous function:

    w3(x) = a0 + a1*cos(2π*x) + a2*cos(4π*x) + a3*cos(6π*x) + a4*cos(8π*x)

in the domain `[-0.5, 0.5]` with the following coefficients:

| Coefficient | Value |
| --- | --- |
| a0 | 0.21557895 |
| a1 | 0.41663158 |
| a2 | 0.277263158 |
| a3 | 0.083578947 |
| a4 | 0.006947368 |

Due to the symmetric definition of the domain around zero, all coefficients are positive.
Flat top windows have very low passband ripple (< 0.01 dB) and are used
primarily for calibration purposes. Their bandwidth is approximately 2.5 times
wider than a Hanning window.

$(twoD_docs())

$zerophase_docs
"""
function flattop(n::Integer; padding::Integer=0, zerophase::Bool=false)
    a0, a1, a2, a3, a4 = 0.21557895, 0.41663158, 0.277263158, 0.083578947, 0.006947368
    makewindow(n, padding, zerophase) do x
        muladd(a1, cospi(2x), muladd(a2, cospi(4x), muladd(a3, cospi(6x), muladd(a4, cospi(8x), a0))))
    end
end

# Discrete prolate spheroid sequences (Slepian tapers)
#
# See Gruenbacher, D. M., & Hummels, D. R. (1994). A simple algorithm
# for generating discrete prolate spheroidal sequences. IEEE
# Transactions on Signal Processing, 42(11), 3276-3278.
"""
$dpss_winplot

    dpss(n::Integer, nw::Real, ntapers::Integer=iceil(2*nw)-1;
         padding::Integer=0, zerophase::Bool=false)

The first `ntapers` discrete prolate spheroid sequences (Slepian
tapers) as an `n` × `ntapers` matrix. The signs of the tapers
follow the convention that the first element of the skew-symmetric
(odd) tapers is positive. The time-bandwidth product is given by
`nw`.

The DPSS window maximizes the energy concentration in the main lobe.

$zerophase_docs
"""
function dpss(n::Integer, nw::Real, ntapers::Integer=ceil(Int, 2*nw)-1;
              padding::Integer=0, zerophase::Bool=false)
    if isodd(n) && zerophase
        throw(ArgumentError("`dpss` does not currently support odd-length zerophase windows"))
    end
    # TODO there's probably a more efficient way to compute the zero-phase
    # version of this
    if zerophase
        n += 1
    end
    0 < ntapers <= n || throw(DomainError(ntapers, "ntapers must be in the interval (0, n]"))
    0 <= nw < n/2 || throw(DomainError(nw, "nw must be in the interval [0, n/2)"))

    # Construct symmetric tridiagonal matrix
    v = cospi(2*nw/n)
    dv = Vector{Float64}(undef, n)
    ev = Vector{Float64}(undef, n - 1)
    dv[1] = v * abs2((n - 1) / 2)
    for i = 1:(n-1)
        dv[i + 1] = v * abs2((n - 1) / 2 - i)
        ev[i] = 0.5 * (i * n - i^2)
    end
    mat = SymTridiagonal(dv, ev)

    # Get tapers
    eigvec = eigen!(mat, n-ntapers+1:n).vectors
    rv = reverse!(eigvec; dims=2)::Matrix{Float64}

    # Slepian's convention; taper starts with a positive element
    sgn = fill!(resize!(dv, ntapers), 1) # save one allocation by re-purposing dv
    for i = 2:2:size(rv, 2)
        s = zero(eltype(rv))
        for j = 1:n
            s = sign(rv[j, i])
            !iszero(s) && break
        end
        @assert !iszero(s)
        sgn[i] = s
    end
    rmul!(rv, Diagonal(sgn))

    if zerophase
        # remove the last element (should be equal to the first element)
        rv = rv[1:end-1, :]
    end

    if padding > 0
        rv = [rv; zeros(padding, ntapers)]
    end

    if zerophase
        # TODO: figure out how to handle odd-length zerophase windows. See the
        # tests for one approach, but upsampling by 2 doesn't work here becasue
        # the overall amplitude varies with `n`
        rv = ifftshift(rv, 1)
    end

    rv
end

# Eigenvalues of DPSS, following Percival & Walden p. 390, exercise 8.1
# See also implementation in MNE:
# https://github.com/mne-tools/mne-python/blob/d7082cf909ccab581667bc1f1ed3c23e6a24b567/mne/time_frequency/multitaper.py#L226
"""
    dpsseig(A, nw)

Eigenvalues of the DPSS matrix, representing the ratios of the
power within the main lobe to the total power (main and sidelobes).
`A` is the output of [`dpss`](@ref), and `nw` is the
time-bandwidth product provided to [`dpss`](@ref) as input.
"""
function dpsseig(A::Matrix{Float64}, nw::Real)
    0 <= nw < size(A, 1)/2 || throw(DomainError(nw, "nw must be in the interval [0, n/2)"))

    w = nw/size(A, 1)

    # Compute coefficients
    seq = Vector{Float64}(undef, size(A, 1))
    seq[1] = 1.0
    for i = 1:size(A, 1)-1
        seq[i+1] = 2 * sinc(2w*i)
    end

    q = Vector{Float64}(undef, size(A, 2))
    nfft = nextfastfft(2*size(A, 1)-1)

    tmp1 = Vector{Float64}(undef, nfft)
    tmp2 = Vector{Complex{Float64}}(undef, nfft >> 1 + 1)
    p1 = plan_rfft(tmp1)
    p2 = plan_brfft(tmp2, nfft)

    for i = 1:size(A, 2)
        fill!(tmp1, 0)
        copyto!(tmp1, 1, A, (i-1)*size(A, 1)+1, size(A, 1))
        mul!(tmp2, p1, tmp1)
        for j in eachindex(tmp2)
            tmp2[j] = abs2(tmp2[j])
        end
        mul!(tmp1, p2, tmp2)

        eig = 0.0
        for j = 1:size(A, 1)
            eig = muladd(seq[j], tmp1[j], eig)
        end
        q[i] = 2w * eig / nfft
    end

    q
end

# tensor product window functions in 2-d, defined as w(x,y) = w(x) \otimes w(y)

# convert the given argument to a 2-Tuple so we can distribute it to the
# input windows when making a 2D window
argdup(arg::Tuple) = arg
argdup(arg::Real) = (arg, arg)
const IntegerOr2 = Union{Tuple{Integer, Integer}, Integer}
const RealOr2 = Union{Tuple{Real, Real}, Real}
const BoolOr2 = Union{Tuple{Bool, Bool}, Bool}

function matrix_window(func::F, dims::Tuple{Integer,Integer}, arg::Union{RealOr2,Nothing}=nothing;
        padding::IntegerOr2=0, zerophase::BoolOr2=false) where {F}
    paddings = argdup(padding)
    zerophases = argdup(zerophase)
    if isnothing(arg)
        w1 = func(dims[1]; padding=paddings[1], zerophase=zerophases[1])
        w2 = func(dims[2]; padding=paddings[2], zerophase=zerophases[2])
    else
        args = argdup(arg)
        w1 = func(dims[1], args[1]; padding=paddings[1], zerophase=zerophases[1])
        w2 = func(dims[2], args[2]; padding=paddings[2], zerophase=zerophases[2])
    end
    return w1 * w2'
end

for func in (:rect, :hanning, :hamming, :cosine, :lanczos,
    :triang, :bartlett, :bartlett_hann, :blackman, :flattop)
    @eval function $func(dims::Tuple{Integer,Integer}; padding::IntegerOr2=0, zerophase::BoolOr2=false)
        return matrix_window($func, dims; padding, zerophase)
    end
end

for func in (:tukey, :gaussian, :kaiser, :blackmanharris, :nuttall)
    @eval function $func(dims::Tuple{Integer,Integer}, arg::RealOr2; padding::IntegerOr2=0, zerophase::BoolOr2=false)
        return matrix_window($func, dims, arg; padding, zerophase)
    end
end

end # end module definition

module Unwrap
using Random: AbstractRNG, default_rng
export unwrap, unwrap!

"""
    unwrap!(m; kwargs...)

In-place version of [`unwrap`](@ref).
"""
unwrap!(m::AbstractArray; kwargs...) = unwrap!(m, m; kwargs...)

"""
    unwrap!(y, m; kwargs...)

Unwrap `m` storing the result in `y`, see [`unwrap`](@ref).
"""
function unwrap!(y::AbstractArray{T,N}, m::AbstractArray{T,N}; dims=nothing, range=2T(pi), kwargs...) where {T, N}
    if dims === nothing
        if N != 1
            throw(ArgumentError("`unwrap!`: required keyword parameter dims missing"))
        end
        dims = 1
    end
    if dims isa Integer
        accumulate!(unwrap_kernel(range), y, m; dims)
    elseif dims == 1:N
        unwrap_nd!(y, m; range, kwargs...)
    else
        throw(ArgumentError("`unwrap!`: Invalid dims specified: $dims"))
    end
    return y
end

unwrap_kernel(range) = (x, y) -> y - round((y - x) / range) * range

"""
    unwrap(m; kwargs...)


Assumes `m` to be a sequence of values that has been wrapped to be inside the
given `range` (centered around zero), and undoes the wrapping by identifying
discontinuities. If a single dimension is passed to `dims`, then `m` is assumed
to have wrapping discontinuities only along that dimension. If a range of
dimensions, as in `1:ndims(m)`, is passed to `dims`, then `m` is assumed to have
wrapping discontinuities across all `ndims(m)` dimensions.

A common usage for unwrapping across a singleton dimension is for a phase
measurement over time, such as when
comparing successive frames of a short-time Fourier transform, as
each frame is wrapped to stay within (-pi, pi].

A common usage for unwrapping across multiple dimensions is for a phase
measurement of a scene, such as when retrieving the phase information
of an image, as each pixel is wrapped to stay within (-pi, pi].

# Arguments
- `m::AbstractArray{T, N}`: Array to unwrap.
- `dims=nothing`: Dimensions along which to unwrap. If `dims` is an integer, then
    `unwrap` is called on that dimension. If `dims=1:ndims(m)`, then `m` is unwrapped
    across all dimensions.
- `range=2pi`: Range of wrapped array.
- `circular_dims=(false, ...)`:  When an element of this tuple is `true`, the
    unwrapping process will consider the edges along the corresponding axis
    of the array to be connected.
- `rng=default_rng()`: Unwrapping of arrays with dimension > 1 uses a random
    initialization. A user can pass their own RNG through this argument.
"""
unwrap(m::AbstractArray; kwargs...) = unwrap!(similar(m), m; kwargs...)

#= Algorithm based off of
 M. A. Herráez, D. R. Burton, M. J. Lalor, and M. A. Gdeisat,
 "Fast two-dimensional phase-unwrapping algorithm based on sorting by reliability following a noncontinuous path"
 `Applied Optics, Vol. 41, Issue 35, pp. 7437-7444 (2002) <http://dx.doi.org/10.1364/AO.41.007437>`
 and
 H. Abdul-Rahman, M. Gdeisat, D. Burton, M. Lalor,
 "Fast three-dimensional phase-unwrapping algorithm based on sorting by reliability following a non-continuous path",
 `Proc. SPIE 5856, Optical Measurement Systems for Industrial Inspection IV, 32 (2005) <http://dx.doi.ogr/doi:10.1117/12.611415>`
 Code inspired by Scipy's implementation, which is under BSD license.
=#

mutable struct Pixel{T}
    periods::Int
    const val::T
    reliability::Float64
    groupsize::Int
    head::Pixel{T}
    last::Pixel{T}
    next::Union{Nothing, Pixel{T}}
    function Pixel{T}(periods, val, rel, gs) where T
        pixel = new(periods, val, rel, gs)
        pixel.head = pixel
        pixel.last = pixel
        pixel.next = nothing
        return pixel
    end
end
Pixel(v, rel::Float64) = Pixel{typeof(v)}(0, v, rel, 1)
@inline Base.length(p::Pixel) = p.head.groupsize

struct Edge{T}
    reliability::Float64
    periods::Int
    pixel_1::Pixel{T}
    pixel_2::Pixel{T}
end
function Edge{T}(p1::Pixel{T}, p2::Pixel{T}, range) where {T}
    rel = p1.reliability + p2.reliability
    periods = find_period(p1.val, p2.val, range)
    return Edge{T}(rel, periods, p1, p2)
end
@inline Base.isless(e1::Edge, e2::Edge) = isless(e1.reliability, e2.reliability)

function unwrap_nd!(dest::AbstractArray{T, N},
                    src::AbstractArray{T, N};
                    range::Number=2*convert(T, pi),
                    circular_dims::NTuple{N, Bool}=ntuple(_->false, Val(N)),
                    rng::AbstractRNG=default_rng()) where {T, N}

    range_T = convert(T, range)

    pixel_image = init_pixels(src, rng)
    calculate_reliability(pixel_image, circular_dims, range_T)
    edges = Edge{T}[]
    num_edges = _predict_num_edges(size(src), circular_dims)
    sizehint!(edges, num_edges)
    for idx_dim = 1:N
        populate_edges!(edges, pixel_image, idx_dim, circular_dims[idx_dim], range_T)
    end

    perm = sortperm(map(x -> x.reliability, edges); alg=MergeSort)
    edges = edges[perm]
    gather_pixels!(edges)
    unwrap_image!(dest, pixel_image, range_T)

    return dest
end

function _predict_num_edges(size_img, circular_dims)
    num_edges = 0
    for (size_dim, wrap_dim) in zip(size_img, circular_dims)
        num_edges += prod(size_img) * (size_dim-1) ÷ size_dim + wrap_dim * prod(size_img) ÷ size_dim
    end
    return num_edges
end

# function to broadcast
function init_pixels(wrapped_image::AbstractArray{T, N}, rng) where {T, N}
    pixel_image = similar(wrapped_image, Pixel{T})

    # Initialize reliability values before going parallel. This ensures that
    # reliability values are generated in a deterministic order.
    rels = rand(rng, Float64, size(wrapped_image))

    Threads.@threads for i in eachindex(wrapped_image, pixel_image, rels)
        pixel_image[i] = Pixel(wrapped_image[i], rels[i])
    end
    return pixel_image
end

function gather_pixels!(edges)
    for edge in edges
        p1 = edge.pixel_1
        p2 = edge.pixel_2
        if is_differentgroup(p1, p2)
            periods = edge.periods
            merge_groups!(periods, p1, p2)
        end
    end
end

function unwrap_image!(dest, pixel_image, range)
    Threads.@threads for i in eachindex(dest, pixel_image)
        p = pixel_image[i]
        dest[i] = muladd(range, p.periods, p.val)
    end
end

function wrap_val(val, range)
    wrapped_val  = val
    wrapped_val -= ifelse(val >  range / 2, range, zero(val))
    wrapped_val += ifelse(val < -range / 2, range, zero(val))
    return wrapped_val
end

function find_period(val_left, val_right, range)
    difference = val_left - val_right
    period  = 0
    period -= (difference >  range / 2)
    period += (difference < -range / 2)
    return period
end

function merge_groups!(periods, base, target)
    # target is alone in group
    if is_pixelalone(target)
        periods = -periods
    elseif is_pixelalone(base)
        base, target = target, base
    else
        if is_bigger(base, target)
            periods = -periods
        else
            base, target = target, base
        end
        merge_into_group!(base, target, periods)
        return
    end
    merge_pixels!(base, target, periods)
end

@inline is_differentgroup(p1::Pixel, p2::Pixel) = p1.head !== p2.head
@inline is_pixelalone(pixel::Pixel) = pixel.head === pixel.last
@inline is_bigger(p1::Pixel, p2::Pixel) = length(p1) ≥ length(p2)

function merge_pixels!(pixel_base::Pixel, pixel_target::Pixel, periods)
    pixel_base.head.groupsize += pixel_target.head.groupsize
    pixel_base.head.last.next = pixel_target.head
    pixel_base.head.last = pixel_target.head.last
    pixel_target.head = pixel_base.head
    pixel_target.periods = pixel_base.periods + periods
    return nothing
end

function merge_into_group!(pixel_base::Pixel, pixel_target::Pixel, periods)
    add_periods = pixel_base.periods + periods - pixel_target.periods
    pixel = pixel_target.head
    while !isnothing(pixel)
        # merge all pixels in pixel_target's group to pixel_base's group
        if pixel !== pixel_target
            pixel.periods += add_periods
            pixel.head = pixel_base.head
        end
        pixel = pixel.next
    end
    # assign pixel_target to pixel_base's group last
    merge_pixels!(pixel_base, pixel_target, periods)
end

function populate_edges!(edges::Vector{Edge{T}}, pixel_image::AbstractArray{Pixel{T},N}, dim, connected, range) where {T,N}
    idx_step      = ntuple(i -> Int(i == dim), Val(N))
    idx_step_cart = CartesianIndex{N}(idx_step)
    image_inds    = CartesianIndices(pixel_image)
    fi, li        = first(image_inds), last(image_inds)
    for i in fi:li-idx_step_cart
        push!(edges, Edge{T}(pixel_image[i], pixel_image[i + idx_step_cart], range))
    end
    if connected
        idx_step_cart *= size(pixel_image, dim) - 1
        for i in fi+idx_step_cart:li
            push!(edges, Edge{T}(pixel_image[i], pixel_image[i - idx_step_cart], range))
        end
    end
end

function calculate_reliability(pixel_image::AbstractArray{T, N}, circular_dims, range) where {T, N}
    # get the shifted pixel indices in CartesianIndex form
    # This gets all the nearest neighbors
    one_cart = oneunit(CartesianIndex{N})
    pixel_shifts = -one_cart:one_cart
    image_inds = CartesianIndices(pixel_image)
    fi, li = first(image_inds) + one_cart, last(image_inds) - one_cart
    size_img = size(pixel_image)
    # inner loop
    for i in fi:li
        pixel_image[i].reliability = calculate_pixel_reliability(pixel_image, i, pixel_shifts, range)
    end

    if !(true in circular_dims)
        return
    end

    pixel_shifts_border = similar(pixel_shifts)
    new_ps = zeros(Int, N)
    for (idx_dim, connected) in enumerate(circular_dims)
        if connected
            # first border
            copyto!(pixel_shifts_border, pixel_shifts)
            for (idx_ps, ps) in enumerate(pixel_shifts_border)
                # if the pixel shift goes out of bounds, we make the shift wrap
                if ps[idx_dim] == 1
                    new_ps[idx_dim] = -size_img[idx_dim]+1
                    pixel_shifts_border[idx_ps] = CartesianIndex{N}(NTuple{N,Int}(new_ps))
                    new_ps[idx_dim] = 0
                end
            end
            border_range = get_border_range(fi:li, idx_dim, li[idx_dim] + 1)
            for i in CartesianIndices(border_range)
                pixel_image[i].reliability = calculate_pixel_reliability(pixel_image, i, pixel_shifts_border, range)
            end
            # second border
            pixel_shifts_border = copyto!(pixel_shifts_border, pixel_shifts)
            for (idx_ps, ps) in enumerate(pixel_shifts_border)
                # if the pixel shift goes out of bounds, we make the shift wrap, this time to the other side
                if ps[idx_dim] == -1
                    new_ps[idx_dim] = size_img[idx_dim]-1
                    pixel_shifts_border[idx_ps] = CartesianIndex{N}(NTuple{N,Int}(new_ps))
                    new_ps[idx_dim] = 0
                end
            end
            border_range = get_border_range(fi:li, idx_dim, fi[idx_dim] - 1)
            for i in CartesianIndices(border_range)
                pixel_image[i].reliability = calculate_pixel_reliability(pixel_image, i, pixel_shifts_border, range)
            end
        end
    end
end

function get_border_range(C::CartesianIndices{N}, border_dim, border_idx) where {N}
    border_range = [C.indices[dim] for dim=1:N]
    border_range[border_dim] = border_idx:border_idx
    return NTuple{N,UnitRange{Int}}(border_range)
end

function calculate_pixel_reliability(pixel_image::AbstractArray{Pixel{T},N}, pixel_index, pixel_shifts, range) where {T,N}
    pix_val = pixel_image[pixel_index].val
    rel_contrib(shift) = wrap_val(pixel_image[pixel_index+shift].val - pix_val, range)^2
    # for N=3, pixel_shifts[14] is null shift, can avoid if manually unrolling loop
    sum_val = sum(rel_contrib, pixel_shifts)
    return sum_val
end

end

using DSP, FFTW, Test

using DSP: allocate_output
using Random: seed!

module_tests = [
    :DSPBase => ["dsp.jl", "diric.jl"],
    :Utils => ["util.jl"],
    :Windows => ["windows.jl"],
    :Filters => [
        "filter_conversion.jl", "filter_design.jl", "filter_response.jl", "filt.jl",
        "filt_order.jl", "filt_stream.jl", "resample.jl", "remez_fir.jl"
    ],
    :Periodograms => ["periodograms.jl", "multitaper.jl"],
    :LPC => ["lpc.jl"],
    :Estimation => ["estimation.jl"],
    :Unwrap => ["unwrap.jl"]
]

seed!(1776)

@testset verbose=true "DSP.jl" begin
    @testset verbose=true "$(first(module_test))" for module_test in module_tests
        @testset "$testfile" for testfile in last(module_test)
            include(testfile)
        end
    end
end

using DSP, Test
using Statistics: mean

@testset "hilbert" begin
    # Testing hilbert transform
    t = (0:1/256:2-1/256)
    a0 = sinpi.(t)
    a1 = cospi.(t)
    a2 = sinpi.(2*t)
    a3 = cospi.(2*t)
    a = hcat(a0, a1, a2, a3)

    h = hcat(hilbert(a0), hilbert(a1), hilbert(a2), hilbert(a3))
    h_abs = abs.(h)
    h_angle = angle.(h)
    h_real = real.(h)
    #The real part should be equal to the original signals:
    @test h_real ≈ a

    #The absolute value should be one everywhere, for this input:
    @test h_abs ≈ ones(size(a))

    #For the 'slow' sine - the phase should go from -pi/2 to pi/2 in
    #the first 256 bins:
    @test h_angle[1:256,1] ≈ -pi/2:pi/256:pi/2-pi/256

    #For the 'slow' cosine - the phase should go from 0 to pi in the
    #same interval:
    @test h_angle[1:256,2] ≈ 0:pi/256:pi-pi/256

    #The 'fast' sine should make this phase transition in half the time:
    @test h_angle[1:128,3] ≈ -pi/2:pi/128:pi/2-pi/128

    #Ditto for the 'fast' cosine:
    @test h_angle[1:128,4] ≈ 0:pi/128:pi-pi/128

    #The imaginary part of hilbert(cos(t)) = sin(t) Wikipedia
    @test imag(h[:,2]) ≈ a0

    #Sanity check with odd number of samples
    h2 = hilbert([ones(10); zeros(9)])
    @test real(h2) ≈ [ones(10); zeros(9)]

    #Sanity check with integer arguments
    r = rand(1:20, 128)
    @test hilbert(r) == hilbert(map(Float64, r))

    # Test hilbert with 2D input
    @test h ≈ hilbert(a)
end

@testset "fft helpers" begin
    @test meanfreq(sinpi.(2 * 10 * (0:1e-3:10*π)), 1e3) ≈ 10.0 rtol = 1e-3

    # nextfastfft
    @test nextfastfft(64) == 64
    @test nextfastfft(65) == 70
    @test nextfastfft(127) == 128
    @test nextfastfft((64,65,127)) == (64,70,128)
    @test @test_deprecated(nextfastfft(64,65,127)) == nextfastfft.((64,65,127))
end

## COMMON DSP TOOLS

@testset "dB conversion" begin
    # dB conversion
    @test 3dB ≈ db2pow(3)
    @test -3dB ≈ db2pow(-3)
    @test 3dBa ≈ db2amp(3)
    @test -3dBa ≈ db2amp(-3)
    @test isa(3e0dB, Float64)
    @test isa(3f0dB, Float32)
    test_num = convert(Float64, pi)
    @test pow2db(test_num) ≈ 10*log10(test_num)
    @test amp2db(test_num) ≈ 20*log10(test_num)
    @test test_num*dB ≈ db2pow(test_num)
    @test test_num*dBa ≈ db2amp(test_num)
    @test test_num ≈ db2pow(pow2db(test_num))
    @test test_num ≈ db2amp(amp2db(test_num))
end

@testset "rms" begin
    n = (5,6)
    for x in ( randn(n), randn(n)+randn(n)im )
        @test rms(x) ≈ sqrt(mean(abs.(x).^2))
        @test rms(x; dims=1) ≈ sqrt.(mean(abs.(x).^2; dims=1))
        @test rms(x; dims=2) ≈ sqrt.(mean(abs.(x).^2; dims=2))
        @test rms(x; dims=1:2) ≈ sqrt.(mean(abs.(x).^2; dims=1:2))
        @test rmsfft(fft(x)) ≈ rms(x)
    end # for
end

@test shiftin!([1,2,3,4],[5,6]) ≈ [3,4,5,6]

## arraysplit

# utility for checking our definition off `size` for `arraysplit` matches how many times we can iterate it
function _length(itr)
    c = 0
    for x in itr
        c += 1
    end
    return c
end

@testset "`arraysplit`" begin
    @test collect(DSP.arraysplit(collect(1:10), 3, 1)) == [ collect(1.0:3), collect(3.0:5), collect(5.0:7), collect(7.0:9)]

    @testset "`arraysplit` with `n_samples`=$(n_samples), `n_samples_per_window`=$(n_samples_per_window), `n_overlap`=$(n_overlap) " for n_samples in (20:20:100), n_samples_per_window in (20:20:100), n_overlap in (0:20:(n_samples_per_window-1))
        @test _length(arraysplit(1:n_samples, n_samples_per_window, n_overlap)) == length(arraysplit(1:n_samples, n_samples_per_window, n_overlap))
    end
end

# DELAY FINDING UTILITIES

@testset "delay finders" begin
    # Test signals length
    L = 10
    # Test delay
    d = 3

    # Forcing valid test parameters values
    L = round(Int, abs(L))
    d = round(Int, min(abs(d), L))

    # Generating the test signal as random 0 mean white uniform noise
    x = 2.0 .* rand(L) .- 1.0

    # Tests

    @test finddelay([zeros(d); x], x) == d
    @test finddelay([zeros(d); x], -x) == d
    @test finddelay(x, [zeros(d); x]) == -d
    @test finddelay(-x, [zeros(d); x]) == -d

    @test shiftsignal(x, d) == [zeros(d); x[1:(end - d)]]
    @test shiftsignal(x, -d) == [x[(d + 1):end]; zeros(d)]

    y = copy(x)
    z = shiftsignal!(y, d)
    @test z == y
    @test y == [zeros(d); x[1:(end - d)]]

    y = copy(x)
    z = shiftsignal!(y, -d)
    @test z == y
    @test y == [x[(d + 1):end]; zeros(d)]

    y, s = alignsignals([zeros(d); x], x)
    @test y == [x; zeros(d)]
    @test s == d

    y, s = alignsignals(x, [zeros(d); x])
    @test y == [zeros(d); x[1:(end - d)]]
    @test s == -d

    y = copy(x)
    z, s = alignsignals!(y, [zeros(d); x])
    @test z == y
    @test s == -d
    @test y == [zeros(d); x[1:(end - d)]]

    y = [zeros(d); x]
    z, s = alignsignals!(y, x)
    @test z == y
    @test s == d
    @test y == [x; zeros(d)]

    @test_throws DomainError shiftsignal([1], -2)
end

!(@__DIR__() in LOAD_PATH) && push!(LOAD_PATH, @__DIR__)
using DSP, Test, Random, FilterTestHelpers
#
# filt with different filter forms
#
@testset "filt" begin
    x = randn(100)

    for n = 1:6
        for proto in (Butterworth(n), Chebyshev1(n, 1), Chebyshev2(n, 1), Elliptic(n, 0.5, 2))
            zpk = digitalfilter(Lowpass(0.2), proto)
            tf = convert(PolynomialRatio, zpk)
            if n <= 2
                bq = convert(Biquad, zpk)
            else
                @test_throws ArgumentError convert(Biquad, zpk)
            end
            sos = convert(SecondOrderSections, zpk)

            res = filt(sos, x)

            # Test with filt with tf/sos
            tfres = filt(tf, x)
            @test res ≈ tfres
            @test res ≈ filt!(similar(x), sos, x)
            @test res ≈ filt!(similar(x), tf, x)

            # For <= 2 poles, test with biquads
            if n <= 2
                @test res ≈ filt(bq, x)
                @test res ≈ filt!(similar(x), bq, x)
                f = DF2TFilter(bq)
                @test tfres ≈ [filt(f, x[1:50]); filt(f, x[51:end])]
            end

            # Test that filt with zpk converts
            @test res ≈ filt(zpk, x)
            @test res ≈ filt!(similar(x), zpk, x)

            # Test with DF2TFilter
            f = DF2TFilter(sos)
            @test res ≈ [filt(f, x[1:50]); filt(f, x[51:end])]
            f = DF2TFilter(tf)
            @test tfres ≈ [filt(f, x[1:50]); filt(f, x[51:end])]
            f = DF2TFilter(zpk)
            @test res ≈ [filt(f, x[1:50]); filt(f, x[51:end])]
        end
    end

    # Test simple scaling with DF2TFilter
    @test filt(DF2TFilter(PolynomialRatio([3.7], [4.2])), x) == x * (3.7/4.2)

    # DF2TFilter{<:PolynomialRatio} with unequal numerator/denominator orders (issue #436)
    @test filt(DF2TFilter(PolynomialRatio([0, 0, 1, 0.8], [1])), [1; zeros(9)]) == [0; 0; 1; 0.8; zeros(6)]
    @test filt([0, 0, 1, 0.8], [1], [1; zeros(9)]) == [0; 0; 1; 0.8; zeros(6)]
    @test filt(DF2TFilter(PolynomialRatio([1], [1, -0.5])), [1; zeros(9)]) ≈ 0.5.^(0:9)
    @test filt([1], [1, -0.5], [1; zeros(9)]) ≈ 0.5.^(0:9)
    @test_nowarn filt(DF2TFilter(PolynomialRatio([1:5;], [1, -0.5])), ones(10))
    @test_nowarn filt(DF2TFilter(PolynomialRatio(rand(DSP.SMALL_FILT_CUTOFF + 1), [1])), ones(10))

    # DF2TFilter{:z} state type selection for ZeroPoleGain (issue #371)
    s = rand(30) + im * rand(30)
    df = digitalfilter(Lowpass(0.25), Butterworth(4))
    f = @test_nowarn DF2TFilter(df, ComplexF64)
    @test_nowarn filt(f, s)

    # DF2TFilter{ZPG/SOS} stackoverflow error
    @test_throws MethodError DF2TFilter(ZeroPoleGain([1], [2], 3), :D, 'x', Ref(1))
end

@testset "multi-column filt $D-D" for D in 1:4
     b = [0.1, 0.1]
     a = [1.0, -0.8]
     sz = (10, ntuple(n -> n+1, Val(D))...)
     y_ref = filt(b, a, ones(sz[1]))
     x = ones(sz)
     slicedims = ntuple(n -> n+1, Val(D))
     @test all(col -> col ≈ y_ref, eachslice(filt(b, a, x); dims=slicedims))
     @test all(col -> col ≈ y_ref, eachslice(filt(PolynomialRatio(b, a), x); dims=slicedims))
     @test all(col -> col ≈ y_ref, eachslice(filt(Biquad(PolynomialRatio(b, a)), x); dims=slicedims))
     @test all(col -> col ≈ y_ref, eachslice(filt(SecondOrderSections(PolynomialRatio(b, a)), x); dims=slicedims))
     # with si given
     @test all(col -> col ≈ y_ref, eachslice(@test_deprecated(filt(b, a, x, zeros(1, sz[2:end]...))); dims=slicedims))
     @test all(col -> col ≈ y_ref, eachslice(@test_deprecated(filt(PolynomialRatio(b, a), x, zeros(1, sz[2:end]...))); dims=slicedims))
     @test all(col -> col ≈ y_ref, eachslice(@test_deprecated(filt(Biquad(PolynomialRatio(b, a)), x, zeros(2, sz[2:end]...))); dims=slicedims))
     @test all(col -> col ≈ y_ref, eachslice(@test_deprecated(filt(SecondOrderSections(PolynomialRatio(b, a)), x, zeros(2, 1, sz[2:end]...))); dims=slicedims))
     # use _small_filt_fir!
     b = [0.1, 0.1]
     a = [1.0]
     y_ref = filt(b, a, ones(sz[1]))
     @test all(col -> col ≈ y_ref, eachslice(filt(b, a, x); dims=slicedims))
     @test all(col -> col ≈ y_ref, eachslice(filt(PolynomialRatio(b, a), x); dims=slicedims))
end

@testset "multi-column DF2TFilter $D-D" for D in 1:4
    b = [0.1, 0.1]
    a = [1.0, -0.8]
    sz = (10, ntuple(n -> n+1, Val(D))...)
    y_ref = filt(b, a, ones(2*sz[1]))
    x = ones(sz)

    H = DF2TFilter(PolynomialRatio(b, a),sz[2:end])
    @test all(col -> col ≈ y_ref[1:sz[1]], eachslice(filt(H, x); dims=ntuple(n -> n+1, Val(D))))
    @test all(col -> col ≈ y_ref[sz[1]+1:end], eachslice(filt(H, x); dims=ntuple(n -> n+1, Val(D))))

    H = DF2TFilter(SecondOrderSections(PolynomialRatio(b, a)), sz[2:end])
    @test all(col -> col ≈ y_ref[1:sz[1]], eachslice(filt(H, x); dims=ntuple(n -> n+1, Val(D))))
    @test all(col -> col ≈ y_ref[sz[1]+1:end], eachslice(filt(H, x); dims=ntuple(n -> n+1, Val(D))))

    H = DF2TFilter(Biquad(PolynomialRatio(b, a)), sz[2:end])
    @test all(col -> col ≈ y_ref[1:sz[1]], eachslice(filt(H, x); dims=ntuple(n -> n+1, Val(D))))
    @test all(col -> col ≈ y_ref[sz[1]+1:end], eachslice(filt(H, x); dims=ntuple(n -> n+1, Val(D))))
end

#
# filtfilt
#

@testset "filt_stepstate" begin
    ##############
    #
    # Filter initial conditions
    # Python example 1 - http://docs.scipy.org/doc/scipy/reference/generated/scipy.signal.lfilter_zi.html
    #
    # b, a = butter(5, 0.25)
    # zi = lfilter_zi(b, a)
    #
    ##############
    zi_python = [ 0.99672078, -1.49409147,  1.28412268, -0.45244173,  0.07559489]

    b = [ 0.00327922,  0.01639608,  0.03279216,  0.03279216,  0.01639608,  0.00327922]
    a = [ 1.        , -2.47441617,  2.81100631, -1.70377224,  0.54443269, -0.07231567]

    @test ≈(zi_python, DSP.Filters.filt_stepstate(b, a)[1], atol=1e-7)

    ##############
    #
    # Filter initial conditions
    # Matlab - Random filter coefficients
    #
    # filtfilt([0.222, 0.43, 0.712], [1, 0.33, 0.22], x)
    # Then used breakpoints to extract zi
    #
    ##############

    zi_matlab = [0.6580, 0.5184]

    b = [0.222, 0.43, 0.712]
    a = [1, 0.33, 0.22]

    @test zi_matlab ≈ DSP.Filters.filt_stepstate(b, a)[1]


    ##############
    #
    # Filter initial conditions
    # Python - non 1 first coeffecient
    #
    # b = array([ 0.00327922,  0.01639608,  0.03279216,  0.03279216,  0.01639608,  0.00327922])
    # a = array([ 1.1       , -2.47441617,  2.81100631, -1.70377224,  0.54443269, -0.07231567])
    # zi = lfilter_zi(b, a)
    #
    ##############

    zi_python = [0.55996501, -0.72343165,  0.68312446, -0.2220676 ,  0.04030775]

    b = [ 0.00327922,  0.01639608,  0.03279216,  0.03279216,  0.01639608,  0.00327922]
    a = [ 1.1       , -2.47441617,  2.81100631, -1.70377224,  0.54443269, -0.07231567]

    @test ≈(zi_python, DSP.Filters.filt_stepstate(b, a)[1], atol=1e-7)
end


##############
#
# Filter in place check (with initial conditions)
#
# x = '/Users/rluke/.julia/v0.3/DSP/test/data/spectrogram_x.txt';
# filtcheck  = filter([0.4, 1], [0.9, 0.6], x, 0.4750)
# dlmwrite('filt_check.txt',[filtcheck], 'delimiter', '\t', 'precision', '%.12f')
#
##############
@testset "filt! with init. cond." begin
    matlab_filt = read_reference_data("filt_check.txt")

    a = [0.9, 0.6]
    b = [0.4, 1]
    z = [0.4750]
    x = vec(read_reference_data("spectrogram_x.txt"))
    @test_deprecated(filt!(x, b, a, x, z))

    @test matlab_filt ≈ x

    x = vec(read_reference_data("spectrogram_x.txt"))
    filt!(x, DF2TFilter(PolynomialRatio(b, a), z), x)

    @test matlab_filt ≈ x

    # With initial conditions: a lowpass 5-pole butterworth filter with W_n = 0.25,
    # and a stable initial filter condition matched to the initial value
    zpg = digitalfilter(Lowpass(0.25), Butterworth(5))
    si = [0.9967207836936347, -1.4940914728163142, 1.2841226760316475, -0.4524417279474106, 0.07559488540931815]
    @test filt(DF2TFilter(PolynomialRatio(zpg), si), ones(10)) ≈ ones(10) # Shouldn't affect DC offset
end

#######################################
#
# Test 1d filtfilt against matlab results
#
# x = '/Users/rluke/.julia/v0.3/DSP/test/data/spectrogram_x.txt'; x = textread(x);
# b = [ 0.00327922,  0.01639608,  0.03279216,  0.03279216,  0.01639608,  0.00327922];
# a = [ 1.        , -2.47441617,  2.81100631, -1.70377224,  0.54443269, -0.07231567];
# x2 = filtfilt(b, a, x);
# dlmwrite('filtfilt_output.txt',[x2], 'delimiter', '\t', 'precision', '%.12f')
#
#######################################
@testset "filtfilt 1D" begin
    x2_matlab = read_reference_data("filtfilt_output.txt")

    b = [ 0.00327922,  0.01639608,  0.03279216,  0.03279216,  0.01639608,  0.00327922]
    a = [ 1.        , -2.47441617,  2.81100631, -1.70377224,  0.54443269, -0.07231567]
    x = read_reference_data("spectrogram_x.txt")

    @test x2_matlab ≈ filtfilt(b, a, x)
end

# Make sure above doesn't crash for real coeffs & complex data.
@testset "filtfilt 1D Complex" begin
    x2_matlab = read_reference_data("filtfilt_output.txt")

    b = [ 0.00327922,  0.01639608,  0.03279216,  0.03279216,  0.01639608,  0.00327922]
    a = [ 1.        , -2.47441617,  2.81100631, -1.70377224,  0.54443269, -0.07231567]
    x = read_reference_data("spectrogram_x.txt")

    y = x .+ 1im .* randn(size(x, 1))

    @test x2_matlab ≈ real.(filtfilt(b, a, y))
end

#######################################
#
# Test 2d filtfilt against matlab results
#

#=x = '/Users/rluke/.julia/v0.3/DSP/test/data/spectrogram_x.txt'; x = textread(x);=#

#=x = repmat(x, 1, 3);=#
#=x(:,2) = circshift(x(:,2), 64);=#
#=x(:,3) = circshift(x(:,3), 128);=#

#=b = [ 0.00327922,  0.01639608,  0.03279216,  0.03279216,  0.01639608,  0.00327922];=#
#=a = [ 1.        , -2.47441617,  2.81100631, -1.70377224,  0.54443269, -0.07231567];=#
#=x2 = filtfilt(b, a, x);=#
#=dlmwrite('filtfilt_output_2d.txt',[x2], 'delimiter', '\t', 'precision', '%.12f')=#

#
#######################################

@testset "filtfilt 2D" begin
    b = [ 0.00327922,  0.01639608,  0.03279216,  0.03279216,  0.01639608,  0.00327922]
    a = [ 1.        , -2.47441617,  2.81100631, -1.70377224,  0.54443269, -0.07231567]

    x2_output = read_reference_data("filtfilt_output_2d.txt")

    x = read_reference_data("spectrogram_x.txt")
    x = repeat(x, outer=(1, 3))
    x[:,2] = circshift(x[:,2], 64)
    x[:,3] = circshift(x[:,3], 128)

    @test x2_output ≈ filtfilt(b, a, x)

    #######################################
    #
    # Test 2d filtfilt with filter type
    #
    #
    #######################################

    f = PolynomialRatio(b, a)

    # Use 2d data from last test
    @test x2_output ≈ filtfilt(f, x)
end

#######################################
#
# Test 2d filtfilt with SecondOrderSections
#
# Our implementation differs from MATLAB, but should match the
# PolynomialRatio provided the filter order is even. (Otherwise
# the extrapolation will differ slightly.)
#######################################
@testset "filtfilt SOS" begin
    x = read_reference_data("spectrogram_x.txt")

    f = digitalfilter(Lowpass(0.2), Butterworth(4))
    @test filtfilt(convert(SecondOrderSections, f), x) ≈ filtfilt(convert(PolynomialRatio, f), x)

    f = digitalfilter(Highpass(0.1), Butterworth(6))
    @test filtfilt(convert(SecondOrderSections, f), x) ≈ filtfilt(convert(PolynomialRatio, f), x)

    f = digitalfilter(Bandpass(0.1, 0.3), Butterworth(2))
    @test filtfilt(convert(SecondOrderSections, f), x) ≈ filtfilt(convert(PolynomialRatio, f), x)
    @test_nowarn filtfilt(f, [1.])  # check that pad_length won't throw oob
end

#
# fftfilt/filt
#

# make sure to include blen > SMALL_FILT_CUTOFF
@testset "fftfilt $xlen/$blen" for xlen in 2 .^ (7:18) .- 1, blen in 2 .^ (1:7) .- 1
    b = randn(blen)
    for x in (rand(xlen), rand(xlen, 2))
        out = similar(x)
        filtres = filt(b, [1.0], x)
        fftres = fftfilt(b, x)
        firres = filt(b, x)
        td_res = tdfilt(b, x)

        @test filtres ≈ fftres
        @test filtres ≈ firres
        @test filtres ≈ td_res

        fftfilt!(out, b, x)
        @test filtres ≈ out # test output of fftfilt!

        tdfilt!(out, b, x)
        @test filtres ≈ out # test output of tdfilt!
    end
end

# fir_filtfilt
@testset "fir_filtfilt" begin
    for b in (randn(10), [1:10;]), x in (randn(100), randn(100, 2), randn(10))   # also tests issue #537
        @test filtfilt(b, x) ≈ DSP.Filters.iir_filtfilt(b, [1], x)
        @test filtfilt(b, [2.0], x) ≈ DSP.Filters.iir_filtfilt(b, [2], x)
    end
end

# Filter prototypes, transformations, and transforms

using ..Windows

abstract type FilterType end

#
# Butterworth prototype
#

function Butterworth(::Type{T}, n::Integer) where {T<:Real}
    n > 0 || throw(DomainError(n, "n must be positive"))

    poles = Vector{Complex{T}}(undef, n)
    for i = 1:n÷2
        w = convert(T, 2i - 1) / 2n
        sinpi_w, cospi_w = @inline sincospi(w)
        pole = complex(-sinpi_w, cospi_w)
        poles[2i-1] = pole
        poles[2i] = conj(pole)
    end
    if isodd(n)
        poles[end] = -1
    end
    ZeroPoleGain{:s}(Complex{T}[], poles, one(T))
end

"""
    Butterworth(n::Integer)

``n`` pole Butterworth filter.
"""
Butterworth(n::Integer) = Butterworth(Float64, n)

#
# Chebyshev type I and II prototypes
#

function chebyshev_poles(::Type{T}, n::Integer, ε::Real) where {T<:Real}
    p = Vector{Complex{T}}(undef, n)
    μ = asinh(one(T) / ε) / n
    b = -sinh(μ)
    c = cosh(μ)
    for i = 1:n÷2
        w = convert(T, 2i - 1) / 2n
        sinpi_w, cospi_w = @inline sincospi(w)
        pole = complex(b * sinpi_w, c * cospi_w)
        p[2i-1] = pole
        p[2i] = conj(pole)
    end
    if isodd(n)
        w = convert(T, 2 * (n ÷ 2) + 1) / 2n
        pole = b * sinpi(w)
        p[end] = pole
    end
    p
end

function Chebyshev1(::Type{T}, n::Integer, ripple::Real) where {T<:Real}
    n > 0 || throw(DomainError(n, "n must be positive"))
    ripple >= 0 || throw(DomainError(ripple, "ripple must be non-negative"))

    ε = sqrt(exp10(convert(T, ripple) / 10) - 1)
    p = chebyshev_poles(T, n, ε)
    k = one(T)
    for i = 1:n÷2
        k *= abs2(p[2i])
    end
    if iseven(n)
        k /= sqrt(1+abs2(ε))
    else
        k *= real(-p[end])
    end
    ZeroPoleGain{:s}(Complex{T}[], p, k)
end

"""
    Chebyshev1(n::Integer, ripple::Real)

`n` pole Chebyshev type I filter with `ripple` dB ripple in
the passband.
"""
Chebyshev1(n::Integer, ripple::Real) = Chebyshev1(Float64, n, ripple)

function Chebyshev2(::Type{T}, n::Integer, ripple::Real) where {T<:Real}
    n > 0 || throw(DomainError(n, "n must be positive"))
    ripple >= 0 || throw(DomainError(ripple, "ripple must be non-negative"))

    ε = 1 / sqrt(exp10(convert(T, ripple) / 10) - 1)
    p = chebyshev_poles(T, n, ε)
    map!(inv, p, p)

    z = Vector{Complex{T}}(undef, n - isodd(n))
    k = one(T)
    for i = 1:n÷2
        w = convert(T, 2i - 1) / 2n
        ze = @inline complex(zero(T), -inv(cospi(w)))
        z[2i-1] = ze
        z[2i] = conj(ze)
        k *= abs2(p[2i]) / abs2(ze)
    end
    isodd(n) && (k *= -real(p[end]))

    ZeroPoleGain{:s}(z, p, k)
end

"""
    Chebyshev2(n::Integer, ripple::Real)

`n` pole Chebyshev type II filter with `ripple` dB ripple in
the stopband.
"""
Chebyshev2(n::Integer, ripple::Real) = Chebyshev2(Float64, n, ripple)

#
# Elliptic prototype
#
# See Orfanidis, S. J. (2007). Lecture notes on elliptic filter design.
# Retrieved from http://www.ece.rutgers.edu/~orfanidi/ece521/notes.pdf

# Compute Landen sequence for evaluation of elliptic functions
function landen(k::Real)
    niter = 7
    kn = Vector{typeof(k)}(undef, niter)
    # Eq. (50)
    for i = 1:niter
        kn[i] = k = abs2(k / (1 + sqrt(1 - abs2(k))))
    end
    kn
end

# cde computes cd(u*K(k), k)
# sne computes sn(u*K(k), k)
# Both accept the Landen sequence as generated by landen above
function _ellip(init::Number, landen::Vector{<:Real})
    winv = inv(init)
    # Eq. (55)
    for x in Iterators.reverse(landen)
        winv = 1 / (1 + x) * (winv + x / winv)
    end
    w = inv(winv)
end
@inline cde(u::Number, landen::Vector{<:Real}) = @inline _ellip(cospi(u / 2), landen)
@inline sne(u::Number, landen::Vector{<:Real}) = @inline _ellip(sinpi(u / 2), landen)

# sne inverse
function asne(w::Number, k::Real)
    oldw = NaN
    while w != oldw
        oldw = w
        kold = k
        # Eq. (50)
        k = abs2(k/(1+sqrt(1-abs2(k))))
        # Eq. (56)
        w = 2w / ((1 + k) * (1 + sqrt(muladd(-abs2(kold), w^2, 1))))
    end
    2*asin(w)/π
end

function Elliptic(::Type{T}, n::Integer, rp::Real, rs::Real) where {T<:Real}
    n > 0 || throw(DomainError(n, "n must be positive"))
    rp > 0 || throw(DomainError(rp, "rp must be positive"))
    rp < rs || throw(DomainError(rp, "rp must be less than rs"))

    # Eq. (2)
    εp = sqrt(exp10(convert(T, rp) / 10) - 1)
    εs = sqrt(exp10(convert(T, rs) / 10) - 1)

    # Eq. (3)
    k1 = εp/εs
    k1 >= 1 && throw(ArgumentError("filter order is too high for parameters"))

    # Eq. (20)
    k1′² = 1 - abs2(k1)
    k1′ = sqrt(k1′²)
    k1′_landen = landen(k1′)

    # Eq. (47)
    k′ = one(T)
    for i = 1:n÷2
        k′ *= sne(convert(T, 2i - 1) / n, k1′_landen)
    end
    k′ = k1′²^(convert(T, n) / 2) * k′^4

    k = sqrt(1 - abs2(k′))
    k_landen = landen(k)

    # Eq. (65)
    v0 = -im / convert(T, n) * asne(im / εp, k1)

    z = Vector{Complex{T}}(undef, 2*(n÷2))
    p = Vector{Complex{T}}(undef, n)
    gain = one(T)
    for i = 1:n÷2
        # Eq. (43)
        w = convert(T, 2i - 1) / n

        # Eq. (62)
        ze = complex(zero(T), -inv(k*cde(w, k_landen)))
        z[2i-1] = ze
        z[2i] = conj(ze)

        # Eq. (64)
        pole = im*cde(w - im*v0, k_landen)
        p[2i-1] = conj(pole)
        p[2i] = pole

        gain *= abs2(pole)/abs2(ze)
    end

    if isodd(n)
        pole = im*sne(im*v0, k_landen)
        p[end] = pole
        gain *= abs(pole)
    else
        gain *= exp10(-convert(T, rp) / 20)
    end

    ZeroPoleGain{:s}(z, p, gain)
end

"""
    Elliptic(n::Integer, rp::Real, rs::Real)

`n` pole elliptic (Cauer) filter with `rp` dB ripple in the
passband and `rs` dB attenuation in the stopband.
"""
Elliptic(n::Integer, rp::Real, rs::Real) = Elliptic(Float64, n, rp, rs)

#
# Prototype transformation types
#

# returns frequency in half-cycles per sample ∈ (0, 1)
function normalize_freq(w::Real, fs::Real)
    w <= 0 && throw(DomainError(w, "frequencies must be positive"))
    f = 2 * w / fs
    f >= 1 && throw(DomainError(f, lazy"frequencies must be less than the Nyquist frequency $(fs/2)"))
    f
end
function normalize_complex_freq(w::Real, fs::Real)
    f = 2 * w / fs
    f >= 2 && throw(DomainError(f, lazy"frequencies must be less than the sampling frequency $(fs)"))
    f
end

"""
    Lowpass(Wn::Real)

Low pass filter with cutoff frequency `Wn`.
"""
struct Lowpass{T<:Real} <: FilterType
    w::T
    Lowpass{T}(w::Real) where {T<:Real} = new{T}(w)
    Lowpass(w::Real) = Lowpass{typeof(w / 1)}(w)
end

"""
    Highpass(Wn::Real)

High pass filter with cutoff frequency `Wn`.
"""
struct Highpass{T<:Real} <: FilterType
    w::T
    Highpass{T}(w::Real) where {T<:Real} = new{T}(w)
    Highpass(w::Real) = Highpass{typeof(w / 1)}(w)
end

"""
    Bandpass(Wn1::Real, Wn2::Real)

Band pass filter with pass band frequencies (`Wn1`, `Wn2`).
"""
struct Bandpass{T<:Real} <: FilterType
    w1::T
    w2::T
    function Bandpass{T}(w1::Real, w2::Real) where {T<:Real}
        w1 < w2 || throw(ArgumentError("w1 must be less than w2"))
        new{T}(w1, w2)
    end
    Bandpass(w1::T, w2::V) where {T<:Real,V<:Real} =
        Bandpass{typeof(one(promote_type(T, V)) / 1)}(w1, w2)
end

"""
    ComplexBandpass(Wn1, Wn2)

Complex band pass filter with pass band frequencies (`Wn1`, `Wn2`).
"""
struct ComplexBandpass{T<:Real} <: FilterType
    w1::T
    w2::T
    function ComplexBandpass{T}(w1::Real, w2::Real) where {T<:Real}
        w1 < w2 || throw(ArgumentError("w1 must be less than w2"))
        new{T}(w1, w2)
    end
    ComplexBandpass(w1::T, w2::V) where {T,V} =
        ComplexBandpass{typeof(one(promote_type(T, V)) / 1)}(w1, w2)
end

"""
    Bandstop(Wn1::Real, Wn2::Real)

Band stop filter with stop band frequencies (`Wn1`, `Wn2`).
"""
struct Bandstop{T<:Real} <: FilterType
    w1::T
    w2::T
    function Bandstop{T}(w1::Real, w2::Real) where {T<:Real}
        w1 < w2 || throw(ArgumentError("w1 must be less than w2"))
        new{T}(w1, w2)
    end
    Bandstop(w1::T, w2::V) where {T,V} =
        Bandstop{typeof(one(promote_type(T, V)) / 1)}(w1, w2)
end

#
# Prototype transformation implementations
#
# The formulas implemented here come from the documentation for the
# corresponding functionality in Octave, available at
# https://staff.ti.bfh.ch/sha1/Octave/index/f/sftrans.html
# The Octave implementation was not consulted in creating this code.

# Create a lowpass filter from a lowpass filter prototype
transform_prototype(ftype::Lowpass, proto::ZeroPoleGain{:s, Z, P, K}) where {Z, P, K} =
    ZeroPoleGain{:s, Z, P, K}(ftype.w * proto.z, ftype.w * proto.p,
              proto.k * ftype.w^(length(proto.p)-length(proto.z)))

# Create a highpass filter from a lowpass filter prototype
function transform_prototype(ftype::Highpass, proto::ZeroPoleGain{:s})
    z = proto.z
    p = proto.p
    k = proto.k
    nz = length(z)
    np = length(p)
    TR = Base.promote_eltype(z, p)
    newz = zeros(TR, max(nz, np))
    newp = zeros(TR, max(nz, np))

    num = one(eltype(z))
    for i = 1:nz
        num *= -z[i]
        newz[i] = ftype.w / z[i]
    end

    den = one(eltype(p))
    for i = 1:np
        den *= -p[i]
        newp[i] = ftype.w / p[i]
    end

    abs(real(num) - 1) < np*eps(real(num)) && (num = 1)
    abs(real(den) - 1) < np*eps(real(den)) && (den = 1)
    ZeroPoleGain{:s}(newz, newp, oftype(k, k * real(num)/real(den)))
end

# Create a bandpass filter from a lowpass filter prototype
function transform_prototype(ftype::Bandpass, proto::ZeroPoleGain{:s})
    z = proto.z
    p = proto.p
    k = proto.k
    nz = length(z)
    np = length(p)
    ncommon = min(nz, np)
    TR = Base.promote_eltype(z, p)
    newz = zeros(TR, 2*nz+np-ncommon)
    newp = zeros(TR, 2*np+nz-ncommon)
    for (oldc, newc) in ((p, newp), (z, newz))
        for i in eachindex(oldc)
            b = oldc[i] * ((ftype.w2 - ftype.w1)/2)
            pm = sqrt(muladd(-ftype.w2, ftype.w1, b^2))
            newc[2i-1] = b + pm
            newc[2i] = b - pm
        end
    end
    ZeroPoleGain{:s}(newz, newp, oftype(k, k * (ftype.w2 - ftype.w1) ^ (np - nz)))
end

# Create a bandstop filter from a lowpass filter prototype
function transform_prototype(ftype::Bandstop, proto::ZeroPoleGain{:s})
    z = proto.z
    p = proto.p
    k = proto.k
    nz = length(z)
    np = length(p)
    npairs = max(nz, np)
    TR = Base.promote_eltype(z, p)
    newz = Vector{TR}(undef, 2*npairs)
    newp = Vector{TR}(undef, 2*npairs)

    num = one(eltype(z))
    for i = 1:nz
        num *= -z[i]
        b = (ftype.w2 - ftype.w1)/2z[i]
        pm = sqrt(muladd(-ftype.w2, ftype.w1, b^2))
        newz[2i-1] = b - pm
        newz[2i] = b + pm
    end

    den = one(eltype(p))
    for i = 1:np
        den *= -p[i]
        b = (ftype.w2 - ftype.w1)/2p[i]
        pm = sqrt(muladd(-ftype.w2, ftype.w1, b^2))
        newp[2i-1] = b - pm
        newp[2i] = b + pm
    end

    # Any remaining poles/zeros are real and not cancelled
    npm = sqrt(-complex(ftype.w2 * ftype.w1))
    for (n, newc) in ((np, newp), (nz, newz))
        for i = n+1:npairs
            newc[2i-1] = -npm
            newc[2i] = npm
        end
    end

    abs(real(num) - 1) < np*eps(real(num)) && (num = 1)
    abs(real(den) - 1) < np*eps(real(den)) && (den = 1)
    ZeroPoleGain{:s}(newz, newp, oftype(k, k * real(num)/real(den)))
end

transform_prototype(ftype, proto::FilterCoefficients{:s}) =
    transform_prototype(ftype, convert(ZeroPoleGain, proto))

"""
    analogfilter(responsetype::FilterType, designmethod::FilterCoefficients)

Construct an analog filter. See below for possible response and
filter types.
"""
analogfilter(ftype::FilterType, proto::FilterCoefficients) =
    transform_prototype(ftype, proto)

# Bilinear transform
"""
    bilinear(f::FilterCoefficients{:s}, fs::Real)

Calculate the digital filter (z-domain) ZPK representation of an analog filter defined
in s-domain using bilinear transform with sampling frequency `fs`. The s-domain
representation is first converted to a ZPK representation in s-domain and then
transformed to z-domain using bilinear transform.
"""
bilinear(f::FilterCoefficients{:s}, fs::Real) = bilinear(convert(ZeroPoleGain, f), fs)

"""
    bilinear(f::ZeroPoleGain{:s,Z,P,K}, fs::Real) where {Z,P,K}

Calculate the digital filter (z-domain) ZPK representation of an analog filter defined
as a ZPK representation in s-domain using bilinear transform with sampling frequency
`fs`.

Input s-domain representation must be a `ZeroPoleGain{:s, Z, P, K}` object:
```math
H(s) = f.k\\frac{(s - \\verb!f.z[1]!) \\ldots (s - \\verb!f.z[m]!)}{(s - \\verb!f.p[1]!) \\ldots (s - \\verb!f.p[n]!)}
```
Output z-domain representation is a `ZeroPoleGain{:z, Z, P, K}` object:
```math
H(z) = K\\frac{(z - \\verb!Z[1]!) \\ldots (z - \\verb!Z[m]!)}{(z - \\verb!P[1]!) \\ldots (z - \\verb!P[n]!)}
```
where `Z, P, K` are calculated as:
```math
Z[i] = \\frac{(2 + \\verb!f.z[i]!/\\verb!fs!)}{(2 - \\verb!f.z[i]!/\\verb!fs!)} \\quad \\text{for } i = 1, \\ldots, m
```
```math
P[i] = \\frac{(2 + \\verb!f.p[i]!/\\verb!fs!)}{(2 - \\verb!f.p[i]!/\\verb!fs!)} \\quad \\text{for } i = 1, \\ldots, n
```
```math
K = f.k \\ \\mathcal{Re} \\left[ \\frac{\\prod_{i=1}^m (2*fs - f.z[i])}{\\prod_{i=1}^n (2*fs - f.p[i])} \\right]
```
Here, `m` and `n` are respectively the numbers of zeros and poles in the s-domain representation. If `m < n`,
then additional `n-m` zeros are added at `z = -1`.
"""
function bilinear(f::ZeroPoleGain{:s,Z,P,K}, fs::Real) where {Z,P,K}
    ztype = typeof(0 + zero(Z) / fs)
    z = fill(convert(ztype, -1), max(length(f.p), length(f.z)))

    ptype = typeof(0 + zero(P) / fs)
    p = Vector{ptype}(undef, length(f.p))

    num = one(one(fs) - one(Z))
    for i = 1:length(f.z)
        z[i] = (2 + f.z[i] / fs) / (2 - f.z[i] / fs)
        num *= (2 * fs - f.z[i])
    end

    den = one(one(fs) - one(P))
    for i = 1:length(f.p)
        p[i] = (2 + f.p[i] / fs) / (2 - f.p[i] / fs)
        den *= (2 * fs - f.p[i])
    end

    ZeroPoleGain{:z}(z, p, f.k * real(num) / real(den))
end

# Pre-warp filter frequencies for digital filtering
prewarp(ftype::Lowpass, fs::Real) = Lowpass(prewarp(normalize_freq(ftype.w, fs)))
prewarp(ftype::Highpass, fs::Real) = Highpass(prewarp(normalize_freq(ftype.w, fs)))
prewarp(ftype::Bandpass, fs::Real) = Bandpass(prewarp(normalize_freq(ftype.w1, fs)), prewarp(normalize_freq(ftype.w2, fs)))
prewarp(ftype::Bandstop, fs::Real) = Bandstop(prewarp(normalize_freq(ftype.w1, fs)), prewarp(normalize_freq(ftype.w2, fs)))
# freq in half-samples per cycle
prewarp(f::Real) = 4 * tanpi(f / 2)

# Digital filter design
"""
    digitalfilter(responsetype::FilterType, designmethod::FilterCoefficients[; fs::Real])

Construct a digital filter. See below for possible response and
filter types.
"""
digitalfilter(ftype::FilterType, proto::FilterCoefficients; fs::Real=2) =
    bilinear(transform_prototype(prewarp(ftype, fs), proto), 2)

#
# Special filter types
#

"""
    iirnotch(Wn::Real, bandwidth::Real[; fs=2])

Second-order digital IIR notch filter [^Orfanidis] at frequency `Wn` with
bandwidth `bandwidth`. If `fs` is not specified, `Wn` is
interpreted as a normalized frequency in half-cycles/sample.

[^Orfanidis]: Orfanidis, S. J. (1996). Introduction to signal processing.
    Englewood Cliffs, N.J: Prentice Hall, p. 370.
"""
function iirnotch(w::Real, bandwidth::Real; fs=2)
    w = normalize_freq(w, fs)
    bandwidth = normalize_freq(bandwidth, fs)

    # Eq. 8.2.23
    b = 1 / (1 + tanpi(bandwidth / 2))
    # Eq. 8.2.22
    cosw0 = cospi(w)
    b1 = -2b * cosw0
    Biquad(b, b1, b, b1, 2b-1)
end

#
# FIR filter design
#

# Get length and alpha for Kaiser window filter with specified
# transition band width and stopband attenuation in dB
function kaiserord(transitionwidth::Real, attenuation::Real=60)
    n = ceil(Int, (attenuation - 7.95) / (π * 2.285 * transitionwidth)) + 1

    if attenuation > 50
        β = 0.1102 * (attenuation - 8.7)
    elseif attenuation >= 21
        β = 0.5842 * (attenuation - 21)^0.4 + 0.07886 * (attenuation - 21)
    else
        β = 0.0
    end

    return n, β/π
end

struct FIRWindow{T}
    window::Vector{T}
    scale::Bool
end

"""
    FIRWindow(window::Vector; scale=true)

FIR filter design using window `window`, a vector whose length
matches the number of taps in the resulting filter.

If `scale` is `true` (default), the designed FIR filter is
scaled so that the following holds:

- For [`Lowpass`](@ref) and [`Bandstop`](@ref) filters, the frequency
  response is unity at 0 (DC).
- For [`Highpass`](@ref) filters, the frequency response is unity
  at the Nyquist frequency.
- For [`Bandpass`](@ref) filters, the frequency response is unity
  in the center of the passband.
"""
FIRWindow(window::Vector; scale::Bool=true) = FIRWindow(window, scale)

# FIRWindow(n::Integer, window::Function, args...) = FIRWindow(window(n, args...))
"""
    FIRWindow(; transitionwidth::Real, attenuation::Real=60, scale::Bool=true)

Kaiser window FIR filter design. The required number of taps is
calculated based on `transitionwidth` (in half-cycles/sample)
and stopband `attenuation` (in dB). `attenuation` defaults to
60 dB.
"""
FIRWindow(; transitionwidth::Real=throw(ArgumentError("must specify transitionwidth")),
          attenuation::Real=60, scale::Bool=true) =
    FIRWindow(kaiser(kaiserord(transitionwidth, attenuation)...), scale)

# Compute coefficients for FIR prototype with specified order
function _firprototype(n::Integer, ftype::Lowpass, fs::Real, ::Type{T}) where {T<:Number}
    w = normalize_freq(ftype.w, fs)

    promote_type(typeof(w), T)[w*sinc(w*(k-(n+1)/2)) for k = 1:n]
end

firprototype(n::Integer, ftype::Lowpass, fs::Real) =
    _firprototype(n, ftype, fs, typeof(fs))

function firprototype(n::Integer, ftype::Bandpass, fs::Real)
    w1 = normalize_freq(ftype.w1, fs)
    w2 = normalize_freq(ftype.w2, fs)

    [w2*sinc(w2*(k-(n+1)/2)) - w1*sinc(w1*(k-(n+1)/2)) for k = 1:n]
end

function firprototype(n::Integer, ftype::ComplexBandpass, fs::T) where {T<:Real}
    w1 = normalize_complex_freq(ftype.w1, fs)
    w2 = normalize_complex_freq(ftype.w2, fs)
    w_center = (w2 + w1) / 2
    w_cutoff = (w2 - w1) / 2
    lp = Lowpass(w_cutoff)
    _firprototype(n, lp, 2, Complex{T}) .*= cispi.(w_center * (0:(n-1)))
end

function firprototype(n::Integer, ftype::Highpass, fs::Real)
    w = normalize_freq(ftype.w, fs)
    isodd(n) || throw(ArgumentError("FIRWindow highpass filters must have an odd number of coefficients"))

    out = [-w*sinc(w*(k-(n+1)/2)) for k = 1:n]
    out[n÷2+1] += 1
    out
end

function firprototype(n::Integer, ftype::Bandstop, fs::Real)
    w1 = normalize_freq(ftype.w1, fs)
    w2 = normalize_freq(ftype.w2, fs)
    isodd(n) || throw(ArgumentError("FIRWindow bandstop filters must have an odd number of coefficients"))

    out = [w1*sinc(w1*(k-(n+1)/2)) - w2*sinc(w2*(k-(n+1)/2)) for k = 1:n]
    out[n÷2+1] += 1
    out
end

scalefactor(coefs::Vector, ::Union{Lowpass, Bandstop}, fs::Real) = sum(coefs)
function scalefactor(coefs::Vector{T}, ::Highpass, fs::Real) where {T<:Number}
    c = zero(T)
    for k = 1:length(coefs)
        c += ifelse(isodd(k), coefs[k], -coefs[k])
    end
    c
end
function scalefactor(coefs::Vector{T}, ftype::Bandpass, fs::Real) where {T<:Number}
    n = length(coefs)
    freq = normalize_freq(middle(ftype.w1, ftype.w2), fs)
    c = zero(T)
    for k = 1:n
        c = muladd(coefs[k], cospi(freq * (k - (n + 1) / 2)), c)
    end
    c
end
function scalefactor(coefs::Vector{T}, ftype::ComplexBandpass, fs::Real) where T<:Number
    n = length(coefs)
    freq = normalize_complex_freq(middle(ftype.w1, ftype.w2), fs)
    c = zero(T)
    for k = 1:n
        c = muladd(coefs[k], cispi(-freq * (k - (n + 1) / 2)), c)
    end
    return abs(c)
end

function digitalfilter(ftype::FilterType, proto::FIRWindow; fs::Real=2)
    coefs = firprototype(length(proto.window), ftype, fs)
    @assert length(proto.window) == length(coefs)
    out = (coefs .*= proto.window)
    proto.scale ? rmul!(out, 1 / scalefactor(out, ftype, fs)) : out
end


"""
    resample_filter(rate::AbstractFloat, Nϕ::Integer=32, rel_bw::Real=1.0, att=60)

Compute FIR coefficients suitable for arbitrary rate resampling
with `Nϕ` filters / phases, stop-band attenuation `att`, and relative bandwidth `rel_bw`.
"""
function resample_filter(rate::AbstractFloat, Nϕ::Integer=32, rel_bw::Real=1.0, attenuation=60)
    f_nyq = rate >= 1.0 ? 1.0 / Nϕ : rate / Nϕ
    return _resample_filter(f_nyq, Nϕ, rel_bw, attenuation)
end

"""
    resample_filter(rate::Union{Integer,Rational}, rel_bw::Real=1.0, attenuation=60)

Compute FIR coefficients suitable for rational rate resampling,
with stop-band attenuation `att`, and relative bandwidth `rel_bw`.
"""
function resample_filter(rate::Union{Integer,Rational}, rel_bw::Real=1.0, attenuation=60)
    Nϕ         = numerator(rate)
    decimation = denominator(rate)
    f_nyq      = min(1 / Nϕ, 1 / decimation)
    return _resample_filter(f_nyq, Nϕ, rel_bw, attenuation)
end

function _resample_filter(f_nyq, Nϕ, rel_bw, attenuation)
    cutoff      = f_nyq * rel_bw
    trans_width = cutoff * 0.2

    # Determine resampling filter order
    hLen, α = kaiserord(trans_width, attenuation)

    # Round the number of taps up to a multiple of Nϕ.
    # Otherwise the missing taps will be filled with 0.
    hLen = Nϕ * cld(hLen, Nϕ)

    # Ensure that the filter is an odd length
    if iseven(hLen)
        hLen += 1
    end

    # Design filter
    h = digitalfilter(Lowpass(cutoff), FIRWindow(kaiser(hLen, α)))
    rmul!(h, Nϕ)
end

using ..DSP: _zeropad

const PFB{T} = Matrix{T}          # polyphase filter bank

abstract type FIRKernel{T} end

# Single rate FIR kernel
struct FIRStandard{T} <: FIRKernel{T}
    h::Vector{T}
    hLen::Int
end

function FIRStandard(h::Vector)
    h    = reverse(h)
    hLen = length(h)
    FIRStandard(h, hLen)
end


# Interpolator FIR kernel
mutable struct FIRInterpolator{T} <: FIRKernel{T}
    const pfb::PFB{T}
    const interpolation::Int
    const Nϕ::Int
    const tapsPerϕ::Int
    const hLen::Int
    ϕIdx::Int
    inputDeficit::Int
end

function FIRInterpolator(h::Vector, interpolation::Int)
    pfb          = taps2pfb(h, interpolation)
    tapsPerϕ, Nϕ = size(pfb)
    inputDeficit = 1
    ϕIdx         = 1
    hLen         = length(h)

    FIRInterpolator(pfb, interpolation, Nϕ, tapsPerϕ, hLen, ϕIdx, inputDeficit)
end
FIRInterpolator(h::Vector, interpolation::Integer) = FIRInterpolator(h, Int(interpolation))

# Decimator FIR kernel
mutable struct FIRDecimator{T} <: FIRKernel{T}
    const h::Vector{T}
    const hLen::Int
    const decimation::Int
    inputDeficit::Int
end

function FIRDecimator(h::Vector, decimation::Int)
    h            = reverse(h)
    hLen         = length(h)
    inputDeficit = 1
    FIRDecimator(h, hLen, decimation, inputDeficit)
end
FIRDecimator(h::Vector, decimation::Integer) = FIRDecimator(h, Int(decimation))

# Rational resampler FIR kernel
mutable struct FIRRational{T}  <: FIRKernel{T}
    const pfb::PFB{T}
    const ratio::Rational{Int}
    const Nϕ::Int
    const ϕIdxStepSize::Int
    const tapsPerϕ::Int
    const hLen::Int
    ϕIdx::Int
    inputDeficit::Int
end

function FIRRational(h::Vector, ratio::Rational{Int})
    pfb          = taps2pfb(h, numerator(ratio))
    tapsPerϕ, Nϕ = size(pfb)
    ϕIdxStepSize = mod(denominator(ratio), numerator(ratio))
    hLen         = length(h)
    ϕIdx         = 1
    inputDeficit = 1
    FIRRational(pfb, ratio, Nϕ, ϕIdxStepSize, tapsPerϕ, hLen, ϕIdx, inputDeficit)
end
FIRRational(h::Vector, ratio::Union{Integer,Rational}) = FIRRational(h, convert(Rational{Int}, ratio))

#
# Arbitrary resampler FIR kernel
#
# This kernel is different from the others in that it has two polyphase filter banks.
# The second filter bank, dpfb, is the derivative of pfb. The purpose of this is to
# allow us to compute two y values, yLower & yUpper, without having to advance the input
# index by 1. It makes the kernel simpler by not having to store extra state in the case
# when where's at the last polyphase branch and the last available input sample. By using
# a derivative filter, we can always compute the output in that scenario.
# See section 7.6.1 in [1] for a better explanation.

mutable struct FIRArbitrary{T} <: FIRKernel{T}
    const rate::Float64
    const pfb::PFB{T}
    const dpfb::PFB{T}
    const Nϕ::Int
    const tapsPerϕ::Int
    const hLen::Int
    const Δ::Float64
    ϕAccumulator::Float64
    ϕIdx::Int
    α::Float64
    xIdx::Int
    inputDeficit::Int
end

function FIRArbitrary(h::Vector, rate::Float64, Nϕ::Int)
    dh           = [diff(h); zero(eltype(h))]
    pfb          = taps2pfb(h,  Nϕ)
    dpfb         = taps2pfb(dh, Nϕ)
    tapsPerϕ     = size(pfb, 1)
    hLen         = length(h)
    Δ            = Nϕ / rate
    ϕAccumulator = 0.0
    ϕIdx         = 1
    α            = 0.0
    xIdx         = 1
    inputDeficit = 1
    if Nϕ + Δ > maxintfloat(Float64)    # invariant; ensure safe trunc
        throw(ArgumentError("Nϕ + Δ must be <= than maxintfloat(Float64)"))
    end
    FIRArbitrary(
        rate,
        pfb,
        dpfb,
        Nϕ,
        tapsPerϕ,
        hLen,
        Δ,
        ϕAccumulator,
        ϕIdx,
        α,
        xIdx,
        inputDeficit
    )
end
FIRArbitrary(h::Vector, rate::Real, Nϕ::Integer) = FIRArbitrary(h, convert(Float64, rate), convert(Int, Nϕ))

# FIRFilter - the kernel does the heavy lifting
mutable struct FIRFilter{Tk<:FIRKernel,T}
    const kernel::Tk
    const h::Vector{T}
    const historyLen::Int
    history::Vector
end

# Constructor for single-rate, decimating, interpolating, and rational resampling filters
"""
    FIRFilter(h::Vector, ratio::Union{Integer,Rational}=1)
    FIRFilter(ratio::Union{Integer,Rational}, args...)

Construct a stateful FIRFilter object from the vector of filter taps `h`.
`ratio` is an optional rational integer which specifies
the input to output sample rate relationship (e.g. `147//160` for
converting recorded audio from 48 KHz to 44.1 KHz).

Constructs `h` with `resample_filter(ratio, args...)` if it is not provided.
"""
function FIRFilter(h::Vector, resampleRatio::Union{Integer,Rational} = 1)
    Base.@constprop :aggressive
    resampleRatio > 0 || throw(DomainError(resampleRatio, "ratio must be positive"))
    interpolation = numerator(resampleRatio)
    decimation    = denominator(resampleRatio)
    historyLen    = 0

    if resampleRatio == 1                                     # single-rate
        kernel     = FIRStandard(h)
        historyLen = kernel.hLen - 1
    elseif decimation == 1                                    # interpolate
        kernel     = FIRInterpolator(h, interpolation)
        historyLen = kernel.tapsPerϕ - 1
    elseif interpolation == 1                                 # decimate
        kernel     = FIRDecimator(h, decimation)
        historyLen = kernel.hLen - 1
    else                                                      # rational
        kernel     = FIRRational(h, resampleRatio)
        historyLen = kernel.tapsPerϕ - 1
    end

    history = zeros(historyLen)

    FIRFilter(kernel, h, historyLen, history)
end

# Constructor for arbitrary resampling filter (polyphase interpolator w/ intra-phase linear interpolation)
"""
    FIRFilter(h::Vector, rate::AbstractFloat, Nϕ::Integer=32)
    FIRFilter(rate::AbstractFloat, Nϕ::Integer=32, args...)

Returns a polyphase FIRFilter object from the vector of filter taps `h`.
`rate` is a floating point number that specifies the input to output
sample-rate relationship ``\\frac{fs_{out}}{fs_{in}}``. `Nϕ` is an
optional parameter which specifies the number of *phases* created from
`h`. `Nϕ` defaults to 32.

Constructs `h` with `resample_filter(rate, Nϕ, args...)` if it is not provided.
"""
function FIRFilter(h::Vector, rate::AbstractFloat, Nϕ::Integer=32)
    rate > 0.0 || throw(DomainError(rate, "rate must be greater than 0"))
    Nϕ > 0 || throw(DomainError(Nϕ, "Nϕ must be greater than 0"))
    kernel     = FIRArbitrary(h, rate, Nϕ)
    historyLen = kernel.tapsPerϕ - 1
    history    = zeros(historyLen)
    FIRFilter(kernel, h, historyLen, history)
end

# Constructor for a resampling FIR filter, where the user needs only to set the sampling rate
function FIRFilter(rate::AbstractFloat, Nϕ::Integer=32, args...)
    h = resample_filter(rate, Nϕ, args...)
    FIRFilter(h, rate, Nϕ)
end

function FIRFilter(ratio::Union{Integer,Rational}, args...)
    h = resample_filter(ratio, args...)
    FIRFilter(h, ratio)
end


#
# setphase! set's filter kernel phase index
#
function setphase!(kernel::FIRDecimator, ϕ::Real)
    ϕ >= zero(ϕ) || throw(DomainError(ϕ, "ϕ must be >= 0"))
    xThrowaway = round(Int, ϕ)
    kernel.inputDeficit += xThrowaway
    nothing
end

function setphase!(kernel::Union{FIRInterpolator, FIRRational}, ϕ::Real)
    ϕ >= zero(ϕ) || throw(DomainError(ϕ, "ϕ must be >= 0"))
    xThrowaway, ϕIdx = divrem(round(Int, ϕ * kernel.Nϕ), kernel.Nϕ)
    kernel.inputDeficit += xThrowaway
    kernel.ϕIdx = ϕIdx + 1
    nothing
end

function setphase!(kernel::FIRArbitrary, ϕ::Real)
    zero(ϕ) <= ϕ < maxintfloat(typeof(ϕ), Int) ||
        throw(DomainError(ϕ, "ϕ must be >= 0 and < maxintfloat(ϕ)"))
    ϕ, xThrowaway = modf(ϕ)
    kernel.inputDeficit += unsafe_trunc(Int, xThrowaway)    # safe, but llvm unable to optimize
    kernel.ϕAccumulator = ϕ * kernel.Nϕ
    kernel.ϕIdx         = 1 + trunc(Int, kernel.ϕAccumulator)
    kernel.α            = modf(kernel.ϕAccumulator)[1]
    nothing
end

setphase!(self::FIRFilter, ϕ::Real) = setphase!(self.kernel, ϕ)

#
# reset! filter and its kernel to an initial state
#

function reset!(kernel::FIRStandard)
    kernel
end

function reset!(kernel::Union{FIRRational,FIRInterpolator})
    kernel.ϕIdx         = 1
    kernel.inputDeficit = 1
    kernel
end

function reset!(kernel::FIRDecimator)
    kernel.inputDeficit = 1
    kernel
end

function reset!(kernel::FIRArbitrary)
    kernel.ϕAccumulator = 0.0
    kernel.ϕIdx         = 1
    kernel.α            = 0.0
    kernel.xIdx         = 1
    kernel.inputDeficit = 1
    kernel
end

# For FIRFilter, set history vector to zeros of same type and required length
function reset!(self::FIRFilter)
    fill!(self.history, 0)
    reset!(self.kernel)
    self
end

#
# taps2pfb
#
# Converts a vector of coefficients to a matrix. Each column is a filter.
# NOTE: also flips the matrix up/down so computing the dot product of a
#       column with a signal vector is more efficient (since filter is convolution)
# Appends zeros if necessary.
# Example:
#   julia> taps2pfb( [1:9], 4 )
#   3x4 Array{Int64,2}:
#    9  0  0  0
#    5  6  7  8
#    1  2  3  4
#
#  In this example, the first phase, or ϕ, is [9, 5, 1].

function taps2pfb(h::Vector{T}, Nϕ::Integer) where T
    hLen     = length(h)
    tapsPerϕ = cld(hLen, Nϕ)
    pfb      = Matrix{T}(undef, tapsPerϕ, Nϕ)
    hIdx     = 1

    for rowIdx in tapsPerϕ:-1:1, colIdx in 1:Nϕ
        tap = hIdx > hLen ? zero(T) : h[hIdx]
        pfb[rowIdx, colIdx] = tap
        hIdx += 1
    end

    return pfb
end


#
# Calculates the resulting length of a multirate filtering operation, given a
#   FIRFilter{FIRRational} object and an input vector
#
# ( It's hard to explain how this works without a diagram )
#

function outputlength(inputlength::Integer, ratio::Union{Integer,Rational}, initialϕ::Integer)
    interpolation = numerator(ratio)
    decimation    = denominator(ratio)
    outLen        = cld((inputlength * interpolation) - initialϕ + 1, decimation)
    outLen
end

function outputlength(::FIRStandard, inputlength::Integer)
    inputlength
end

function outputlength(kernel::FIRInterpolator, inputlength::Integer)
    outputlength(inputlength-kernel.inputDeficit+1, kernel.interpolation, kernel.ϕIdx)
end

function outputlength(kernel::FIRDecimator, inputlength::Integer)
    outputlength(inputlength-kernel.inputDeficit+1, 1//kernel.decimation, 1)
end

function outputlength(kernel::FIRRational, inputlength::Integer)
    outputlength(inputlength-kernel.inputDeficit+1, kernel.ratio, kernel.ϕIdx)
end

function outputlength(kernel::FIRArbitrary, inputlength::Integer)
    ceil(Int, (inputlength-kernel.inputDeficit+1) * kernel.rate - kernel.ϕAccumulator / kernel.Δ)
end

function outputlength(self::FIRFilter, inputlength::Integer)
    outputlength(self.kernel, inputlength)
end


#
# Calculates the input length of a multirate filtering operation,
# given the output length. The dividend is assumed positive.
# With RoundToZero and RoundDown, inputlength returns the largest input length
# such that the actual output length will be _at most_ the given one.
# With RoundUp and RoundFromZero, inputlength returns the shortest input length
# such that the actual output length will be _at least_ the given one.
#

function inputlength(outputlength::Int, ratio::Union{Integer,Rational}, initialϕ::Integer, r::RoundingMode=RoundToZero)
    interpolation = numerator(ratio)
    decimation    = denominator(ratio)
    d             = r == RoundUp || r == RoundFromZero ? decimation : 1
    inLen         = div((outputlength * decimation + initialϕ - d), interpolation, r)
    inLen
end

function inputlength(::FIRStandard, outputlength::Int, ::RoundingMode)
    outputlength
end

function inputlength(kernel::FIRInterpolator, outputlength::Int, r::RoundingMode)
    inLen = inputlength(outputlength, kernel.interpolation, kernel.ϕIdx, r)
    inLen += kernel.inputDeficit - 1
end

function inputlength(kernel::FIRDecimator, outputlength::Int, r::RoundingMode)
    inLen  = inputlength(outputlength, 1//kernel.decimation, 1, r)
    inLen += kernel.inputDeficit - 1
end

function inputlength(kernel::FIRRational, outputlength::Int, r::RoundingMode)
    inLen  = inputlength(outputlength, kernel.ratio, kernel.ϕIdx, r)
    inLen += kernel.inputDeficit - 1
end

function inputlength(kernel::FIRArbitrary, outputlength::Int, r::RoundingMode)
    d      = r == RoundUp || r == RoundFromZero ? 1 : 0
    inLen  = trunc(Int, (outputlength - d + kernel.ϕAccumulator / kernel.Δ)/kernel.rate) + d
    inLen += kernel.inputDeficit - 1
end

inputlength(kernel::FIRKernel, outputlength::Integer) = inputlength(kernel, Int(outputlength), RoundToZero)
inputlength(self::FIRFilter, outputlength::Integer, r::RoundingMode=RoundToZero) =
    inputlength(self.kernel, Int(outputlength), r)


#
# Calculates the delay caused by the FIR filter in # samples, at the input sample rate, caused by the filter process
#

timedelay(kernel::Union{FIRRational,FIRInterpolator,FIRArbitrary}) =
    (kernel.hLen - 1) / (2 * kernel.Nϕ)
timedelay(kernel::Union{FIRStandard,FIRDecimator}) = (kernel.hLen - 1) / 2
timedelay(self::FIRFilter) = timedelay(self.kernel)

#
# Single rate filtering
#

function filt!(
    buffer::AbstractVector{Tb},
    self::FIRFilter{FIRStandard{Th}},
    x::AbstractVector{Tx}, history::Vector{Tx}
) where {Tb,Th,Tx}
    kernel              = self.kernel
    bufLen              = length(buffer)
    xLen                = length(x)

    bufLen >= xLen || throw(ArgumentError("buffer length must be >= length(x)"))

    h = kernel.h
    for i = 1:min(kernel.hLen-1, xLen)
        buffer[i] = unsafe_dot(h, history, x, i)
    end
    for i = kernel.hLen:xLen
        buffer[i] = unsafe_dot(h, x, i)
    end

    self.history = shiftin!(history, x)

    return xLen
end


#
# Interpolation
#

function filt!(
    buffer::AbstractVector{Tb},
    self::FIRFilter{FIRInterpolator{Th}},
    x::AbstractVector{Tx}, history::Vector{Tx}
) where {Tb,Th,Tx}
    kernel              = self.kernel
    xLen                = length(x)
    bufLen              = length(buffer)
    bufIdx              = 0

    if xLen < kernel.inputDeficit
        self.history = shiftin!(history, x)
        kernel.inputDeficit -= xLen
        return bufIdx
    end

    inputIdx = kernel.inputDeficit
    bufLen >= outputlength(self, xLen) || throw(ArgumentError("length(buffer) must be >= interpolation * length(x)"))

    while inputIdx <= xLen
        bufIdx += 1

        if inputIdx < kernel.tapsPerϕ
            accumulator = unsafe_dot(kernel.pfb, kernel.ϕIdx, history, x, inputIdx)
        else
            accumulator = unsafe_dot(kernel.pfb, kernel.ϕIdx, x, inputIdx)
        end

        buffer[bufIdx]          = accumulator
        (kernel.ϕIdx, inputIdx) = kernel.ϕIdx == kernel.Nϕ ? (1, inputIdx+1) : (kernel.ϕIdx+1, inputIdx)
    end

    kernel.inputDeficit = 1
    self.history        = shiftin!(history, x)

    return bufIdx
end


#
# Rational resampling
#

function filt!(
    buffer::AbstractVector{Tb},
    self::FIRFilter{FIRRational{Th}},
    x::AbstractVector{Tx}, history::Vector{Tx}
) where {Tb,Th,Tx}
    kernel              = self.kernel
    xLen                = length(x)
    bufLen              = length(buffer)
    bufIdx              = 0

    if xLen < kernel.inputDeficit
        self.history = shiftin!(history, x)
        kernel.inputDeficit -= xLen
        return bufIdx
    end

    outLen = outputlength(kernel, xLen)
    bufLen >= outLen || throw(ArgumentError("buffer is too small"))

    interpolation       = numerator(kernel.ratio)
    decimation          = denominator(kernel.ratio)
    inputIdx            = kernel.inputDeficit
    ϕIdx                = kernel.ϕIdx

    while inputIdx <= xLen
        bufIdx += 1

        if inputIdx < kernel.tapsPerϕ
            accumulator = unsafe_dot(kernel.pfb, ϕIdx, history, x, inputIdx)
        else
            accumulator = unsafe_dot(kernel.pfb, ϕIdx, x, inputIdx)
        end

        buffer[bufIdx]  = accumulator
        inputIdx       += div(ϕIdx + decimation - 1, interpolation)
        ϕIdx           += kernel.ϕIdxStepSize
        kernel.ϕIdx     = ϕIdx = ifelse(ϕIdx > interpolation, ϕIdx - interpolation, ϕIdx)
    end

    kernel.inputDeficit = inputIdx - xLen
    self.history        = shiftin!(history, x)

    return bufIdx
end


#
# Decimation
#

function filt!(
    buffer::AbstractVector{Tb},
    self::FIRFilter{FIRDecimator{Th}},
    x::AbstractVector{Tx}, history::Vector{Tx}
) where {Tb,Th,Tx}
    kernel              = self.kernel
    bufLen              = length(buffer)
    xLen                = length(x)
    bufIdx              = 0

    if xLen < kernel.inputDeficit
        self.history = shiftin!(history, x)
        kernel.inputDeficit -= xLen
        return bufIdx
    end

    outLen              = outputlength(self, xLen)
    inputIdx            = kernel.inputDeficit

    nbufout = fld(xLen - inputIdx, kernel.decimation) + 1
    bufLen >= nbufout || throw(ArgumentError("buffer length insufficient"))

    while inputIdx <= xLen
        bufIdx += 1

        if inputIdx < kernel.hLen
            accumulator = unsafe_dot(kernel.h, history, x, inputIdx)
        else
            accumulator = unsafe_dot(kernel.h, x, inputIdx)
        end

        buffer[bufIdx] = accumulator
        inputIdx      += kernel.decimation
    end

    kernel.inputDeficit = inputIdx - xLen
    self.history        = shiftin!(history, x)

    return bufIdx
end


#
# Arbitrary resampling
#
# Updates FIRArbitrary state. See Section 7.5.1 in [1].
#   [1] uses a phase accumulator that increments by Δ (Nϕ/rate)

@fastmath function update!(kernel::FIRArbitrary)
    ϕAcc = kernel.ϕAccumulator + kernel.Δ
    xIdx = kernel.xIdx
    α, ϕosF64 = modf(ϕAcc)
    ϕ_os = unsafe_trunc(Int, ϕosF64)

    if ϕ_os >= kernel.Nϕ
        Δx, ϕ_os = divrem(ϕ_os, kernel.Nϕ)
        ϕAcc = ϕ_os + α
        kernel.xIdx = (xIdx += Δx)
    end
    # "atomic" update
    kernel.α = α
    kernel.ϕIdx = 1 + ϕ_os
    kernel.ϕAccumulator = ϕAcc
    xIdx
end

function filt!(
    buffer::AbstractVector{Tb},
    self::FIRFilter{FIRArbitrary{Th}},
    x::AbstractVector{Tx}, history::Vector{Tx}
) where {Tb,Th,Tx}
    kernel              = self.kernel
    pfb                 = kernel.pfb
    dpfb                = kernel.dpfb
    xLen                = length(x)
    bufIdx              = 0

    # Do we have enough input samples to produce one or more output samples?
    # if xLen < kernel.inputDeficit     # redundant; while cond covers case.
    #     self.history = shiftin!(history, x)
    #     kernel.inputDeficit -= xLen
    #     return bufIdx
    # end

    # Skip over input samples that are not needed to produce output results.
    # We do this by seting inputIdx to inputDeficit which was calculated in the previous run.
    # InputDeficit is set to 1 when instantiation the FIRArbitrary kernel, that way the first
    #   input always produces an output.
    kernel.xIdx = xIdx = kernel.inputDeficit

    while xIdx <= xLen
        bufIdx += 1
        ϕIdx = kernel.ϕIdx

        if xIdx < kernel.tapsPerϕ
            yLower = unsafe_dot(pfb,  ϕIdx, history, x, xIdx)
            yUpper = unsafe_dot(dpfb, ϕIdx, history, x, xIdx)
        else
            yLower = unsafe_dot(pfb,  ϕIdx, x, xIdx)
            yUpper = unsafe_dot(dpfb, ϕIdx, x, xIdx)
        end

        # Used to have @inbounds. Restore @inbounds if buffer length
        # can be verified prior to access.
        buffer[bufIdx] = muladd(yUpper, kernel.α, yLower)
        xIdx = update!(kernel)
    end

    kernel.inputDeficit = xIdx - xLen
    self.history        = shiftin!(history, x)

    return bufIdx
end

"""
    filt!(buffer::AbstractVector, self::FIRFilter, x::AbstractVector{Tx})
    filt!(buffer::AbstractVector, self::FIRFilter, x::AbstractVector{Tx}, history::Vector{Tx})

Filters `x` with `self::FIRFilter` and writes the output to `buffer`.
A history `Vector` with the same eltype as `x` can be provided that
will then be set as `self.history`.

The default argument is `convert(Vector{Tx}, self.history)`.
"""
filt!(buffer::AbstractVector, self::FIRFilter, x::AbstractVector{Tx}) where Tx =
    filt!(buffer, self, x, convert(Vector{Tx}, self.history))



"""
    filt(self::FIRFilter{Tk}, x::AbstractVector{Th})

Filters `x` with `self::FIRFilter`. The output array will have
eltype `promote_type(Tk, Th)`.

To choose otherwise, provide an output array as the first argument to `filt!`.
"""
function filt(self::FIRFilter{Tk}, x::AbstractVector) where Tk<:FIRKernel
    buffer = allocate_output(self, x)
    bufLen = length(buffer)
    samplesWritten = filt!(buffer, self, x)
    if Tk <: FIRArbitrary
        samplesWritten == bufLen || resize!(buffer, samplesWritten)
    else
        samplesWritten == bufLen || throw(AssertionError("Length of resampled output different from expectation."))
    end
    return buffer
end

function allocate_output(sf::FIRFilter{Tk}, x::AbstractVector{Tx}) where {Th,Tx,Tk<:FIRKernel{Th}}
    # In some cases when `filt(::FIRFilter{FIRArbitrary}, x)` is called
    # with certain values of `x`, `filt!(buffer, ::FIRFilter{FIRArbitrary}, x)`
    # tries to write one sample too many to the buffer and a `BoundsError`
    # is thrown. Add one extra sample to catch these exceptional cases.
    #
    # See https://github.com/JuliaDSP/DSP.jl/issues/317
    #
    # FIXME: Remove this if and when the code in
    #        `filt!(buffer, ::FIRFilter{FIRArbitrary}, x)`
    #        is updated to properly account for pathological arbitrary rates.
    outLen = outputlength(sf, length(x))
    if Tk <: FIRArbitrary
        outLen += 1
    end
    return Vector{promote_type(Th, Tx)}(undef, outLen)
end


#
# Stateless filt implementations
#

# Single-rate, decimation, interpolation, and rational resampling.
function filt(h::Vector, x::AbstractVector, ratio::Union{Integer,Rational})
    self = FIRFilter(h, ratio)
    filt(self, x)
end

# Arbitrary resampling with polyphase interpolation and two neighbor linear interpolation.
function filt(h::Vector, x::AbstractVector, rate::AbstractFloat, Nϕ::Integer=32)
    self = FIRFilter(h, rate, Nϕ)
    filt(self, x)
end

"""
    resample(x::AbstractVector, rate::Real[, coef::Vector])

Resample `x` at rational or arbitrary `rate`.
`coef` is an optional vector of FIR filter taps. If `coef`
is not provided, the taps will be computed using a Kaiser window.

Internally, `resample` uses a polyphase `FIRFilter` object,
but performs additional operations to make resampling a signal easier.
It compensates for the `FIRFilter`'s delay (ramp-up), and appends
zeros to `x`. The result is that when the input and output signals
are plotted on top of each other, they correlate very well, but one
signal will have more samples than the other.
"""
function resample(x::AbstractVector, rate::Union{Integer,Rational}, h::Vector)
    _resample!(x, rate, FIRFilter(h, rate))
end

function resample(x::AbstractVector, rate::AbstractFloat, h::Vector, Nϕ::Integer=32)
    _resample!(x, rate, FIRFilter(h, rate, Nϕ))
end

function _resample!(x::AbstractVector, rate::Real, sf::FIRFilter)
    undelay!(sf)
    outLen  = ceil(Int, length(x) * rate)
    xPadded = _zeropad(x, inputlength(sf, outLen, RoundUp))

    buffer = allocate_output(sf, xPadded)
    samplesWritten = filt!(buffer, sf, xPadded)
    return checked_resample_output!(buffer, outLen, samplesWritten, sf)
end

function undelay!(sf::FIRFilter)
    # Get delay, in # of samples at the output rate, caused by filtering processes
    τ = timedelay(sf)

    # Use setphase! to
    #   a) adjust the input samples to skip over before producing and output (integer part of τ)
    #   b) set the ϕ index of the PFB (fractional part of τ)
    setphase!(sf, τ)
end

function checked_resample_output!(y::AbstractVector, outLen, samplesWritten, ::FIRFilter{Tk}) where Tk<:FIRKernel
    if !(Tk <: FIRArbitrary)
        samplesWritten == length(y) || throw(AssertionError("Length of resampled output different from expectation."))
    end
    # outLen: the desired output length ceil(Int, rate * length(input)), but we can overshoot
    # samplesWritten: number of samples actually written to y; if longer, y[samplesWritten+1:end] contains invalid data
    samplesWritten >= outLen || throw(AssertionError("Resample output shorter than expected."))
    length(y) == outLen || resize!(y, outLen)
    return y
end

"""
    resample(x::AbstractVector, rate::Real, args::Real...)

Constructs a filter with `resample_filter` using the optional arguments `args`,
and resamples the signal `x` with it.
"""
function resample(x::AbstractVector, rate::Real, args::Real...)
    sf = FIRFilter(rate, args...)
    _resample!(x, rate, sf)
end

"""
    resample(x::AbstractArray, rate::Real, h::Vector = resample_filter(rate); dims)
    resample(x::AbstractArray, rate::AbstractFloat, h::Vector, Nϕ=32; dims)

Resample an array `x` along dimension `dims`.
If `rate` is an `AbstractFloat`, the number of phases `Nϕ`
to be used in constructing `FIRArbitrary` can be supplied
as an optional argument, which defaults to 32.
"""
function resample(x::AbstractArray, rate::Union{Integer,Rational}, h::Vector; dims)
    sf = FIRFilter(h, rate)
    _resample!(x, rate, sf, dims)
end
function resample(x::AbstractArray, rate::AbstractFloat, h::Vector, Nϕ=32; dims)
    sf = FIRFilter(h, rate, Nϕ)
    _resample!(x, rate, sf, dims)
end

resample(x::AbstractArray, rate::Real, args::Real...; dims) =
    _resample!(x, rate, FIRFilter(rate, args...), dims)

function _resample!(x::AbstractArray{T}, rate::Real, sf::FIRFilter, dims::Int) where T
    undelay!(sf)
    size_v  = size(x, dims)
    outLen  = ceil(Int, size_v * rate)
    xPadded = Vector{T}(undef, inputlength(sf, outLen, RoundUp))
    xPadded[size_v+1:end] .= zero(T)
    buffer  = allocate_output(sf, xPadded)
    bufLen  = length(buffer)

    mapslices(x; dims) do v::AbstractVector
        undelay!(reset!(sf))
        length(buffer) == bufLen || resize!(buffer, bufLen)
        copyto!(xPadded, v)
        samplesWritten = filt!(buffer, sf, xPadded)
        return checked_resample_output!(buffer, outLen, samplesWritten, sf)
    end
end

#
# References
#

# [1] F.J. Harris, *Multirate Signal Processing for Communication Systems*. Prentice Hall, 2004
# [2] Dick, C.; Harris, F., "Options for arbitrary resamplers in FPGA-based modulators",
#       Signals, Systems and Computers, 2004.
#       Conference Record of the Thirty-Eighth Asilomar Conference on vol.1, no., pp.777,781 Vol.1, 7-10 Nov. 2004
# [3] Kim, S.C.; Plishker, W.L.; Bhattacharyya, S.S.,
#       "An efficient GPU implementation of an arbitrary resampling polyphase channelizer",
#       Design and Architectures for Signal and Image Processing (DASIP),
#       2013 Conference on, vol., no., pp.231,238, 8-10 Oct. 2013
# [4] Horridge, J.P.; Frazer, Gordon J., "Accurate arbitrary resampling with exact delay for radar applications",
#       Radar, 2008 International Conference on , vol., no., pp.123,127, 2-5 Sept. 2008
# [5] Blok, M., "Fractional delay filter design for sample rate conversion",
#       Computer Science and Information Systems (FedCSIS),
#       2012 Federated Conference on , vol., no., pp.701,706, 9-12 Sept. 2012

# The periodogram module contains functions which compute non-parametric
# estimates of the periodogram P[s] of a signal s.
module Periodograms
using LinearAlgebra: mul!
using ..Util, ..Windows
using Statistics: mean!
export arraysplit, nextfastfft, periodogram,
       WelchConfig, welch_pgram, welch_pgram!,
       spectrogram, power, freq, stft,
       MTConfig, mt_pgram, mt_pgram!,
       MTSpectrogramConfig, mt_spectrogram, mt_spectrogram!,
       MTCrossSpectraConfig, mt_cross_power_spectra, mt_cross_power_spectra!,
       MTCoherenceConfig, mt_coherence, mt_coherence!,
       coherence
import ..DSP: allocate_output
using FFTW

## ARRAY SPLITTER
"""
    ArraySplit{T<:AbstractVector,S,W} <: AbstractVector{Vector{S}}

ArraySplit object with fields
- `s::T`
- `buf::Vector{S}`
- `n::Int`
- `noverlap::Int`
- `window::W`
- `k::Int`
where `buf`: buffer, `k`: number of split arrays, and `s`, `n`, `noverlap`, `window` are
as per arguments in [`arraysplit`](@ref).
"""
struct ArraySplit{T<:AbstractVector,S,W} <: AbstractVector{Vector{S}}
    s::T
    buf::Vector{S}
    n::Int
    noverlap::Int
    window::W
    k::Int

    function ArraySplit{Ti,Si,Wi}(s, n, noverlap, nfft, window;
        buffer::Vector{Si}=zeros(Si, max(nfft, 0))) where {Ti<:AbstractVector,Si,Wi}

        # n = noverlap is a problem - the algorithm will not terminate.
        (0 ≤ noverlap < n) || throw(DomainError((; noverlap, n), "noverlap must be between zero and n"))
        nfft >= n || throw(DomainError((; nfft, n), "nfft must be >= n"))
        length(buffer) == nfft ||
            throw(ArgumentError(lazy"buffer length ($(length(buffer))) must equal `nfft` ($nfft)"))

        new{Ti,Si,Wi}(s, buffer, n, noverlap, window, length(s) >= n ? div((length(s) - n),
            n - noverlap) + 1 : 0)
    end
end
ArraySplit(s::T, n, noverlap, nfft, window::W; kwargs...) where {S,T<:AbstractVector{S},W} =
    ArraySplit{T,fftintype(S),W}(s, n, noverlap, nfft, window; kwargs...)

function Base.getindex(x::ArraySplit{T,S,Nothing} where {T<:AbstractVector,S}, i::Int)
    @boundscheck (1 <= i <= x.k) || throw(BoundsError(x, i))
    copyto!(x.buf, 1, x.s, (i - 1) * (x.n - x.noverlap) + firstindex(x.s), x.n)
end
function Base.getindex(x::ArraySplit, i::Int)
    @boundscheck (1 <= i <= x.k) || throw(BoundsError(x, i))
    offset = (i - 1) * (x.n - x.noverlap) + firstindex(x.s) - 1
    window = x.window
    for i = 1:x.n
        @inbounds x.buf[i] = x.s[offset+i] * window[i]
    end
    x.buf
end

Base.IndexStyle(::ArraySplit) = IndexLinear()
Base.iterate(x::ArraySplit, i::Int = 1) = (i > x.k ? nothing : (x[i], i+1))
Base.size(x::ArraySplit) = (x.k,)

"""
    arraysplit(s, n, noverlap, nfft=n, window=nothing; buffer=zeros(eltype(s), nfft))

Split an array `s` into arrays of length `n` with overlapping regions
of length `noverlap`.

# Arguments
- `s`: Input array.
- `n`: Specifies the required subarray length (`n ≤ length(s)`).
- `noverlap`: Number of overlapping elements between subarrays.
- `nfft`: Specifies the length of the split arrays. If `length(s)` < `nfft`, then the
    input is padded with zeros.
- `window`: An optional scaling vector to be applied to the split arrays.
- `buffer`: An optional buffer of length `nfft`. Iterating or indexing the returned
    AbstractVector always yields the same Vector with different contents. The last result
    after iteration or indexing calls is stored into buffer.

# Returns
An [`ArraySplit`](@ref) object with split subarrays.

# Examples
```jldoctest
julia> arraysplit([0.1, 0.2, 0.3, 0.4, 0.5], 3, 1)
2-element DSP.Periodograms.ArraySplit{Vector{Float64}, Float64, Nothing}:
 [0.1, 0.2, 0.3]
 [0.3, 0.4, 0.5]

julia> arraysplit([0.1, 0.2, 0.3, 0.4, 0.5], 3, 2, 8)
3-element DSP.Periodograms.ArraySplit{Vector{Float64}, Float64, Nothing}:
 [0.1, 0.2, 0.3, 0.0, 0.0, 0.0, 0.0, 0.0]
 [0.2, 0.3, 0.4, 0.0, 0.0, 0.0, 0.0, 0.0]
 [0.3, 0.4, 0.5, 0.0, 0.0, 0.0, 0.0, 0.0]

julia> arraysplit([0.1, 0.2, 0.3, 0.4, 0.5], 3, 1, 3, [1, 2, 1])
2-element DSP.Periodograms.ArraySplit{Vector{Float64}, Float64, Vector{Int64}}:
 [0.1, 0.4, 0.3]
 [0.3, 0.8, 0.5]
```
arraysplit function with buffer
```jldoctest
julia> x = [1, 2, 3, 4, 5];

julia> sub_arr, n_overlap, nfft = 3, 1, 3;

julia> x_split = arraysplit(x, sub_arr, n_overlap, nfft, nothing; buffer=zeros(nfft));

julia> x_split[2]   # Returns AbstractVector result and stores it in ArraySplit.buf and buffer
3-element Vector{Float64}:
 3.0
 4.0
 5.0

julia> x_split.buf  # Returns stored results from previous x_split[2] call
3-element Vector{Float64}:
 3.0
 4.0
 5.0
```
"""
arraysplit(s, n, noverlap, nfft=n, window=nothing; kwargs...) = ArraySplit(s, n, noverlap, nfft, window; kwargs...)

## Make collect() return the correct split arrays rather than repeats of the last computed copy
Base.collect(x::ArraySplit) = collect(copy(a) for a in x)

## UTILITY FUNCTIONS

# Convert the output of an FFT to a PSD and add it to out
function fft2pow!(out::AbstractVecOrMat{T}, s_fft::AbstractVector{Complex{T}}, nfft::Int, r::Real, onesided::Bool, offset::Int=0) where T
    m1 = convert(T, 1/r)
    n = length(s_fft)
    if onesided
        m2 = convert(T, 2/r)
        out[offset+1] = muladd(abs2(s_fft[1]), m1, out[offset+1])
        for i = 2:n-1
            @inbounds out[offset+i] = muladd(abs2(s_fft[i]), m2, out[offset+i])
        end
        out[offset+n] = muladd(abs2(s_fft[end]), ifelse(iseven(nfft), m1, m2), out[offset+n])
    else
        if n == nfft
            for i in eachindex(s_fft)
                @inbounds out[offset+i] = muladd(abs2(s_fft[i]), m1, out[offset+i])
            end
        else
            # Convert real FFT to two-sided
            out[offset+1] = muladd(abs2(s_fft[1]), m1, out[offset+1])
            @inbounds for i = 2:n-1
                k = abs2(s_fft[i])
                out[offset+i] = muladd(k, m1, out[offset+i])
                out[offset+nfft-i+2] = muladd(k, m1, out[offset+nfft-i+2])
            end
            out[offset+n] = muladd(abs2(s_fft[n]), m1, out[offset+n])
            if isodd(nfft)
                out[offset+n+1] = muladd(abs2(s_fft[n]), m1, out[offset+n+1])
            end
        end
    end
    out
end

# Convert the output of a 2-d FFT to a 2-d PSD and add it to out
function fft2pow2!(out::Matrix{T}, s_fft::Matrix{Complex{T}}, r::Real) where T
    m1 = convert(T, 1/r)
    for i in eachindex(out, s_fft)
        @inbounds out[i] = abs2(s_fft[i]) * m1
    end
    out
end
# Convert the output of a 2-d FFT to a radial PSD and add it to out
function fft2pow2radial!(out::Vector{T}, s_fft::Matrix{Complex{T}}, n1::Int, n2::Int, r::Real, ptype::Int) where T
    nmin = min(n1, n2)
    n1max = n1 >> 1 + 1  # since rfft is used
    n1max != size(s_fft, 1) && throw(ArgumentError("fft size incorrect"))
    m1 = convert(T, 1/r)
    m2 = convert(T, 2/r)
    wavenum = 0             # wavenumber index
    kmax = length(out)      # the highest wavenumber
    wc = zeros(Int, kmax)   # wave count for radial average
    if n1 == nmin           # scale the wavevector for non-square s_fft
        c2 = n1/n2
        c1 = one(c2)
    else
        c1 = n2/n1
        c2 = one(c1)
    end
    d1, d2 = iseven(n1) ? (m1, 1) : (m2, 2)

    sqrt_muladd(a, k) = sqrt(muladd(a, a, k))

    @inbounds begin
        for j = 1:n2
            kj1 = ifelse(j <= n2>>1 + 1, j-1, -n2+j-1)
            kj2 = (kj1 * c2)^2

            wavenum = round(Int, sqrt_muladd(c1 * (1 - 1), kj2)) + 1
            if wavenum<=kmax
                out[wavenum] = muladd(abs2(s_fft[1, j]), m1, out[wavenum])
                wc[wavenum] += 1
            end
            for i = 2:n1max-1
                wavenum = round(Int, sqrt_muladd(c1 * (i - 1), kj2)) + 1
                if wavenum<=kmax
                    out[wavenum] = muladd(abs2(s_fft[i, j]), m2, out[wavenum])
                    wc[wavenum] += 2
                end
            end
            wavenum = round(Int, sqrt_muladd(c1 * (n1max - 1), kj2)) + 1
            if wavenum<=kmax
                out[wavenum] = muladd(abs2(s_fft[n1max, j]), d1, out[wavenum])
                wc[wavenum] += d2
            end
        end
    end
    if ptype == 2
        for i = 1:kmax
            @inbounds out[i] /= wc[i]
        end
    end
    out
end

function fft2oneortwosided!(out::Matrix{V}, s_fft::Vector{V}, nfft::Int, onesided::Bool, offset::Int=0) where V <: Complex
    n = length(s_fft)
    copyto!(out, offset+1, s_fft, 1, n)
    if !onesided && n != nfft
        # Convert real FFT to two-sided
        @inbounds for i = 2:n-iseven(nfft)
            out[offset+nfft-i+2] = conj(s_fft[i])
        end
    end
    out
end

# Evaluate a window function at n points, returning both the window
# (or nothing if no window) and the squared L2 norm of the window
compute_window(::Nothing, n::Int) = (nothing, n)
function compute_window(window::Function, n::Int)
    win = window(n)::Vector{Float64}
    norm2 = sum(abs2, win)
    (win, norm2)
end
function compute_window(window::AbstractVector, n::Int)
    length(window) == n || throw(DimensionMismatch("length of window must match input"))
    (window, sum(abs2, window))
end

## PERIODOGRAMS
abstract type TFR{T} end

"""
    Periodogram{T, F<:Union{Frequencies,AbstractRange}, V<:AbstractVector{T}} <: TFR{T}

A Periodogram object with fields:
- `power::V`
- `freq::F`.
See [`power`](@ref) and [`freq`](@ref) for further details.
"""
struct Periodogram{T, F<:Union{Frequencies,AbstractRange}, V <: AbstractVector{T}} <: TFR{T}
    power::V
    freq::F
end

"""
    Periodogram2{T, F1<:Union{Frequencies,AbstractRange}, F2<:Union{Frequencies,AbstractRange}, M<:AbstractMatrix{T}} <: TFR{T}

A Periodogram2 object with fields:
- `power::M`
- `freq1::F1`
- `freq2::F2`
See [`power`](@ref) and [`freq`](@ref) for further details.
"""
struct Periodogram2{T,F1<:Union{Frequencies,AbstractRange},F2<:Union{Frequencies,AbstractRange}, M<:AbstractMatrix{T}} <: TFR{T}
    power::M
    freq1::F1
    freq2::F2
end

"""
    power(p)

For a [`Periodogram`](@ref), returns the computed power spectral density (PSD) as
a Vector.

For a [`Spectrogram`](@ref), returns the computed power spectral density (PSD) at each frequency and
time bin as a Matrix. Dimensions are frequency × time.

For a [`CrossPowerSpectra`](@ref), returns the pairwise cross power spectral density (CPSD) between each pair
of channels at each frequency. Dimensions are channel x channel x frequency.

# Examples
```jldoctest
julia> power(periodogram([1, 2, 3]; fs=210))
2-element Vector{Float64}:
 0.05714285714285714
 0.009523809523809525
```
"""
power(p::TFR) = p.power

"""
    freq(p)

Returns the frequency bin centers for a given [`Periodogram`](@ref),
[`Spectrogram`](@ref), [`CrossPowerSpectra`](@ref), or [`Coherence`](@ref) object.

Returns a tuple of frequency bin centers for a given `Periodogram2`
object.

# Examples
```jldoctest
julia> freq(periodogram([1, 2, 3]; fs=210))
2-element AbstractFFTs.Frequencies{Float64}:
  0.0
 70.0
```
"""
freq(p::TFR) = p.freq
freq(p::Periodogram2) = (p.freq1, p.freq2)
FFTW.fftshift(p::Periodogram{T,<:Frequencies} where T) =
    Periodogram(p.freq.n_nonnegative == p.freq.n ? p.power : fftshift(p.power), fftshift(p.freq))
FFTW.fftshift(p::Periodogram{T,<:AbstractRange} where T) = p
# 2-d
FFTW.fftshift(p::Periodogram2{T,<:Frequencies,<:Frequencies} where T) =
    Periodogram2(p.freq1.n_nonnegative == p.freq1.n ? fftshift(p.power,2) : fftshift(p.power), fftshift(p.freq1), fftshift(p.freq2))
FFTW.fftshift(p::Periodogram2{T,<:AbstractRange,<:Frequencies} where T) =
    Periodogram2(fftshift(p.power,2), p.freq1, fftshift(p.freq2))
FFTW.fftshift(p::Periodogram2{T,<:AbstractRange,<:AbstractRange} where T) = p

# Compute the periodogram of a signal S, defined as 1/N*X[s(n)]^2, where X is the
# DTFT of the signal S.
"""
    periodogram(s::AbstractVector; onesided=eltype(s)<:Real, nfft=nextfastfft(length(s)), fs=1, window=nothing)

Computes periodogram of a 1-d signal `s` by FFT and returns a
[`Periodogram`](@ref) object.

# Arguments
- `onesided`: For real signals, the two-sided periodogram is symmetric and this
    function returns a one-sided (real only) periodogram by default. A
    two-sided periodogram can be obtained by setting `onesided=false`.
- `nfft`: Specifies the number of points to use for the Fourier
    transform. If `length(s)` < `nfft`, then the input is padded
    with zeros. By default, `nfft` is the closest size for which the
    Fourier transform can be computed with maximal efficiency.
- `fs`: The sample rate of the original signal.
- `window`: An optional window function or vector to be applied to the original
    signal before computing the Fourier transform. The computed
    periodogram is normalized so that the area under the periodogram is
    equal to the uncentered variance (or average power) of the original
    signal.

# Returns
A [`Periodogram`](@ref) object with the 2 computed fields: power, freq.

# Examples
Frequency estimate of `cos(2π(25)t)` with a 1-sided periodogram.
```jldoctest
julia> Fs = 100;                     # Sampling frequency

julia> t = (1:Fs)/Fs;                # 100 time samples

julia> x = cos.(2π*25*t);            # Cosine signal with 25Hz frequency

julia> pxx = periodogram(x; fs=Fs);                 # Periodogram

julia> _, max_index = findmax(pxx.power);           # Find index of max power

julia> pxx.power[max_index], pxx.freq[max_index]    # (power, frequency)
(0.5, 25.0)
```
2-sided periodogram of a rectangle function with Hamming window.
```jldoctest
julia> x = rect(50; padding=50);     # Rectangular pulse function

julia> pxx = periodogram(x; onesided=false, nfft=512, fs=1000, window=hamming);

julia> round(maximum(pxx.power), digits=4)  # Expect max power to be close to 0Hz for a DC signal
0.0182
```
"""
function periodogram(s::AbstractVector{T}; onesided::Bool=T<:Real,
                     nfft::Int=nextfastfft(length(s)), fs::Real=1,
                     window::Union{Function,AbstractVector,Nothing}=nothing) where T<:Number
    onesided && T <: Complex && throw(ArgumentError("cannot compute one-sided FFT of a complex signal"))
    nfft >= length(s) || throw(DomainError((; nfft, n=length(s)), "nfft must be >= n = length(s)"))

    win, norm2 = compute_window(window, length(s))
    if nfft == length(s) && win === nothing && isa(s, StridedArray)
        input = s # no need to pad
    else
        input = zeros(fftintype(T), nfft)
        if win !== nothing
            for i in eachindex(s, win)
                @inbounds input[i] = s[i] * win[i]
            end
        else
            copyto!(input, s)
        end
    end

    s_fft = T <: Real ? rfft(input) : fft(input)
    Periodogram(fft2pow!(zeros(fftabs2type(T), onesided ? (nfft >> 1)+1 : nfft),
                         s_fft, nfft, fs*norm2, onesided),
                onesided ? rfftfreq(nfft, fs) : fftfreq(nfft, fs))
end

# Compute the periodogram of a 2-d signal S. Returns 1/N*X[s(n)]^2, where X is the 2-d
# DTFT of the signal S if radialsum and radialavg are both false (default),
# a radial sum if radialsum=true, or a radial averave if radialavg=true
"""
    periodogram(s::AbstractMatrix; nfft::NTuple{2,Int}=nextfastfft(size(s)), fs=1, radialsum=false, radialavg=false)

Computes periodogram of a 2-d signal using the 2-d FFT and returns a
[`Periodogram2`](@ref) or [`Periodogram`](@ref) object.

# Arguments
- `nfft`: A 2-tuple specifying the number of points to use for the Fourier
    transform for each respective dimension. If `size(s)` < `nfft`, then the input is padded
    with zeros. By default, `nfft` is the closest size for which the
    Fourier transform can be computed with maximal efficiency.
- `fs`: The sample rate of the original signal in both directions.
- `radialsum`: For `radialsum=true`, the value of `power[k]` is proportional to
    ``\\frac{1}{N}\\sum_{k\\leq |k'|<k+1} |X[k']|^2``.
- `radialavg`: For `radialavg=true`, the value of `power[k]` is proportional to
    ``\\frac{1}{N \\#\\{k\\leq |k'|<k+1\\}} \\sum_{k\\leq |k'|<k+1} |X[k']|^2``.
    The computation of `|k'|` takes into account non-square signals
    by scaling the coordinates of the wavevector accordingly.

# Returns
- A [`Periodogram2`](@ref) object by default with the 3 computed fields: power, freq1, freq2.
- A [`Periodogram`](@ref) object is returned for a radially summed or averaged periodogram
    (if `radialsum` or `radialavg` is true, respectively). Only one of `radialsum`
    or `radialavg` can be set to `true` in the function.

# Examples
```jldoctest
julia> x = [1 1; 0 1; 0 0];

julia> pxx = periodogram(x; nfft=(3, 2));   # Returns Periodogram2

julia> power(pxx)
3×2 Matrix{Float64}:
 1.5  0.166667
 0.5  0.166667
 0.5  0.166667

julia> freq(pxx)
([0.0, 0.3333333333333333, -0.3333333333333333], [0.0, -0.5])
```
Radial sum and radial average periodograms
```jldoctest
julia> x = [1 3; 0 1];

julia> periodogram(x; radialsum=true)  # Returns Periodogram
DSP.Periodograms.Periodogram{Float64, AbstractFFTs.Frequencies{Float64}, Vector{Float64}}([6.25, 4.75], [0.0, 0.5])

julia> periodogram(x; radialavg=true)  # Returns Periodogram
DSP.Periodograms.Periodogram{Float64, AbstractFFTs.Frequencies{Float64}, Vector{Float64}}([6.25, 1.5833333333333333], [0.0, 0.5])
```
"""
function periodogram(s::AbstractMatrix{T};
                     nfft::NTuple{2,Int}=nextfastfft(size(s)),
                     fs::Real=1,
                     radialsum::Bool=false, radialavg::Bool=false) where T<:Real
    size(s,1)<=nfft[1] && size(s,2)<=nfft[2] || throw(ArgumentError("nfft must be >= size(s)"))
    size(s,1)>1 && size(s,2)>1 || throw(ArgumentError("dimensions of s must be > 1"))
    if radialsum && radialavg
        throw(ArgumentError("radialsum and radialavg are mutually exclusive"))
    elseif !radialsum && !radialavg
        ptype = 0
    elseif radialsum
        ptype = 1
    else    # if radialavg
        ptype = 2
    end
    norm2 = length(s)
    nmin = minimum(nfft)

    if prod(nfft) == length(s) && isa(s, StridedArray)
        input = s # no need to pad
    else
        input = zeros(fftintype(T), nfft)
        input[1:size(s,1), 1:size(s,2)] = s
    end

    if ptype == 0
        s_fft = fft(input)
        out = Matrix{fftabs2type(T)}(undef, nfft)
        fft2pow2!(out, s_fft, fs * norm2)
        return Periodogram2(out, fftfreq(nfft[1], fs), fftfreq(nfft[2], fs))
    else
        s_fft = rfft(input)
        out = zeros(fftabs2type(T), nmin>>1 + 1)
        fft2pow2radial!(out, s_fft, nfft..., fs * norm2, ptype)
        return Periodogram(out, Frequencies(length(out), length(out), fs / nmin))
    end
end

forward_plan(X::AbstractArray{T}, ::AbstractArray{Complex{T}}) where {T<:Union{Float32, Float64}} =
    plan_rfft(X)
forward_plan(X::AbstractArray{T}, ::AbstractArray{T}) where {T<:Union{ComplexF32, ComplexF64}} =
    plan_fft(X)

struct WelchConfig{F,Fr,W,P,T1,T2,R}
    nsamples::Int
    noverlap::Int
    onesided::Bool
    nfft::Int
    fs::F
    freq::Fr
    window::W
    plan::P
    inbuf::T1
    outbuf::T2
    r::R # inverse normalization
end

"""
    WelchConfig(s::AbstractArray; n=size(s, ndims(s))>>3, noverlap=n>>1,
             onesided=eltype(s)<:Real, nfft=nextfastfft(n),
             fs=1, window)

    WelchConfig(nsamples, eltype; n=nsamples>>3, noverlap=n>>1,
             onesided=eltype<:Real, nfft=nextfastfft(n),
             fs=1, window)

Captures all configuration options for [`welch_pgram`](@ref) in a single struct (akin to
[`MTConfig`](@ref)). When passed on the second argument of [`welch_pgram`](@ref), computes the
periodogram based on segments with `n` samples with overlap of `noverlap` samples, and
returns a Periodogram object. For a Bartlett periodogram, set `noverlap=0`. See
[`periodogram`](@ref) for description of optional keyword arguments.

!!! note

    WelchConfig precomputes an fft plan, and preallocates the necessary intermediate buffers.
    Thus, repeated calls to `welch_pgram` that use the same `WelchConfig` object
    will be more efficient than otherwise possible.

# Examples
```jldoctest
julia> x = 1:8;

julia> wconfig1 = WelchConfig(x; n=length(x), noverlap=0, window=hanning, nfft=16);

julia> wconfig2 = WelchConfig(8, Float64; n=length(x), noverlap=0, window=hanning, nfft=16);
```
"""
function WelchConfig(nsamples::Integer, ::Type{T};
    n::Int=Int(nsamples >> 3), noverlap::Int=Int(n >> 1),
    onesided::Bool=T <: Real, nfft::Int=nextfastfft(n),
    fs::Real=1, window::Union{Function,AbstractVector,Nothing}=welch_config_default_window()
) where T

    onesided && T <: Complex && throw(ArgumentError("cannot compute one-sided FFT of a complex signal"))
    nfft >= n || throw(DomainError((; nfft, n), "nfft must be >= n"))

    win, norm2 = compute_window(window, n)
    r = fs * norm2
    inbuf = zeros(float(T), nfft)
    outbuf = Vector{fftouttype(T)}(undef, T<:Real ? (nfft >> 1)+1 : nfft)
    plan = forward_plan(inbuf, outbuf)

    freq = onesided ? rfftfreq(nfft, fs) : fftfreq(nfft, fs)

    return WelchConfig(n, noverlap, onesided, nfft, fs, freq, win, plan, inbuf, outbuf, r)
end

function WelchConfig(data::AbstractArray; kwargs...)
    return WelchConfig(size(data, ndims(data)), eltype(data); kwargs...)
end

function welch_config_default_window()
    # deprecation added in 0.8, TODO for 0.9: replace with just `hanning`
    Base.depwarn("Omitting `window` is deprecated; \
        specify `window=nothing` for the old behaviour or `window=hanning` for the future default.", :WelchConfig)
    return nothing
end

# Compute an estimate of the power spectral density of a signal s via Welch's
# method.  The resulting periodogram has length N and is computed with an overlap
# region of length M.  The method is detailed in "The Use of Fast Fourier Transform
# for the Estimation of Power Spectra: A Method based on Time Averaging over Short,
# Modified Periodograms."  P. Welch, IEEE Transactions on Audio and Electroacoustics,
# vol AU-15, pp 70-73, 1967.
"""
    welch_pgram(s::AbstractVector, n=div(length(s), 8), noverlap=div(n, 2); onesided=eltype(s)<:Real,
                nfft=nextfastfft(n), fs=1, window)

Computes the Welch periodogram of a signal `s` based on segments with `n` samples
with overlap of `noverlap` samples, and returns a [`Periodogram`](@ref) object.

`welch_pgram` by default divides `s` into 8 segments with 50% overlap between them.
For a Bartlett periodogram, set `noverlap=0`.

See [`periodogram`](@ref) for description of optional keyword arguments.

# Examples
```jldoctest
julia> x = rect(10; padding=20);

julia> power(welch_pgram(x; window=nothing))                    # 1-sided periodogram
2-element Vector{Float64}:
 0.9523809523809523
 0.04761904761904761

julia> power(welch_pgram(x; onesided=false, window=nothing))    # 2-sided periodogram
3-element Vector{Float64}:
 0.9523809523809523
 0.023809523809523805
 0.023809523809523805


julia> power(welch_pgram(x, 5; onesided=false, window=hanning)) # 5 samples segment
5-element Vector{Float64}:
 0.8888888888888888
 0.3807834425694269
 0.008105446319461968
 0.008105446319461968
 0.3807834425694269

```
welch_pgram with ``x = sin(2π(100)t) + 2sin(2π(150)t) + noise ``
```jldoctest
julia> Fs = 1000;                         # Sampling frequency

julia> t = (1:Fs)/Fs;                     # 1000 time samples

julia> f = [100 150];                     # 100Hz & 150Hz frequencies

julia> A = [1; 2];                        # Amplitudes

julia> x = sin.(2π*f.*t)*A + randn(1000); # Noise corrupted x signal

julia> pxx = welch_pgram(x, 100; fs=Fs, nfft=512, window=hamming);
```
"""
function welch_pgram(s::AbstractVector, n::Int=length(s)>>3, noverlap::Int=n>>1; kwargs...)
    welch_pgram(s, WelchConfig(s; n, noverlap, kwargs...))
end

"""
    welch_pgram!(out::AbstractVector, s::AbstractVector, n=div(length(s), 8),
                 noverlap=div(n, 2); onesided=eltype(s)<:Real, nfft=nextfastfft(n),
                 fs=1, window=nothing)

Computes the Welch periodogram of a signal `s`, based on segments with `n` samples with
overlap of `noverlap` samples, and returns a [`Periodogram`](@ref) object. The Power Spectral Density
(PSD) of Welch periodogram is stored in `out`.

`welch_pgram!` by default divides `s` into 8 segments with 50% overlap between them.
For a Bartlett periodogram, set `noverlap=0`.

See [`periodogram`](@ref) for description of optional keyword arguments.

# Examples
```jldoctest
julia> Fs = 100;                     # Sampling frequency

julia> t = (1:Fs)/Fs;                # 100 time samples

julia> x = cos.(2π*25*t);            # Cosine signal with 25Hz frequency

julia> nfft = 512;

julia> y = vec(zeros(1, nfft));

julia> pxx = welch_pgram!(y, x, 10; onesided=false, nfft=nfft, fs=Fs);

julia> y == power(pxx)
true
```
"""
function welch_pgram!(output::AbstractVector, s::AbstractVector, n::Int=length(s)>>3, noverlap::Int=n>>1;
                      kwargs...)
    welch_pgram!(output, s, WelchConfig(s; n, noverlap, kwargs...))
end

"""
    welch_pgram(s::AbstractVector, config::WelchConfig)

Computes the Welch periodogram of the given signal `s` using a predefined [`WelchConfig`](@ref) object.

# Examples
```jldoctest
julia> x = rect(10; padding=20);

julia> wconfig = WelchConfig(x; fs=1000, window=hamming);

julia> welch_pgram(x, wconfig);
```
"""
function welch_pgram(s::AbstractVector{T}, config::WelchConfig) where T<:Number
    out = Vector{fftabs2type(T)}(undef, config.onesided ? (config.nfft >> 1)+1 : config.nfft)
    return welch_pgram_helper!(out, s, config)
end

"""
    welch_pgram!(out::AbstractVector, s::AbstractVector, config::WelchConfig)

Computes the Welch periodogram of the given signal `s`, using a predefined
[`WelchConfig`](@ref) object. The Power Spectral Density (PSD) of Welch
periodogram is stored in `out`.

# Examples
```jldoctest
julia> Fs = 100;                     # Sampling frequency

julia> t = (1:Fs)/Fs;                # 100 time samples

julia> x = cos.(2π*25*t);            # Cosine signal with 25Hz frequency

julia> nfft = 512;

julia> y = vec(zeros(1, nfft));

julia> wconfig = WelchConfig(x; n=10, onesided=false, nfft=nfft, fs=Fs, window=hamming);

julia> pxx = welch_pgram!(y, x, wconfig);

julia> y == power(pxx)
true
```
"""
function welch_pgram!(out::AbstractVector, s::AbstractVector{T}, config::WelchConfig) where {T<:Number}
    if length(out) != length(config.freq)
        throw(DimensionMismatch(lazy"""Expected `output` to be of length `length(config.freq)`;
            got `length(output)` = $(length(out)) and `length(config.freq)` = $(length(config.freq))"""))
    elseif eltype(out) != fftabs2type(T)
        throw(ArgumentError(lazy"Eltype of output ($(eltype(out))) doesn't match the expected type: $(fftabs2type(T))."))
    elseif float(T) != eltype(config.inbuf)
        throw(ArgumentError(lazy"float(eltype(s)) = $T doesn't match the eltype of the input buffer: $(eltype(config.inbuf))."))
    end
    welch_pgram_helper!(out, s, config)
end

function welch_pgram_helper!(out::AbstractVector, s::AbstractVector, config::WelchConfig)
    fill!(out, 0)
    sig_split = arraysplit(s, config.nsamples, config.noverlap, config.nfft, config.window;
                           buffer=config.inbuf)

    r = length(sig_split) * config.r

    for sig in sig_split
        mul!(config.outbuf, config.plan, sig)
        fft2pow!(out, config.outbuf, config.nfft, r, config.onesided)
    end

    Periodogram(out, config.freq)
end

## SPECTROGRAM

const Float64Range = typeof(range(0.0, step=1.0, length=2))
"""
    Spectrogram{T, F<:Union{Frequencies,AbstractRange}, M<:AbstractMatrix{T}} <: TFR{T}

A Spectrogram object with fields:
- `power::M`
- `freq::F`
- `time::Float64Range`
See [`power`](@ref), [`freq`](@ref) and [`time`](@ref) for further details.
"""
struct Spectrogram{T,F<:Union{Frequencies,AbstractRange}, M<:AbstractMatrix{T}} <: TFR{T}
    power::M
    freq::F
    time::Float64Range
end
FFTW.fftshift(p::Spectrogram{T,<:Frequencies} where T) =
    Spectrogram(p.freq.n_nonnegative == p.freq.n ? p.power : fftshift(p.power, 1), fftshift(p.freq), p.time)
FFTW.fftshift(p::Spectrogram{T,<:AbstractRange} where T) = p

"""
    time(p)

Returns the time bin centers for a given [`Spectrogram`](@ref) object.

# Examples
```jldoctest
julia> time(spectrogram(0:1/20:1; fs=8000))
0.000125:0.000125:0.0025
```
"""
Base.time(p::Spectrogram) = p.time

"""
    spectrogram(s, n=div(length(s), 8), noverlap=div(n, 2); onesided=eltype(s)<:Real, nfft=nextfastfft(n), fs=1, window=nothing)

Computes the spectrogram of a signal `s` based on segments with `n` samples
with overlap of `noverlap` samples, and returns a [`Spectrogram`](@ref) object.

`spectrogram` by default divides `s` into 8 segments with 50% overlap between them.
See [`periodogram`](@ref) for description of optional keyword arguments.

The returned [`Spectrogram`](@ref) object stores the 3 computed fields: power, freq and time. See [`power`](@ref),
[`freq`](@ref) and [`time`](@ref) for further details.

# Examples
```jldoctest
julia> Fs = 1000;

julia> t = 0:1/Fs:1-1/Fs;

julia> x = sin.(2π*100*t.*t);

julia> spec = spectrogram(x; fs=Fs);

julia> size(power(spec))
(63, 14)

julia> size(freq(spec))
(63,)

julia> time(spec)
0.0625:0.063:0.8815
```

"""
function spectrogram(s::AbstractVector{T}, n::Int=length(s)>>3, noverlap::Int=n>>1;
                     onesided::Bool=T<:Real,
                     nfft::Int=nextfastfft(n), fs::Real=1,
                     window::Union{Function,AbstractVector,Nothing}=nothing) where T

    out = stft(s, n, noverlap, PSDOnly(); onesided, nfft, fs, window)
    Spectrogram(out, onesided ? rfftfreq(nfft, fs) : fftfreq(nfft, fs),
                (n/2 : n-noverlap : (size(out,2)-1)*(n-noverlap)+n/2) / fs)

end

struct PSDOnly end
stfttype(T::Type, ::PSDOnly) = fftabs2type(T)
stfttype(T::Type, ::Nothing) = fftouttype(T)

"""
    stft(s, n=div(length(s), 8), noverlap=div(n, 2); onesided=eltype(s)<:Real, nfft=nextfastfft(n), fs=1, window=nothing)

Computes the Short Time Fourier Transform (STFT) of a signal `s` based on segments with
`n` samples with overlap of `noverlap` samples, and returns a matrix containing the STFT
coefficients.

`stft` by default divides `s` into 8 segments with 50% overlap between them. See [`periodogram`](@ref)
for description of optional keyword arguments.

The STFT computes the DFT over `K` sliding windows (segments) of the signal `s`. This returns a `J` x `K` matrix where
`J` is the number of DFT coefficients and `K` the number of windowed segments. The `k`th column of the returned matrix
contains the DFT coefficients for the `k`th segment.

# Examples
```jldoctest
julia> Fs = 1000;

julia> t = 0:1/Fs:5-1/Fs;

julia> x = sin.(2π*t.*t);

julia> size(stft(x; window=hamming))
(313, 14)

julia> size(stft(x, 500, 250; onesided=false, window=hanning))
(500, 19)
```
"""
function stft(s::AbstractVector{T}, n::Int=length(s)>>3, noverlap::Int=n>>1,
              psdonly::Union{Nothing,PSDOnly}=nothing;
              onesided::Bool=T<:Real, nfft::Int=nextfastfft(n), fs::Real=1,
              window::Union{Function,AbstractVector,Nothing}=nothing) where T
    onesided && T <: Complex && throw(ArgumentError("cannot compute one-sided FFT of a complex signal"))

    win, norm2 = compute_window(window, n)
    sig_split = arraysplit(s, n, noverlap, nfft, win)
    nout = onesided ? (nfft >> 1)+1 : nfft
    out = zeros(stfttype(T, psdonly), (nout, length(sig_split)))
    tmp = Vector{fftouttype(T)}(undef, T<:Real ? (nfft >> 1)+1 : nfft)
    r = fs*norm2

    plan = forward_plan(sig_split.buf, tmp)
    offset = 0
    for sig in sig_split
        mul!(tmp, plan, sig)
        if isa(psdonly, PSDOnly)
            fft2pow!(out, tmp, nfft, r, onesided, offset)
        else
            fft2oneortwosided!(out, tmp, nfft, onesided, offset)
        end
        offset += nout
    end
    out
end

include("multitaper.jl")

end # end module definition

using DSP, Test

# Naive rational resampler
function naivefilt(h::Vector, x::Vector{T}, resamplerate::Union{Integer, Rational}=1) where T

    upfactor     = numerator(resamplerate)
    downfactor   = denominator(resamplerate)
    xLen         = length(x)
    xZeroStuffed = zeros(T, xLen * upfactor)

    for n in 0:xLen-1
        xZeroStuffed[n*upfactor+1] = x[n+1]
    end

    y = filt(h, one(T), xZeroStuffed)
    return y[1:downfactor:length(y)]
end


# Naive arbitrary resampler
function naivefilt(h::Vector, x::Vector, resamplerate::AbstractFloat, numfilters::Integer=32)
    xLen          = length(x)
    xInterpolated = naivefilt(h, x, numfilters//1)
    xLen          = length(xInterpolated)
    yLen          = ceil(Int, xLen * resamplerate)
    y             = similar(x, yLen)
    yIdx          = 1
    xIdx          = 1
    α             = 0.0
    (δ, ϕStride)  = modf(numfilters/resamplerate)
    ϕStride       = convert(Int, ϕStride)

    while xIdx < xLen
        yLower  = xInterpolated[xIdx]
        yUpper  = xInterpolated[xIdx+1]
        y[yIdx] = yLower + α*(yUpper - yLower)
        yIdx   += 1
        α      += δ
        xIdx   += floor(Int, α) + ϕStride
        α       = mod(α, 1.0)
    end

    resize!(y, yIdx-1)

    return y
end

# Disable time and printf macros when not running interactively ( for travis )
if isinteractive()
    macro timeifinteractive(ex)
        :(@time $(esc(ex)))
    end

    using Printf: @printf

    macro printfifinteractive(s, args...)
        :(@printf($s, $(map(esc, args)...)))
    end
else
    macro timeifinteractive(ex)
        esc(ex)
    end

    macro printfifinteractive(args...)
    end
end


#
# Single rate filtering
#

function test_singlerate(h::AbstractVector{T}, x::AbstractVector) where T
    xLen       = length(x)
    hLen       = length(h)
    pivotPoint = min(rand(50:150), xLen ÷ 4)
    x1         = x[1:pivotPoint]
    x2         = x[pivotPoint+1:end]

    @printfifinteractive( """\n\n
        ____ _ _  _ ____ _    ____    ____ ____ ___ ____
        [__  | |\\ | | __ |    |___    |__/ |__|  |  |___
        ___] | | \\| |__] |___ |___    |  \\ |  |  |  |___\n\n""" )
    @printfifinteractive( "Testing single-rate filtering, h::%s, x::%s. xLen = %d, hLen = %d\n", typeof(h), typeof(x), xLen, hLen )

    @printfifinteractive( "\n\tfilt\n\t\t")
    @timeifinteractive naiveResult = filt(h, one(T), x)

    @printfifinteractive( "\n\tfilt( h, x, 1//1 )\n\t\t" )
    @timeifinteractive statelessResult = filt(h, x)
    @test naiveResult ≈ statelessResult

    @printfifinteractive( "\n\tfilt. length(x1) = %d, length(x2) = %d\n\t\t", length(x1), length(x2) )
    myfilt = FIRFilter(h, 1//1)
    @timeifinteractive begin
        y1 = filt(myfilt, x1)
        y2 = filt(myfilt, x2)
    end
    statefulResult = [y1; y2]
    @test naiveResult ≈ statefulResult

    @printfifinteractive( "\n\tfilt filt. Piecewise for first %d inputs\n\t\t", length(x1) )
    reset!(myfilt)
    @timeifinteractive begin
        one_buffer = similar(x1, 1)
        for (i, p) in enumerate(x1)
            y1[i] = filt(myfilt, setindex!(one_buffer, p, 1))[1]
        end
        y2 = filt(myfilt, x2)
    end
    piecewiseResult = [y1; y2]
    @test naiveResult ≈ piecewiseResult

    reset!(myfilt)
    @test inputlength(myfilt, length(piecewiseResult)) == xLen
end


#
# Decimation
#

function test_decimation(h, x, decimation::Integer)
    xLen       = length(x)
    hLen       = length(h)
    pivotPoint = min(rand(50:150), xLen ÷ 4)
    x1         = x[1:pivotPoint]
    x2         = x[pivotPoint+1:end]

    @printfifinteractive( """\n\n
        ___  ____ ____ _ _  _ ____ ___ _ ____ _  _
        |  \\ |___ |    | |\\/| |__|  |  | |  | |\\ |
        |__/ |___ |___ | |  | |  |  |  | |__| | \\|\n\n""" )
    @printfifinteractive( "Testing decimation. h::%s, x::%s. xLen = %d, hLen = %d, decimation = %d\n", typeof(h), typeof(x), xLen, hLen, decimation )

    @printfifinteractive( "\n\tNaive decimation\n\t\t")
    @timeifinteractive naiveResult = naivefilt(h, x, 1//decimation)

    @printfifinteractive( "\n\tfilt( h, x, 1//%d)\n\t\t", decimation )
    @timeifinteractive statelessResult = filt(h, x, 1//decimation)
    @test naiveResult ≈ statelessResult

    @printfifinteractive( "\n\tfilt decimation. length(x1) = %d, length(x2) = %d\n\t\t", length(x1), length(x2) )
    myfilt = FIRFilter(h, 1//decimation)
    @timeifinteractive begin
        y1 = filt(myfilt, x1)
        y2 = filt(myfilt, x2)
    end
    statefulResult = [y1; y2]
    @test naiveResult ≈ statefulResult

    @printfifinteractive( "\n\tfilt decimation. Piecewise for first %d inputs.\n\t\t", length(x1) )
    reset!(myfilt)
    y1 = similar(x, 0)
    @timeifinteractive begin
        one_buffer = similar(x1, 1)
        for p in x1
            append!(y1, filt(myfilt, setindex!(one_buffer, p, 1)))
        end
        y2 = filt(myfilt, x2)
    end
    piecewiseResult = [y1; y2]
    @test ≈(naiveResult, piecewiseResult, atol=sqrt(eps(real(one(eltype(x))))))

    reset!(myfilt)
    @test inputlength(myfilt, length(piecewiseResult)) == xLen
end


#
# Interpolation
#

function test_interpolation(h::AbstractVector{T}, x::AbstractVector{V}, interpolation::Integer) where {T,V}
    xLen = length(x)
    hLen       = length(h)
    pivotPoint = min(rand(50:150), xLen ÷ 4)
    x1         = x[1:pivotPoint]
    x2         = x[pivotPoint+1:end]

    @printfifinteractive( """\n\n
        _ _  _ ___ ____ ____ ___  ____ _   ____ ___ _ ____ _  _
        | |\\ |  |  |___ |__/ |__] |  | |   |__|  |  | |  | |\\ |
        | | \\|  |  |___ |  \\ |    |__| |__ |  |  |  | |__| | \\|\n\n""")
    @printfifinteractive( "Testing interpolation, h::%s, x::%s. xLen = %d, hLen = %d, interpolation = %d\n", typeof(h), typeof(x), xLen, hLen, interpolation )

    @printfifinteractive( "\n\tNaive interpolation with filt\n\t\t")
    @timeifinteractive begin
        xZeroStuffed = zeros(V, xLen * interpolation)
        for n = 0:xLen-1
            xZeroStuffed[n*interpolation+1] = x[n+1]
        end
        naiveResult = filt(h, one(T), xZeroStuffed)
    end

    @printfifinteractive( "\n\tfilt( h, x, %d//1 )\n\t\t", interpolation )
    @timeifinteractive statelessResult = filt(h, x, interpolation//1)
    @test naiveResult ≈ statelessResult

    @printfifinteractive( "\n\tfilt interpolation. length(x1) = %d, length(x2) = %d\n\t\t", length(x1), length(x2) )
    myfilt = FIRFilter(h, interpolation//1)
    @timeifinteractive begin
        y1 = filt(myfilt, x1)
        y2 = filt(myfilt, x2)
    end
    statefulResult = [y1; y2]
    @test naiveResult ≈ statefulResult

    reset!(myfilt)
    @test inputlength(myfilt, length(statefulResult)) == xLen

    @printfifinteractive( "\n\tfilt interpolation. Piecewise for first %d inputs\n\t\t", length(x1) )
    reset!(myfilt)
    y1 = similar(x, 0)
    @timeifinteractive begin
        one_buffer = similar(x1, 1)
        for p in x1
            append!(y1, filt(myfilt, setindex!(one_buffer, p, 1)))
        end
        y2 = filt(myfilt, x2)
    end
    piecewiseResult = [y1; y2]
    @test ≈(naiveResult, piecewiseResult, atol=sqrt(eps(real(one(V)))))
end


#
# Rational resampling
#

function test_rational(h, x, ratio)
    xLen       = length(x)
    hLen       = length(h)
    pivotPoint = min(rand(50:150), xLen ÷ 4)
    x1         = x[1:pivotPoint]
    x2         = x[pivotPoint+1:end]
    upfactor   = numerator(ratio)
    downfactor = denominator(ratio)
    resultType = promote_type(eltype(h), eltype(x))

    @printfifinteractive( """\n\n
              ____ ____ ___ _ ____ _  _ ____ _
              |__/ |__|  |  | |  | |\\ | |__| |
              |  \\ |  |  |  | |__| | \\| |  | |___

        ____ ____ ____ ____ _  _ ___  _    _ _  _ ____
        |__/ |___ [__  |__| |\\/| |__] |    | |\\ | | __
        |  \\ |___ ___] |  | |  | |    |___ | | \\| |__]\n\n""")
    @printfifinteractive( "Testing rational resampling, h::%s, x::%s. xLen = %d, hLen = %d, ratio = %d//%d\n", typeof(h), typeof(x), xLen, hLen, upfactor, downfactor )

    @printfifinteractive( "\n\tNaive rational resampling\n\t\t")
    @timeifinteractive naiveResult = naivefilt(h, x, ratio)

    @printfifinteractive( "\n\tfilt( h, x, %d//%d )\n\t\t", upfactor, downfactor )
    @timeifinteractive statelessResult = filt(h, x, ratio)
    @test naiveResult ≈ statelessResult

    @printfifinteractive( "\n\tfilt rational resampling. length(x1) = %d, length(x2) = %d\n\t\t", length(x1), length(x2) )
    myfilt = FIRFilter(h, ratio)
    @timeifinteractive begin
        s1 = filt(myfilt, x1)
        s2 = filt(myfilt, x2)
    end
    statefulResult = [s1; s2]
    @test naiveResult ≈ statefulResult

    @printfifinteractive( "\n\tfilt rational. Piecewise for all %d inputs\n\t\t", length( x ) )
    reset!(myfilt)
    y1 = similar(x, 0)
    @timeifinteractive begin
        one_buffer = similar(x1, 1)
        for p in x
            append!(y1, filt(myfilt, setindex!(one_buffer, p, 1)))
        end
    end
    piecewiseResult = y1
    @test naiveResult ≈ piecewiseResult

    reset!(myfilt)
    @test inputlength(myfilt, length(piecewiseResult)) == xLen
end


#
# Arbitrary resampling
#

function test_arbitrary(Th, x, resampleRate, numFilters::Integer)
    cutoffFreq      = 0.45
    transitionWidth = 0.05
    h               = digitalfilter(Lowpass(cutoffFreq), FIRWindow(transitionwidth=transitionWidth/numFilters); fs=numFilters) .* numFilters
    h               = convert(Vector{Th}, h)
    myfilt          = FIRFilter(h, resampleRate, numFilters)
    xLen            = length(x)

    @printfifinteractive("""\n\n
        ____ ____ ___      ____ ____ ____ ____ _  _ ___  _    _ _  _ ____
        |__| |__/ |__]     |__/ |___ [__  |__| |\\/| |__] |    | |\\ | | __
        |  | |  \\ |__] .   |  \\ |___ ___] |  | |  | |    |___ | | \\| |__]\n\n""")
    @printfifinteractive( "h::%s, x::%s, rate = %f, Nϕ = %d, xLen = %d\n", typeof(h), typeof(x), resampleRate, numFilters, xLen )

    @printfifinteractive( "\n\tNaive arbitrary resampling\n\t\t" )
    @timeifinteractive naiveResult = naivefilt(h, x, resampleRate, numFilters)

    @printfifinteractive( "\n\tStateless arbitrary resampling\n\t\t" )
    @timeifinteractive statelessResult = filt(h, x, resampleRate, numFilters)

    @printfifinteractive( "\n\tStateful arbitrary resampling\n\t\t" )
    @timeifinteractive statefulResult = filt(myfilt, x)

    # reset!(myfilt)
    # TODO: figure out why this fails
    # @test inputlength(myfilt, length(statefulResult)) == xLen

    @printfifinteractive( "\n\tPiecewise arbitrary resampling\n\t\t" )
    reset!(myfilt)
    piecewiseResult = similar(x, 0)
    sizehint!(piecewiseResult, ceil(Int, length(x)*resampleRate))
    one_buffer = similar(x, 1)
    @timeifinteractive for p in x
        thisY = filt(myfilt, setindex!(one_buffer, p, 1))
        append!(piecewiseResult, thisY)
    end

    results = (naiveResult, statelessResult, statefulResult, piecewiseResult)
    commonLen = minimum(length, results)
    foreach(x -> resize!(x, commonLen), results)

    @test naiveResult ≈ statelessResult
    @test naiveResult ≈ statefulResult
    @test naiveResult ≈ piecewiseResult
end

#
# Run the tests
#

@testset "interp.=$interpolation, dec.=$decimation, Th=$Th, Tx=$Tx" for interpolation in [1, 5, 14, 23],
            decimation in [1, 9, 17, 21],
                Th in [Float32, Float64],
                    Tx in [Float32, Float64, ComplexF32, ComplexF64]

    h     = rand(Th, rand(16:128))
    xLen  = rand(200:300)
    xLen  = xLen-mod(xLen, decimation)
    x     = rand(Tx, xLen)
    ratio = interpolation//decimation
    if isone(ratio)
        test_singlerate(h, x)
    elseif numerator(ratio) == interpolation
        test_rational(h, x, ratio)
        if Tx in (Float32, ComplexF32)
            test_arbitrary(Th, x, convert(Float64, ratio) + rand(), 32)
        end
    end
    if decimation != 1
        test_decimation(h, x, decimation)
    else
        test_rational(h, x, interpolation)
    end
    if interpolation != 1
        test_interpolation(h, x, interpolation)
    end
end

@testset "pathological cases: setphase! and outputlength" begin
    # PR #596
    @test resample(1:2, 3, [zeros(2); 1; zeros(3)]) == [1, 0, 0, 2, 0, 0]
    @test resample(1:2, 3//2, [zeros(2); 1; zeros(3)]) == [1, 0, 0]
    # PR #593
    let H = FIRFilter(2.22)
        setphase!(H, 0.99)
        @test length(filt(H, 1:2)) == 3
    end
    let H = FIRFilter(122.2)
        setphase!(H, 0.99)
        @test length(filt(H, 1:2)) == 124
    end
end

@testset "FIRArbitrary exceptions" begin
    @test_throws ArgumentError FIRFilter(rand(10), 1e-13, 1000)
    @test_throws DomainError FIRFilter(rand(10), 1.1, -1)
    @test_throws DomainError setphase!(FIRFilter(rand(10), 1.1, 1), -1.0)
    @test_throws DomainError setphase!(FIRFilter(rand(10), 1.1, 1), nextfloat(maxintfloat()))
end

using DSP, FFTW, Test
using Statistics: mean
using DSP: allocate_output

!(@__DIR__() in LOAD_PATH) && push!(LOAD_PATH, @__DIR__)
using FilterTestHelpers

const epsilon = 10^-3

@testset "Configuration objects" begin
    @test_throws ArgumentError MTConfig{Float64}(100; nfft = 99)
    @test_throws ArgumentError MTConfig{Float64}(100; fs=-1)
    @test_throws DimensionMismatch MTConfig{Float64}(100; window = rand(1, 200))
    @test_throws ArgumentError MTConfig{Complex{Float64}}(100; onesided=true)

    @testset "`MTSpectrogramConfig` with `n_samples`=$(n_samples), `n_samples_per_window`=$(n_samples_per_window), `n_overlap`=$(n_overlap) " for n_samples in (20:20:100), n_samples_per_window in (20:20:100), n_overlap in (0:20:(n_samples_per_window-1))
        config = MTSpectrogramConfig{Float64}(n_samples, n_samples_per_window, n_overlap)
        @test length(config.time) == length(arraysplit(1:n_samples, n_samples_per_window, n_overlap))
    end

    @testset "`MTConfig` inner constructor errors" begin
        n_samples = 100
        nfft = 200
        ntapers = 5
        fs = 1
        window = rand(n_samples, ntapers)
        for T in (Float32, Float64, Complex{Float32}, Complex{Float64})
            fft_input_tmp = Vector{T}(undef, nfft)
            onesided = T <: Real
            fft_flags = FFTW.ESTIMATE
            freqs = onesided ? rfftfreq(nfft, fs) : fftfreq(nfft, fs)
            fft_output_tmp = Vector{fftouttype(T)}(undef, length(freqs))
            r = fs*ntapers*ones(ntapers)
            plan = onesided ? plan_rfft(fft_input_tmp; flags=fft_flags) :
                plan_fft(fft_input_tmp; flags=fft_flags)
            # Test that the current configuration is valid so we know if it errors later
            # it's because we changed it, not that it was always broken
            @test MTConfig{T}(n_samples, nfft, ntapers, freqs, fs, plan, fft_input_tmp, fft_output_tmp, window, onesided, r) isa MTConfig
            # now do a series of changes (in let-blocks to introduce new local bindings)
            # and check that they are each invalid
            let n_samples = 201
                @test_throws ArgumentError MTConfig{T}(n_samples, nfft, ntapers, freqs, fs, plan, fft_input_tmp, fft_output_tmp, window, onesided, r)
            end
            let n_samples = -1
                @test_throws ArgumentError MTConfig{T}(n_samples, nfft, ntapers, freqs, fs, plan, fft_input_tmp, fft_output_tmp, window, onesided, r)
            end
            let ntapers = -1
                @test_throws ArgumentError MTConfig{T}(n_samples, nfft, ntapers, freqs, fs, plan, fft_input_tmp, fft_output_tmp, window, onesided, r)
            end
            let fs = -1
                @test_throws ArgumentError MTConfig{T}(n_samples, nfft, ntapers, freqs, fs, plan, fft_input_tmp, fft_output_tmp, window, onesided, r)
            end
            let fft_input_tmp = Vector{T}(undef, 2*nfft)
                @test_throws DimensionMismatch MTConfig{T}(n_samples, nfft, ntapers, freqs, fs, plan, fft_input_tmp, fft_output_tmp, window, onesided, r)
            end
            let nfft = 2*nfft, fft_input_tmp = Vector{T}(undef, 2*nfft)
                @test_throws DimensionMismatch MTConfig{T}(n_samples, nfft, ntapers, freqs, fs, plan, fft_input_tmp, fft_output_tmp, window, onesided, r)
            end
            let window = rand(2*ntapers, n_samples)
                @test_throws DimensionMismatch MTConfig{T}(n_samples, nfft, ntapers, freqs, fs, plan, fft_input_tmp, fft_output_tmp, window, onesided, r)
            end
            let r = 1.0
                @test_throws DimensionMismatch MTConfig{T}(n_samples, nfft, ntapers, freqs, fs, plan, fft_input_tmp, fft_output_tmp, window, onesided, r)
            end
            if T <: Complex
                let onesided=true, freqs=rfftfreq(nfft, fs), fft_output_tmp=Vector{fftouttype(T)}(undef, length(freqs)), plan=plan_fft(fft_input_tmp; flags=fft_flags)
                    @test_throws ArgumentError MTConfig{T}(n_samples, nfft, ntapers, freqs, fs, plan, fft_input_tmp, fft_output_tmp, window, onesided, r)
                end
            end
            # let's check that our original config is still valid, meaning we haven't
            # accidentally broken the config by not properly scoping our changes
            # (and therefore invalidating the tests that follow).
            @test MTConfig{T}(n_samples, nfft, ntapers, freqs, fs, plan, fft_input_tmp, fft_output_tmp, window, onesided, r) isa MTConfig
        end
    end

end

@testset "`dpss_config`" begin
    dpss_config = DSP.Periodograms.dpss_config(Float64, 1024; keep_only_large_evals=false, weight_by_evals=false)
    mt_config = MTConfig{Float64}(1024)

    @test dpss_config.window ≈ mt_config.window
    @test dpss_config.ntapers == mt_config.ntapers
    @test dpss_config.r ≈ mt_config.r

    dpss_config = DSP.Periodograms.dpss_config(Float64, 1024; keep_only_large_evals=false, weight_by_evals=true)
    @test dpss_config.window ≈ mt_config.window
    @test dpss_config.ntapers == mt_config.ntapers
    # should be different since we're weighting by eigenvalues now
    @test sum(abs, dpss_config.r - mt_config.r) > 0.1
end

avg_coh(x) = dropdims(mean(coherence(x); dims=3); dims=3)

@testset "Coherence (synthetic data)" begin
    fs = 1000.0
    n_samples = 1024
    t = (0:1023) ./ fs
    freq_range = (10, 15)
    sin_1 = sinpi.(2 * 12.0 * t)  # 12 Hz sinusoid signal
    sin_2 = sinpi.(2 * 12.0 * t .+ 1)
    noise = rand(1024) * 2 .- 1

    T = Float64
    same_signal = Matrix{T}(undef, 2, n_samples)
    same_signal[1, :] = sin_1
    same_signal[2, :] = sin_1
    coh = avg_coh(mt_coherence(same_signal; demean=true, fs, freq_range))
    same_signal_coherence = coh[2, 1]

    # test in-place gets the same result
    config = MTCoherenceConfig{T}(size(same_signal)...; demean=true, fs, freq_range)
    out = allocate_output(config)
    coh2 = avg_coh(mt_coherence!(out, same_signal, config))
    @test coh ≈ coh2

    # check that the output object has the right frequency information and properties
    coh_object = mt_coherence!(out, same_signal, config)
    @test freq(coh_object) == coh_object.freq == config.cs_config.freq
    @test all(x -> 10 <= x <= 15, freq(coh_object))
    # Check symmetries
    for i in 1:2, j in 1:2, f in eachindex(freq(coh_object))
        @test coherence(coh_object)[i, j, f] == coherence(coh_object)[j, i, f]
        if i == j
            @test coherence(coh_object)[i,j, f] == 1
        end
    end

    # check that manually demeaning with `demean=false` gives the same result
    same_signal_demeaned = same_signal .- mean(same_signal; dims = 2)
    coh3 = avg_coh(mt_coherence(same_signal_demeaned; demean = false))
    @test coh3 ≈ coh2


    @test_throws DimensionMismatch mt_coherence!(zeros(size(out,1), 2*size(out, 2), size(out, 3)), same_signal, config)
    @test_throws DimensionMismatch mt_coherence!(out, vcat(same_signal, same_signal), config)


    @test abs(same_signal_coherence - 1) < epsilon

    phase_shift = Matrix{T}(undef, 2, n_samples)
    phase_shift[1, :] = sin_1
    phase_shift[2, :] = sin_2
    coh = avg_coh(mt_coherence(phase_shift; fs, freq_range))
    phase_shift_coherence = coh[2,1]
    @test abs(phase_shift_coherence - 1) < epsilon
    @test coh[1,1] ≈ 1
    @test coh[2,2] ≈ 1

    # test in-place gets the same result
    config = MTCoherenceConfig{T}(size(phase_shift)...; fs, freq_range)
    out = allocate_output(config)
    coh2 = avg_coh(mt_coherence!(out, phase_shift, config))
    @test coh ≈ coh2

    # test out-of-place with config the same result
    config = MTCoherenceConfig{T}(size(phase_shift)...; fs, freq_range)
    coh3 = avg_coh(mt_coherence(phase_shift, config))
    @test coh ≈ coh3

    # test in-place without config the same result
    coh4 = avg_coh(mt_coherence!(out, phase_shift; fs, freq_range))
    @test coh ≈ coh4

    # Construct the config via an `MTConfig`
    mt_config = MTConfig{T}(size(phase_shift, 2); fs)
    config = MTCoherenceConfig(size(phase_shift, 1), mt_config; freq_range)
    coh5 = avg_coh(mt_coherence(phase_shift, config))
    @test coh ≈ coh5
    # test that including type parameter produces the same result
    config = @test_nowarn MTCoherenceConfig{T}(size(phase_shift, 1), mt_config; freq_range)
    cohT = avg_coh(mt_coherence(phase_shift, config))
    @test coh5 == cohT

    # Construct the config via an `MTCrossSpectraConfig`
    cs_config = MTCrossSpectraConfig(size(phase_shift, 1), mt_config; freq_range)
    # also test with type parameter
    config, configT = MTCoherenceConfig(cs_config), MTCoherenceConfig{T}(cs_config)
    coh5, cohT = avg_coh.(mt_coherence.((phase_shift,), (config, configT)))
    @test coh ≈ coh5 == cohT

    different_signal = Matrix{T}(undef, 2, n_samples)
    different_signal[1, :] = sin_1
    different_signal[2, :] = noise
    coh = avg_coh(mt_coherence(different_signal; fs, freq_range))
    different_signal_coherence = coh[2,1]
    # .8 is arbitrary, but represents a high coherence, so if a sine wave is
    # that coherent with noise, there is a problem
    @test different_signal_coherence < 0.8

    # test in-place gets the same result
    config = MTCoherenceConfig{T}(size(different_signal)...; fs, freq_range)
    out = allocate_output(config)
    coh2 = avg_coh(mt_coherence!(out, different_signal, config))
    @test coh ≈ coh2

    less_noisy = Matrix{T}(undef, 2, n_samples)
    less_noisy[1, :] = sin_1
    less_noisy[2, :] .= sin_1 .+ noise
    coh = avg_coh(mt_coherence(less_noisy; fs, freq_range))
    less_noisy_coherence = coh[2, 1]

    # test in-place gets the same result
    config = MTCoherenceConfig{T}(size(less_noisy)...; fs, freq_range)
    out = allocate_output(config)
    coh2 = avg_coh(mt_coherence!(out, less_noisy, config))
    @test coh ≈ coh2

    more_noisy = Matrix{T}(undef, 2, n_samples)
    more_noisy[1, :] = sin_1
    more_noisy[2, :] .= sin_1 .+ 3 * noise
    coh = avg_coh(mt_coherence(more_noisy; fs, freq_range))
    more_noisy_coherence = coh[2, 1]
    @test less_noisy_coherence < same_signal_coherence
    @test more_noisy_coherence < less_noisy_coherence
    @test different_signal_coherence < more_noisy_coherence

    # test in-place gets the same result
    config = MTCoherenceConfig{T}(size(more_noisy)...; fs, freq_range)
    out = allocate_output(config)
    coh2 = avg_coh(mt_coherence!(out, more_noisy, config))
    @test coh ≈ coh2

    several_signals = Matrix{T}(undef, 3, n_samples)
    several_signals[1, :] = sin_1
    several_signals[2, :] = sin_2
    several_signals[3, :] = noise
    several_signals_coherences = avg_coh(mt_coherence(several_signals; fs, freq_range))
    @test length(several_signals_coherences) == 9
    @test several_signals_coherences[2, 1] ≈ phase_shift_coherence
    @test several_signals_coherences[3, 1] ≈ different_signal_coherence

    # test in-place gets the same result
    config = MTCoherenceConfig{T}(size(several_signals)...; fs, freq_range)
    out = allocate_output(config)
    @test eltype(out) == Float64
    coh2 = avg_coh(mt_coherence!(out, several_signals, config))
    @test coh2 ≈ several_signals_coherences

    T = Float32
    # Float32 output:
    config = MTCoherenceConfig{T}(size(several_signals)...; fs, freq_range)
    out = allocate_output(config)
    @test eltype(out) == Float32
    coh3 = avg_coh(mt_coherence!(out, several_signals, config))
    @test coh3 ≈ several_signals_coherences

    # Float32 input and output:
    coh4 = avg_coh(mt_coherence!(out, Float32.(several_signals), config))
    @test coh4 ≈ several_signals_coherences
end

@testset "`mt_coherence` reference test" begin
    fs = 1000.0
    n_samples = 1024
    t = (0:1023) ./ fs
    sin_1 = sinpi.(2 * 12.0 * t)  # 12 Hz sinusoid signal
    sin_2 = sinpi.(2 * 12.0 * t .+ 1)
    noise = vec(read_reference_data("noise.txt", '\n')) # generated by `rand(1024) * 2 .- 1`
    more_noisy = Array{Float64,3}(undef, 1, 2, n_samples)
    more_noisy[1, 1, :] = sin_1
    more_noisy[1, 2, :] .= sin_1 .+ 3 * noise

    ## to generate the reference result:
    # using PyMNE
    # mne_coherence_matrix, _ = PyMNE.connectivity.spectral_connectivity(more_noisy, method="coh",sfreq=fs,mode="multitaper",fmin=10,fmax=15,verbose=false)
    # coh = dropdims(mean(mne_coherence_matrix; dims=3); dims=3)[2, 1]
    coh = 0.982356762670818

    mt_config = DSP.Periodograms.dpss_config(Float64, n_samples; fs, keep_only_large_evals=true, weight_by_evals=true)
    config = MTCoherenceConfig(2, mt_config; freq_range = (10,15), demean=true)
    result = avg_coh(mt_coherence(dropdims(more_noisy;dims=1), config))
    @test result[2, 1] ≈ coh
end

@testset "`mt_cross_power_spectra`" begin
    fs = 1000.0
    n_samples = 1024
    t = (0:1023) ./ fs
    data = Array{Float64, 3}(undef, 1, 2, n_samples)
    data[1, 1, :] = sinpi.(2 * 12.0 * t) # 12 Hz sinusoid signal
    data[1, 2, :] = sinpi.(2 * 12.0 * t .+ 1)
    ## Script to generate reference data:
    # using PyMNE, DelimitedFiles
    # result = PyMNE.time_frequency.csd_array_multitaper(data, fs, n_fft = nextpow(2, n_samples), low_bias=true, adaptive=false)
    # csd_array_multitaper_frequencies = result.frequencies
    # csd_array_multitaper_values = reduce((x,y) -> cat(x,y; dims=3), [ r.get_data() for r in result])
    # writedlm("data/csd_array_multitaper_frequencies.txt", csd_array_multitaper_frequencies)
    # writedlm("data/csd_array_multitaper_values_re.txt", real(csd_array_multitaper_values))
    # writedlm("data/csd_array_multitaper_values_im.txt", imag(csd_array_multitaper_values))
    csd_array_multitaper_frequencies = read_reference_data("csd_array_multitaper_frequencies.txt", '\n')
    csd_array_multitaper_values_re = reshape(read_reference_data("csd_array_multitaper_values_re.txt", '\n'), (2,2,512))
    csd_array_multitaper_values_im = reshape(read_reference_data("csd_array_multitaper_values_im.txt", '\n'), (2,2,512))
    csd_array_multitaper_values = csd_array_multitaper_values_re + im*csd_array_multitaper_values_im

    signal = dropdims(data; dims=1)
    mt_config = DSP.Periodograms.dpss_config(Float64, n_samples; fs, keep_only_large_evals=true, weight_by_evals=true)
    config = MTCrossSpectraConfig(2, mt_config; demean=true)
    result = mt_cross_power_spectra(signal, config)
    @test signal isa Matrix{Float64}
    @test freq(result)[2:end] ≈ csd_array_multitaper_frequencies
    @test power(result)[:,:,2:end] ≈ csd_array_multitaper_values

    # Test in-place. Full precision:
    config = MTCrossSpectraConfig(size(signal, 1), mt_config; demean=true)
    out = allocate_output(config)
    @test eltype(out) == Complex{Float64}
    result2 = mt_cross_power_spectra!(out, signal, config)
    @test freq(result) ≈ freq(result2)
    @test power(result) ≈ power(result2)

    # Float32 output:
    mt_config32 = DSP.Periodograms.dpss_config(Float32, n_samples; fs, keep_only_large_evals=true, weight_by_evals=true)
    config = MTCrossSpectraConfig(size(signal, 1), mt_config32; demean=true)
    out = allocate_output(config)
    @test eltype(out) == Complex{Float32}
    result2 = mt_cross_power_spectra!(out, signal, config)
    @test freq(result2) ≈ freq(result)
    @test power(result2) ≈ power(result)

    # Float32 input and output:
    result3 = mt_cross_power_spectra!(out, Float32.(signal), config)
    @test freq(result3) ≈ freq(result)
    @test power(result3) ≈ power(result)

    @test_throws DimensionMismatch mt_cross_power_spectra!(similar(out, size(out, 1) + 1, size(out, 2), size(out, 3)), signal, config)
    @test_throws DimensionMismatch mt_cross_power_spectra!(out, vcat(signal, signal), config)

end


@testset "`mt_cross_power_spectra` agrees with `mt_pgram`" begin
    fs = 1000.0
    n_samples = 1024
    t = (0:1023) ./ fs
    noise = vec(read_reference_data("noise.txt", '\n'))
    signal = sinpi.(2 * 12.0 * t) .+ 3 * noise
    cs = mt_cross_power_spectra(reshape(signal, 1, :); fs)
    p = mt_pgram(signal; fs)

    @test freq(cs) ≈ freq(p)
    @test dropdims(power(cs); dims=(1,2)) ≈ power(p)

    # out-of-place with config
    config = MTCrossSpectraConfig{Float64}(1, length(signal); fs)
    cs = mt_cross_power_spectra(reshape(signal, 1, :), config)
    @test freq(cs) ≈ freq(p)
    @test dropdims(power(cs); dims=(1,2)) ≈ power(p)

    # in-place without config
    out = allocate_output(config)
    cs = mt_cross_power_spectra!(out, reshape(signal, 1, :); fs)
    @test freq(cs) ≈ freq(p)
    @test dropdims(power(cs); dims=(1,2)) ≈ power(p)

    # rm once two-sided FFTs supported
    @test_throws ArgumentError mt_cross_power_spectra(reshape(complex.(signal), 1, :); fs)
end

module FilterTestHelpers
using DSP, Test, DelimitedFiles

export tffilter_eq, zpkfilter_eq, tffilter_accuracy, zpkfilter_accuracy,
       matrix_to_sosfilter, sosfilter_to_matrix,
       read_reference_data

read_reference_data(s, delim='\t') = readdlm(joinpath(@__DIR__, "data", s), delim)

function lt(a, b)
    if abs(real(a) - real(b)) > 1e-10
        isless(real(a), real(b))
    else
        isless(imag(a), imag(b))
    end
end

function tffilter_eq(f1, f2)
    b1, a1 = (coefb(f1), coefa(f1))
    b2, a2 = (coefb(f2), coefa(f2))
    @test map(Float64, b1) ≈ map(Float64, b2)
    @test map(Float64, a1) ≈ map(Float64, a2)
end

function zpkfilter_eq(f1, f2)
    if !isempty(f1.z) || !isempty(f2.z)
        @test map(ComplexF64, sort(f1.z; lt)) ≈ map(ComplexF64, sort(f2.z; lt))
    end
    @test map(ComplexF64, sort(f1.p; lt)) ≈ map(ComplexF64, sort(f2.p; lt))
    @test map(Float64, f1.k) ≈ map(Float64, f2.k)
end

function zpkfilter_eq(f1, f2, atol)
    if !isempty(f1.z) || !isempty(f2.z)
        @test ≈(map(ComplexF64, sort(f1.z; lt)), map(ComplexF64, sort(f2.z; lt)); atol)
    end
    @test ≈(map(ComplexF64, sort(f1.p; lt)), map(ComplexF64, sort(f2.p; lt)); atol)
    @test ≈(map(Float64, f1.k), map(Float64, f2.k); atol)
end

loss(x::Real, y::Real) = abs(float(x) - float(y))/eps(float(x))
loss(x::Union{Real,Complex}, y::Union{Real,Complex}) = loss(real(x), real(y)) + loss(imag(x), imag(y))
loss(x::AbstractVector, y::AbstractVector) = sum(map(loss, x, y))

function accuracy_check(err1, err2, part, relerr=1)
    try
        @test err1 <= relerr*err2
    catch e
        println("Filter 1 $part error (ULP): ", map(Float64, err1))
        println("Filter 2 $part error (ULP): ", map(Float64, err2))
        println("Ratio: ", map(Float64, err1/err2))
        rethrow(e)
    end
end

function tffilter_accuracy(f1, f2, accurate_f)
    b1, a1 = (coefb(f1), coefa(f1))
    b2, a2 = (coefb(f2), coefa(f2))
    accurate_b, accurate_a = (coefb(accurate_f), coefa(accurate_f))
    accuracy_check(loss(b1, accurate_b), loss(b2, accurate_b), "b")
    accuracy_check(loss(a1, accurate_a), loss(a2, accurate_a), "a")
end

function zpkfilter_accuracy(f1, f2, accurate_f; relerr=1, compare_gain_at=nothing, atol=0.0)
    z1, p1 = sort(f1.z; lt), sort(f1.p; lt)
    z2, p2 = sort(f2.z; lt), sort(f2.p; lt)
    accurate_z, accurate_p = sort(accurate_f.z; lt), sort(accurate_f.p; lt)
    if !isempty(z1) || !isempty(z2) || !isempty(accurate_z)
        @test ≈(z1, accurate_z; atol)
        @test ≈(z2, accurate_z; atol)
        accuracy_check(loss(z1, accurate_z), loss(z2, accurate_z), "z", relerr)
    end
    @test ≈(p1, accurate_p; atol)
    @test ≈(p2, accurate_p; atol)
    @test ≈(f1.k, accurate_f.k; atol)
    @test ≈(f2.k, accurate_f.k; atol)
    accuracy_check(loss(p1, accurate_p), loss(p2, accurate_p), "p", relerr)
    if isnothing(compare_gain_at)
        accuracy_check(loss(f1.k, accurate_f.k), loss(f2.k, accurate_f.k), "k", relerr)
    else
        jω = compare_gain_at*im
        gain1 = Float64(abs(f1.k * prod(Complex{BigFloat}.(z1) .- jω) / prod(Complex{BigFloat}.(p1) .- jω)))
        gain2 = Float64(abs(f2.k * prod(Complex{BigFloat}.(z2) .- jω) / prod(Complex{BigFloat}.(p2) .- jω)))
        accurate_gain = abs(accurate_f.k * prod(Complex{BigFloat}.(accurate_z) .- jω) / prod(Complex{BigFloat}.(accurate_p) .- jω))
        accuracy_check(loss(gain1, accurate_gain), loss(gain2, accurate_gain), "k", relerr)
    end
end

# Convert an SOS matrix, as returned by MATLAB, to an SecondOrderSections
matrix_to_sosfilter(sos::Matrix, g::Number) =
    SecondOrderSections([Biquad(sos[i, 1], sos[i, 2], sos[i, 3],
                            sos[i, 4], sos[i, 5], sos[i, 6])
               for i = 1:size(sos, 1)], g)

# Convert an SecondOrderSections to an SOS matrix as returned by MATLAB
function sosfilter_to_matrix(sos::SecondOrderSections)
    A = ones(length(sos.biquads), 6)
    for (i, biquad) in enumerate(sos.biquads)
        A[i, 1] = biquad.b0
        A[i, 2] = biquad.b1
        A[i, 3] = biquad.b2
        A[i, 5] = biquad.a1
        A[i, 6] = biquad.a2
    end
    A
end

# Show the poles and zeros in each biquad
# This is not currently used for testing, but is useful for debugging
function sosfilter_poles_zeros(sos::SecondOrderSections)
    z = fill(complex(nan(T)), 2, length(sos.biquads))
    p = fill(complex(nan(T)), 2, length(sos.biquads))
    for (i, biquad) in enumerate(sos.biquads)
        zpk = convert(ZeroPoleGain, biquad)
        z[1:length(zpk.z), i] = zpk.z
        p[1:length(zpk.p), i] = zpk.p
    end
    (z, p)
end
end

# Filter types and conversions

using Base: uabs

abstract type FilterCoefficients{Domain} end

Base.convert(::Type{T}, f::FilterCoefficients) where {T<:FilterCoefficients} = T(f)


#
# Zero-pole gain form
#

"""
    ZeroPoleGain(z::Vector, p::Vector, k::Number)

Filter representation in terms of zeros `z`, poles `p`, and
gain `k`:
```math
H(x) = k\\frac{(x - \\verb!z[1]!) \\ldots (x - \\verb!z[m]!)}{(x - \\verb!p[1]!) \\ldots (x - \\verb!p[n]!)}
```
"""
struct ZeroPoleGain{Domain,Z<:Number,P<:Number,K<:Number} <: FilterCoefficients{Domain}
    z::Vector{Z}
    p::Vector{P}
    k::K
end

ZeroPoleGain(f::FilterCoefficients{D}) where {D} = ZeroPoleGain{D}(f)
ZeroPoleGain(z::Vector, p::Vector, k) = ZeroPoleGain{:z}(z, p, k)
ZeroPoleGain{D,Z,P,K}(f::ZeroPoleGain) where {D,Z,P,K} = ZeroPoleGain{D,Z,P,K}(f.z, f.p, f.k)
ZeroPoleGain{D}(f::ZeroPoleGain{D,Z,P,K}) where {D,Z,P,K} = ZeroPoleGain{D,Z,P,K}(f)
ZeroPoleGain{D}(z::Vector{Z}, p::Vector{P}, k::K) where {D,Z<:Number,P<:Number,K<:Number} =
    ZeroPoleGain{D,Z,P,K}(z, p, k)

Base.promote_rule(::Type{ZeroPoleGain{D,Z1,P1,K1}}, ::Type{ZeroPoleGain{D,Z2,P2,K2}}) where {D,Z1,P1,K1,Z2,P2,K2} =
    ZeroPoleGain{D,promote_type(Z1,Z2),promote_type(P1,P2),promote_type(K1,K2)}

*(f::ZeroPoleGain{D}, g::Number) where {D} = ZeroPoleGain{D}(f.z, f.p, f.k * g)
*(g::Number, f::ZeroPoleGain{D}) where {D} = ZeroPoleGain{D}(f.z, f.p, f.k * g)
*(f1::ZeroPoleGain{D}, f2::ZeroPoleGain{D}) where {D} =
    ZeroPoleGain{D}([f1.z; f2.z], [f1.p; f2.p], f1.k * f2.k)
*(f1::ZeroPoleGain{D}, fs::ZeroPoleGain{D}...) where {D} =
    ZeroPoleGain{D}(vcat(f1.z, map(f -> f.z, fs)...), vcat(f1.p, map(f -> f.p, fs)...),
        f1.k * prod(f.k for f in fs))

Base.inv(f::ZeroPoleGain{D}) where {D} = ZeroPoleGain{D}(f.p, f.z, inv(f.k))

function Base.:^(f::ZeroPoleGain{D}, e::Integer) where {D}
    ae = uabs(e)
    z, p = repeat(f.z, ae), repeat(f.p, ae)
    return e < 0 ? ZeroPoleGain{D}(p, z, inv(f.k)^ae) : ZeroPoleGain{D}(z, p, f.k^ae)
end

#
# Transfer function form
#

function shiftpoly(p::LaurentPolynomial{T,D}, i::Integer) where {T<:Number,D}
    if !iszero(i)
        return p * LaurentPolynomial{T,D}([one(T)], i)
    end
    return p
end

struct PolynomialRatio{Domain,T<:Number} <: FilterCoefficients{Domain}
    b::LaurentPolynomial{T,Domain}
    a::LaurentPolynomial{T,Domain}

    function PolynomialRatio{:z,Ti}(b::LaurentPolynomial, a::LaurentPolynomial) where {Ti<:Number}
        i = max(lastindex(a), lastindex(b))
        b = shiftpoly(b, -i)
        a = shiftpoly(a, -i)
        if !isone(a[0])
            if iszero(a[0])
                throw(ArgumentError("filter must have non-zero leading denominator coefficient"))
            end
            b /= a[0]
            a /= a[0]
        end
        return new{:z,Ti}(b, a)
    end
    function PolynomialRatio{:s,Ti}(b::LaurentPolynomial, a::LaurentPolynomial) where {Ti<:Number}
        if iszero(a)
            throw(ArgumentError("filter must have non-zero denominator"))
        end
        i = min(firstindex(a), firstindex(b))
        b = shiftpoly(b, -i)
        a = shiftpoly(a, -i)
        return new{:s,Ti}(b, a)
    end
end
PolynomialRatio(f::FilterCoefficients{D}) where {D} = PolynomialRatio{D}(f)
"""
    PolynomialRatio(b::Union{Number, Vector{<:Number}}, a::Union{Number, Vector{<:Number}})

Filter representation in terms of the coefficients of the numerator
`b` and denominator `a` in the z or s domain
where `b` and `a` are vectors ordered from highest power to lowest.\n
Inputs that are `Number`s are treated as one-element `Vector`s.\n
Filter with:
- Transfer function in z domain (zero & negative z powers):
```math
H(z) = \\frac{\\verb!b[1]! + \\ldots + \\verb!b[m]! z^{-m+1}}{\\verb!a[1]! + \\ldots + \\verb!a[n]! z^{-n+1}}
```
returns `PolynomialRatio` object with `a[1] = 1` and other specified coefficients divided by `a[1]`.
```jldoctest
julia> PolynomialRatio([1,1],[1,2])
PolynomialRatio{:z, Float64}(LaurentPolynomial(1.0*z⁻¹ + 1.0), LaurentPolynomial(2.0*z⁻¹ + 1.0))
julia> PolynomialRatio{:z}([1,2,3],[2,3,4])
PolynomialRatio{:z, Float64}(LaurentPolynomial(1.5*z⁻² + 1.0*z⁻¹ + 0.5), LaurentPolynomial(2.0*z⁻² + 1.5*z⁻¹ + 1.0))
```
- Transfer function in s domain (zero & positive s powers):
```math
H(s) = \\frac{\\verb!b[1]! s^{m-1} + \\ldots + \\verb!b[m]!}{\\verb!a[1]! s^{n-1} + \\ldots + \\verb!a[n]!}
```
returns `PolynomialRatio` object with specified `b` and `a` coefficients.
```jldoctest
julia> PolynomialRatio{:s}([1,2,3],[2,3,4])
PolynomialRatio{:s, Int64}(LaurentPolynomial(3 + 2*s + s²), LaurentPolynomial(4 + 3*s + 2*s²))
```

"""
PolynomialRatio(b, a) = PolynomialRatio{:z}(b, a)
const PolynomialRatioArgTs{T} = Union{T,Vector{T},LaurentPolynomial{T}} where {T<:Number}
PolynomialRatio{:z}(b::PolynomialRatioArgTs{T1}, a::PolynomialRatioArgTs{T2}) where {T1<:Number,T2<:Number} =
    PolynomialRatio{:z,typeof(one(T1) / one(T2))}(b, a)
PolynomialRatio{:s}(b::PolynomialRatioArgTs{T1}, a::PolynomialRatioArgTs{T2}) where {T1<:Number,T2<:Number} =
    PolynomialRatio{:s,promote_type(T1, T2)}(b, a)

"""
    _polyprep(D::Symbol, x::Union{T,Vector{T}}, ::Type) where {T<:Number}

Converts `x` to polynomial form. If x is a `Number`, it has to be converted into
a `Vector`, otherwise `LaurentPolynomial` dispatch goes into stack overflow
trying to collect a 0-d array into a `Vector`.

!!! warning

    The DSP convention for Laplace domain is highest power first.\n
    The Polynomials.jl convention is lowest power first.
"""
@inline _polyprep(D::Symbol, x::Union{T,Vector{T}}, ::Type{V}) where {T<:Number,V} =
    LaurentPolynomial{V,D}(x isa Vector ? reverse(x) : [x], D === :z ? -length(x) + 1 : 0)

function PolynomialRatio{:z,T}(b::Union{Number,Vector{<:Number}}, a::Union{Number,Vector{<:Number}}) where {T<:Number}
    if isempty(a) || iszero(a[1])
        throw(ArgumentError("filter must have non-zero leading denominator coefficient"))
    end
    return PolynomialRatio{:z,T}(_polyprep(:z, b / a[1], T), _polyprep(:z, a / a[1], T))
end
PolynomialRatio{:s,T}(b::Union{Number,Vector{<:Number}}, a::Union{Number,Vector{<:Number}}) where {T<:Number} =
    PolynomialRatio{:s,T}(_polyprep(:s, b, T), _polyprep(:s, a, T))

PolynomialRatio{D,T}(f::PolynomialRatio{D}) where {D,T} = PolynomialRatio{D,T}(f.b, f.a)
PolynomialRatio{D}(f::PolynomialRatio{D,T}) where {D,T} = PolynomialRatio{D,T}(f)

Base.promote_rule(::Type{PolynomialRatio{D,T}}, ::Type{PolynomialRatio{D,S}}) where {D,T,S} = PolynomialRatio{D,promote_type(T,S)}

function PolynomialRatio{D,T}(f::ZeroPoleGain{D}) where {D,T<:Real}
    b = convert(LaurentPolynomial{T}, real(f.k * fromroots(f.z; var=D)))
    a = convert(LaurentPolynomial{T}, real(fromroots(f.p; var=D)))
    return PolynomialRatio{D,T}(b, a)
end
PolynomialRatio{D}(f::ZeroPoleGain{D,Z,P,K}) where {D,Z,P,K} =
    PolynomialRatio{D,promote_type(real(Z),real(P),K)}(f)

ZeroPoleGain{D,Z,P,K}(f::PolynomialRatio{D}) where {D,Z,P,K} =
    ZeroPoleGain{D,Z,P,K}(ZeroPoleGain{D}(f))
function ZeroPoleGain{D}(f::PolynomialRatio{D,T}) where {D,T}
    i = -min(firstindex(f.a), firstindex(f.b), 0)
    z = roots(shiftpoly(f.b, i))
    p = roots(shiftpoly(f.a, i))
    return ZeroPoleGain{D}(z, p, f.b[end]/f.a[end])
end

*(f::PolynomialRatio{D}, g::Number) where {D} = PolynomialRatio{D}(g * f.b, f.a)
*(g::Number, f::PolynomialRatio{D}) where {D} = PolynomialRatio{D}(g * f.b, f.a)
*(f1::PolynomialRatio{D}, f2::PolynomialRatio{D}) where {D} =
    PolynomialRatio{D}(f1.b * f2.b, f1.a * f2.a)
*(f1::PolynomialRatio{D}, fs::PolynomialRatio{D}...) where {D} =
    PolynomialRatio{D}(f1.b * prod(f.b for f in fs), f1.a * prod(f.a for f in fs))

Base.inv(f::PolynomialRatio{D}) where {D} = PolynomialRatio{D}(f.a, f.b)

function Base.:^(f::PolynomialRatio{D,T}, e::Integer) where {D,T}
    ae = uabs(e)
    b, a = f.b^ae, f.a^ae
    if e < 0
        b, a = a, b
    end
    return PolynomialRatio{D}(b, a)
end

coef_s(p::LaurentPolynomial) = p[end:-1:0]
coef_z(p::LaurentPolynomial) = p[0:-1:begin]

"""
    coefb(f::PolynomialRatio)

Coefficients of the numerator of a `PolynomialRatio` object, highest power
first, i.e., the `b` passed to `filt()`
"""
coefb(f::PolynomialRatio{:s}) = coef_s(f.b)
coefb(f::PolynomialRatio{:z}) = coef_z(f.b)
coefb(f::FilterCoefficients) = coefb(PolynomialRatio(f))

"""
    coefa(f::PolynomialRatio)

Coefficients of the denominator of a `PolynomialRatio` object, highest power
first, i.e., the `a` passed to `filt()`
"""
coefa(f::PolynomialRatio{:s}) = coef_s(f.a)
coefa(f::PolynomialRatio{:z}) = coef_z(f.a)
coefa(f::FilterCoefficients) = coefa(PolynomialRatio(f))

#
# Biquad filter in transfer function form
# A separate immutable to improve efficiency of filtering using SecondOrderSections
#
"""
    Biquad(b0::T, b1::T, b2::T, a1::T, a2::T) where T <: Number

Filter representation in terms of the transfer function of a single
second-order section given by:
```math
H(s) = \\frac{\\verb!b0! s^2+\\verb!b1! s+\\verb!b2!}{s^2+\\verb!a1! s + \\verb!a2!}
```
or equivalently:
```math
H(z) = \\frac{\\verb!b0!+\\verb!b1! z^{-1}+\\verb!b2! z^{-2}}{1+\\verb!a1! z^{-1} + \\verb!a2! z^{-2}}
```
"""
struct Biquad{Domain,T<:Number} <: FilterCoefficients{Domain}
    b0::T
    b1::T
    b2::T
    a1::T
    a2::T
end
Biquad(f::FilterCoefficients{D}) where {D} = Biquad{D}(f)
Biquad(args...) = Biquad{:z}(args...)
Biquad{D}(b0::T, b1::T, b2::T, a1::T, a2::T) where {D,T} =
    Biquad{D,T}(b0, b1, b2, a1, a2)
Biquad{D}(b0::T, b1::T, b2::T, a0::T, a1::T, a2::T, g::Number=1) where {D,T} =
    (x = g*b0/a0; Biquad{D,typeof(x)}(x, g*b1/a0, g*b2/a0, a1/a0, a2/a0))

Biquad{D,T}(f::Biquad{D}) where {D,T} = Biquad{D,T}(f.b0, f.b1, f.b2, f.a1, f.a2)

Base.promote_rule(::Type{Biquad{D,T}}, ::Type{Biquad{D,S}}) where {D,T,S} = Biquad{D,promote_type(T,S)}

ZeroPoleGain{D,Z,P,K}(f::Biquad{D}) where {D,Z,P,K} = ZeroPoleGain{D,Z,P,K}(PolynomialRatio{D}(f))
ZeroPoleGain{D}(f::Biquad) where {D} = ZeroPoleGain{D}(convert(PolynomialRatio{D}, f))

function PolynomialRatio{D,T}(f::Biquad{D}) where {D,T}
    b = T[f.b0, f.b1, f.b2]
    a = T[one(T), f.a1, f.a2]
    PolynomialRatio{D,T}(b, a)
end
PolynomialRatio{D}(f::Biquad{D,T}) where {D,T} = PolynomialRatio{D,T}(f)

function Biquad{D,T}(f::PolynomialRatio{D}) where {D,T}
    a, b = f.a, f.b
    lastidx = max(lastindex(b), lastindex(a))

    if lastidx - min(firstindex(b), firstindex(a)) >= 3
        throw(ArgumentError("cannot convert a filter of length > 3 to Biquad"))
    end
    if !isone(a[lastidx])
        throw(ArgumentError("leading denominator coefficient of a Biquad must be one"))
    end
    Biquad{D,T}(b[lastidx], b[lastidx-1], b[lastidx-2], a[lastidx-1], a[lastidx-2])
end
Biquad{D}(f::PolynomialRatio{D,T}) where {D,T} = Biquad{D,T}(f)

Biquad{D,T}(f::ZeroPoleGain{D}) where {D,T} = Biquad{D,T}(convert(PolynomialRatio, f))
Biquad{D}(f::ZeroPoleGain{D}) where {D} = Biquad{D}(convert(PolynomialRatio, f))

*(f::Biquad{D}, g::Number) where {D} = Biquad{D}(f.b0*g, f.b1*g, f.b2*g, f.a1, f.a2)
*(g::Number, f::Biquad{D}) where {D} = Biquad{D}(f.b0*g, f.b1*g, f.b2*g, f.a1, f.a2)

Base.inv(f::Biquad{D,T}) where {D,T} = Biquad{D}(one(T), f.a1, f.a2, f.b0, f.b1, f.b2)

#
# Second-order sections (array of biquads)
#
"""
    SecondOrderSections(biquads::Vector{<:Biquad}, gain::Number)

Filter representation in terms of a cascade of second-order
sections and gain. `biquads` must be specified as a vector of
`Biquads`.
"""
struct SecondOrderSections{Domain,T<:Number,G<:Number} <: FilterCoefficients{Domain}
    biquads::Vector{Biquad{Domain,T}}
    g::G
end
SecondOrderSections(f::FilterCoefficients{D}) where {D} = SecondOrderSections{D}(f)
SecondOrderSections{D}(biquads::Vector{Biquad{D,T}}, g::G) where {D,T,G} =
    SecondOrderSections{D,T,G}(biquads, g)

Base.promote_rule(::Type{SecondOrderSections{D,T1,G1}}, ::Type{SecondOrderSections{D,T2,G2}}) where {D,T1,G1,T2,G2} =
    SecondOrderSections{D,promote_type(T1,T2),promote_type(G1,G2)}

SecondOrderSections{D,T,G}(f::SecondOrderSections) where {D,T,G} =
    SecondOrderSections{D,T,G}(f.biquads, f.g)
SecondOrderSections{D,T,G}(f::Biquad{D}) where {D,T,G} = SecondOrderSections{D,T,G}([f], one(G))

SecondOrderSections{D}(f::SecondOrderSections{D,T,G}) where {D,T,G} = SecondOrderSections{D,T,G}(f)
SecondOrderSections{D}(f::Biquad{D,T}) where {D,T} = SecondOrderSections{D,T,Int}(f)

*(f::SecondOrderSections{D}, g::Number) where {D} = SecondOrderSections{D}(f.biquads, f.g * g)
*(g::Number, f::SecondOrderSections{D}) where {D} = SecondOrderSections{D}(f.biquads, f.g * g)
*(f1::SecondOrderSections{D}, f2::SecondOrderSections{D}) where {D} =
    SecondOrderSections{D}([f1.biquads; f2.biquads], f1.g * f2.g)
*(f1::SecondOrderSections{D}, fs::SecondOrderSections{D}...) where {D} =
    SecondOrderSections{D}(vcat(f1.biquads, map(f -> f.biquads, fs)...), f1.g * prod(f.g for f in fs))

*(f1::Biquad{D}, f2::Biquad{D}) where {D} = SecondOrderSections{D}([f1, f2], 1)
*(f1::Biquad{D}, fs::Biquad{D}...) where {D} = SecondOrderSections{D}([f1, fs...], 1)
*(f1::SecondOrderSections{D}, f2::Biquad{D}) where {D} =
    SecondOrderSections{D}([f1.biquads; f2], f1.g)
*(f1::Biquad{D}, f2::SecondOrderSections{D}) where {D} =
    SecondOrderSections{D}([f1; f2.biquads], f2.g)

Base.inv(f::SecondOrderSections{D}) where {D} = SecondOrderSections{D}(inv.(f.biquads), inv(f.g))

function Base.:^(f::SecondOrderSections{D}, e::Integer) where {D}
    ae = uabs(e)
    if e < 0
        inv_f = inv(f)
        return SecondOrderSections{D}(repeat(inv_f.biquads, ae), inv_f.g^ae)
    else
        return SecondOrderSections{D}(repeat(f.biquads, ae), f.g^ae)
    end
end

function Base.:^(f::Biquad{D}, e::Integer) where {D}
    ae = uabs(e)
    return SecondOrderSections{D}(fill(e < 0 ? inv(f) : f, ae), 1)
end

function Biquad{D,T}(f::SecondOrderSections{D}) where {D,T}
    if length(f.biquads) != 1
        throw(ArgumentError("only a single second order section may be converted to a biquad"))
    end
    Biquad{D,T}(f.biquads[1] * f.g)
end
Biquad{D}(f::SecondOrderSections{D,T,G}) where {D,T,G} = Biquad{D,promote_type(T, G)}(f)

function ZeroPoleGain{D,Z,P,K}(f::SecondOrderSections{D}) where {D,Z,P,K}
    z = Z[]
    p = P[]
    k = f.g
    for biquad in f.biquads
        biquadzpk = ZeroPoleGain{D}(biquad)
        append!(z, biquadzpk.z)
        append!(p, biquadzpk.p)
        k *= biquadzpk.k
    end
    ZeroPoleGain{D,Z,P,K}(z, p, k)
end
ZeroPoleGain{D}(f::SecondOrderSections{D,T,G}) where {D,T,G} =
    ZeroPoleGain{D,complex(T),complex(T),G}(f)

PolynomialRatio{D,T}(f::SecondOrderSections{D}) where {D,T} = PolynomialRatio{D,T}(ZeroPoleGain(f))
PolynomialRatio{D}(f::SecondOrderSections{D}) where {D} = PolynomialRatio{D}(ZeroPoleGain(f))

# Group each pole in p with its closest zero in z
# Remove paired poles from p and z
function groupzp(z, p)
    n = min(length(z), length(p))
    groupedz = similar(z, n)
    i = 1
    while i <= n
        p_i = p[i]
        _, closest_zero_idx = findmin(x -> abs(x - p_i), z)
        groupedz[i] = splice!(z, closest_zero_idx)
        if !isreal(groupedz[i])
            i += 1
            groupedz[i] = splice!(z, closest_zero_idx)
        end
        i += 1
    end
    return (groupedz, splice!(p, 1:n))
end

# Sort zeros or poles lexicographically (so that poles are adjacent to
# their conjugates). Handle repeated values. Split real and complex
# values into separate vectors. Ensure that each value has a conjugate.
function split_real_complex(x::Vector{T}; sortby=nothing) where T
    # Get counts and store in a Dict
    d = Dict{T,Int}()
    for v in x
        # needs to be in normal form since 0.0 !== -0.0
        tonormal(x) = x == 0 ? abs(x) : x
        vn = complex(tonormal(real(v)), tonormal(imag(v)))
        d[vn] = get(d, vn, 0)+1
    end

    c = T[]
    r = real(T)[]
    ks = collect(keys(d))
    if sortby !== nothing
        sort!(ks; by=sortby)
    end
    for k in ks
        if imag(k) != 0
            if !haskey(d, conj(k)) || d[k] != d[conj(k)]
                # No match for conjugate
                return (c, r, false)
            elseif imag(k) > 0
                # Add key and its conjugate
                for n = 1:d[k]
                    push!(c, k, conj(k))
                end
            end
        else
            for n = 1:d[k]
                push!(r, k)
            end
        end
    end
    return (c, r, true)
end

# Convert a filter to second-order sections
# The returned sections are in ZPK form
function SecondOrderSections{D,T,G}(f::ZeroPoleGain{D,Z,P}) where {D,T,G,Z,P}
    z = f.z
    p = f.p
    nz = length(z)
    n = length(p)
    nz > n && throw(ArgumentError("ZeroPoleGain must not have more zeros than poles"))

    # Split real and complex poles
    (complexz, realz, matched) = split_real_complex(z)
    matched || throw(ArgumentError("complex zeros could not be matched to their conjugates"))
    (complexp, realp, matched) = split_real_complex(p; sortby=x->abs(abs(x) - 1))
    matched || throw(ArgumentError("complex poles could not be matched to their conjugates"))

    # Group complex poles with closest complex zeros
    z1, p1 = groupzp(complexz, complexp)
    # Group real poles with remaining complex zeros
    z2, p2 = groupzp(complexz, realp)
    # Group remaining complex poles with closest real zeros
    z3, p3 = groupzp(realz, complexp)
    # Group remaining real poles with closest real zeros
    z4, p4 = groupzp(realz, realp)

    # All zeros are now paired with a pole, but not all poles are
    # necessarily paired with a zero
    @assert isempty(complexz)
    @assert isempty(realz)
    groupedz = [z1; z2; z3; z4]::Vector{Z}
    groupedp = [p1; p2; p3; p4; complexp; realp]::Vector{P}
    @assert length(groupedz) == nz
    @assert length(groupedp) == n

    # Allocate memory for biquads
    biquads = Vector{Biquad{D,T}}(undef, (n >> 1)+(n & 1))

    # Build second-order sections in reverse
    # First do complete pairs
    npairs = length(groupedp) >> 1
    odd = isodd(n)
    for i = 1:npairs
        pairidx = 2 * (npairs - i)
        biquads[odd+i] = convert(Biquad, ZeroPoleGain{D}(groupedz[pairidx+1:min(pairidx+2, length(groupedz))],
                                                         groupedp[pairidx+1:pairidx+2], one(T)))
    end

    if odd
        # Now do remaining pole and (maybe) zero
        biquads[1] = convert(Biquad, ZeroPoleGain{D}(groupedz[length(groupedp):end],
                                                     [groupedp[end]], one(T)))
    end

    SecondOrderSections{D,T,G}(biquads, f.k)
end
SecondOrderSections{D}(f::ZeroPoleGain{D,Z,P,K}) where {D,Z,P,K} =
    SecondOrderSections{D,promote_type(real(Z), real(P)), K}(f)

SecondOrderSections{D}(f::FilterCoefficients{D}) where {D} = SecondOrderSections{D}(ZeroPoleGain(f))

# This file was formerly a part of Julia. License is MIT: https://julialang.org/license
# TODO: parameterize conv tests
using Test, OffsetArrays
using DSP: filt, filt!, deconv, conv, conv!, xcorr,
           optimalfftfiltlength, unsafe_conv_kern_os!, _conv_kern_fft!,
           nextfastfft



@testset "filt" begin
    # Filter
    b = [1., 2., 3., 4.]
    x = [1., 1., 0., 1., 1., 0., 0., 0.]
    @test filt(b, 1., x)  == [1., 3., 5., 8., 7., 5., 7., 4.]
    @test filt(b, [1., -0.5], x)  == [1., 3.5, 6.75, 11.375, 12.6875, 11.34375, 12.671875, 10.3359375]
    # With ranges
    @test filt(b, 1., 1.0:10.0) == [1., 4., 10., 20., 30., 40., 50., 60., 70., 80.]
    @test filt(1.:4., 1., 1.0:10.0) == [1., 4., 10., 20., 30., 40., 50., 60., 70., 80.]
    # Across an array is the same as channel-by-channel
    @test filt(b, 1., [x 1.0:8.0]) == [filt(b, 1., x) filt(b, 1., 1.0:8.0)]
    @test filt(b, [1., -0.5], [x 1.0:8.0]) == [filt(b, [1., -0.5], x) filt(b, [1., -0.5], 1.0:8.0)]
    si = zeros(3)
    @test @test_deprecated(filt(b, 1., [x 1.0:8.0], si) == [filt(b, 1., x, si) filt(b, 1., 1.0:8.0, si)])
    @test si == zeros(3) # Will likely fail if/when arrayviews are implemented
    si = [zeros(3) ones(3)]
    @test @test_deprecated(filt(b, 1., [x 1.0:8.0], si) == [filt(b, 1., x, zeros(3)) filt(b, 1., 1.0:8.0, ones(3))])
    # With initial conditions: a lowpass 5-pole butterworth filter with W_n = 0.25,
    # and a stable initial filter condition matched to the initial value
    b = [0.003279216306360201,0.016396081531801006,0.03279216306360201,0.03279216306360201,0.016396081531801006,0.003279216306360201]
    a = [1.0,-2.4744161749781606,2.8110063119115782,-1.703772240915465,0.5444326948885326,-0.07231566910295834]
    si = [0.9967207836936347,-1.4940914728163142,1.2841226760316475,-0.4524417279474106,0.07559488540931815]
    @test @test_deprecated(filt(b, a, ones(10), si)) ≈ ones(10) # Shouldn't affect DC offset

    @test_throws ArgumentError filt!([1, 2], [1], [1], [1])
end

@testset "conv" begin

    @test optimalfftfiltlength(1, 3) == 1 # Should be at least the first input

    # check that empty arrays are handled correctly (issue #168)
    for N in (1, 2, 3), algorithm in (:direct, :fft, :fft_simple, :fft_overlapsave)
        A = rand(ntuple(_ -> 5, N)...)
        B = Array{Float64}(undef, ntuple(_ -> 0, N))
        out = zeros(ntuple(_ -> 4, N))
        @test conv(A, B; algorithm) == out
        @test conv(B, A; algorithm) == out
        @test conv(B, B; algorithm) == B
    end

    @testset "conv-1D" begin
        # Convolution
        a = [1, 2, 1, 2]
        b = [1, 2, 3]
        expectation = [1, 4, 8, 10, 7, 6]
        im_expectation = [1, 3, 6, 6, 5, 3]
        a32 = convert(Array{Int32}, a)
        @test conv(a, b) == expectation
        @test conv(a32, b) == expectation
        fa = convert(Array{Float64}, a)
        f32a = convert(Array{Float32}, a)
        fb = convert(Array{Float64}, b)
        fexp = convert(Array{Float64}, expectation)
        im_fexp = convert(Array{Float64}, im_expectation)
        @test conv(fa, fb) ≈ fexp
        @test conv(complex.(fa, 1.), complex.(fb)) ≈ complex.(fexp, im_fexp)

        @test conv(fa, b) ≈ fexp
        @test conv(f32a, b) ≈ fexp
        @test conv(fb, a) ≈ fexp

        u = rand(190)
        v = rand(200)
        @test conv(u, v; algorithm=:direct) ≈ conv(u, v; algorithm=:fft_simple) ≈
            conv(u, v; algorithm=:fft_overlapsave) ≈ conv(u, v; algorithm=:fft) ≈
            conv(u, v; algorithm=:fast) ≈ conv(u, v; algorithm=:auto)
        @test_throws ArgumentError conv(u, v; algorithm=:quantum) # no such algorithm

        # issue #410
        n = 314159265
        @test conv([n], [n]) == [n^2]

        offset_arr = OffsetVector{Int}(undef, -1:2)
        offset_arr[:] = a
        @test_throws ArgumentError conv(offset_arr, 1:3)
        @test conv(offset_arr, OffsetArray(1:3)) == OffsetVector(expectation, 0:5)
        offset_arr_f = OffsetVector{Float64}(undef, -1:2)
        offset_arr_f[:] = fa
        @test_throws ArgumentError conv(offset_arr_f, 1:3)
        @test conv(offset_arr_f, OffsetArray(1:3)) ≈ OffsetVector(fexp, 0:5)
        @test_throws ArgumentError conv!(zeros(6), offset_arr, 1:3) # output needs to be OA, too
        @test_throws ArgumentError conv!(OffsetVector{Int}(undef, 1:6), 1:4, 1:3) # output mustn't be OA

        @test conv(fa, fill(true)) == conv(fill(true), fa) == fa
        @test_broken conv(offset_arr_f, fill(true)) == conv(fill(true), offset_arr_f) == offset_arr_f
        @test conv(fill(true), fill(true)) == fill(true)

        for M in [10, 200], N in [10, 200], T in [Float64, ComplexF64]
            u = rand(T, M)
            v = rand(T, N)
            u_off = OffsetVector(u, 23)
            v_off = OffsetVector(v, -42)
            @test conv(u, v; algorithm=:direct) ≈ conv(u, v; algorithm=:fft_simple) ≈ conv(u, v; algorithm=:fft_overlapsave)
            @test conv(u_off, v_off; algorithm=:direct) ≈ conv(u_off, v_off; algorithm=:fft_simple) ≈ conv(u_off, v_off; algorithm=:fft_overlapsave)
            @test conv(u, v) ≈ conv(u_off, v_off)[23-42+2:23-42+N+M]

            for algorithm in [:direct, :fft_simple, :fft_overlapsave]
                # pre-allocated non-offset output larger than necessary
                out = ones(T, M+N+10)
                conv!(out, u, v; algorithm)
                @test out[1:M+N-1] == conv(u, v; algorithm)
                @test all(iszero, out[M+N:end])

                # pre-allocated output with offset larger than necessary
                out = OffsetVector(ones(T, M+N+10), 23-42-5)
                conv!(out, u_off, v_off; algorithm)
                @test out[23-42+2:23-42+N+M] ≈ conv(u, v; algorithm)
                @test all(iszero, out[begin:23-42+1])
                @test all(iszero, out[23-42+N+M+1:end])
            end
        end

        # Issue #352
        @test conv([1//2, 1//3, 1//4], [1, 2]) ≈ [1//2, 4//3, 11//12, 1//2]
        # Non-numerical arrays should not be convolved
        @test_throws MethodError conv([sin], [cos])
    end


    @testset "conv-2D" begin
        a =[1 2 1;
            2 3 1;
            1 2 1]

        b = [3 2;
             0 1]

        expectation = [3 8 7 2;
                       6 14 11 3;
                       3 10 10 3;
                       0 1 2 1]
        im_expectation = [3 5 5 2;
                          3 6 6 3;
                          3 6 6 3;
                          0 1 1 1]

        # Integers
        # Real Integers
        a32 = convert(Array{Int32}, a)
        @test conv(a, b) == expectation
        @test conv(a32, b) == expectation
        # Floats
        fa = convert(Array{Float64}, a)
        f32a = convert(Array{Float32}, a)
        fb = convert(Array{Float64}, b)
        fexp = convert(Array{Float64}, expectation)
        im_fexp = convert(Array{Float64}, im_expectation)
        # Real
        @test conv(fa, fb) == fexp
        # Complex
        @test conv(complex.(fa, 1), complex.(fb)) == complex.(fexp,
                                                               im_fexp)
        @test conv(fa, b) ≈ fexp
        @test conv(f32a, b) ≈ fexp
        @test conv(fb, a) ≈ fexp

        u = rand(10, 20)
        v = rand(10, 10)
        @test conv(u, v; algorithm=:direct) ≈ conv(u, v; algorithm=:fft_simple) ≈
            conv(u, v; algorithm=:fft_overlapsave) ≈ conv(u, v; algorithm=:fft) ≈
            conv(u, v; algorithm=:fast) ≈ conv(u, v; algorithm=:auto)

        offset_arr = OffsetMatrix{Int}(undef, -1:1, -1:1)
        offset_arr[:] = a
        @test_throws ArgumentError conv(offset_arr, b)
        @test conv(offset_arr, OffsetArray(b)) == OffsetArray(expectation, 0:3, 0:3)

        for (M1, M2) in [(10, 20), (190, 200)], (N1, N2) in [(20, 10), (210, 200)], T in [Float64, ComplexF64]
            u = rand(T, M1, M2)
            v = rand(T, N1, N2)
            u_off = OffsetMatrix(u, 23, 1)
            v_off = OffsetMatrix(v, -42, 2)
            @test conv(u, v; algorithm=:direct) ≈ conv(u, v; algorithm=:fft_simple) ≈ conv(u, v; algorithm=:fft_overlapsave)
            @test conv(u_off, v_off; algorithm=:direct) ≈ conv(u_off, v_off; algorithm=:fft_simple) ≈ conv(u_off, v_off; algorithm=:fft_overlapsave)
            @test conv(u, v) ≈ conv(u_off, v_off)[23-42+2:23-42+N1+M1, 1+2+2:1+2+N2+M2]

            for algorithm in [:direct, :fft_simple, :fft_overlapsave]
                # pre-allocated non-offset output larger than necessary
                out = ones(T, M1+N1+10, M2+N2+15)
                conv!(out, u, v; algorithm)
                @test out[1:M1+N1-1, 1:M2+N2-1] == conv(u, v; algorithm)
                @test all(iszero, out[M1+N1:end, :])
                @test all(iszero, out[:, M2+N2:end])

                # pre-allocated output with offset larger than necessary
                out = OffsetMatrix(ones(T, M1+N1+10, M2+N2+15), 23-42-5, 1+2-4)
                conv!(out, u_off, v_off; algorithm)
                @test out[23-42+2:23-42+N1+M1, 1+2+2:1+2+N2+M2] ≈ conv(u, v; algorithm)
            end
        end
    end

    @testset "separable conv" begin
        u = [1, 2, 3, 2, 1]
        v = [6, 7, 3, 2]
        A = [1 2 3 4 5 6 7;
             8 9 10 11 12 13 14;
             15 16 17 18 19 20 21;
             22 23 24 25 26 27 28]
        exp = [6 19 35 53 71 89 107 77 33 14;
               60 148 217 285 339 393 447 315 134 56;
               204 478 658 822 930 1038 1146 798 338 140;
               468 1062 1400 1684 1828 1972 2116 1456 614 252;
               636 1426 1848 2188 2332 2476 2620 1792 754 308;
               624 1388 1778 2082 2190 2298 2406 1638 688 280;
               354 785 1001 1167 1221 1275 1329 903 379 154;
               132 292 371 431 449 467 485 329 138 56]
        @test_broken conv(u, transpose(v), A) == exp

        fu = convert(Array{Float64}, u)
        fv = convert(Array{Float64}, v)
        fA = convert(Array{Float64}, A)
        fexp = convert(Array{Float64}, exp)
        @test @test_deprecated(conv(fu, fv, fA)) ≈ fexp
        @test conv(fu, transpose(fv), fA) ≈ fexp

    end

    @testset "conv-ND" begin
        # is it safe to assume that if conv works for
        # int/float/complex in 1 and 2 D, it does in ND?
        a = convert(Array, reshape(1:27, (3, 3, 3)))
        b = ones(Int64, 2, 2, 2)
        exp = convert(Array, reshape([1, 3, 5, 3,
                                      5, 12, 16, 9,
                                      11, 24, 28, 15,
                                      7, 15, 17, 9,

                                      11, 24, 28, 15,
                                      28, 60, 68, 36,
                                      40, 84, 92, 48,
                                      23, 48, 52, 27,
                                      29, 60, 64, 33,

                                      64, 132, 140, 72,
                                      76, 156, 164, 84,
                                      41, 84, 88, 45,
                                      19, 39, 41, 21,

                                      41, 84, 88, 45,
                                      47, 96,  100, 51,
                                      25, 51, 53, 27], (4, 4, 4)))
        @test conv(a, b) == exp


        #6D, trivial, just to see if it works
        a = ones(2, 2, 2, 2, 2, 2)
        b = ones(1, 1, 1, 1, 1, 1)
        @test conv(a, b) == a

        # promote dims to largest
        a = cat([fill(n, 3, 3) for n in 1:6]..., dims=3)
        b = ones(Int64, 2, 2)
        expf1 = conv(a[:, :, 1], b)
        exp = cat([expf1 * n for n in 1:6]..., dims=3)
        @test conv(a, b) == conv(b, a) == exp
        fb = convert(Array{Float64}, b)
        @test conv(a, fb) ≈ conv(fb, a) ≈ convert(Array{Float64}, exp)
    end

    @testset "Overlap-Save" begin
        to_sizetuple(diml, N) = ntuple(_ -> diml, N)
        function os_test_data(::Type{T}, diml, N) where T
            s = to_sizetuple(diml, N)
            arr = rand(T, s)
            s, arr
        end
        function test_os(::Type{T}, nu, nv, N, nfft) where T
            nffts = to_sizetuple(nfft, N)
            su, u = os_test_data(T, nu, N)
            sv, v = os_test_data(T, nv, N)
            sout = su .+ sv .- 1
            out = similar(u, T, sout)
            unsafe_conv_kern_os!(out, CartesianIndices(out), u, v, nffts)
            os_out = copy(out)
            _conv_kern_fft!(out, CartesianIndices(out), u, v)
            @test out ≈ os_out
        end
        Ns = [1, 2, 3]
        eltypes = [Float32, Float64, Complex{Float64}]
        nlarge = 128

        regular_nsmall = [12, 128]
        for numdim in Ns, elt in eltypes, nsmall in regular_nsmall
            nfft = optimalfftfiltlength(nsmall, nlarge)
            test_os(elt, nlarge, nsmall, Val{numdim}(), nfft)
        end

        # small = 12, fft = 256 exercises output being smaller than the normal
        # valid region of OS convolution block
        #
        # small = 13, fft = 32 makes sout evenly divisble by nfft - sv + 1
        # small = 12, fft = 32 does not
        adversarial_nsmall_nfft = [(12, 256), (13, 32), (12, 32)]
        for (nsmall, nfft) in adversarial_nsmall_nfft
            test_os(Float64, nlarge, nsmall, Val{1}(), nfft)
        end

        # Should not bug:
        conv(zeros(4, 7, 1), zeros(3, 3, 3))

        # three blocks need to be padded in the following case:
        test_os(Float64, 25, 4, Val{1}(), 16)
    end
end

@testset "xcorr" begin
    a = [1, 2, 3]
    b = [4, 5]
    exp = [5, 14, 23, 12]
    @test xcorr([1, 2], [3, 4]) == [4, 11, 6]
    @test xcorr(a, b) == exp
    @test xcorr(a, b, padmode = :longest) == [0, 5, 14, 23, 12]
    @test xcorr(a, b, padmode = :none) == exp
    @test xcorr([1, 2], [3, 4, 5]) == [5, 14, 11, 6]
    @test xcorr([1, 2], [3, 4, 5], padmode = :longest) == [5, 14, 11, 6, 0]
    @test xcorr([1, 2], [3, 4, 5], padmode = :none) == [5, 14, 11, 6]
    @test xcorr([1.0im], [1.0im]) == [1]
    @test xcorr([1, 2, 3]*1.0im, ComplexF64[4, 5]) ≈ [5, 14, 23, 12]*im
    @test xcorr([1, 2]*1.0im, ComplexF64[3, 4, 5]) ≈ [5, 14, 11, 6]*im
    @test xcorr(ComplexF64[1, 2, 3], [4, 5]*1.0im) ≈ -[5, 14, 23, 12]*im
    @test xcorr(ComplexF64[1, 2], [3, 4, 5]*1.0im) ≈ -[5, 14, 11, 6]*im
    @test xcorr([1, 2, 3]*1.0im, [4, 5]*1.0im) ≈ [5, 14, 23, 12]
    @test xcorr([1, 2]*1.0im, [3, 4, 5]*1.0im) ≈ [5, 14, 11, 6]

    # Base Julia issue #17351
    let
        x = rand(10)
        u = rand(10, 3)
        su = view(u, :, 1)
        @test size(@inferred(xcorr(su, x))) == (19,)
        @test size(@inferred(xcorr(x, su))) == (19,)
    end

    # xcorr only supports 1d inputs at the moment
    @test_throws MethodError xcorr(rand(2, 2), rand(2, 2))

    off_a = OffsetVector(a, -1:1)
    off_b = OffsetVector(b, 0:1)
    @test xcorr(off_a, off_b, padmode = :none) == OffsetVector(exp, -2:1)

    # Issue #288
    @test xcorr(off_a, off_b, padmode = :longest) == OffsetVector(vcat(0, exp), -3:1)

    @test_throws ArgumentError xcorr([1], [2]; padmode=:bug)
    @test_throws DimensionMismatch xcorr([1], [2,3]; scaling=:biased)

    # check that :biased doesn't throw InexactError
    @test xcorr([1, 2], [3, 4]; scaling=:biased) == [2.0, 5.5, 3.0]
end

@testset "deconv" begin
    # Test for issue #188: deconv mutates inputs
    let b = [4.0, 2.0, 1.0]; a = [2.0, 1.0]
        bb = b[:]
        aa = a[:]
        c = deconv(b,a)
        @test c == [2.0, 0.0]
        @test a == aa
        @test b == bb
    end
end

!(@__DIR__() in LOAD_PATH) && push!(LOAD_PATH, @__DIR__)
using DSP, Test, DelimitedFiles, FilterTestHelpers

@testset "remez_argument_check1" begin
    # bands not monotonically increasing
    @test_throws ArgumentError remez(151, [0, 0.25, 0.25, 0.5], [1.0, 0.0])
    @test_throws ArgumentError remez(151, [0.2, 0.1, 0.25, 0.5], [1.0, 0.0])
end

@testset "remez_argument_check2" begin
    # bands values out of range
    @test_throws ArgumentError remez(151, [0, 0.23, 0.25, 0.6], [1.0, 0.0])
end

@testset "remez_argument_check3" begin
    # bands values out of range
    @test_throws ArgumentError remez(151, [-0.01, 0.23, 0.25, 0.5], [1.0, 0.0])
end

@testset "remez_argument_check4" begin
    # length of bands not 2x length of desired
    @test_throws ArgumentError remez(151, [0, 0.23, 0.5], [1.0, 0.0])
end

@testset "remez_argument_check5" begin
    # length of bands not 2x length of weight
    @test_throws ArgumentError remez(151, [0, 0.23, 0.25, 0.5], [1.0, 0.0]; weight=[1.0, 1.0, 17.0])
end

#
# Length 151 LPF (Low Pass Filter).
#
@testset "remez_151_lpf" begin
    h_scipy = read_reference_data("remez_151_lpf.txt")
    h = remez(151, [0, 0.475, 0.5, 1.0], [1.0, 0.0]; Hz=2.0);
    @test h ≈ h_scipy
    h = remez(151, [(0, 0.475) => 1, (0.5, 1.0) => 0]; Hz=2.0);
    @test h ≈ h_scipy
end

#
# Length 152 LPF. Non-default "weight" input.
#
#    from scipy.signal import remez
#    lpf = remez(152, [0, 0.475, 0.5, 1.0], [1.0, 0.0], weight=[1,2], Hz=2.0)
#    lpf.tofile('remez_152_lpf.txt', sep='\n')
#
@testset "remez_152_lpf" begin
    h_scipy = read_reference_data("remez_152_lpf.txt")
    h = remez(152, [0, 0.475, 0.5, 1.0], [1.0, 0.0]; weight=[1,2], Hz=2.0);
    @test h ≈ h_scipy
    h = remez(152, [(0, 0.475) => (1, 1), (0.5, 1.0) => (0, 2)]; Hz=2.0);
    @test h ≈ h_scipy
end

#
# Length 51 HPF (High Pass Filter).
#
#    from scipy.signal import remez
#    hpf = remez(51, [0, 0.75, 0.8, 1.0], [0.0, 1.0], Hz=2.0)
#    hpf.tofile('remez_51_hpf.txt', sep='\n')
#
@testset "remez_51_hpf" begin
    h_scipy = read_reference_data("remez_51_hpf.txt")
    h = remez(51, [0, 0.75, 0.8, 1.0], [0.0, 1.0]; Hz=2.0);
    @test h ≈ h_scipy
    h = remez(51, [(0, 0.75) => 0, (0.8, 1.0) => 1]; Hz=2.0);
    @test h ≈ h_scipy
end

#
# Length 180 BPF (Band Pass Filter).
#
#    from scipy.signal import remez
#    bpf = remez(180, [0, 0.375, 0.4, 0.5, 0.525, 1.0], [0.0, 1.0, 0.0], Hz=2.0, maxiter=30)
#    bpf.tofile('remez_180_bpf.txt', sep='\n')
#
@testset "remez_180_bpf" begin
h_scipy = read_reference_data("remez_180_bpf.txt")
    h = remez(180, [0, 0.375, 0.4, 0.5, 0.525, 1.0], [0.0, 1.0, 0.0]; Hz=2.0, maxiter=30);
    @test h ≈ h_scipy
    h = remez(180, [(0, 0.375) => 0, (0.4, 0.5) => 1, (0.525, 1.0) => 0]; Hz=2.0, maxiter=30);
    @test h ≈ h_scipy
end

@testset "remez_warn_no_converge_after_maxiter_iterations" begin
    @test_logs (:warn, r"filter is not converged") remez(180, [0, 0.375, 0.4, 0.5, 0.525, 1.0], [0.0, 1.0, 0.0]; Hz=2.0)
    @test_logs (:warn, r"filter is not converged") remez(180, [(0, 0.375) => 0, (0.4, 0.5) => 1, (0.525, 1.0) => 0]; Hz=2.0)
end

@testset "remez_error_no_converge_transition_band_too_wide" begin
    @test_throws ErrorException remez(151, [0, 0.1, 0.4, 0.5], [1.0, 0.0])
    @test_throws ErrorException remez(151, [(0, 0.1) => 1, (0.4, 0.5) => 0])
end

#
#  Odd-symmetric filters - hilbert and differentiators type.
#  Even length - much better approximation since it is not constrained to 0 at
#  the nyquist frequency
#
# Length 20 hilbert
#
#    from scipy.signal import remez
#    h = remez(20, [0.1, 0.95], [1], type="hilbert", Hz=2.0)
#    h.tofile('remez_20_hilbert.txt', sep='\n')
#
@testset "remez_20_hilbert" begin
    h_scipy = read_reference_data("remez_20_hilbert.txt")
    h = remez(20, [0.1, 0.95], [1]; filter_type=filter_type_hilbert, Hz=2.0);
    @test h ≈ h_scipy
    h = remez(20, [(0.1, 0.95) => 1]; neg=true, Hz=2.0);
    @test h ≈ h_scipy
end

#
# Length 21 hilbert
#
#    from scipy.signal import remez
#    h = remez(21, [0.1, 0.95], [1], type="hilbert", Hz=2.0)
#    h.tofile('remez_21_hilbert.txt', sep='\n')
#
@testset "remez_21_hilbert" begin
    h_scipy = read_reference_data("remez_21_hilbert.txt")
    h = remez(21, [0.1, 0.95], [1]; filter_type=filter_type_hilbert, Hz=2.0);
    @test h ≈ h_scipy
    h = remez(21, [(0.1, 0.95) => 1]; neg=true, Hz=2.0);
    @test h ≈ h_scipy
end

#
# Length 200 differentiator
#
#    from scipy.signal import remez
#    h = remez(200,[0.01, 0.99],[1],type="differentiator" Hz=2.0)
#    h.tofile('remez_200_differentiator.txt', sep='\n')
#
@testset "remez_200_differentiator" begin
    h_scipy = read_reference_data("remez_200_differentiator.txt")
    h = remez(200, [0.01, 0.99], [1]; filter_type=filter_type_differentiator, Hz=2.0);
    @test h ≈ h_scipy
    h = remez(200, [(0.01, 0.99) => (f -> f/2, f -> 1/f)]; neg=true, Hz=2.0);
    @test h ≈ h_scipy
end

#
# Length 201 differentiator
#
#    from scipy.signal import remez
#    h = remez(201,[0.05, 0.95],[1],type="differentiator" Hz=2.0)
#    h.tofile('remez_201_differentiator.txt', sep='\n')
#
@testset "remez_201_differentiator" begin
    h_scipy = read_reference_data("remez_201_differentiator.txt")
    h = remez(201, [0.05, 0.95], [1]; filter_type=filter_type_differentiator, Hz=2.0);
    @test h ≈ h_scipy
    h = remez(201, [(0.05, 0.95) => (f -> f/2, f -> 1/f)]; neg=true, Hz=2.0);
    @test h ≈ h_scipy
end


#
# Inverse sinc filter - custom response function
#
@testset "inverse_sinc_response_function" begin
    L = 64

    Fs = 4800*L
    f = range(0, stop=0.5, length=10000)

    P = (π * f * Fs / 4800) ./ sinpi.(f * Fs / 4800)
    Pdb = 20 * log10.(abs.(P))
    Pdb[1] = 0.0

    g_vec = remez(201, [
            (    0.0, 2880.0) => (f -> (f==0) ? 1.0 : abs.((π*f/4800) ./ sinpi.(f/4800)), 1.0),
            (10000.0,  Fs/2) => (0.0, 100.0)
        ]; Hz=Fs)
    g = PolynomialRatio(g_vec, [1.0])
    Gdb = 20*log10.(abs.(freqresp(g, 2π*f)))

    passband_indices = (f*Fs) .< 2880.0
    # Test that maximum passband error is less than 1/4 dB.
    @test maximum(abs.(Pdb[passband_indices] - Gdb[passband_indices])) < 0.25
end

# Filter response functions

#
# Frequency response of a digital filter
#

using ..DSP: xcorr

"""
    H, w = freqresp(filter::FilterCoefficients)

Frequency response `H` of a `filter` at (normalized) frequencies `w` in
radians/sample for a digital filter or radians/second for an analog filter
chosen as a reasonable default.
"""
function freqresp(filter::FilterCoefficients)
    w = _freqrange(filter)
    return (freqresp(filter, w), w)
end

"""
    freqresp(filter::FilterCoefficients{:z}, w)

Frequency response of digital `filter` at normalized frequency or
frequencies `w` in radians/sample.
"""
freqresp(filter::FilterCoefficients{:z}, w) = _freq(filter).(cis.(w))

"""
    freqresp(filter::FilterCoefficients{:s}, w)

Frequency response of analog `filter` at frequency or frequencies `w` in
radians/second.
"""
freqresp(filter::FilterCoefficients{:s}, w) = _freq(filter).(im .* w)


_freq(filter::FilterCoefficients) = x::Number -> _freq(filter, x)

_freq(filter::FilterCoefficients, x::Number) =
    _freq(convert(PolynomialRatio, filter), x)
_freq(filter::PolynomialRatio, x::Number) = filter.b(x) / filter.a(x)

_prod_freq(f, v::Vector{<:Union{Z,Biquad{D,Z}}}, ::Type{T}) where {D,T<:Number,Z<:Number} =
    mapreduce(f, Base.mul_prod, v; init=one(promote_type(T, Z)))

_freq(filter::ZeroPoleGain, x::T) where {T<:Number} =
    filter.k * _prod_freq(z -> x - z, filter.z, T) / _prod_freq(p -> x - p, filter.p, T)
_freq(filter::Biquad, x::Number) =
    muladd(muladd(filter.b0, x, filter.b1), x, filter.b2) / muladd((x + filter.a1), x, filter.a2)
_freq(filter::SecondOrderSections, x::T) where {T<:Number} =
    filter.g * _prod_freq(b -> _freq(b, x), filter.biquads, T)


"""
    phi, w = phaseresp(filter::FilterCoefficients)

Phase response `phi` of a `filter` at (normalized) frequencies `w` in
radians/sample for a digital filter or radians/second for an analog filter
chosen as a reasonable default.
"""
function phaseresp(filter::FilterCoefficients)
    w = _freqrange(filter)
    return (phaseresp(filter, w), w)
end

"""
    phaseresp(filter::FilterCoefficients, w)

Phase response of a `filter` at (normalized) frequency or frequencies `w` in
radians/sample for a digital filter or radians/second for an analog filter.
"""
function phaseresp(filter::FilterCoefficients, w)
    h = freqresp(filter, w)
    unwrap(angle.(h); dims=ndims(h))
end

"""
    tau, w = grpdelay(filter::FilterCoefficients)

Group delay `tau` of a `filter` at (normalized) frequencies `w` in
radians/sample for a digital filter or radians/second for an analog filter
chosen as a reasonable default.
"""
function grpdelay(filter::FilterCoefficients)
    w = _freqrange(filter)
    return (grpdelay(filter, w), w)
end

"""
    grpdelay(filter::FilterCoefficients{:z}, w)

Group delay of a digital `filter` at normalized frequency
or frequencies `w` in radians/sample.
"""
function grpdelay(filter::FilterCoefficients{:z}, w)
    filter = convert(PolynomialRatio, filter)
    b, a = coefb(filter), coefa(filter)

    # Linear Phase FIR
    if (length(a) == 1) & (_is_sym(b) | _is_anti_sym(b))
        return fill((length(b)-1)/2, length(w))
    end

    c = xcorr(b, a; padmode = :none)
    cr = range(0, stop=length(c)-1) .* c
    ejw = cis.(.- w)
    num = Polynomial(cr).(ejw)
    den = Polynomial(c).(ejw)
    return real.(num ./ den) .- (length(a) - 1)
end

function grpdelay(filter::FilterCoefficients{:s}, w)
    filter = convert(PolynomialRatio, filter)
    b, a = filter.b, filter.a
    bd = derivative(b)
    ad = derivative(a)
    s = im .* w
    return real.((bd*a - ad*b).(s) ./ (a * b).(s))
end

"""
    impresp(filter::FilterCoefficients{:z}, n=100)

Impulse response of a digital `filter` with `n` points.
"""
function impresp(filter::FilterCoefficients{:z}, n=100)
  i = setindex!(zeros(n), 1, 1)
  filt(filter, i)
end

"""
    stepresp(filter::FilterCoefficients{:z}, n=100)

Step response of a digital `filter` with `n` points.
"""
function stepresp(filter::FilterCoefficients{:z}, n=100)
  i = ones(n)
  filt(filter, i)
end



#
# Helper functions
#

function _is_sym(x::AbstractArray)
    n = length(x) ÷ 2
    return all(x[1+i] == x[end-i] for i in 0:n-1)
end

function _is_anti_sym(x::AbstractArray)
    n = length(x) ÷ 2
    return all(x[1+i] == -x[end-i] for i in 0:n)
end

_freqrange(::FilterCoefficients{:z}) = range(0, stop=π, length=257)
function _freqrange(filter::FilterCoefficients{:s})
    filter = convert(ZeroPoleGain, filter)
    w_interesting = sort!(Float64.(abs.([filter.p; filter.z])))
    include_zero = !isempty(w_interesting) && iszero(w_interesting[1])
    first_nonzero = findfirst(!iszero, w_interesting)
    if isnothing(first_nonzero) # no non-zero poles or zeros
        if !include_zero || !isfinite(1 / filter.k)
            return [0.0, 1.0, 1e1, 1e2, 1e3, 1e4, 1e5, 1e6] # fallback
        end
        # include the point where |H|=1 (if any) and go further by factor 10
        return collect(range(0.0, stop=10 * Float64(max(filter.k, 1 / filter.k)), length=200))
    end
    # normal case: go from smallest to largest pole/zero, extended by factor 10
    w_min, w_max = w_interesting[first_nonzero], w_interesting[end]
    w = 10 .^ range(log10(w_min) - 1, stop=log10(w_max) + 1, length=200)
    return include_zero ? pushfirst!(w, 0.0) : w
end

# This file was formerly a part of Julia. License is MIT: https://julialang.org/license

const SMALL_FILT_CUTOFF = 66

"""
    filt(b::Union{AbstractVector,Number},
         a::Union{AbstractVector,Number},
         x::AbstractArray)

Apply filter described by vectors `a` and `b` to vector `x`.

Inputs that are `Number`s are treated as one-element `Vector`s.
"""
filt(b::Union{AbstractVector, Number}, a::Union{AbstractVector, Number}, x::AbstractArray{T}) where {T} =
    filt!(similar(x, promote_type(eltype(b), eltype(a), T)), b, a, x)

# in-place filtering: returns results in the out argument, which may shadow x
# (and does so by default)

"""
    filt!(out, b, a, x)

Same as [`filt`](@ref) but writes the result into the `out` argument, which may
alias the input `x` to modify it in-place.
"""
function filt!(out::AbstractArray, b::Union{AbstractVector, Number}, a::Union{AbstractVector, Number},
               x::AbstractArray{T}) where {T}
    isempty(b) && throw(ArgumentError("filter vector b must be non-empty"))
    isempty(a) && throw(ArgumentError("filter vector a must be non-empty"))
    a[1] == 0  && throw(ArgumentError("filter vector a[1] must be nonzero"))
    if size(x) != size(out)
        throw(ArgumentError(lazy"output size $(size(out)) must match input size $(size(x))"))
    end

    as = length(a)
    bs = length(b)
    sz = max(as, bs)

    iszero(size(x, 1)) && return out
    isone(sz) && return (k = b[1] / a[1]; @noinline mul!(out, x, k)) # Simple scaling without memory

    # Filter coefficient normalization
    if !isone(a[1])
        norml = a[1]
        a = @noinline broadcast(/, a, norml)
        b = @noinline broadcast(/, b, norml)
    end

    si = Vector{promote_type(eltype(b), eltype(a), T)}(undef, sz - 1)

    if as == 1 && bs <= SMALL_FILT_CUTOFF
        @static VERSION < v"1.13-" && fill!(si, zero(eltype(si)))
        _small_filt_fir!(out, b, x, si, Val(bs))
    else
        for col in CartesianIndices(axes(x)[2:end])
            # Reset the filter state
            fill!(si, zero(eltype(si)))
            if as > 1
                _filt_iir!(out, b, a, x, si, col)
            else
                _filt_fir!(out, b, x, si, col)
            end
        end
    end
    return out
end

# Transposed direct form II
function _filt_iir!(out, b, a, x, si, col)
    silen = length(si)
    @inbounds for i in axes(x, 1)
        xi = x[i, col]
        val = muladd(xi, b[1], si[1])
        out[i, col] = val
        for j in 1:min(length(a), length(b), silen) - 1
            si[j] = muladd(val, -a[j+1], muladd(xi, b[j+1], si[j+1]))
        end
        if length(a) == length(b)
            si[silen] = muladd(xi, b[silen+1], -a[silen+1]*val)
        elseif length(a) > length(b)
            for j in length(b):silen-1
                si[j] = muladd(val, -a[j+1], si[j+1])
            end
            si[silen] = -a[silen+1]*val
        else
            for j in length(a):silen-1
                si[j] = muladd(xi, b[j+1], si[j+1])
            end
            si[silen] = xi*b[silen+1]
        end
    end
end

# Transposed direct form II
function _filt_fir!(out, b, x, si, col)
    silen = length(si)
    @inbounds for i in axes(x, 1)
        xi = x[i, col]
        out[i, col] = muladd(xi, b[1], si[1])
        for j=1:(silen-1)
            si[j] = muladd(xi, b[j+1], si[j+1])
        end
        si[silen] = b[silen+1] * xi
    end
end

#
# filt implementation for FIR filters
#

### NOTE ###
# Fragile because of the impact of @inbounds and checkbounds
# on the effects system

const SMALL_FILT_VECT_CUTOFF = 19

# Transposed direct form II
function _filt_fir!(out, b::NTuple{N,T}, x, siarr, col, ::Val{StoreSI}) where {N,T,StoreSI}
if @generated
    silen = N - 1
    si_end = Symbol(:si_, silen)

    quote
        VECTORIZE_LARGER = N > SMALL_FILT_VECT_CUTOFF
        VECTORIZE_LARGER || checkbounds(siarr, $silen)
        Base.@nextract $silen si siarr
        ax = axes(x, 1)
        $(@static if VERSION >= v"1.12"
          :(checkbounds(x, ax, col);
            checkbounds(out, ax, col))
        end)
        for i in ax
            xi = x[i, col]
            val = muladd(xi, b[1], si_1)
            if VECTORIZE_LARGER
      $(@static if VERSION.major == 1 && VERSION.minor == 12
                    :(@inbounds out[i, col] = val)
                else
                    :(out[i, col] = val)
                end)
            end
            Base.@nexprs $(silen - 1) j -> (si_j = muladd(xi, b[j+1], si_{j + 1}))
            $si_end = xi * b[N]
            if !VECTORIZE_LARGER
                out[i, col] = val
            end
        end
        if StoreSI
            Base.@nexprs $silen j -> siarr[j] = si_j
        end
        return nothing
    end
else
    if StoreSI
        _filt_fir!(out, b, x, siarr, col)
    else
        si = copy(siarr)
        _filt_fir!(out, b, x, si, col)
    end
end # end if @generated
end

# Convert array filter tap input to tuple for small-filtering
function _small_filt_fir!(
    out::AbstractArray, h::AbstractVector, x::AbstractArray,
    si::AbstractVector, ::Val{bs}
) where {bs}

    bs < 2 && throw(ArgumentError("invalid tuple size"))
    length(h) != bs && throw(ArgumentError("length(h) does not match bs"))
    b = ntuple(j -> h[j], Val(bs))
    for col in CartesianIndices(axes(x)[2:end])
        @static if VERSION > v"1.13-"
            fill!(si, zero(eltype(si)))
            _filt_fir!(out, b, x, si, col, Val(true))
        else
            _filt_fir!(out, b, x, si, col, Val(false))
        end
    end
end

"""
    deconv(b,a) -> c

Construct vector `c` such that `b = conv(a,c) + r`.
Equivalent to polynomial division.
"""
function deconv(b::StridedVector{T}, a::StridedVector{T}) where T
    lb = size(b,1)
    la = size(a,1)
    if lb < la
        return [zero(T)]
    end
    lx = lb-la+1
    x = zeros(T, lx)
    x[1] = 1
    filt(b, a, x)
end


"""
    _zeropad!(padded::AbstractVector,
              u::AbstractVector,
              padded_axes = axes(padded),
              data_dest::Tuple = (1,),
              data_region = CartesianIndices(u))

Place the portion of `u` specified by `data_region` into `padded`, starting at
location `data_dest`. Sets the rest of `padded` to zero. This will mutate
`padded`. `padded_axes` must correspond to the axes of `padded`.

"""
@inline function _zeropad!(
    padded::AbstractVector,
    u::AbstractVector,
    padded_axes = axes(padded),
    data_dest::Tuple = (first(padded_axes[1]),),
    data_region = CartesianIndices(u),
)
    datasize = length(data_region)
    # Use axes to accommodate arrays that do not start at index 1
    data_first_i = first(data_region)[1]
    dest_first_i = data_dest[1]
    copyto!(padded, dest_first_i, u, data_first_i, datasize)
    padded[first(padded_axes[1]):dest_first_i - 1] .= 0
    padded[dest_first_i + datasize : end] .= 0

    padded
end

@inline function _zeropad!(
    padded::AbstractArray,
    u::AbstractArray,
    padded_axes = axes(padded),
    data_dest::Tuple = first.(padded_axes),
    data_region = CartesianIndices(u),
)
    fill!(padded, zero(eltype(padded)))
    dest_axes = UnitRange.(data_dest, data_dest .+ size(data_region) .- 1)
    dest_region = CartesianIndices(dest_axes)
    copyto!(padded, dest_region, u, data_region)

    padded
end

"""
    _zeropad(u, padded_size, [data_dest, data_region])

Creates and returns a new base-1 index array of size `padded_size`, with the
section of `u` specified by `data_region` copied into the region of the new
 array as specified by `data_dest`. All other values will be initialized to
 zero.

If either `data_dest` or `data_region` is not specified, then the defaults
described in [`_zeropad!`](@ref) will be used.
"""
function _zeropad(u, padded_size, args...)
    padded = similar(u, padded_size)
    _zeropad!(padded, u, axes(padded), args...)
end

function _zeropad_keep_offset(u, padded_size, u_axes, args...)
    ax_starts = first.(u_axes)
    new_axes = UnitRange.(ax_starts, ax_starts .+ padded_size .- 1)
    _zeropad!(similar(u, new_axes), u, args...)
end

function _zeropad_keep_offset(
    u, padded_size, ::NTuple{<:Any, Base.OneTo{Int}}, args...
)
    _zeropad(u, padded_size, args...)
end

"""
    _zeropad_keep_offset(u, padded_size, [data_dest, dat_region])

Like [`_zeropad`](@ref), but retains the first index of `u` when creating a new
array.
"""
function _zeropad_keep_offset(u, padded_size, args...)
    _zeropad_keep_offset(u, padded_size, axes(u), args...)
end

"""
Estimate the number of floating point multiplications per output sample for an
overlap-save algorithm with fft size `nfft`, and filter size `nb`.
"""
os_fft_complexity(nfft, nb) =  (nfft * log2(nfft) + nfft) / (nfft - nb + 1)

"""
Determine the length of FFT that minimizes the number of multiplications per
output sample for an overlap-save convolution of vectors of size `nb` and `nx`.
"""
function optimalfftfiltlength(nb, nx)
    nfull = nb + nx - 1

    # Step through possible nffts and find the nfft that minimizes complexity
    # Assumes that complexity is convex
    first_pow2 = ceil(Int, log2(nb))
    max_pow2 = ceil(Int, log2(nfull))
    prev_complexity = os_fft_complexity(2 ^ first_pow2, nb)
    pow2 = first_pow2 + 1
    while pow2 <= max_pow2
        new_complexity = os_fft_complexity(2 ^ pow2, nb)
        new_complexity > prev_complexity && break
        prev_complexity = new_complexity
        pow2 += 1
    end
    nfft = pow2 > max_pow2 ? 2 ^ max_pow2 : 2 ^ (pow2 - 1)

    if nfft > nfull
        # If nfft > nfull, then it's better to find next fast power
        nfft = nextfastfft(nfull)
    end

    nfft
end

"""
Prepare buffers and FFTW plans for convolution. The two buffers, tdbuff and
fdbuff may be an alias of each other, because complex convolution only requires
one buffer. The plans are mutating where possible, and the inverse plan is
unnormalized.
"""
@inline function os_prepare_conv(u::AbstractArray{T, N},
                                 nffts) where {T<:Real, N}
    tdbuff = similar(u, nffts)
    bufsize = ntuple(i -> i == 1 ? nffts[i] >> 1 + 1 : nffts[i], N)
    fdbuff = similar(u, Complex{T}, NTuple{N, Int}(bufsize))

    p = plan_rfft(tdbuff)
    ip = plan_brfft(fdbuff, nffts[1])

    tdbuff, fdbuff, p, ip
end

@inline function os_prepare_conv(u::AbstractArray{<:Complex}, nffts)
    buff = similar(u, nffts)

    p = plan_fft!(buff)
    ip = inv(p).p

    buff, buff, p, ip # Only one buffer for complex
end

"""
Transform the smaller convolution input to frequency domain, and return it in a
new array. However, the contents of `buff` may be modified.
"""
@inline function os_filter_transform!(buff::AbstractArray{<:Real}, p)
    p * buff
end

@inline function os_filter_transform!(buff::AbstractArray{<:Complex}, p!)
    copy(p! * buff) # p operates in place on buff
end

"""
Take a block of data, and convolve it with the smaller convolution input. This
may modify the contents of `tdbuff` and `fdbuff`, and the result will be in
`tdbuff`.
"""
@inline function os_conv_block!(tdbuff::AbstractArray{<:Real},
                                fdbuff::AbstractArray,
                                filter_fd,
                                p,
                                ip)
    mul!(fdbuff, p, tdbuff)
    fdbuff .*= filter_fd
    mul!(tdbuff, ip, fdbuff)
end

"Like the real version, but only operates on one buffer"
@inline function os_conv_block!(buff::AbstractArray{<:Complex},
                                ::AbstractArray, # Only one buffer for complex
                                filter_fd,
                                p!,
                                ip!)
    p! * buff # p! operates in place on buff
    buff .*= filter_fd
    ip! * buff # ip! operates in place on buff
end

# Used by `unsafe_conv_kern_os!` to handle blocks of input data that need to be padded.
#
# For a given number of edge dimensions, convolve all regions along the
# perimeter that have that number of edge dimensions
#
# For a 3d cube, if n_edges = 1, this means all faces. If n_edges = 2, then
# all edges. Finally, if n_edges = 3, then all corners.
#
# This needs to be a separate function for subsets to generate tuple elements,
# which is only the case if the number of edges is a Val{n} type. Iterating over
# the number of edges with Val{n} is inherently type unstable, so this function
# boundary allows dispatch to make efficient code for each number of edge
# dimensions.
function unsafe_conv_kern_os_edge!(
    # These arrays and buffers will be mutated
    out::AbstractArray{<:Any, N},
    tdbuff,
    fdbuff,
    perimeter_range,
    # Number of edge dimensions to pad and convolve
    n_edges::Val,
    # Data to be convolved
    u,
    filter_fd,
    # FFTW plans
    p,
    ip,
    # Sizes, ranges, and other pre-calculated constants
    #
    ## ranges listing center and edge blocks
    edge_ranges,
    center_block_ranges,
    ## size and axis information
    all_dims, # 1:N
    su,
    u_start,
    sv,
    nffts,
    out_start,
    out_stop,
    save_blocksize,
    sout_deficit, # How many output samples are missing if nffts > sout
    tdbuff_axes,
) where N
    # Iterate over all possible combinations of edge dimensions for a number of
    # edges
    #
    # For a 3d cube with n_edges = 1, this will specify the top and bottom faces
    # (edge_dims = (1,)), then the left and right faces (edge_dims = (2,)), then
    # the front and back faces (edge_dims = (3,))
    for edge_dims in subsets(all_dims, n_edges)
        # Specify a region on the perimeter by combining an edge block index for
        # each dimension on an edge, and the central blocks for dimensions not
        # on an edge.
        #
        # First make all entries equal to the center blocks:
        copyto!(perimeter_range, 1, center_block_ranges, 1, N)

        # For the dimensions chosen to be on an edge (edge_dims), get the
        # ranges of the blocks that would need to be padded (lie on an edge)
        # in that dimension.
        #
        # There can be one to two such ranges for each dimension, because with
        # some inputs sizes the whole convolution is just one range
        # (one edge block), or the padding will be needed at both the leading
        # and trailing side of that dimension
        selected_edge_ranges = getindex.(Ref(edge_ranges), edge_dims)

        # Visit each combination of edge ranges for the edge dimensions chosen.
        # For a 3d cube with n_edges = 1 and edge_dims = (1,), this will visit
        # the top face, and then the bottom face.
        for perimeter_edge_ranges in Iterators.ProductIterator(selected_edge_ranges)
            # The center region for non-edge dimensions has been specified above,
            # so finish specifying the region of the perimeter for this edge
            # block
            for (i, dim) in enumerate(edge_dims)
                perimeter_range[dim] = perimeter_edge_ranges[i]
            end

            # Region of block indices, not data indices!
            block_region = CartesianIndices(
                NTuple{N, UnitRange{Int}}(perimeter_range)
            )
            for block_pos in block_region
                # Figure out which portion of the input data should be transformed

                block_idx = convert(NTuple{N, Int}, block_pos)
                ## data_offset is NOT the beginning of the region that will be
                ## convolved, but is instead the beginning of the unaliased data.
                data_offset = save_blocksize .* (block_idx .- 1)
                ## How many zeros will need to be added before the data
                pad_before = max.(0, sv .- data_offset .- 1)
                data_ideal_stop = data_offset .+ save_blocksize
                ## How many zeros will need to be added after the data
                pad_after = max.(0, data_ideal_stop .- su)

                ## Data indices, not block indices
                data_region = CartesianIndices(
                    UnitRange.(
                        u_start .+ data_offset .- sv .+ pad_before .+ 1,
                        u_start .+ data_ideal_stop .- pad_after .- 1
                    )
                )

                # Convolve portion of input

                _zeropad!(tdbuff, u, tdbuff_axes, pad_before .+ 1, data_region)
                os_conv_block!(tdbuff, fdbuff, filter_fd, p, ip)

                # Save convolved result to output

                block_out_stop = min.(
                    out_start .+ data_offset .+ save_blocksize .- 1,
                    out_stop
                )
                block_out_region = CartesianIndices(
                    UnitRange.(out_start .+ data_offset, block_out_stop)
                )
                ## If the input could not fill tdbuff, account for that before
                ## copying the convolution result to the output
                u_deficit = max.(0, pad_after .- sv .+ 1)
                valid_buff_region = CartesianIndices(
                    UnitRange.(sv, nffts .- u_deficit .- sout_deficit)
                )
                copyto!(out, block_out_region, tdbuff, valid_buff_region)
            end
        end
    end
end

# Assumes u is larger than, or the same size as, v
# nfft should be greater than or equal to 2*sv-1
function unsafe_conv_kern_os!(out,
                        output_indices,
                        u::AbstractArray{<:Any, N},
                        v,
                        nffts) where N
    sout = size(out)
    su = size(u)
    sv = size(v)
    u_start = first.(axes(u))
    out_start = Tuple(first(output_indices))
    out_stop = Tuple(last(output_indices))
    ideal_save_blocksize = nffts .- sv .+ 1
    # Number of samples that are "missing" if the output is smaller than the
    # valid portion of the convolution
    sout_deficit = max.(0, ideal_save_blocksize .- sout)
    # Size of the valid portion of the convolution result
    save_blocksize = ideal_save_blocksize .- sout_deficit
    nblocks = cld.(sout, save_blocksize)

    # Pre-allocation
    tdbuff, fdbuff, p, ip = os_prepare_conv(out, nffts)
    tdbuff_axes = axes(tdbuff)

    # Transform the smaller filter
    _zeropad!(tdbuff, v)
    filter_fd = os_filter_transform!(tdbuff, p)
    filter_fd .*= 1 / prod(nffts) # Normalize once for brfft

    # block indices for center blocks, which need no padding
    first_center_blocks = cld.(sv .- 1, save_blocksize) .+ 1
    last_center_blocks = fld.(su, save_blocksize)
    center_block_ranges = UnitRange.(first_center_blocks, last_center_blocks)

    # block index ranges for blocks that need to be padded
    # Corresponds to the leading and trailing side of a dimension, or if there
    # are no center blocks, corresponds to the whole dimension
    edge_ranges = map(nblocks, first_center_blocks, last_center_blocks) do nblock, firstfull, lastfull
        lastfull > 1 ? [1:firstfull - 1, lastfull + 1 : nblock] : [1:nblock]
    end
    all_dims = 1:N
    val_dims = ntuple(Val, Val(N))
    # Buffer to store ranges of indices for a single region of the perimeter
    perimeter_range = Vector{UnitRange{Int}}(undef, N)

    # Convolve all blocks that require padding.
    #
    # This is accomplished by dividing the perimeter of the volume into
    # subsections, where the division is done by the number of edge dimensions.
    # For a 3d cube, this convolves the perimeter in the following order:
    #
    # Number of Edge Dimensions | Convolved Region
    # --------------------------+-----------------
    #                         1 | Faces of Cube
    #                         2 | Edges of Cube
    #                         3 | Corners of Cube
    #
    for n_edges in val_dims
        unsafe_conv_kern_os_edge!(
            # These arrays and buffers will be mutated
            out,
            tdbuff,
            fdbuff,
            perimeter_range,
            # Number of edge dimensions to pad and convolve
            n_edges,
            # Data to be convolved
            u,
            filter_fd,
            # FFTW plans
            p,
            ip,
            # Sizes, ranges, and other pre-calculated constants
            #
            ## ranges listing center and edge blocks
            edge_ranges,
            center_block_ranges,
            ## size and axis information
            all_dims, # 1:N
            su,
            u_start,
            sv,
            nffts,
            out_start,
            out_stop,
            save_blocksize,
            sout_deficit,
            tdbuff_axes) # How many output samples are missing if nffts > sout
    end

    tdbuff_region = CartesianIndices(tdbuff)
    # Portion of buffer with valid result of convolution
    valid_buff_region = CartesianIndices(UnitRange.(sv, nffts))
    # Iterate over block indices (not data indices) that do not need to be padded
    for block_pos in CartesianIndices(center_block_ranges)
        # Calculate portion of data to transform

        block_idx = convert(NTuple{N, Int}, block_pos)
        ## data_offset is NOT the beginning of the region that will be
        ## convolved, but is instead the beginning of the unaliased data.
        data_offset = save_blocksize .* (block_idx .- 1)
        data_stop = data_offset .+ save_blocksize
        data_region = CartesianIndices(
            UnitRange.(u_start .+ data_offset .- sv .+ 1, u_start .+ data_stop .- 1)
        )

        # Convolve this portion of the data

        copyto!(tdbuff, tdbuff_region, u, data_region)
        os_conv_block!(tdbuff, fdbuff, filter_fd, p, ip)

        # Save convolved result to output

        block_out_region = CartesianIndices(
            UnitRange.(data_offset .+ out_start, data_stop .+ out_start .- 1)
        )
        copyto!(out, block_out_region, tdbuff, valid_buff_region)
    end

    out
end

function _conv_kern_fft!(out::AbstractArray{T, N},
                         output_indices,
                         u::AbstractArray{<:Real, N},
                         v::AbstractArray{<:Real, N}) where {T<:Real, N}
    outsize = size(output_indices)
    nffts = nextfastfft(outsize)
    padded = _zeropad!(similar(u, T, nffts), u)
    p = plan_rfft(padded)
    uf = p * padded
    _zeropad!(padded, v)
    vf = p * padded
    uf .*= vf
    raw_out = irfft(uf, nffts[1])
    copyto!(out,
            output_indices,
            raw_out,
            CartesianIndices(outsize))
end
function _conv_kern_fft!(out::AbstractArray{T}, output_indices, u, v) where {T}
    outsize = size(output_indices)
    nffts = nextfastfft(outsize)
    upad = _zeropad!(similar(u, T, nffts), u)
    vpad = _zeropad!(similar(v, T, nffts), v)
    p! = plan_fft!(upad)
    ip! = inv(p!)
    p! * upad # Operates in place on upad
    p! * vpad
    upad .*= vpad
    ip! * upad
    copyto!(out,
            output_indices,
            upad,
            CartesianIndices(outsize))
end

function _conv_td!(out, output_indices, u::AbstractArray{<:Number, N}, v::AbstractArray{<:Number, N}) where {N}
    index_offset = first(CartesianIndices(u)) + first(CartesianIndices(v)) - first(output_indices)
    checkbounds(out, output_indices)
    fill!(out, zero(eltype(out)))
    if size(u, 1) ≤ size(v, 1) # choose more efficient iteration order
        for m in CartesianIndices(u), n in CartesianIndices(v)
            @inbounds out[n+m - index_offset] = muladd(u[m], v[n], out[n+m - index_offset])
        end
    else
        for n in CartesianIndices(v), m in CartesianIndices(u)
            @inbounds out[n+m - index_offset] = muladd(u[m], v[n], out[n+m - index_offset])
        end
    end
    return out
end

# whether the given axis are to be considered to carry an offset for `conv!` and `conv`
conv_axis_with_offset(::Base.OneTo) = false
conv_axis_with_offset(a::Any) = throw(ArgumentError(lazy"unsupported axis type $(typeof(a))"))

function conv_axes_with_offset(as::Tuple...)
    with_offset = ((map(a -> map(conv_axis_with_offset, a), as)...)...,)
    if !allequal(with_offset)
        throw(ArgumentError("cannot mix offset and non-offset axes"))
    end
    return !isempty(with_offset) && first(with_offset)
end

const FFTTypes = Union{Float32, Float64, ComplexF32, ComplexF64}

"""
    conv!(out, u, v; algorithm=:auto)

Convolution of two arrays `u` and `v` with the result stored in `out`. `out`
must be large enough to store the entire result; if it is even larger, the
excess entries will be zeroed.

`out`, `u`, and `v` can be N-dimensional arrays, with arbitrary indexing
offsets. If none of them has offset axes,
`size(out,d) ≥ size(u,d) + size(v,d) - 1` must hold. If both input and output
have offset axes, `firstindex(out,d) ≤ firstindex(u,d) + firstindex(v,d)` and
`lastindex(out,d) ≥ lastindex(u,d) + lastindex(v,d)` must hold (for d = 1,...,N).
A mix of offset and non-offset axes is not permitted.

The `algorithm` keyword allows choosing the algorithm to use:
* `:direct`: Evaluates the convolution sum in time domain.
* `:fft_simple`: Evaluates the convolution as a product in the frequency domain.
* `:fft_overlapsave`: Evaluates the convolution block-wise as a product in the
  frequency domain, overlapping the resulting blocks.
* `:fft`: Selects the faster of `:fft_simple` and `:fft_overlapsave` (as
   estimated from the input size).
* `:fast`: Selects the fastest of `:direct`, `:fft_simple` and
  `:fft_overlapsave` (as estimated from the input size).
* `:auto` (default): Equivalent to `:fast` if the data type is known to be
  suitable for FFT-based computation, equivalent to `:direct` otherwise.

!!! warning
    The choices made by `:fft`, `:fast`, and `:auto` are based on performance
    heuristics which may not result in the fastest algorithm in all cases. If
    best performance for a certain size/type combination is required, it is
    advised to do individual benchmarking and explicitly specify the desired
    algorithm.
"""
function conv!(
    out::AbstractArray{T, N},
    u::AbstractArray{<:Number, N},
    v::AbstractArray{<:Number, N};
    algorithm=:auto
) where {T<:Number, N}
    offset = conv_axes_with_offset(axes(out), axes(u), axes(v)) ? 0 : 1
    output_indices = CartesianIndices(map(axes(out), axes(u), axes(v)) do ao, au, av
        return (first(au)+first(av) : last(au)+last(av)) .- offset
    end)

    if algorithm === :auto
        algorithm = T <: FFTTypes ? :fast : :direct
    end
    if algorithm === :fast
        if length(u) * length(v) < 2^16 # TODO: better heuristic
            algorithm = :direct
        else
            algorithm = :fft
        end
    end
    if algorithm === :direct || any(isempty, (u, v)) # ensure correct handling of empty arrays
        return _conv_td!(out, output_indices, u, v)
    else
        if output_indices != CartesianIndices(out)
            fill!(out, zero(eltype(out)))
        end
        os_nffts = length(u) >= length(v) ? map(optimalfftfiltlength, size(v), size(u)) : map(optimalfftfiltlength, size(u), size(v))
        if algorithm === :fft
            if any(os_nffts .< size(output_indices))
                algorithm = :fft_overlapsave
            else
                algorithm = :fft_simple
            end
        end
        if algorithm === :fft_overlapsave
            # v should be smaller than u for good performance
            if length(u) >= length(v)
                return unsafe_conv_kern_os!(out, output_indices, u, v, os_nffts)
            else
                return unsafe_conv_kern_os!(out, output_indices, v, u, os_nffts)
            end
        elseif algorithm === :fft_simple
            return _conv_kern_fft!(out, output_indices, u, v)
        else
            throw(ArgumentError("algorithm must be :auto, :fast, :direct, :fft, :fft_simple, or :fft_overlapsave"))
        end
    end
end

function conv_output_axes(au::Tuple, av::Tuple)
    if conv_axes_with_offset(au, av)
        return map((au, av) -> first(au)+first(av):last(au)+last(av), au, av)
    else
        return map((au, av) -> Base.OneTo(last(au) + last(av) - 1), au, av)
    end
end

"""
    conv(u, v; algorithm)

Convolution of two arrays. A convolution algorithm is automatically chosen among
direct convolution, FFT, or FFT overlap-save, depending on the size of the
input, unless explicitly specified with the `algorithm` keyword argument; see
[`conv!`](@ref) for details.
"""
function conv(
    u::AbstractArray{Tu, N}, v::AbstractArray{Tv, N};  kwargs...
) where {Tu<:Number, Tv<:Number, N}
    T = promote_type(Tu, Tv)
    out_axes = conv_output_axes(axes(u), axes(v))
    out = similar(u, T, out_axes)
    return conv!(out, u, v; kwargs...)
end

function conv(A::AbstractArray{<:Number, M},
              B::AbstractArray{<:Number, N}; kwargs...) where {M, N}
    if (M < N)
        conv(cat(A, dims=N)::AbstractArray{eltype(A), N}, B; kwargs...)
    else
        @assert M > N
        conv(A, cat(B, dims=M)::AbstractArray{eltype(B), M}; kwargs...)
    end
end

"""
    conv(u,v,A)

2-D convolution of the matrix `A` with the 2-D separable kernel generated by
the vector `u` and row-vector `v`.
Uses 2-D FFT algorithm.
"""
function conv(u::AbstractVector{T}, v::Transpose{T,<:AbstractVector}, A::AbstractMatrix{T}) where T
    # Arbitrary indexing offsets not implemented
    if any(conv_axis_with_offset, (axes(u)..., axes(v)..., axes(A)...))
        throw(ArgumentError("offset axes not supported"))
    end
    m = length(u) + size(A, 1) - 1
    n = length(v) + size(A, 2) - 1
    B = zeros(T, m, n)
    B[CartesianIndices(A)] = A
    u = fft(_zeropad(u, m))
    vt = fft(_zeropad(transpose(v), n))
    C = ifft(fft(B) .*= u .* transpose(vt))
    if T <: Real
        return real(C)
    end
    return C
end


dsp_reverse(v::AbstractVector, ::Tuple{Base.OneTo}) = reverse(v)
function dsp_reverse(v::AbstractVector, vaxes::Tuple{AbstractUnitRange})
    vsize = length(v)
    reflected_start = - first(only(vaxes)) - vsize + 1
    reflected_axes = (reflected_start : reflected_start + vsize - 1,)
    out = similar(v, reflected_axes)
    copyto!(out, reflected_start, Iterators.reverse(v), 1, vsize)
end


"""
    xcorr(u; padmode::Symbol=:none, scaling::Symbol=:none)
    xcorr(u, v; padmode::Symbol=:none, scaling::Symbol=:none)

With two arguments, compute the cross-correlation of two vectors, by calculating
the similarity between `u` and `v` with various offsets of `v`. Delaying `u`
relative to `v` will shift the result to the right. If one argument is provided,
calculate `xcorr(u, u; kwargs...)`.

The size of the output depends on the `padmode` keyword argument: with `padmode =
:none` the length of the result will be `length(u) + length(v) - 1`, as with `conv`.
With `padmode = :longest`, the shorter of the arguments will be padded so they
are of equal length. This gives a result with length `2*max(length(u), length(v))-1`,
with the zero-lag condition at the center.

The keyword argument `scaling` can be provided. Possible arguments are the default
`:none` and `:biased`. `:biased` is valid only if the vectors have the same length,
or only one vector is provided, dividing the result by `length(u)`.

!!! note

    In this package, `xcorr` conjugates the second argument `v`, choosing the same
    convention as MATLAB's `xcorr` and `scipy.signal.correlate`. This differs from
    the inner product convention more prevalent in physics, that conjugates the
    first vector.
# Examples

```jldoctest
julia> xcorr([1,2,3],[1,2,3])
5-element Vector{Int64}:
  3
  8
 14
  8
  3
```
"""
function xcorr(
    u::AbstractVector, v::AbstractVector; padmode::Symbol=:none, scaling::Symbol=:none
)
    su = size(u, 1); sv = size(v, 1)

    if scaling == :biased && su != sv
        throw(DimensionMismatch("scaling only valid for vectors of same length"))
    end

    if padmode == :longest
        if su < sv
            u = _zeropad_keep_offset(u, sv)
        elseif sv < su
            v = _zeropad_keep_offset(v, su)
        end
    elseif padmode != :none
        throw(ArgumentError("padmode keyword argument must be either :none or :longest"))
    end

    res = conv(u, dsp_reverse(conj(v), axes(v)))
    if scaling == :biased
        res = _normalize!(res, su)
    end

    return res
end

_normalize!(x::AbstractArray{<:Integer}, sz::Int) = (x ./ sz)   # does not mutate x
_normalize!(x::AbstractArray, sz::Int) = (x ./= sz)

# TODO: write specialized (r/)fft-ed autocorrelation functions
xcorr(u::AbstractVector; kwargs...) = xcorr(u, u; kwargs...)

# `Util` - utility functions

!!! note
    As of version 0.6.1 of DSP.jl, `fftfreq` and `rfftfreq` have been moved from
    DSP.jl to [AbstractFFTs.jl](https://github.com/JuliaMath/AbstractFFTs.jl)
    version 0.5 and above. You can also access these functions through
    [FFTW.jl](https://github.com/JuliaMath/FFTW.jl) version 1.1 and above.

```@docs
unwrap
unwrap!
hilbert
nextfastfft
pow2db
amp2db
db2pow
db2amp
rms
rmsfft
meanfreq
finddelay
shiftin!
shiftsignal
shiftsignal!
alignsignals
alignsignals!
diric
```

# Welcome to DSP.jl's documentation!

DSP.jl provides a number of common [digital signal processing](https://en.wikipedia.org/wiki/Digital_signal_processing) routines in Julia.  
Many methods provided in this package are validated against popular tools such as [MATLAB's Signal Processing suite](https://www.mathworks.com/help/overview/signal-processing.html?s_tid=hc_product_group_bc) and [Python's MNE-Python package](https://mne.tools/stable/index.html). 
So far, the following submodules are implemented:

## Table of contents
```@contents
Pages = [
    "index.md",
    "periodograms.md",
    "estimation.md",
    "windows.md",
    "filters.md",
    "util.md",
    "convolutions.md",
    "lpc.md",
    "internals.md",
    "appendix.md"
]
```

# `Filters` - filter design and filtering

DSP.jl differentiates between [filter coefficients](@ref coefficient-objects)
and [stateful filters](@ref stateful-filter-objects). Filter
coefficient objects specify the response of the filter in one of
several standard forms. Stateful filter objects carry the state of the
filter together with filter coefficients in an implementable form
(`PolynomialRatio`, `Biquad`, or `SecondOrderSections`).
When invoked on a filter coefficient object, `filt` does not preserve
state.

## [Filter coefficient objects](@id coefficient-objects)

DSP.jl supports common filter representations. Filter coefficients can
be converted from one type to another using `convert`.

```@docs
ZeroPoleGain
PolynomialRatio
Biquad
SecondOrderSections
```

These filter coefficient objects support the following arithmetic operations:
inversion (`inv`), multiplication (`*`) for series connection, and integral
power (`^`) for repeated multiplication with itself. For example:

```jldoctest; setup = :(using DSP)
julia> H = PolynomialRatio([1.0], [1.0, 0.3])
PolynomialRatio{:z, Float64}(LaurentPolynomial(1.0), LaurentPolynomial(0.3*z⁻¹ + 1.0))

julia> inv(H)
PolynomialRatio{:z, Float64}(LaurentPolynomial(0.3*z⁻¹ + 1.0), LaurentPolynomial(1.0))

julia> H * H
PolynomialRatio{:z, Float64}(LaurentPolynomial(1.0), LaurentPolynomial(0.09*z⁻² + 0.6*z⁻¹ + 1.0))

julia> H^2
PolynomialRatio{:z, Float64}(LaurentPolynomial(1.0), LaurentPolynomial(0.09*z⁻² + 0.6*z⁻¹ + 1.0))

julia> H^-2
PolynomialRatio{:z, Float64}(LaurentPolynomial(0.09*z⁻² + 0.6*z⁻¹ + 1.0), LaurentPolynomial(1.0))

```

## [Stateful filter objects](@id stateful-filter-objects)

```@docs
DF2TFilter
```

DSP.jl's `FIRFilter` type maintains state between calls to [`filt`](@ref), allowing
you to filter a signal of indefinite length in RAM-friendly chunks. `FIRFilter`
contains nothing more that the state of the filter, and a `FIRKernel`. There are
five different kinds of `FIRKernel` for single rate, up-sampling, down-sampling,
rational resampling, and arbitrary sample-rate conversion. You need not specify the
type of kernel. The `FIRFilter` constructor selects the correct kernel based on input
parameters.

```@docs
FIRFilter
resample_filter
```

## Filter application

```@docs
filt
filt!
filtfilt
fftfilt
fftfilt!
tdfilt
tdfilt!
resample
```

## Filter design

Most analog and digital filters are constructed by composing
[response types](@ref response-types), which determine the frequency
response of the filter, with [design methods](@ref design-methods),
which determine how the filter is constructed.

The response type is [`Lowpass`](@ref), [`Highpass`](@ref), [`Bandpass`](@ref)
or [`Bandstop`](@ref) and includes the edges of the bands.

The design method is [`Butterworth`](@ref), [`Chebyshev1`](@ref), [`Chebyshev2`](@ref),
[`Elliptic`](@ref), or [`FIRWindow`](@ref), and includes any
necessary parameters for the method that affect the shape of the response,
such as filter order, ripple, and attenuation.

[Filter order estimation methods](@ref order-est-methods)
are available in [`buttord`](@ref), [`cheb1ord`](@ref), [`cheb2ord`](@ref),
and [`ellipord`](@ref) if the corner frequencies for different IIR filter types are known.
[`remezord`](@ref) can be used for an initial FIR filter order estimate.

```@docs
analogfilter
digitalfilter
```

For some filters, the design method is more general or
inherently implies a response type;
these [direct design methods](@ref direct-design-methods)
include [`remez`](@ref) which designs equiripple FIR
filters of all types, and [`iirnotch`](@ref) which designs a
2nd order "biquad" IIR notch filter.

For a more general application of creating a digital filter from s-domain
representation of an analog filter, one can use [`bilinear`](@ref):

```@docs
bilinear
```

### [Filter response types](@id response-types)

```@docs
Lowpass
Highpass
Bandpass
ComplexBandpass
Bandstop
```

The interpretation of the frequencies `Wn`, `Wn1` and `Wn2` depends on wether an analog
or a digital filter is designed.
1. If an analog filter is designed using [`analogfilter`](@ref), the frequencies are
   interpreted as analog frequencies in radians/second.
1. If a digital filter is designed using [`digitalfilter`](@ref) and the sampling
   frequency `fs` is specified, the frequencies of the filter response type are
   normalized to `fs`. This requires that the sampling frequency and the filter response
   type use the same frequency unit (Hz, radians/second, ...). If `fs` is not specified,
   the frequencies of the filter response type are interpreted as normalized frequencies
   in half-cycles/sample.


### [Filter design methods](@id design-methods)

#### IIR filter design methods

```@docs
Butterworth
Chebyshev1
Chebyshev2
Elliptic
```

### [Filter order estimation methods](@id order-est-methods)

#### IIR filter order estimation methods

```@docs
buttord
cheb1ord
cheb2ord
ellipord
```

#### FIR filter order estimation methods

```@docs
remezord
```

#### FIR filter design methods

```@docs
FIRWindow
```

### [Direct filter design methods](@id direct-design-methods)

```@docs
remez
iirnotch
```

## Filter response

```@docs
freqresp
phaseresp
grpdelay
impresp
stepresp
```

## Miscellaneous

```@docs
coefb
coefa
```

## Examples

Construct a 4th order elliptic lowpass filter with normalized cutoff
frequency 0.2, 0.5 dB of passband ripple, and 30 dB attenuation in
the stopband and extract the coefficients of the numerator and
denominator of the transfer function:

```julia
responsetype = Lowpass(0.2)
designmethod = Elliptic(4, 0.5, 30)
tf = convert(PolynomialRatio, digitalfilter(responsetype, designmethod))
numerator_coefs = coefb(tf)
denominator_coefs = coefa(tf)
```

Filter the data in `x`, sampled at 1000 Hz, with a 4th order
Butterworth bandpass filter between 10 and 40 Hz:

```julia
responsetype = Bandpass(10, 40)
designmethod = Butterworth(4)
filt(digitalfilter(responsetype, designmethod; fs=1000), x)
```

Filter the data in `x`, sampled at 50 Hz, with a 64 tap Hanning
window FIR lowpass filter at 5 Hz:

```julia
responsetype = Lowpass(5)
designmethod = FIRWindow(hanning(64))
filt(digitalfilter(responsetype, designmethod; fs=50), x)
```

Estimate a Lowpass Elliptic filter order with a normalized
passband cutoff frequency of 0.2, a stopband cutoff frequency of 0.4,
3 dB of passband ripple, and 40 dB attenuation in the stopband:

```julia
(N, ωn) = ellipord(0.2, 0.4, 3, 40)
```

# Internals
Functions here are not exported.

```@docs
DSP.os_fft_complexity
DSP.os_prepare_conv
DSP.os_conv_block!
DSP.os_filter_transform!
DSP.Windows.makewindow
DSP.Windows.padplot
DSP._zeropad
DSP._zeropad!
DSP._zeropad_keep_offset
DSP.Filters._polyprep
DSP.Filters.freq_eval
DSP.Filters.build_grid
DSP.Filters.lagrange_interp
DSP.Periodograms.coherence_from_cs!
DSP.optimalfftfiltlength
```

# `Periodograms` - periodogram estimation

## Basic functions
Common procedures like computing the [short-time Fourier transform](@ref stft),
[`periodogram`](@ref)s, and [`spectrogram`](@ref)s are documented below.

```@docs
arraysplit
DSP.Periodograms.ArraySplit
periodogram
DSP.Periodograms.Periodogram
DSP.Periodograms.Periodogram2
welch_pgram
welch_pgram!
spectrogram
DSP.Periodograms.Spectrogram
stft
freq
power
time
coherence
DSP.Periodograms.Coherence
```

## Multitaper periodogram estimation

```@docs
mt_pgram
mt_pgram!
mt_spectrogram
mt_spectrogram!
mt_cross_power_spectra
mt_cross_power_spectra!
DSP.Periodograms.CrossPowerSpectra
mt_coherence
mt_coherence!
```

## Configuration objects

```@docs
WelchConfig
MTConfig
MTSpectrogramConfig
MTCrossSpectraConfig
MTCoherenceConfig
```
